#ident  "@(#)cktodc.c	35.1"

/*
 *  Command to check the correctness of the hardware time of day clock.
 *  (Used by bcheckrc at boot time.)
 *
 *  Copyright, 1988, Motorola, Inc.
 */

#include	<sys/sysm68k.h>
#include	<stdio.h>


/**************
 **  cktodc  **
 **************
 **
 **  FUNCTION:	Routine to check the validity of the time of day clock.
 **
 **  CALLED:	Currently implemented as a "command" for calling from
 ** 		/etc/bcheckrc shell script
 **
 **  RETURNS:	exit values:  0 == "good" time of day clock (exists&valid)
 **			     -1 == can't use time of day clock time
 ************/


main()
{

	/*
	 *  Determine if the time of day clock is "good" (i.e., it exists
	 *  and is considered valid by the kernel).
	 */
	if (sysm68k(S68TODCSTAT) == GOOD_TODC)
		exit(0);
	else
		exit(-1);
}

