/*		@(#)badtrk.c	35.3		*/
/*
 *	Copyright (c) 1987 Motorola Inc.  
 *		All Rights Reserved.
 */
#include "dinit.h"

/* read a bad track list */

readlist(file, max)
char	*file;
int	max;
{	
	register struct dkbadlst *bl, *p1, *q1;
	int	compdk();
	char	dot;
	FILE	*infile;
	int	cnt, tmp, done;
	int	stat;		/* look for EOF status on "fscanf" */
	char	mesg[80];	/* storage for error message */
	char	skip[2];	/* skip over " \" */

	if( VID.vid_strat == DKPERFECT )
		return;

	/* allocate space to read bad spot list into		 */
	/* malloc "maxbad +1" to leave room for a sentinel added */
	/* in fillbads()					 */

	/* round size to a "full" disk block */

	tmp=(((((maxbad +1) * sizeof(struct dkbadlst))+(BSIZE-1))/BSIZE)*BSIZE);
	if(( bad_lst = (struct dkbadlst *) malloc(tmp)) == NULL ) {
		fprintf( stderr, "dinit: out of space\n" );
		exit(ENOSPC);
	}

	/* clear the mem just malloc'd so the disk copy will be clean */

	memset( bad_lst, 0, tmp);

	VID.vid_maxbad=sizeof(tmp);	/* save size of maxbad for future use */

	/*
	 *	open list file (if not standard input)
	 */

	infile = stdin;
	if (file && ((infile = fopen(file, "r")) == NULL)) {
		fprintf(stderr, "dinit: can't open file '%s'\n", file);
		exit(errno);
	}

	/*
	 *	If the file is standard input, and it's a tty,
	 *	then issue instructions.
	 */

	if (infile == stdin) {
		printf("Enter: ");
		switch( VID.vid_strat ) {
		case (DKSOFTWARE & 0xff):
		case DKHARDWARE:
			if(topt) { 	/* head cyl format OR track format ? */
				printf("bad tracks");
				strcpy(mesg, "dinit: Expected track#\n");
			}
			else {
				printf("head/cyl");
				strcpy(mesg, "dinit: Expected head/cyl\n");
				
			}
			break;
		case DKHARDSEC:
			printf("bad head/cylinder/sector");
			strcpy(mesg, "dinit: Expected head/cylinder/sector\n");
			break;
		case DKHARDSPOT:
			printf("bad head/cylinder/BFI");
			strcpy(mesg, "dinit: Expected head/cylinder/BFI\n");
			break;
		}
		printf(".\nEnd input with a period\n");
	}

	if( max > maxbad )
		max = maxbad;

	for( done=0, cnt=0, stat=0,bl=bad_lst; cnt <= max; cnt++, bl++ ) {
		switch( VID.vid_strat ) {
		case (DKSOFTWARE & 0xff):
		case DKHARDWARE:
			if (topt) { /* track  format ? */
				if((done = fscanf(infile,
				"%d", &bl->dk_track )) != 1) {
					stat = -1;
					break;	/* break out of `switch' */
				}
				bl->dk_head = bl->dk_sector = 0;
				/* compute track equivalent of bad spot */
				bl->dk_alt = gettrack(bl); 
			}
			else {	/* head cyl format */
				if((done = fscanf(infile,"%d%[ /]%d\n",
				&bl->dk_head,skip,&bl->dk_cyl)) != 3) {
					stat = -1;
					break;	/* break out of `switch' */
				}
				bl->dk_track = (bl->dk_cyl * IOS.ios_hds)
					+ bl->dk_head;	/* compute track */
				/* zero unused fields */
				bl->dk_head = bl->dk_sector = 0;

				/* temp. store track eqv. */
				bl->dk_alt = gettrack(bl);
			}
			break;		/* break out of switch */
		case DKHARDSEC:
		case DKHARDSPOT:
			if((done = fscanf(infile,"%d%[ /]%d%[ /]%d",
			&bl->dk_head,skip,&bl->dk_cyl,skip,&bl->dk_sector)) != 5) {
					stat = -1;
					break;	/* break out of `switch' */
				}
			/* compute track equivalent of bad spot */
			bl->dk_alt = gettrack(bl);  /* temp. store track eqv. */
			break;
		}
		if( stat == -1 )	/* break out of `for' loop */
			break;
	}

	if(done != EOF)  {
		fscanf(infile, "%c", &dot);
		if( dot != '.')  {
			fprintf(stderr, "dinit: Error reading bad list! \n");
			fprintf(stderr, "%s",mesg);
			if (infile != stdin)
				fclose(infile);
			exit(EINVAL);
		}
	}

	bad_cnt= cnt;		/* bad_cnt= number of bad spots */
	if (infile != stdin)
		fclose(infile);

	/* sort bad spots */

	bl=bad_lst;

	updown=0;	/* sort high to low */
	qsort(bl,maxbad, sizeof(struct dkbadlst), compdk);

	/* remove any duplicate bad spots */

	for(cnt = 1, p1 = bad_lst + 1, q1 = bad_lst; cnt < bad_cnt; cnt++, p1++)
		/* updown is set to 0 above, check "high to low" */

		if (compdk(p1,q1) != 0)
			*++q1 = *p1;
	if ( (p1 -1) != q1) {
		fprintf(stderr,"dinit: WARNING-- duplicate bad entry found\n");
		bad_cnt = q1 - bad_lst + 1;	/* adjust bad_cnt */
	}


	updown=1;	/* sort bad spots low to high */
/* THIS IS REQUIRED FOR BAD ALTS TO BE DETECTED/CORRECTED IN assignalts() */
	qsort(bl,bad_cnt, sizeof(struct dkbadlst), compdk);

	/* copy bad spot info and track equivalent to alt_info array */

	for(bl=bad_lst, alt_ptr=sv_ptr, cnt=0; cnt<bad_cnt; cnt++) {
		alt_ptr->dk_cyl    = bl->dk_cyl;
		alt_ptr->dk_head   = bl->dk_head;
		alt_ptr->dk_sector = bl->dk_sector;
		alt_ptr++->dk_eqv  = bl++->dk_alt;

		/* NOTE:						   */
		/* dk_alt temporarily contains the track equivalent of the */
		/* bad spot.  It will be updated to contain the assigned   */
		/* alternate in the routine "assignalt" */
	}
}

/* compute bad track from bad track/spot info */

gettrack(p)
struct dkbadlst *p;
{
	if (( VID.vid_strat == (DKSOFTWARE & 0xff)) || (VID.vid_strat == DKHARDWARE ))
		return(p->dk_track);
	return(( p->dk_cyl * IOS.ios_hds) + p->dk_head);
}

/* fill the bad track table and hash table with the proper values */

fillbads()
{

	int	compdk();
	int	tmp;
	register int	k;
	struct dkbadlst	*bl, *tv = bad_lst;

	if( VID.vid_strat == DKPERFECT )
		return;

	/* degenerate case	(no bad spots) */
	if(bad_cnt == 0) {
		bl= bad_lst;
		bl->dk_cyl = bl->dk_head = bl->dk_sector = bl->dk_alt = 0;
	}

	/* copy bad spot info and track equivalent from alt_info array */

	for(bl=bad_lst, alt_ptr=sv_ptr, k=0; k<bad_cnt; k++) {
		bl->dk_cyl = alt_ptr->dk_cyl;
 		bl->dk_head = alt_ptr->dk_head;
 		bl->dk_sector = alt_ptr->dk_sector;
 		bl++->dk_alt = alt_ptr++->dk_alt;
	}

	/* put badlst in ascending order */

	updown=1;	/* sort low to high */
	qsort(tv, bad_cnt, sizeof(struct dkbadlst), compdk);

	if ((VID.vid_strat != DKHARDWARE)
	&& (VID.vid_strat != (DKSOFTWARE & 0xff))) {
		return;
	}

	/* fill dummy entries */
	bad_lst[bad_cnt].dk_track = -1;
	bad_lst[bad_cnt].dk_alt = -1;
	++bad_cnt;	/* adjust bad_cnt to include the "0xff entry (above) */

	/*  For Software handling continue building tree and hash table */

	/* malloc a table rounded up to a full disk block and "zero" it */

	tmp =(((bad_cnt * sizeof(struct badent))+(BSIZE-1)/BSIZE)*BSIZE);
	
	if((bttable = (struct badent *) malloc(tmp)) == NULL ) {
		fprintf( stderr, "dinit: out of space\n" );
		exit(ENOSPC);
	}
	memset( bttable, 0, tmp);

	mkhash(hash, tv, (bad_cnt -1) );

	/* find order of problem */
	for (k = 1; k <= bad_cnt; k *= 2);
	process(0, k, bad_cnt, 1);
}


/* fill the hash table based on the bad track information */

mkhash(htab, badtrks, badcnt)
char	htab[HASHSIZE];
struct dkbadlst	*badtrks;
int	badcnt;
{
	register i;
	register l;

	/* fill it with non-zero */
	for (i = 0; i < HASHSIZE; htab[i++] = 255);

	/* if no bad tracks then done */
	if (badcnt == 0)
		return;

	/* fill in the bad tracks */
	for (i = 0; i < badcnt; i++, badtrks++)
		htab[badtrks->dk_track & 255] = 0;

	/* find last bad track */
	for (l = HASHSIZE - 1; htab[l]; l--);

	/* fill in entries from "l" down to 0 */
	for (i = l - 1; i >= 0; i--)
		if (htab[i])
			htab[i] = htab[i + 1] + 1;

	/* wrap around */
	if (htab[HASHSIZE - 1])
		htab[HASHSIZE - 1] = htab[0] + 1;

	/* fill in entries from HASHSIZE-1 down to "l" */
	for (i = HASHSIZE - 2; i > l; i--)
		if (htab[i])
			htab[i] = htab[i + 1] + 1;

	/* Voila */
}


/* create the packed tree for the bad track table */

process(base, step, size, location)
int	base, step, size, location;
{
	int	mid, midplus;
	struct dkbadlst	*tv = bad_lst;

	if (size == 0)
		return;

	/* mid is middle for full balanced tree */
	mid = step / 2 - 1;

	/* midplus is 3/4 full, middle doesn't change */
	midplus = 3 * step / 4 - 1;

	if (size < midplus)	/* if less than 3/4, adjust mid */
		mid -= midplus - size;

	bttable[location-1].b_bad = bad_lst[base + mid].dk_track;
	bttable[location-1].b_alt = bad_lst[base + mid].dk_alt;
	step /= 2;
	process(base, step, mid, location * 2);
	if (step / 2 > size - mid - 1)
		step /= 2;
	process(base + mid + 1, step, size - mid - 1, location * 2 + 1);
}

readlst(fid)
FILE	*fid;
{	
	register struct dkbadlst *bl;
	register struct badent	*bttable;
	int	tmp, i, j, ok;
	struct alt_info *p1;
	long cur_cyl, cur_head, cur_sector, cur_alt;

	/* skip VID and CONFIG */ 

	if ( lseek(fid, sizeof(struct dkblk0), 0) == -1) {
		fprintf(stderr, "dinit:  seek error\n");
		exit(ENXIO);
	}

	if(def_vid_strat != VID.vid_strat) {
		fprintf(stderr, "dinit: Bad spot strategy on disk does not match ddefs file!\n");
		exit(-1);
	}

	/* Compare actual # heads/cylinders with the ddefs file values and */
	/* BLOW UP if they don't match */

	if((def_ios_hds != IOS.ios_hds) || (def_ios_trk != IOS.ios_trk)) {
		fprintf(stderr, "dinit:  Invalid Config block!\n");
		exit(-1);
	}

	/* we are ready to copy the bad track table */
	/* malloc space for the bad spot list.  Size is */
	/* maxbad "+1" for the "0xff" entry added by fillbads() */

	/* round size to a "full" disk block */

	tmp=(((((maxbad +1) * sizeof(struct dkbadlst))+(BSIZE-1))/BSIZE)*BSIZE);
	if(( bad_lst = (struct dkbadlst *) malloc(tmp)) == NULL ) {
		fprintf( stderr, "dinit: out of space\n" );
		exit(ENOSPC);
	}

	/* clear the mem just malloc'd so the disk copy will be clean */

	memset( bad_lst, 0, tmp);


	if (((VID.vid_strat == (DKSOFTWARE & 0xff))
	|| (VID.vid_strat == DKHARDWARE))  ) {

		/* skip over hash table */ 

		if ( lseek(fid, IOS.ios_rec, 1) == -1) {
			fprintf(stderr, "dinit:  seek error (hash table) \n");
			exit(ENXIO);
		}

		/* we are ready to read the bad track table */
		/* VID.vid_btl is the number of bad tracks  */
		/* PLUS one for the sentinel added in fillbads() */

		tmp=((((VID.vid_btl * sizeof(struct badent))
			+(BSIZE-1))/BSIZE)*BSIZE);
		if((bttable = (struct badent *) malloc(tmp)) == NULL ) {
			fprintf( stderr, "dinit: out of space\n" );
			exit(ENOSPC);
		}
		memset( bttable, 0, tmp); /* clear it */

		/* read bad track table */

		if(read(fid, bttable, tmp) == -1) {
			fprintf(stderr,"dinit:  read error (bad track table) \n");
			exit(ENXIO);
		}
		/* read bad tracks from disk into alt_info array */
		/* AND the badlst array (for use by fillbads() ) */

		for (alt_ptr = sv_ptr, i = j = 0; i < VID.vid_btl ; i++) {
			if (bttable[i].b_bad != FLAG) {
				bad_lst[j].dk_cyl = alt_ptr->dk_eqv
					= alt_ptr->dk_track = bttable[i].b_bad;
				bad_lst[j++].dk_alt = alt_ptr++->dk_alt
					= bttable[i].b_alt;
				bad_cnt = bad_cnt + 1;
			}
		}
		free(bttable);
	} else if (VID.vid_strat != DKPERFECT) {

		/* read bad spot table */

		if(read(fid, bad_lst,tmp) == -1 ) {
			fprintf(stderr, "dinit:  read error (bad spot table) \n");
			exit(ENXIO);
		}

		/* read bad tracks and assigned alts from disk into */
		/* the alt_info array */
		/* check that cyl, head, sector are sorted as they should */
		/* be from dinit AND have valid values (per ddefs file).  */
		/* If anything is found to be unsorted, OR invalid, exit  */
		/* and refuse to add a new bad spot */

		cur_cyl = cur_head = cur_sector = 0;

		for (alt_ptr = sv_ptr, i = 0; i < def_vid_btl; i++, alt_ptr++) {
			if ((bad_lst[i].dk_cyl < cur_cyl)
				|| (bad_lst[i].dk_cyl >= IOS.ios_trk)) {
				/* either the cyl is not "real" per
				ddefs file or it is not 
				sorted in ascending order, so this is
				an invalid entry,  
				assume this is the end of the list
				and previous entries, 
				if any, were valid */

				break;	/* break out of for loop */
			}
			else if(bad_lst[i].dk_cyl == cur_cyl)
				if(bad_lst[i].dk_head < cur_head) {
				/* this is an invalid entry,
				heads should be in ascending order */
					break;
				}
				else if (bad_lst[i].dk_head == cur_head)
					/* ignore -1 sectors */
					if(bad_lst[i].dk_sector != LFLAG )
						if((bad_lst[i].dk_sector
						< cur_sector)
						|| (bad_lst[i].dk_alt != cur_alt)) {
						/* this is an invalid entry,
						if cyl and head match,
						alt should also match
						(either 0 or same as previous
						entry) OR sector is
						not is ascending order, */
							break;
						}

			if (bad_lst[i].dk_head >= IOS.ios_hds) {
				break;
			}

			if((VID.vid_strat == DKHARDSEC)
			&& (bad_lst[i].dk_sector >= IOS.ios_spt)) {
			/* sector number exceeds number of sectors per track! */
			/* it's ok though if it's an "unknown" defect position (LFLAG) */
				if (bad_lst[i].dk_sector != LFLAG ) {
					break;
				}
			}
			/* all seems kosher to this point, read the values in */
			/* save the values for comparison on the next loop */

			cur_cyl = alt_ptr->dk_cyl = bad_lst[i].dk_cyl;
			cur_head = alt_ptr->dk_head = bad_lst[i].dk_head;
			if(bad_lst[i].dk_sector == LFLAG) {	/* ignore LFLAG */
				cur_sector = 0;
				alt_ptr->dk_sector = bad_lst[i].dk_sector;
			}
			else cur_sector = alt_ptr->dk_sector = bad_lst[i].dk_sector;
			cur_alt = alt_ptr->dk_alt = bad_lst[i].dk_alt;
			alt_ptr->dk_eqv = (bad_lst[i].dk_cyl * IOS.ios_hds)
				+ bad_lst[i].dk_head;	/* compute track */
			if(alt_ptr->dk_alt == 0)
				alt_ptr->dk_flags |= SSLIP;	/* indicate sector slipped */
			bad_cnt = i + 1;
		}
	}

	/* remove any alternates just read from the available alternates list */

	for (alt_ptr = sv_ptr, i=0; i < altcnt; alt_ptr++, i++){
		for (p1 = sv_ptr, j=0; j < altcnt; p1++, j++){
			if(p1->dk_alt == alt_ptr->dk_avalt) {
				alt_ptr->dk_avalt = -1;	/* mark as used */
				alts_used++;
			}
		}
	}

	/*	remove any bad spots that are alternates */

	for (alt_ptr = sv_ptr, i=0; i < bad_cnt; alt_ptr++, i++){
		for (p1 = sv_ptr, j=0; j < altcnt; p1++, j++){
			if(alt_ptr->dk_eqv == p1->dk_avalt) {
				p1->dk_avalt = -1;	/* mark as used */
				alts_used++;
			}
		}
	}
}

/* read a  new bad spot */

readnew()
{
	register struct alt_info *p1, *p2;
	struct dkbadlst *p3;
	register FILE *infile;
	char mesg[80];	/* storage for error message */
	register i, tmp, done = 0;
	char	skip[2];	/* skip over " \" */

	/*
	 *	The file is standard input, if it's a tty,
	 *	then issue instructions.
	 *	ELSE, error!
	 */

	if (isatty(0)) {
		fprintf(stdout, "Enter: ");
		switch( VID.vid_strat ) {
		case (DKSOFTWARE & 0xff):
		case DKHARDWARE:
			if(topt) { 	/* head/cyl  format OR track format ? */
				fprintf(stdout, "bad track");
				strcpy(mesg, "dinit: Expected track#\n");
			}
			else {
				fprintf(stdout, "head/cyl");
				strcpy(mesg, "dinit: Expected head/cyl\n");
			}
			break;
		case DKPERFECT:
		case DKHARDSPOT:
		case DKHARDSEC:
			fprintf(stdout, "bad head/cylinder/logical sector");
			strcpy(mesg, "dinit: Expected head/cylinder/logical sector\n");
			break;
		}
	}

	fprintf(stdout, "\n");

	infile=stdin;	/* force input from stdin */

	p2 = &sv_ptr[bad_cnt]; /* point to next entry */

	/* set up DKFIXBADSPOT structure (make the ioctl call in wrtcyl0) */

	tmp =sizeof(struct dkbadlst);
	if((new_spot = (struct dkbadlst *)malloc(tmp)) == NULL) {
		fprintf( stderr, "dinit: out of space\n" );
		exit(ENOSPC);
	}

	memset( new_spot, 0, tmp);	/* clear it */

	switch( VID.vid_strat ) {
	case (DKSOFTWARE & 0xff):
	case DKHARDWARE:
		if (topt) { /* track format ? */
			if(done = (fscanf(infile, "%d", &p2->dk_track ) != 1)) {
				break;	/* break out of `switch' */
			}
			p2->dk_head = p2->dk_sector = 0;
			/* compute track equivalent of bad spot */
			p2->dk_eqv = p2->dk_track;
		}
		else {	/* head cyl format */
			if(done = (fscanf(infile,
			"%d%[ /]%d",&p2->dk_head,skip,&p2->dk_cyl) != 3)) {
				break;	/* break out of `switch' */
			}
			/* compute track */
			p2->dk_track = (p2->dk_cyl * IOS.ios_hds) + p2->dk_head;

			p2->dk_head = p2->dk_sector = 0; /*zero unused fields */
			p2->dk_eqv = p2->dk_track;
		}
		break;		/* break out of switch */
	case DKHARDSEC:
	case DKPERFECT:
	case DKHARDSPOT:
		if(done = (fscanf(infile,
		"%d%[ /]%d%[ /]%d",&p2->dk_head,skip,&p2->dk_cyl,skip,&p2->dk_sector ) != 5)) {
				break;	/* break out of `switch' */
			}

		/* keep info typed in for DKFIXBAD */
		new_spot->dk_cyl = p2->dk_cyl;

		/* keep info typed in for DKFIXBAD */
		new_spot->dk_head = p2->dk_head;

		/* keep info typed in for DKFIXBAD */
		new_spot->dk_sector = p2->dk_sector;

		/* clear for now, set in wrtcyl0, after assignnew */
		new_spot->dk_alt = 0;

		/* compute track equivalent of bad spot */
		p2->dk_eqv = (p2->dk_cyl * IOS.ios_hds) + p2->dk_head; /* track eqv */
		/* can't convert LOGICAL sector to physical sector */
		p2->dk_sector = LFLAG;

		break;

	} /* end of switch */

	if (( VID.vid_strat == (DKSOFTWARE & 0xff))
		|| (VID.vid_strat == DKHARDWARE ))
		if(p2->dk_head >= IOS.ios_trk) {
			fprintf( stderr, "dinit: Illegal Track\n" );
			exit(-1);
	}

	if((DKHARDSEC == VID.vid_strat) || (DKHARDSPOT == VID.vid_strat) || (DKPERFECT == VID.vid_strat)) 
		if((p2->dk_head >= IOS.ios_hds) || (p2->dk_cyl >= IOS.ios_trk)){
			fprintf( stderr,
			"dinit: Illegal Head or Cylinder number\n" );
			exit(-1);
	}

	bad_cnt += 1;	/* update bad_cnt to reflect bad spot just entered */

	/* if done != 0, then we have a read error on the new bad spot */
	if(done) {
		fprintf(stderr, "dinit: Error reading bad list! \n");
		fprintf(stderr, "%s",mesg);
		exit(-1);
	}

	/* if DKSOFTWARE or DKHARDWARE you must remove duplicates */

	if (( VID.vid_strat == (DKSOFTWARE & 0xff))
		|| (VID.vid_strat == DKHARDWARE )) {
		for (p1 = sv_ptr, i=0; i < (bad_cnt-1); i++, p1++) {
			if(p1->dk_track == p2->dk_eqv) {
				fprintf(stderr,
				"dinit: entry already exists, no change.\n");
				exit(-1);
			}
		}
	}
	/* check if the new bad spot is an alternate and if it is, remove */
	/* it from the available alternate list */

	for (p1 = sv_ptr, i=0; i < info_size; i++, p1++) {
		if(p1->dk_avalt == p2->dk_eqv) {
			p1->dk_avalt = -1;	/* don't use this alt */
		}
	}
	/* save value for formatter call */
	if (( VID.vid_strat == (DKSOFTWARE & 0xff))
		|| (VID.vid_strat == DKHARDWARE ))
			new_spot->dk_track = p2->dk_eqv;
	return(p2->dk_eqv);	/* new bad spot */
}

/* print bad spot list (show assigned alternates if -a option) */

printlist() 
{
	int i;

	if( VID.vid_strat == DKPERFECT )
		return;

	if (isatty(1)) { /* if stdout is a tty, print a header */
		switch( VID.vid_strat ) {
		case (DKSOFTWARE & 0xff):
		case DKHARDWARE:
			if(topt) { 	/* head/cyl format OR track format ? */
				fprintf(stdout,"bad tracks\t\t");
			}
			else {
				fprintf(stdout,"head/cyl\t\t");
			}
			break;
		case DKHARDSEC:
			fprintf(stdout,"bad head/cylinder/sector\t\t");
			break;
		case DKHARDSPOT:
			fprintf(stdout,"bad head/cylinder/BFI\t\t");
		}
	if(aopt)
		fprintf(stdout,"alternate");
	fprintf(stdout,"\n");
	}
	for( i=0, alt_ptr=sv_ptr; i < bad_cnt; i++, alt_ptr++ ) {
		switch( VID.vid_strat ) {
		case (DKSOFTWARE & 0xff):
		case DKHARDWARE:
			if (topt) { /* track format ? */
				if(xopt) {	/* print out in hex ??? */
					fprintf(stdout, "%x",
					alt_ptr->dk_track );
				} else
						fprintf(stdout, "%d",
						alt_ptr->dk_track );
			}
			else {	/* head cyl format */
				if(xopt) {	/* print out in hex ??? */
					fprintf(stdout,"%x/%x",
					(alt_ptr->dk_track % IOS.ios_hds),
					(alt_ptr->dk_track / IOS.ios_hds));
				} else
					fprintf(stdout,"%d/%d",
					(alt_ptr->dk_track % IOS.ios_hds),
					(alt_ptr->dk_track / IOS.ios_hds));
			}
			break;		/* break out of switch */
		case DKHARDSEC:
		case DKHARDSPOT:
				if(xopt) {	/* print out in hex ??? */
					fprintf(stdout,"%x/%x/%-2x",
					alt_ptr->dk_head,
					alt_ptr->dk_cyl,
					alt_ptr->dk_sector );
				} else
						fprintf(stdout,"%d/%d/%-2d",
						alt_ptr->dk_head,
						alt_ptr->dk_cyl,
						alt_ptr->dk_sector );
			}
		if (aopt)	/* print alternate too ??? */
				if(xopt) {	/* print out in hex ??? */
					fprintf(stdout, "\t\t\t%x",
					alt_ptr->dk_alt );
				} else
						fprintf(stdout, "\t\t\t%d",
						alt_ptr->dk_alt );
		fprintf(stdout,"\n");
		}
}
