/*		@(#)fmt.c	35.1			*/	
/*
 *	Copyright (c) 1987 Motorola Inc.  
 *		All Rights Reserved.
 */
#include "dinit.h"

/*
 *	fmtdrive: format drive
 */

fmtdrive()
{	register fid;
	struct dkfmt fmtp;

	if( ! newformat ) {	/* if old style */
		if((fid = open(bdev, O_WRONLY)) == -1) {
			fprintf(stderr, "dinit: cannot open block device `%s'\n", bdev);
			exit(ENXIO);
		}
#ifdef DEBUG
fprintf(stderr, "dinit: /* fid= %d */\n", fid);
#endif

		oldformat("");

		/*
		 *	set up (incomplete) header to make disk usable
		 */

		lseek(fid, 0L, 0);
#ifdef DEBUG
fprintf(stderr, "dinit: /* fid= %d */\n", fid);
fprintf(stderr, "dinit: /* write(%s, &VID, sizeof(struct volumeid)) */\n", bdev);
#endif

		if ( write(fid, &VID, sizeof(struct volumeid)) == -1 ) {
#ifdef DEBUG
			exit(EACCES);
#endif

			fprintf(stderr, "dinit: error on write to %s,", bdev );
			fprintf(stderr, "probably not formatted\n");
		}
		lseek(fid, IOS.ios_rec, 0);
#ifdef DEBUG
fprintf(stderr, "dinit: /* write(%s, &IOS, sizeof(struct dkconfig)) */\n", bdev);
#endif

		write(fid, &IOS, sizeof(struct dkconfig));
#ifdef DEBUG
fprintf(stderr, "dinit: /* close(%s) */\n", bdev);
#endif

		close(fid);

#ifdef DEBUG
fprintf(stderr, "dinit: /* return from fmtdrive() */\n");
#endif

		return;
	}

	/*
	 *	new style configure and format
	 */

	if((fid = open(rdev, O_WRONLY |O_NDELAY)) == -1) {
		fprintf(stderr, "dinit: cannot open raw device `%s'\n", rdev);
		exit(ENXIO);
	}
	/*
	 *	do configuration
	 */

	if( ioctl( fid, DKSETINFO, &dkblk0 ) == -1 ) {
		fprintf( stderr,"dinit: can't set configuration information\n");
		if( doformat )
			exit(errno);
		return;
	}

	/* if no slice table, don't do the DKSETSLC */

	if ( IOS.ios_slccnt != 0 )
		if ( ioctl(fid,DKSETSLC,slctab) == -1) {
			fprintf(stderr, "dinit:  error on DKSETSLC \n");
			exit(1);
		}

	/*
	 *	do format
	 */

	if( doformat ) {

		/* build "dkfmt" structure prior to "format" ioctl call */ 

		fmtp.dk_trkcnt=IOS.ios_trk * IOS.ios_hds;
		fmtp.dk_trkno=0;
		fmtp.dk_badcnt=bad_cnt;
		fmtp.dk_badlst=bad_lst;
		fmtp.dk_altcnt=altcnt;
		fmtp.dk_altlst=alt_lst;

#ifndef CMDEBUG
		if( ioctl( fid, DKFORMAT, &fmtp ) == -1 ) {
			fprintf( stderr, "dinit: format error\n" );
			exit(errno);
		}
#endif
	}

	close(fid);
}

oldformat(opt)
{	char	command[BUFSIZ];
	register char	*s, *t;

	if (strchr(formatter, '#') != NULL) {
		t = formatter;
		while ((s = strchr(t, '#')) != NULL) {
			strncat(command, t, s - t);
			strcat(command, " ");
			strcat(command, rdev);
			t = s + 1;
		}
		strcat(command, t);
		strcat(command, " ");
		strcat(command, opt);
		if (!doformat)
			strcat(command, " -F");
	} else
		sprintf( command, "%s %s %s %s", formatter,
			(!doformat)? "-F" : "", opt, rdev );

	/*
	 *	do-format
	 */

#ifdef	DEBUG
	fprintf( stderr, "DEBUG dinit: %s\n", command);
#endif

#ifdef	CMDEBUG
	printf("> CMDEBUG %s\n", command);
#else
	system(command);
#endif
}
