#ident "@(#)writhead.c	35.5"
/*
 *	Copyright (c) 1987 Motorola Inc.  
 *		All Rights Reserved.
 */
#include "dinit.h"
/* (finally) write it all to the disk */

wrtcyl0(dev, rdev)
char	*dev;
char	*rdev;
{
	register fid, rfid;
	int	tmp, eqv, i;
	struct bentry *bp;
	struct dkbadlst *pt ;
	struct alt_info *p1;
	char	command[BUFSIZ];
	char	btstring[10];
	char	altstring[10];

	/*
	 *	if new style format
	 */

	if(newformat) {
		if(!nopt) {
			if((rfid = open(rdev, O_WRONLY |O_NDELAY)) == -1) {
				fprintf(stderr,
				 	"dinit: cannot open raw device `%s'\n", rdev);
				exit(ENXIO);
			}
			/*
	 		*	do configuration
	 		*/

			if( ioctl( rfid, DKSETINFO, &dkblk0 ) == -1 ) {
				fprintf( stderr,
					"dinit: can't set configuration information\n");
				exit(ENXIO);
			}

	
	
			/* if no slice table, don't do the DKSETSLC */

			if ( IOS.ios_slccnt != 0 )
				if ( ioctl(rfid,DKSETSLC,slctab) == -1) {
					fprintf(stderr, "dinit:  error on DKSETSLC \n");
					exit(ENXIO);
				}
		}
	}

	if(( fid = open(dev, O_WRONLY|O_NDELAY)) == -1) {
		fprintf(stderr, "dinit: cannot open block device `%s'\n", dev);
		exit(ENXIO);
	}
	
	if (hasboot)
		copyboot(fid);
	if (hasdiag)
		copydiag(fid);

	/* 
	 * For Hardware only write if changing the bad track table.
	 * Probably should be the same for DKSOFTWARE.
	 * ie VID.vid_strat != DKPERFECT && ( doformat )
	 */

	if (((VID.vid_strat == (DKSOFTWARE & 0xff))
		|| (VID.vid_strat == DKHARDWARE))  && ((doformat) || (nopt)) ) {
		if (bad_cnt) {
				/* hash table */ 
				if ( lseek(fid, 2 * IOS.ios_rec, 0) == -1) {
					fprintf(stderr, "dinit:  seek error (hash table) \n");
					exit(1);
				}
				if(write(fid, hash, 256) == -1 ) { 
					fprintf(stderr, "dinit:  write error (hash table) \n");
					exit(1);
				}
				/* bad track table */
				if(lseek(fid, 3 * IOS.ios_rec, 0) == -1) {
					fprintf(stderr, "dinit:  seek error (bad track table) \n");
					exit(1);
				}
				tmp=(((((maxbad +1)*sizeof(struct badent))+(lss-1))/lss)*lss);
				if(write(fid, bttable, tmp ) == -1) {
					fprintf(stderr, "dinit:  write error (bad track table) \n");
					exit(1);
				}

  	        if((nopt) && (~newformat) && (VID.vid_strat == DKHARDWARE)){
					/* map the bad track to the alternate track */
					eqv = new_spot->dk_track;
	
					for (p1 = sv_ptr, i=0; i < bad_cnt; p1++, i++) {
						if(p1->dk_eqv == eqv) 
							new_spot->dk_alt = p1->dk_alt;
					}
					sprintf(btstring, "%d", new_spot->dk_track);
					sprintf(altstring, "%d",new_spot->dk_alt);
					strcpy(command, formatter);
					strcat(command, " -M ");
					strcat(command, btstring);
					strcat(command, " ");
					strcat(command, altstring);
					strcat(command, " ");
					strcat(command, rdev);
#ifdef	CMDEBUG
			printf("> CMDEBUG %s\n", command);
#else
		  			system(command);   
#endif
	       	}
			if(newformat && nopt ) {
				if(VID.vid_strat == DKSOFTWARE) {
				/* set up DKADDBADSPOT structure then make the ioctl call */

					if((bp = (struct bentry *) malloc(sizeof(struct bentry))) == NULL) {
					fprintf( stderr, "dinit: out of space\n" );
					exit(ENOSPC);
				}

				tmp =sizeof(struct bentry);
				memset( bp, 0, tmp);	/* clear it */

				bp->b_tsize = bad_cnt;		/* tree size */
				bp->b_hash = hash;			/* hash table pointer */
				bp->b_tree = bttable;		/* tree pointer */

				/* must open raw device to do ioctl call */

				if((rfid = open(rdev, O_WRONLY |O_NDELAY)) == -1) {
					fprintf(stderr,
				 		"dinit: cannot open raw device `%s'\n", rdev);
					exit(ENXIO);
				}

				if(ioctl(rfid,DKADDBADSPOT,bp) == -1) {
					fprintf(stderr, "dinit:  ioctl DKADDBADSPOT error\n");
					exit(1);
				}
				close(rfid);	/* done with rdev */
				}
			}
		}
	} if(nopt) {
			/* new_spot structure contains cyl/head/LOGICAL sector from readnew() */
			/* now we must find the alternate assigned in assignnew() */

			/* compute track equivalent, then search altinfo array for a match */
			/* when found, get the alternate */

			eqv = (new_spot->dk_cyl * IOS.ios_hds) + new_spot->dk_head;

			for (p1 = sv_ptr, i=0; i < bad_cnt; p1++, i++) {
				if(p1->dk_eqv == eqv) 
					new_spot->dk_alt = p1->dk_alt;
			}
			/* must open raw device to do ioctl call */

			if((rfid = open(rdev, O_WRONLY |O_NDELAY)) == -1) {
				fprintf(stderr,
					"dinit: cannot open raw device `%s'\n", rdev);
				exit(ENXIO);
			}

			/* now that the new_spot structure is complete, call DKFIXBAD */
			if(ioctl(rfid,DKFIXBADSPOT,new_spot) == -1) {
				fprintf(stderr, "dinit:  ioctl DKFIXBADSPOT error\n");
				exit(1);
			}
		}
 if((VID.vid_strat == DKHARDSPOT) || (VID.vid_strat == DKHARDSEC)) {
 		/* bad spot info */
		if(lseek(fid, 2 * IOS.ios_rec, 0) == -1 ) {
			fprintf(stderr, "dinit:  seek error (bad spot table) \n");
			exit(1);
		}

		tmp=((((maxbad *sizeof(struct dkbadlst))+(BSIZE-1))/BSIZE)*BSIZE);
		if(write(fid, bad_lst, tmp ) == -1 ) {
			fprintf(stderr, "dinit:  write error (bad spot table) \n");
			exit(1);
		}
	}
	close(rfid);	/* done with rdev */

	VID.vid_btl = bad_cnt;

	/* now put out the real header */
	/* 
	 * Be careful that this is not overriding 
	 * something it's not supposed to 
	 */
	if (lseek(fid, 0L, 0) == -1) {     /* seek to head 0, cyl 0 */
		fprintf(stderr, "dinit:  seek error (vol id blk) \n");
		exit(1);
	}
	/* write volume id */
	if (write(fid, &VID, sizeof(struct volumeid)) == -1 ) { 
		fprintf(stderr, "dinit:  write error (vol id blk) \n");
		exit(1);
	}

 	/* write config block */

	if (lseek(fid, IOS.ios_rec, 0) == -1) {
		fprintf(stderr, "dinit:  seek error (config blk) \n");
		exit(1);
	}
	if (write(fid, &IOS, sizeof(struct dkconfig)) == -1) {
		fprintf(stderr, "dinit:  write error (config blk) \n");
		exit(1);
	}

	if (( IOS.ios_slccnt != 0 ) && (!nopt)) {	 /* if slice table AND...  */
			/* ... we are NOT updating the bad spot list */

		/* write slice table */

		if ( lseek(fid, (IOS.ios_slcblk * BSIZE), 0) == -1) {
			fprintf(stderr, "dinit:  seek error (slice table) \n");
			exit(1);
		}
	
		if ( write(fid,slctab,512) == -1) {
			fprintf(stderr, "dinit:  write error (slice table) \n");
			exit(1);
		}
	}

	if(rfid)  		/* if new style, close raw device */
		close(rfid);

	close(fid);
}


/* copy the bootloader program onto the disk */

copyboot(fid)
int	fid;
{
	char	buffer[1024];
	LDFILE *ldptr;
	SCNHDR text, data;
	register int	l, s, diag_sz, tmp;

	lss = IOS.ios_rec;

	loc = lss * 2;		/* skip over volume id and config entries */

	/* compute size of diadnostic directory, if any */
	diag_sz = (hasdiag != 0) ? lss : 0;

	if((VID.vid_strat == (DKSOFTWARE & 0xff)) || (VID.vid_strat == DKHARDWARE)) {
		loc += lss;	/* skip hash table */
		tmp = (maxbad * sizeof(struct badent) + diag_sz);
		loc = ((loc + tmp + BSIZE - 1)/BSIZE) * BSIZE; /* skip bad spot info and diag. dir. */

	} else if (VID.vid_strat != DKPERFECT)
		/* skip bad spot info */
		loc += ((maxbad * sizeof(struct dkbadlst) + diag_sz + BSIZE - 1)/BSIZE) * BSIZE;

	ldptr = NULL;
	if ((ldptr = ldopen(bootloader, ldptr)) == NULL) {
		fprintf(stderr, "dinit: can't open bootloader file '%s'\n", bootloader);
		return;
	}
	if (ldnshread(ldptr, ".text", &text) == FAILURE) {
		fprintf(stderr, "dinit: can't seek .text header on '%s'\n", bootloader);
		ldclose(ldptr);
		return;
	}
	ldnshread(ldptr, ".data", &data);

	if (data.s_vaddr + data.s_size - text.s_vaddr > MAXBOOT) {
		fprintf(stderr, "dinit: bootloader '%s' too big\n", bootloader);
		ldclose(ldptr);
		return;
	}

#ifdef m88k
/*
** Convert text.s_vaddr (a long) into 2 shorts
**
** PEG	3/14/88
*/
	VID.vid_osa_l = (unsigned short) (text.s_vaddr);
	VID.vid_osa_u = (unsigned short) (text.s_vaddr >> 16);
	VID.vid_ose_l = (unsigned short) (text.s_vaddr);
	VID.vid_ose_u = (unsigned short) (text.s_vaddr >> 16);
#else
	VID.vid_osa = VID.vid_ose = text.s_vaddr;
#endif
	ldnsseek(ldptr, ".text");
	lseek(fid, loc, 0);
	for (s = text.s_size; s; s -= l) {
		l = (s > 1024) ? 1024 : s;
		FREAD(buffer, l, 1, ldptr);
		write(fid, buffer, l);
	}
	ldnsseek(ldptr, ".data");
	lseek(fid, loc + data.s_vaddr - text.s_vaddr, 0);
	for (s = data.s_size; s; s -= l) {
		l = (s > 1024) ? 1024 : s;
		FREAD(buffer, l, 1, ldptr);
		write(fid, buffer, l);
	}
	ldclose(ldptr);
	VID.vid_oss = loc / lss;
	VID.vid_osl = (data.s_vaddr + data.s_size - text.s_vaddr + BSIZE-1) / lss;
	VID.vid_osl = (((VID.vid_osl + 1) >> 1) << 1); /* round up to multiple of 2 */
}

