

/*****************************************************************************

	Rev = 1.1		Date of 'get'   = 09:32:08 1/6/89
				Date of 'delta' = 09:30:53 1/6/89

	File = m250ctl.c

*****************************************************************************/



/**********************************************************************
 *								      *
 *		Copyright (c) Ferranti plc 1988			      *
 *								      *
 *	This is unpublished proprietory source code of Ferranti plc.  *
 *		The copyright of which vests in Ferranti plc.	      *
 **********************************************************************/


/**********************************************************************
 *								      *
 *	m250ctl.c: MVME250 control program			      *
 *								      *
 *								      *
 *	m250ctl options:				              *
 *								      *
 *	-r		rewind				              *
 *	-t		retension				      *
 *	-w		open for writing			      *
 *	-fX		position at beginning of file X	              *	
 *								      *
 **********************************************************************/

#include <stdio.h>
#include <fcntl.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/fvme250/f250cmds.h>

#define	DSIZE	(1024*128)
#define	RDBUFSZ	(BUFSIZ*10)

char	rdbuf[RDBUFSZ];

/*
 *	main: main procedure
 */

main( argc, argv )
register argc;
register char **argv;

{	register char *av;
	register char *fname;
	register arg;
	register omodes = O_NDELAY|O_RDONLY;
	register fd = 0;	/* standard in */
	register c;
	int	sizetype = 1;
	int	fnum = 1;
	struct stat sbuf;

	/*
	 *	first pass over the arguments
	 */

	for( arg=1; arg < argc; arg++ ) {
		av = argv[arg];
		if( *av == '-' ) {
			while(( c = *++av ) != '\0' ) {
				switch(c) {
				case 'w':
					omodes = O_NDELAY|O_WRONLY;
					fd = 1;	/* standard out */
				case 'r':
				case 't':
					break;
				case 'f':
					if( *++av == '\0' ) {
						av--;
						break;
					}
					while(isdigit(*av))
						av++;
					if( *av != '\0' )
						usage();
					av--;
					break;
				default:
					fprintf( stderr, "m250ctl: illegal option: -%c\n", c );
					usage();
				}
			}

		} else if( arg != argc-1 )
			usage();	/* file can only be last argument */

		else if( stat( av, &sbuf ) == -1 )
			ferr( "Can't stat %s\n", av );

		else if( (sbuf.st_mode&S_IFMT) != S_IFCHR )
			ferr( "%s not a character device.\n", av );

		else if((fd = open(av,omodes)) == -1)
			ferr( "Cannot open %s\n", av );

		else
			fname = av;		/* save file name */
	}

	/*
	 *	second pass
	 */

	for( arg=1; arg < argc; arg++ ) {
		av = argv[arg];
		if( *av != '-' )
			continue;
		while(( c = *++av ) != '\0' ) {
			int	size;

			switch(c) {
			case 'r':	doioctl(fd,REWIND_CMD,0);
					break;
			case 't':	doioctl(fd,RETEN_CMD,0);
					break;
			case 'f':	doioctl(fd,REWIND_CMD,0);
					if( *++av != '\0' )
						fnum = atoi(av);
					dopos(fname,omodes,fd,fnum);
					break;
			default:	break;
			}
		}
	}
}

/*
 *	usage: print out usage message and exit
 */

usage()
{	
	fprintf( stderr, "Usage: m250ctl [-rtw] [-fX] [special]\n" );
	fprintf( stderr, "Default special file: standard input\n");
	fprintf( stderr, "Options:\n");
	fprintf( stderr, "-r:\trewinds tape\n");
	fprintf( stderr, "-t:\tretensions tape\n");
	fprintf( stderr, "-w:\topens tape for writing (with filemark)\n");
	fprintf( stderr, "-f:\tpositions at file X\n");
	exit(1);
}

/*
 *	ferr: fatal error
 */

ferr(s,a1)
{	fprintf(stderr, "m250ctl: " );
	fprintf(stderr, s, a1 );
	exit(1);
}

/*
 *	doioctl: perform ioctl
 */

doioctl(fd,cmd,arg)
{	if( ioctl(fd,cmd,arg) != -1 )
		return;
	perror("m250ctl");
	exit(1);
}

/*
 *	dopos: position tape
 */

dopos(fname,omodes,fd,fnum)
register char *fname;
register omodes;
register fd;
register fnum;

{	register n;

	/*while( --fnum > 0 ) {
		while(( n = read( fd, rdbuf, RDBUFSZ )) > 0 );
		if( n == -1 ) {
			perror("read error");
			return;
		}
		close(fd);
		if((fd = open(fname,omodes)) == -1)
			ferr( "Cannot open %s\n", fname );
	}   */

	/* skip fnum - 1 filemarks */
	fnum--;

	if (fnum > 0 ) {
		ioctl(fd,SPFMKS_CMD,fnum);
		close(fd);
		if((fd = open(fname,omodes)) == -1)
			ferr( "Cannot open %s\n", fname );
	}
}
