

/*****************************************************************************

	Rev = 1.1		Date of 'get'   = 09:32:08 1/6/89
				Date of 'delta' = 09:30:54 1/6/89

	File = m250reass.c

*****************************************************************************/



/**********************************************************************
 *								      *
 *		Copyright (c) Ferranti plc 1988			      *
 *								      *
 *	This is unpublished proprietory source code of Ferranti plc.  *
 *		The copyright of which vests in Ferranti plc.	      *
 **********************************************************************/


/**********************************************************************
 *								      *
 *	This is a utility program to reassign a bad sector on a disk. *
 *	It is for for use with the FVME250 device driver.             *
 *								      *
 **********************************************************************/


#include <fcntl.h>
#include <sys/fvme250/f250cmds.h>

main(argc,argv)
	int argc;
	char **argv;
{
	int fd, id, cd;
	int sect_num;

	if ( (argc < 2) || (argc > 3) ){
		printf("Usage: m250reassign device_name [sector no]\n");
	  	exit(-1);
	}

	if (argc > 2) {
		sect_num = atoi(argv[2]);
		if (sect_num == 0) 
			 exit(-1);
	
	}
	else {
		printf("Enter address of defective sector  ");
		sect_num = getnum();
		printf("\n");
	}

	/*  tell user what we are doing */
	printf("Reassigning block no %d\n",sect_num);


	/*  Try and open the device */
	if ( (fd = open(argv[1], O_RDWR)) == -1) {
		perror("open");
		exit(-1);
	}

	/*  send a reassign command */
 	if ( (id = ioctl(fd, REASSIGN_CMD, sect_num)) == -1) {
		perror("ioctl");
		printf("Try reassign command again\n");
		exit(-1);
	}

	/*  Try and close the device */
	if ( (cd = close(fd)) == -1) {
		perror("close :");
		exit(-1);
	}
}

long getnum () {		/* read a positive/negative number */
	register long v;
	register char ch;
	int sign = 1;

	for (ch = getchar(); ch == ' '|| ch == '\n'|| ch=='\t'; ch = getchar());
	if( ch == '+' || ch == '-'){
		sign = ((ch == '+') ? 1: -1);
		ch = getchar();
	}
	for (v = 0; 1 ; ch = getchar ()) {
		if ((ch == ' ') || (ch == '\r') || (ch == ';') || (ch == '\n'))
			return (sign * v);
		if ((ch < '0') || (ch > '9')) return (-1);
		v = (v * 10) + (ch - 0x30); }
	return(-1);
}
