#
# Makefile for SCC Utilities in cmds/SCCS

INC = /usr/include

UTILS =\
		scc_cmd\
		sccclear\
		sccetab\
		sccfifo\
		sccinfo\
		sccreset\
		sccstate\
		scctty\
		srecval

all:		$(UTILS) sccram5.4

# 
# Utility: scc_cmd
#
scc_cmd:	scc_cmd.c\
		se_error.o\
		$(INC)/stdio.h\
		$(INC)/fcntl.h\
		$(INC)/errno.h\
		$(INC)/sys/types.h\
		$(INC)/sys/termio.h\
		$(INC)/local/scc/scclioctl.h
		cc -O scc_cmd.c se_error.o -o scc_cmd
		rm -f scc_cmd.o

# 
# Utility: sccclear
#
sccclear:	sccclear.c\
		$(INC)/stdio.h\
		$(INC)/sys/types.h\
		$(INC)/sys/termio.h\
		$(INC)/local/scc/sccioctl.h
		cc -O sccclear.c -o sccclear

# 
# Utility: sccetab
#
sccetab:	sccetab.c\
		$(INC)/stdio.h\
		$(INC)/fcntl.h\
		$(INC)/time.h\
		$(INC)/sys/types.h\
		$(INC)/sys/stat.h\
		$(INC)/local/scc/sccioctl.h
		cc -O sccetab.c -o sccetab


# 
# Utility: sccfifo
#
sccfifo:	sccfifo.c\
		se_error.o\
		$(INC)/stdio.h\
		$(INC)/fcntl.h\
		$(INC)/errno.h\
		$(INC)/sys/types.h\
		$(INC)/sys/stat.h\
		$(INC)/local/scc/status.h\
		$(INC)/local/scc/fifo.h\
		$(INC)/local/scc/scclioctl.h
		cc -O sccfifo.c se_error.o -o sccfifo
		rm -f sccfifo.o

# 
# Utility: sccinfo
#
sccinfo:	sccinfo.c\
		$(INC)/stdio.h\
		$(INC)/fcntl.h\
		$(INC)/errno.h\
		$(INC)/ctype.h\
		$(INC)/sys/types.h\
		$(INC)/sys/termio.h\
		$(INC)/local/scc/scclioctl.h
		cc -O sccinfo.c -o sccinfo

# 
# Utility: sccreset
#
sccreset:	sccreset.c\
		se_error.o\
		$(INC)/stdio.h\
		$(INC)/fcntl.h\
		$(INC)/errno.h\
		$(INC)/sys/types.h\
		$(INC)/sys/termio.h\
		$(INC)/local/scc/scclioctl.h
		cc -O sccreset.c se_error.o -o sccreset
		rm -f sccreset.o

# 
# Utility: sccstate
#
sccstate:	sccstate.c\
		$(INC)/stdio.h\
		$(INC)/sys/types.h\
		$(INC)/sys/termio.h\
		$(INC)/local/scc/sccioctl.h\
		$(INC)/local/scc/duartchan.h
		cc -O sccstate.c -o sccstate

# 
# Utility: scctty
#
scctty:		scctty.c\
		$(INC)/stdio.h\
		$(INC)/sys/types.h\
		$(INC)/sys/termio.h\
		$(INC)/local/scc/sccioctl.h\
		$(INC)/local/scc/scctermio.h
		cc -O scctty.c -o scctty

# 
# Utility: srecval
#
srecval:	srecval.c\
		$(INC)/stdio.h\
		$(INC)/fcntl.h\
		$(INC)/sys/types.h\
		$(INC)/sys/termio.h\
		$(INC)/local/scc/scclioctl.h\
		$(INC)/local/scc/boolean.h
		cc -O srecval.c -o srecval

se_error.o:	se_error.c
		cc -O -c se_error.c

sccram5.4:	sccram5.4

clean:

clobber: clean
	rm $(UTILS) se_error.o

strip:
	strip $(UTILS)

install: all 
	cp scc_cmd /etc
	chmod 0775 /etc/scc_cmd
	rm /etc/scc /etc/sccinit /etc/sccload
	-ln /etc/scc_cmd /etc/scc
	-ln /etc/scc_cmd /etc/sccinit
	-ln /etc/scc_cmd /etc/sccload
	cp sccclear /bin
	chmod 0775 /bin/sccclear
	cp sccetab /bin
	chmod 0775 /bin/sccetab
	cp sccfifo /etc
	chmod 0775 /etc/sccfifo
	cp sccinfo /etc
	chmod 0775 /etc/sccinfo
	cp sccreset /etc
	chmod 0775 /etc/sccreset
	cp sccram5.4 /etc
	cp sccstate /bin
	chmod 0775 /bin/sccstate
	cp scctty /bin
	chmod 0775 /bin/scctty
	cp srecval /bin
	chmod 0775 /bin/srecval

