/*
 *                  Copyright (c) 1988 Ferranti Plc.
 *                      All Rights Reserved
 *
 *
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF FERRANTI PLC THE COPYRIGHT 
 *                   OF WHICH VESTS IN FERRANTI PLC.
 *
 *   The copyright notice above does not evidence any actual or intended 
 *                   publication of such source code.
 *
 * This source code and the information contained herein is supplied without
 * liability for errors or ommissions and no part may be copied, re-produced, 
 * used or disclosed except as authorised by the Ferranti organisation by 
 *                contract or by other written permission.
 */

/******************************************************************************

	Rev = 5.1		Date of 'get'   = 11:10:58 1/26/89
				Date of 'delta' = 14:58:54 12/8/88

	File = sccclear.c

******************************************************************************/

#ident "@(#)scc-cmds:cmds/sccclear.c Rev 5.1 14:58:54 12/8/88"

#include <stdio.h>
#include <sys/types.h>
#include <sys/termio.h>
#include <local/scc/sccioctl.h>

extern void exit();
extern void perror();

static char clear_id[] = "scc-cmds:cmds/sccclear.c Rev 5.1 14:58:54 12/8/88";

char *cmd;

main(argc, argv)
char	*argv[];
{
	char *cp;
	int vflag;

	/*
	 * Set the command name into string pointer cmd
	 */

	if (cmd = (char *)strrchr(argv[0],'/'))
		++cmd;
	else
		cmd = argv[0];

	vflag = 0;

	if (argc > 1) {
	
		argv++;
		if ((*argv)[0] == '-') {
			for (cp = *argv++; *cp; cp++) {
				switch (*cp) {
					case '-' : break;
					case 'v' : vflag++;
						   break;
					case 'h' : usage(1);
						   exit(0);
					case 'V' : prt_msg();
						   exit(0);
					default  : fprintf(stderr,
				           "%s: %c - Unknown option\n",cmd,*cp);
						   usage(0);
						   exit(1);
				}
			}
		}
	}

	if(ioctl(0, SCCPCLR) == -1) {
		perror("ioctl");
		fprintf(stderr,
		   "%s: Failed to clear terminal proc_error word (SCCPCLR)\n",
								cmd);
		exit(2);
	}

	if (vflag)
		printf("%s: Terminal channel's proc_error word cleared\n",cmd);
	
	exit(0);

}	/* end of main */




prt_msg()
{
	printf("%s: %s\n",cmd,clear_id);
}

usage(all)
int all;
{
	printf("usage: sccclear [-Vhv] [ < /dev/tty-device]\n");
	if (all) {
		printf("\n");
		printf("options: -V  Print utility version string\n");
		printf("         -h  This help message\n");
		printf("         -v  Enable verbose mode\n");
	}
}
