/*
 *                  Copyright (c) 1988 Ferranti Plc.
 *                      All Rights Reserved
 *
 *
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF FERRANTI PLC THE COPYRIGHT 
 *                   OF WHICH VESTS IN FERRANTI PLC.
 *
 *   The copyright notice above does not evidence any actual or intended 
 *                   publication of such source code.
 *
 * This source code and the information contained herein is supplied without
 * liability for errors or ommissions and no part may be copied, re-produced, 
 * used or disclosed except as authorised by the Ferranti organisation by 
 *                contract or by other written permission.
 */

/******************************************************************************

	Rev = 5.1		Date of 'get'   = 11:11:00 1/26/89
				Date of 'delta' = 14:59:04 12/8/88

	File = sccstate.c

******************************************************************************/

#ident "@(#)scc-cmds:cmds/sccstate.c Rev 5.1 14:59:04 12/8/88"

#include <stdio.h>
#include <sys/types.h>
#include <sys/termio.h>
#include <local/scc/sccioctl.h>
#include <local/scc/duartchan.h>

extern void exit();
extern void perror();

static char state_id[] = "scc-cmds:cmds/sccstate.c Rev 5.1 14:59:04 12/8/88";

char *cmd;

main(argc, argv)
char	*argv[];
{
	int nflag, tflag, vflag, err;
	char *cp, *file;

	/*
	 * Set the command name into string pointer cmd
	 */

	if (cmd = (char *)strrchr(argv[0],'/'))
		++cmd;
	else
		cmd = argv[0];

	file = NULL;
	vflag = 0;
	tflag = 0;
	nflag = 0;

	if (argc > 1) {
		argv++;
		if ((*argv)[0] == '-') {
			for (cp = *argv++; *cp; cp++) {
				switch (*cp) {
					case '-' : break;
					case 'n' : nflag++;
						   file = *argv++;
						   break;
					case 'h' : usage(1);
						   exit(0);
					case 't' : tflag++;
						   break;
					case 'v' : vflag++;
						   break;
					case 'V' : prt_msg();
						   exit(0);
					default  : fprintf(stderr,
				           "%s: %c - Unknown option\n",cmd,*cp);
						   usage(0);
						   exit(1);
				}
			}
		}
	}

	if ( (nflag) && (file == NULL)) {
		fprintf(stderr,"%s: No name specified with f option\n",cmd);
		usage(0);
		exit(1);
	}
					
	if(ioctl(0, SCCPERR, &err) == -1) {
		perror("ioctl");
		fprintf(stderr,
		   "%s: Failed to read terminal proc_error word (SCCPERR)\n",
								cmd);
		exit(2);
	}

	if (vflag) {
		if (nflag)
			printf("%s: Process error log state for %s is 0x%04x\n",
					cmd,file,(short)err);
		else
			printf("%s: Process error log state is 0x%04x\n",
					cmd,(short)err);
		
		if (err & (IN_OVERRUN|RIF_OFLOW|HIF_128)) {
			printf("%s: Errors occured :-\n",cmd);
			if (err & IN_OVERRUN)
			printf("%s:    DUART input overrun\n",
					cmd);
			if (err & RIF_OFLOW)
			printf("%s:    Raw input fifo overflow\n",
					cmd);
			if (err & HIF_128)
			printf("%s:    Peak of less than 128 free slots in host fifo\n",
					cmd);
			if (err & RIF_FHCPY)
			printf("%s:    Raw input fifo filled on copy of data from host input fifo\n",
					cmd);
		}
	}
	else  {
		if (tflag) {
			if (nflag)
				printf("%s 0x%04x\n",file,(short)err);
			else
				printf("0x%04x\n",(short)err);
		}
		else
			printf("%s: Process error log state is 0x%04x\n",
			cmd,(short)err);
	}

	exit(0);

}	/* end of main */

prt_msg()
{
	printf("%s: %s\n",cmd,state_id);
}

usage(all)
int all;
{
	printf("usage: sccstate [-Vhntv] [n option string] [ < /dev/tty-device]\n");
	if (all) {
		printf("\n");
		printf("options: -V  Print utility version string\n");
		printf("         -h  This help message\n");
		printf("         -n  String to be output as part of device state message\n");
		printf("         -t  Enable terse mode\n");
		printf("         -v  Enable verbose mode\n");
	}
}
