/*
 *                  Copyright (c) 1988 Ferranti Plc.
 *                      All Rights Reserved
 *
 *
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF FERRANTI PLC THE COPYRIGHT 
 *                   OF WHICH VESTS IN FERRANTI PLC.
 *
 *   The copyright notice above does not evidence any actual or intended 
 *                   publication of such source code.
 *
 * This source code and the information contained herein is supplied without
 * liability for errors or ommissions and no part may be copied, re-produced, 
 * used or disclosed except as authorised by the Ferranti organisation by 
 *                contract or by other written permission.
 */

/******************************************************************************

	Rev = 5.1		Date of 'get'   = 11:11:01 1/26/89
				Date of 'delta' = 15:37:34 1/20/89

	File = scctty.c

******************************************************************************/

#ident "@(#)scc-cmds:cmds/scctty.c Rev 5.1 15:37:34 1/20/89"

#include <stdio.h>
#include <sys/types.h>
#include <sys/termio.h>
#include <local/scc/sccioctl.h>
#include <local/scc/scctermio.h>

extern void exit();
extern void perror();

static char scctty_id[] = "scc-cmds:cmds/scctty.c Rev 5.1 15:37:34 1/20/89";

/* 
 * All funny speeds (e.g. 134.5, 19.2 and 38.4 MUST go at the end of the
 * table so that speed can be output by formula :-
 *
 *    (((bit_pattern & CABUD)-1)*3)
 */

#define	REC	1
#define	TRANS	2
#define	NOSPLIT	3

struct
{
	char	*string;
	int	speedb, speedv, type;
} speeds[] = {
	"r50",		((SIO_RB50 >> 16) & 0xFFFF),	50,	REC,
	"t50",		SIO_B50,				50,	TRANS,
	"50",		SIO_B50,				50,	NOSPLIT,
	"r75",		((SIO_RB75 >> 16) & 0xFFFF),	75,	REC,
	"t75",		SIO_B75,				75,	TRANS,
	"75",		SIO_B75,				75,	NOSPLIT,
	"r110",		((SIO_RB110 >> 16) & 0xFFFF),	110,	REC,
	"t110",		SIO_B110,				110,	TRANS,
	"110",		SIO_B110,				110,	NOSPLIT,
	"r134",		((SIO_RB134 >> 16) & 0xFFFF),	134,	REC,
	"t134",		SIO_B134,				134,	TRANS,
	"134",		SIO_B134,				134,	NOSPLIT,
	"r150",		((SIO_RB150 >> 16) & 0xFFFF),	150,	REC,
	"t150",		SIO_B150,				150,	TRANS,
	"150",		SIO_B150,				150,	NOSPLIT,
	"r200",		((SIO_RB200 >> 16) & 0xFFFF),	200,	REC,
	"t200",		SIO_B200,				200,	TRANS,
	"200",		SIO_B200,				200,	NOSPLIT,
	"r300",		((SIO_RB300 >> 16) & 0xFFFF),	300,	REC,
	"t300",		SIO_B300,				300,	TRANS,
	"300",		SIO_B300,				300,	NOSPLIT,
	"r600",		((SIO_RB600 >> 16) & 0xFFFF),	600,	REC,
	"t600",		SIO_B600,				600,	TRANS,
	"600",		SIO_B600,				600,	NOSPLIT,
	"r1200",	((SIO_RB1200 >> 16) & 0xFFFF),	1200,	REC,
	"t1200",	SIO_B1200,				1200,	TRANS,
	"1200",		SIO_B1200,				1200,	NOSPLIT,
	"r1800",	((SIO_RB1800 >> 16) & 0xFFFF),	1800,	REC,
	"t1800",	SIO_B1800,				1800,	TRANS,
	"1800",		SIO_B1800,				1800,	NOSPLIT,
	"r2400",	((SIO_RB2400 >> 16) & 0xFFFF),	2400,	REC,
	"t2400",	SIO_B2400,				2400,	TRANS,
	"2400",		SIO_B2400,				2400,	NOSPLIT,
	"r4800",	((SIO_RB4800 >> 16) & 0xFFFF),	4800,	REC,
	"t4800",	SIO_B4800,				4800,	TRANS,
	"4800",		SIO_B4800,				4800,	NOSPLIT,
	"r9600",	((SIO_RB9600 >> 16) & 0xFFFF),	9600,	REC,
	"t9600",	SIO_B9600,				9600,	TRANS,
	"9600",		SIO_B9600,				9600,	NOSPLIT,
	"r19200",	((SIO_RB19200 >> 16) & 0xFFFF),	19200,	REC,
	"t19200",	SIO_B19200,				19200,	TRANS,
	"19200",	SIO_B19200,				19200,	NOSPLIT,
	"r38400",	((SIO_RB38400 >> 16) & 0xFFFF),	38400,	REC,
	"t38400",	SIO_B38400,				38400,	TRANS,
	"38400",	SIO_B38400,				38400,	NOSPLIT,
	"r134.5",	((SIO_RB134 >> 16) & 0xFFFF),	134,	REC,
	"t134.5",	SIO_B134,				134,	TRANS,
	"134.5",	SIO_B134,				134,	NOSPLIT,
	"r19.2",	((SIO_RB19200 >> 16) & 0xFFFF),	19200,	REC,
	"t19.2",	SIO_B19200,				19200,	TRANS,
	"19.2",		SIO_B19200,				19200,	NOSPLIT,
	"r38.4",	((SIO_RB38400 >> 16) & 0xFFFF),	38400,	REC,
	"t38.4",	SIO_B38400,				38400,	TRANS,
	"38.4",		SIO_B38400,				38400,	NOSPLIT,
	0
};

struct mode_settings {
	char	*string;
	int	bit_val;
};
						/* Control Modes */
struct mode_settings cmodes[] = {
	"nortscts", 	((SIO_NORTSCTS >> 16) & 0xFFFF),
	"ignnodsr", 	((SIO_IGNNODSR >> 16) & 0xFFFF),
	"ignnodcd", 	((SIO_IGNNODCD >> 16) & 0xFFFF),
	0
};

struct mode_settings imodes[] = {
	"imax", 	((SIO_IMAX >> 16) & 0xFFFF),
	"imaxbell", 	((SIO_IMAXBELL >> 16) & 0xFFFF),
	"iechotbl",	((SIO_IECHOTBL >> 16) & 0xFFFF),
	"imsg",		((SIO_IMSG >> 16) & 0xFFFF),
	0
};

struct mode_settings lmodes[] = {
	"iftoraw", 	((SIO_IFTORAW >> 16) & 0xFFFF),
	"iftocan", 	((SIO_IFTOCAN >> 16) & 0xFFFF),
	0,
};

#define	TRUE	1
#define	FALSE	0

char	*line_ptr;				/* arg: ptr to mode to be set */
int	found;
struct termio tc_t, scc_t;
struct termio origtc_t;
int	nosplit, rspeed, tspeed;

char *cmd;

main(argc, argv)
char	*argv[];
{
	register i;
	int width, owrap;
	char	*cp;
	int dflag, have_split, done_tcsetaw;

	dflag        = FALSE;
	have_split   = FALSE;
	done_tcsetaw = FALSE;

	nosplit = FALSE;
	rspeed = FALSE;
	tspeed = FALSE;
	owrap   = FALSE;

	width = -1;
	
	/*
	 * Set the command name into string pointer cmd
	 */

	if (cmd = (char *)strrchr(argv[0],'/'))
		++cmd;
	else
		cmd = argv[0];

	/*
	 * Do we have arguments, are they V, h or d options ?
	 * V, h and d are only on their own, else is error
	 */
	if (argc == 2) {
		/* 
		 * Check for V, h or d
		 */
		if (strcmp(argv[1],"-V") == 0) {
			printf("%s: %s\n",cmd,scctty_id);
			exit(0);
		}
		else if (strcmp(argv[1],"-h") == 0) {
			usage(1);
			exit(0);
		}
		else if (strcmp(argv[1],"-d") == 0) {
			dflag = TRUE;
			argv++;
			argc--;
		}
	}

	/*
	 * Get normal setting as we may need to change speed as part of
	 * a split speed request.
	 */
	if(ioctl(0, TCGETA, &tc_t) == -1) {
		perror("ioctl");
		fprintf(stderr,
		   "%s: Failed to read terminal characteristics (TCGETA)\n",
								cmd);
		exit(2);
	}
	if(ioctl(0, TCGETA, &origtc_t) == -1) {
		perror("ioctl");
		fprintf(stderr,
		   "%s: Failed to read terminal characteristics (TCGETA)\n",
								cmd);
		exit(2);
	}

	if(ioctl(0, SCCGETA, &scc_t) == -1) {
		perror("ioctl");
		fprintf(stderr,
		   "%s: Failed to read terminal characteristics (SCCGETA)\n",
								cmd);
		exit(2);
	}
	
	/*
	 * Check for a current split setting
	 */
	if (scc_t.c_cflag & ((SIO_RCBAUD >> 16) & 0xFFFF)) {
		have_split = TRUE;
		if (dflag)
			printf("%s: Currently is split mode\n",cmd);
	}

	/*
	 * Is it a print request or a setting request ?
	 */
	if (argc == 1) {
		opsettings();
		exit(0);
	}

	while(--argc > 0) {		

		line_ptr = *++argv;

		found = 0;

		for(i=0; speeds[i].string; i++) {
			if(scan_line(speeds[i].string)) {
				if (speeds[i].type == NOSPLIT) {
					nosplit = TRUE;
					tc_t.c_cflag &= ~SIO_CBAUD;
					tc_t.c_cflag |= 
						speeds[i].speedb&SIO_CBAUD;
					scc_t.c_cflag &= 
						~((SIO_RCBAUD >> 16) & 0xFFFF);
				}
				else if (speeds[i].type == TRANS) {
					tspeed = TRUE;
					tc_t.c_cflag &= ~SIO_CBAUD;
					tc_t.c_cflag |= 
						speeds[i].speedb&SIO_CBAUD;
				}
				else if (speeds[i].type == REC) {
					rspeed = TRUE;
					scc_t.c_cflag &=
						~((SIO_RCBAUD >> 16) & 0xFFFF);
					scc_t.c_cflag |=
				speeds[i].speedb & ((SIO_RCBAUD >> 16) & 0xFFFF);
				}
			}
		}

		/*
		 * Check for owrap <arg>, -owrap
		 */
		
		if (scan_line("owrap")) {
			/* 
			 * Have owrap or -owrap
			 */
			if (line_ptr[0] == '-')
				scc_t.c_oflag &= ~((SIO_OWRAP >> 16) & 0xFFFF);
			else {
				/*
				 * Get setting
				 */
				width = atoi(*++argv);
				argc--;
				owrap = TRUE;
				scc_t.c_oflag |= ((SIO_OWRAP >> 16) & 0xFFFF);
				printf("scctty: owrap %d\n",width);
			}
		}
		
		for(i=0; cmodes[i].string; i++) {
			if(scan_line(cmodes[i].string)) {
				if (line_ptr[0] == '-')
					scc_t.c_cflag &= ~cmodes[i].bit_val;
				else
					scc_t.c_cflag |= cmodes[i].bit_val;
			}
		}

		for(i=0; imodes[i].string; i++) {
			if(scan_line(imodes[i].string)) {
				if (line_ptr[0] == '-')
					scc_t.c_iflag &= ~imodes[i].bit_val;
				else
					scc_t.c_iflag |= imodes[i].bit_val;
			}
		}

		for(i=0; lmodes[i].string; i++) {
			if(scan_line(lmodes[i].string)) {
				if (line_ptr[0] == '-')
					scc_t.c_lflag &= ~lmodes[i].bit_val;
				else
					scc_t.c_lflag |= lmodes[i].bit_val;
			}
		}

		if(!found) {
			fprintf(stderr, "%s: Unknown mode %s\n", cmd,line_ptr);
			usage(0);
			exit(2);
		}

	}

	if (dflag) {
		printf("%s: tc_t.c_oflag  0x%08x\n", cmd,tc_t.c_oflag);
		printf("%s: tc_t.c_iflag  0x%08x\n", cmd,tc_t.c_iflag);
		printf("%s: tc_t.c_lflag  0x%08x\n", cmd,tc_t.c_lflag);
		printf("%s: tc_t.c_cflag  0x%08x\n", cmd,tc_t.c_cflag);
		printf("%s: scc_t.c_oflag 0x%08x\n", cmd,scc_t.c_oflag);
		printf("%s: scc_t.c_iflag 0x%08x\n", cmd,scc_t.c_iflag);
		printf("%s: scc_t.c_lflag 0x%08x\n", cmd,scc_t.c_lflag);
		printf("%s: scc_t.c_cflag 0x%08x\n", cmd,scc_t.c_cflag);

		if ( (!have_split) && (tspeed) )
			printf("%s: Requested tXXX, but no rXXX set\n",cmd);
	}

	if ( (nosplit) || (tspeed) ) {
		done_tcsetaw = TRUE;
		if (dflag)
			printf("%s: Call TCSETAW\n",cmd);
		if(ioctl(0, TCSETAW, &tc_t) == -1) {
			perror("ioctl");
			fprintf(stderr,
		   "%s: Failed to set terminal characteristics (TCSETAW)\n",
								cmd);
			exit(2);
		}

		if ( (!have_split) && (tspeed) && (!rspeed) ) {
			/*
			 * Generate original speed as rXXX speed request
			 */
			if (scc_t.c_cflag) {
				printf("%s: Program assertion fault 1\n",cmd);
				exit(1);
			}
			scc_t.c_cflag = origtc_t.c_cflag & SIO_CBAUD;
			if (dflag)
				printf("%s: NOW scc_t.c_cflag 0x%08x\n", 
							cmd,scc_t.c_cflag);
		}
	}

	if (dflag)
		printf("%s: Call SCCSETAW\n",cmd);
	if(ioctl(0, SCCSETAW, &scc_t) == -1) {
		perror("ioctl");
		fprintf(stderr,
		   "%s: Failed to set terminal characteristics (SCCSETAW)\n",
								cmd);

		/*
		 * Above output may be unreadable as transmit speed may have 
		 * been changed. Reset transmit to former state
	 	 */
		if (done_tcsetaw) {
			if (dflag)
				printf("%s: Call TCSETAW, to reset\n",cmd);
			if(ioctl(0, TCSETAW, &origtc_t) == -1) {
				perror("ioctl");
				fprintf(stderr,
		   "%s: Failed to reset terminal characteristics (TCSETAW)\n",
								cmd);
				exit(2);
			}
			if ( nosplit || tspeed || rspeed)
				fprintf(stderr,
				"%s: Invalid split speed requested\n",cmd);
			else
				fprintf(stderr,"%s: Request failed",cmd);
		}
		exit(2);
	}

	if (owrap) {
		if(ioctl(0, SCCSWRAP, &width) == -1) {
			perror("ioctl");
			fprintf(stderr,
		   "%s: Failed to set terminal characteristic (SCCSWRAP)\n",
								cmd);
			exit(2);
		}
	}
	exit(0);

}

scan_line(string)
char *string;
{
	register i;

	if(!line_ptr)
		return(0);
	i = 0;
	if (line_ptr[i] == '-') 
		i++;

	if (strcmp(&line_ptr[i],string) == 0) {
		found = TRUE;
		return(1);
	}
	else
		return(0);
}

opsettings()
{
	register rtmp;
	int tmp;

	/*
	 * Output speed first. Check scc_t for a speed setting. If none
	 * then no split speed operation.
	 * Get cflag into top 16 bits of 'rtmp' for bit pattern testing
	 */
	rtmp = (scc_t.c_cflag << 16) & 0xFFFF0000;
	if ((rtmp & SIO_RCBAUD) == 0) {
		/* 
		 * No split speed operation. Print out normal speed.
		 */
		printf("speed %d (no split) ", 
			speeds[((tc_t.c_cflag & SIO_CBAUD)-1)*3].speedv);
	}
	else {
		/* 
		 * Have split. Output receive/transmit speed
		 */
		printf("speed receive %d, transmit %d (split) ",
			speeds[(((rtmp & SIO_RCBAUD) >> 16)-1)*3].speedv,
			speeds[((tc_t.c_cflag & SIO_CBAUD)-1)*3].speedv);
	}

	if(ioctl(0, SCCBRGT, &tmp) == -1) {
		perror("ioctl");
		fprintf(stderr,
		   "\n%s: Failed to read terminal characteristics (SCCBRGT)\n",
								cmd);
		exit(2);
	}
	
	printf("Baud rate table %d\n",tmp);
	
	/*
	 * iflag - imax, imaxbell, iechotbl, imsg
	 */
	rtmp = (scc_t.c_iflag << 16) & 0xFFFF0000;

	if (rtmp & SIO_IMAX) printf("imax");
	else printf("-imax");
	printf(" ");

	if (rtmp & SIO_IMAXBELL) printf("imaxbell");
	else printf("-imaxbell");
	printf(" ");

	if (rtmp & SIO_IECHOTBL) printf("iechotbl");
	else printf("-iechotbl");
	printf(" ");
	
	if (rtmp & SIO_IMSG) printf("imsg");
	else printf("-imsg");
	printf("\n");

	/*
	 * cflag - nortscts, ignnodsr, ignnodcd
	 */
	rtmp = (scc_t.c_cflag << 16) & 0xFFFF0000;

	if (rtmp & SIO_NORTSCTS) printf("nortscts");
	else printf("-nortscts");
	printf(" ");

	if (rtmp & SIO_IGNNODSR) printf("ignnodsr");
	else printf("-ignnodsr");
	printf(" ");

	if (rtmp & SIO_IGNNODCD) printf("ignnodcd");
	else printf("-ignnodcd");
	printf("\n");

	/*
	 * lflag - iftoraw, iftocan
	 */
	rtmp = (scc_t.c_lflag << 16) & 0xFFFF0000;

	if (rtmp & SIO_IFTORAW) printf("iftoraw");
	else printf("-iftoraw");
	printf(" ");

	if (rtmp & SIO_IFTOCAN) printf("iftocan");
	else printf("-iftocan");
	printf("\n");

	/*
	 * oflag
	 */
	rtmp = (scc_t.c_oflag << 16) & 0xFFFF0000;
	if (rtmp & SIO_OWRAP) {
		if(ioctl(0, SCCGWRAP, &tmp) == -1) {
			perror("ioctl");
			fprintf(stderr,
		   "%s: Failed to read terminal characteristics (SCCGWRAP)\n",
								cmd);
			exit(2);
		}
		printf("owrap %d",tmp);
	}
	else
		printf("-owrap");
	printf("\n");

}

usage(all)
int all;
{
	printf("usage: scctty [ [-Vh] [speed] [modes] < /dev/tty-device ]\n");
	if (all) {
		printf("\n");
printf("options: -V  Print utility version string\n");
printf("         -h  This help message\n");
printf("options: Only one of the above options may be specified at a time\n");
		printf("\n");
printf("speeds:  r50, t50, 50, r75, t75, 75, r110, t110, 110\n");
printf("         r134, t134, 134, r150, t150, 150, r200, t200, 200\n");
printf("         r300, t300, 300, r600, t600, 600, r1200, t1200, 1200\n");
printf("         r1800, t1800, 1800, r2400, t2400, 2400, r4800, t4800, 4800\n");
printf("         r9600, t9600, 9600, r19200, t19200, 19200\n");
printf("         r38400, t38400, 38400, r134.5, t134.5, 134.5\n");
printf("         r19.2, t19.2, 19.2, r38.4, t38.4, 38.4\n");
		printf("\n");
		printf("imodes:  imax, imaxbell, iechotbl, imsg\n");
		printf("omodes:  owrap <width>\n");
		printf("cmodes:  nortscts, ignnodsr,ignnodcd\n");
		printf("lmodes:  iftoraw, iftocan\n");
	}
}

optionerr(cmd,ch)
char *cmd;
char ch;
{
	fprintf(stderr,"%s: %c - Unknown option\n",cmd,ch);
	usage(0);
}

