/*
 *                  Copyright (c) 1988 Ferranti Plc.
 *                      All Rights Reserved
 *
 *
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF FERRANTI PLC THE COPYRIGHT 
 *                   OF WHICH VESTS IN FERRANTI PLC.
 *
 *   The copyright notice above does not evidence any actual or intended 
 *                   publication of such source code.
 *
 * This source code and the information contained herein is supplied without
 * liability for errors or ommissions and no part may be copied, re-produced, 
 * used or disclosed except as authorised by the Ferranti organisation by 
 *                contract or by other written permission.
 */

/******************************************************************************

	Rev = 5.1		Date of 'get'   = 11:11:02 1/26/89
				Date of 'delta' = 14:59:06 12/8/88

	File = se_error.c

******************************************************************************/

#ident "@(#)scc-cmds_lib:cmds/se_error.c Rev 5.1 14:59:06 12/8/88"

#include <stdio.h>
#include <local/scc/scclioctl.h>
#include <local/scc/scclerr.h>

extern void exit();
extern void perror();

se_error(f,cmd)
int f;
char *cmd;
{
	int err;

	if(ioctl(f, SCCL_ERROR, &err) == -1) {
		perror("ioctl");
		fprintf(stderr,
		   "%s: Failed to read loader error word (SCCL_ERROR)\n",
								cmd);
		exit(2);
	}

	switch (err) {
	case SE_HOSTMDEFW:
		fprintf(stderr,
		"%s: Firmware status not set to HOST_MDEF within 10 seconds\n",
								cmd);
		break;
	case SE_HOSTFDEFW:
		fprintf(stderr,
		"%s: Firmware status not set to HOST_FDEF within 10 seconds\n",
								cmd);
		break;
	case SE_HOSTIDEFW:
		fprintf(stderr,
		"%s: Firmware status not set to HOST_IDEF within 10 seconds\n",
								cmd);
		break;
	case SE_LMTESTW:
		fprintf(stderr,
		"%s: Firmware status not set to LM_TEST within 10 seconds\n",
								cmd);
		break;
	case SE_LMTSTDW:
		fprintf(stderr,
		"%s: Firmware status not set to LM_TEST_DONE within 10 seconds\n",
								cmd);
		break;
	case SE_SIOREADYW:
		fprintf(stderr,
		"%s: Firmware status not set to SIO_READY within 10 seconds\n",
								cmd);
		break;
	case SE_LDINIT:
		fprintf(stderr,
		"%s: Firmware failed to complete handshake after SCCL_LDINIT command\n",
								cmd);
		break;
	case SE_INVCARD:
		fprintf(stderr,
		"%s: Card index out of range for this kernel build\n",
								cmd);
		break;
	case SE_NOCARD:
		fprintf(stderr,
		"%s: No card installed at specified card index\n",
								cmd);
		break;
	case SE_BADLDSTAT:
		fprintf(stderr,
		"%s: Incorrect status for firmware code down load\n",
								cmd);
		break;
	case SE_FWSELFTEST:
		fprintf(stderr,
		"%s: Card selftests failed to complete within 10 seconds\n",
								cmd);
		break;
	case SE_FWFATAL:
		fprintf(stderr,
		"%s: Card selftests failed with a fatal error\n",
								cmd);
		break;
	case SE_FWNOTLD:
		fprintf(stderr,
		"%s: Card is not in firmware load mode\n",
								cmd);
		break;
	case SE_FWBADSTAT:
		fprintf(stderr,
		"%s: Invalid status word returned by firmware\n",
								cmd);
		break;
	case SE_HOSTFARG1W:
		fprintf(stderr,
		"%s: Failed to complete firmware handshake to define fifos\n",
								cmd);
		break;
	default:
		fprintf(stderr,
			"%s: Error code %d has no output message\n",cmd);
		break;
	}
}
