#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"@(#)initpkg:./bcheckrc.sh	35.4"

echo "
# ***** This file has those commands necessary to check the file
# system, date, and anything else that should be done before mounting
# the file systems.


#!	chmod +x \${file}
" >bcheckrc
if u3b2
then echo "
rootfs=/dev/root
/etc/fsstat \${rootfs}  >/dev/null 2>&1

if [ \$? -ne 0 ]
then
	echo \"
	fsstat: root file system needs checking
        The root file system (\${rootfs}) is being checked automatically.\"
	/etc/fsck -y -D -b \${rootfs}
fi
" >>bcheckrc
elif [ m68k -o m88k ]
then cat 0<<!!! 1>>bcheckrc


. /etc/TIMEZONE

# **** Check date

stty sane

(IFS=\; ; set \`stty -a\` ; echo "***\n\$5 \$6 \$3 \$4\n***" )

confirm_date=0
while :
do
	# this test belongs elsewhere, but...; it is excess baggage here
	if [ -f /etc/rc2.d/S00setup ]
	then
		echo
		echo "		Default Timezone may be incorrect."
		echo "		You must login as 'setup' to change this."
		echo
	fi

	# Prompt for date only if time of day clock is invalid or 
	# date confirmation is needed.  If prompt occurs, date command
	# must be executed to ensure sync of time of day clock with
	# system time.

	/etc/cktodc
	if [ \$? -eq 0 -a \$confirm_date -eq 0 ]
	then
		break
	else
		confirm_date=1
		echo "Is the date \`date\` correct? (y or n) \c"
		read reply
		if
			[ "\$reply" = y -o "\$reply" = YS ]
		then
			dstr=\`date '+%m''%d''%H''%M''%y'\`
			date \$dstr > /dev/null
			break
		else
			echo "Enter the correct date [MMddhhmmyy]:  \c"
			read reply
			date "\$reply"
		fi
	fi
done

# Auto-check of root filesystem

rootfs=/dev/root
/etc/fsstat \${rootfs}  >/dev/null 2>&1

if [ \$? -ne 0 ]
then
	echo "
	fsstat: root file system needs checking
        The root file system (\${rootfs}) is being checked automatically."
	/etc/fsck -y -D -b \${rootfs}
fi

!!!
else echo "
trap \"\" 2

# **** Check date

while :
do
	echo \"Is the date \`date\` correct? (y or n) \\\c\"
	read reply
	if
		[ \"\$reply\" = y ]
	then
		break
	else
		echo \"Enter the correct date:  \\\c\"
		read reply
		date \"\$reply\"
	fi
done

# ***** Auto check, if necessary

while :
do
	echo \"Do you want to check the file systems? (y or n) \\\c\"
	read reply
	case \"\$reply\" in
		 y )
			;;

		n* )
			break
			;;

		* )
			echo \"Invalid input. Try again.\"
			continue
			;;
	esac
	trap \"echo Interrupt\" 2
	/etc/fsck
	trap \"\" 2
	break
done
" >>bcheckrc
fi
