/*	Copyright (c) 1987 Motorola Inc
	All Rights Reserved
		@(#)printtime.c	35.1
*/
/*********************************************************************/
/*********************************************************************/
/***                                                               ***/
/***                                                               ***/
/***  (C) Copyright  Motorola, Inc.  1985, 1986, 1987              ***/
/***  All Rights Reserved                                          ***/
/***  Motorola Confidential/Proprietary                            ***/
/***                                                               ***/
/***                                                               ***/
/***  SOFTWARE PRODUCT:  IPRO                                      ***/
/***                                                               ***/
/***                                                               ***/
/***  FUNCTION:  printtime - print the local time to the screen.   ***/
/***                                                               ***/
/***                                                               ***/
/***                                                               ***/
/***                                                               ***/
/***  ORIGINAL DATE:  November 1, 1985                             ***/
/***                                                               ***/
/***                                                               ***/
/***  ALGORITHM:                                                   ***/
/***                                                               ***/
/***     begin print_local_time                                    ***/
/***                                                               ***/
/***        print the local time to the screen                     ***/
/***                                                               ***/
/***     end print_local_time                                      ***/
/***                                                               ***/
/***                                                               ***/
/***  RETURN VALUES:  positive - local time in seconds.            ***/
/***                                                               ***/
/***                  non-positive - error.                        ***/
/***                                                               ***/
/***                                                               ***/
/***  SOURCE LOCATION:  /usr/src/cmd/ipro/prtime.c                 ***/
/***                                                               ***/
/***                                                               ***/
/*********************************************************************/
/*********************************************************************/


#include "iprodefs.h"


   LONG
printtime( verbose, mesgtype, cmdname, fsname, mesgbuf, logfp )

   BOOLEAN       verbose;
   CHARPTR       mesgtype;
   CHARPTR       cmdname;
   CHARPTR       fsname;
   CHARPTR       mesgbuf;
   FILEPTR       logfp;
{
   LONG          gmtime;
   LONG          lcltime;
   LONG          time();
   TIMEPTR       localtime();
   TIME          timercd;
   TIMEPTR       timeptr     = &timercd;
   EXTERNAL LONG timezone;

   /************************************************************/
   /************************************************************/
   /*                                                          */
   /* begin print_local_time                                   */
   /*                                                          */
   /************************************************************/

      /*********************************************************/
      /*********************************************************/
      /*                                                       */
      /* print the local time to the screen                    */
      /*                                                       */
      /*********************************************************/

   time( &gmtime );

   lcltime = gmtime;

   timeptr = localtime( &lcltime );

   sprintf( mesgbuf,
             "CURRENT TIME:                           %02d:%02d:%02d",
                 timeptr->tm_hour, timeptr->tm_min, timeptr->tm_sec );

   printmesg( verbose, INFORMATIVE, cmdname, fsname, mesgbuf, logfp );

   return( gmtime - timezone );

   /************************************************************/
   /************************************************************/
   /*                                                          */
   /* end print_local_time                                     */
   /*                                                          */
   /************************************************************/
}
