/*	@(#)sighand.c	35.1	*/
/*********************************************************************/
/*********************************************************************/
/***                                                               ***/
/***                                                               ***/
/***  (C) Copyright  Motorola, Inc.  1985, 1986, 1987              ***/
/***  All Rights Reserved                                          ***/
/***  Motorola Confidential/Proprietary                            ***/
/***                                                               ***/
/***                                                               ***/
/***  SOFTWARE PRODUCT:  IPRO                                      ***/
/***                                                               ***/
/***                                                               ***/
/***  FUNCTION:  sighand - signal handling function.               ***/
/***                                                               ***/
/***                                                               ***/
/***                                                               ***/
/***                                                               ***/
/***  ORIGINAL DATE:  November 1, 1985                             ***/
/***                                                               ***/
/***                                                               ***/
/***  ALGORITHM:                                                   ***/
/***                                                               ***/
/***     begin signal_handler                                      ***/
/***                                                               ***/
/***        reset the just caught signal if signal specified       ***/
/***                                                               ***/
/***     end signal_handler                                        ***/
/***                                                               ***/
/***                                                               ***/
/***  RETURN VALUES:  the passed-in signal.                        ***/
/***                                                               ***/
/***                                                               ***/
/***  SOURCE LOCATION:  /usr/src/cmd/ipro/sighand.c                ***/
/***                                                               ***/
/***                                                               ***/
/*********************************************************************/
/*********************************************************************/


#include "iprodefs.h"


   INT
sighand( sig )

   INT sig;
{

   /************************************************************/
   /************************************************************/
   /*                                                          */
   /* begin signal_handler                                     */
   /*                                                          */
   /************************************************************/

      /*********************************************************/
      /*********************************************************/
      /*                                                       */
      /* reset the just caught signal if signal specified      */
      /*                                                       */
      /*********************************************************/

   if ( sig EQ SIGHUP )
   {
      signal( SIGHUP, sighand );

      fprintf( stderr,
                 "%s: sighand: hangup signal caught and reset.\n",
                                                       INFORMATIVE );
   }
   else if ( sig EQ SIGINT )
   {
      signal( SIGINT, sighand );

      fprintf( stderr,
             "%s: sighand: interrupt signal caught and reset.\n",
                                                       INFORMATIVE );
   }
   else if ( sig EQ SIGQUIT )
   {
      signal( SIGQUIT, sighand );

      fprintf( stderr,
                  "%s: sighand: quit signal caught and reset.\n",
                                                       INFORMATIVE );
   }
   else if ( sig EQ SIGALRM )
   {
      signal( SIGALRM, sighand );

      fprintf( stderr,
            "%s: sighand: alarm clock signal caught and reset.\n",
                                                       INFORMATIVE );
   }
   else if ( sig EQ SIGTERM )
   {
      signal( SIGTERM, sighand );

      fprintf( stderr,
     "%s: sighand: software terminate signal caught and reset.\n",
                                                       INFORMATIVE );
   }
   else
   {
      signal( sig, SIG_DFL );

      fprintf( stderr,
           "%s: sighand: signal, %d, caught but NOT reset.\n",
                                                  INFORMATIVE, sig );
   }

   return( sig );

   /************************************************************/
   /************************************************************/
   /*                                                          */
   /* end signal_handler                                       */
   /*                                                          */
   /************************************************************/
}
