static	char ident[] = "@(#)print.c	35.2		5/23/88	Copyright MOTOROLA, INC.";
/*FH*********************** FUNCTION HEADER ***************************
**
**  FUNCTION NAME:	print()
**
**  DESCRIPTION:	Prints stats from sm_epb.
**
**  PARAMETERS:		
**
**	Input:		file		- where to print,
**
**			sm_epb 		- has the stats.
**
**	Output:		None.
**
**	Returns:	None.
**
**  COMPLEX LOCALS:
**
**  METHOD:
**
**  NOTES:
**
**********************************************************************/

#include <stdio.h>
#include <time.h>
#include <sys/c37x/ci_driver.h>
#include <sys/osi/common/types.h>
#include <sys/osi/common/selsizes.h>
#include <sys/osi/common/sm_epb.h>

#define	BLANK	 " "

VOID
print(f, sm_epb)

register FILE	 *f;
register SM_EPB	 *sm_epb;
{
	ULONG	 t;		/* Holds current time */

	/*
	**	Print header and time.
	*/

	time(&t);

	switch (sm_epb->board)
	{
		case 372:
		{
			fprintf(f, "%10sMOTOROLA MicroMAP MAC Statistics: %s\n", BLANK, ctime(&t));
			break;
		}

		case 374:
		{
			fprintf(f, "%10sMOTOROLA MicroTOP MAC Statistics: %s\n", BLANK, ctime(&t));
			break;
		}

		case 147:
		{
			fprintf(f, "%11sMOTOROLA MVME147 MAC Statistics: %s\n", BLANK, ctime(&t));
			break;
		}
	}

	/*
	**	Print MAC station address.
	*/

	fprintf(f, "%24sStation Address:  %08x%04x\n\n", BLANK, *(LONG *)sm_epb->station_addr, *(USHORT *)&sm_epb->station_addr[4]);

	/*
	**	Print MAC statistics from the sm_epb.
	*/

	switch (sm_epb->board)
	{
		case 372:
		{
			fprintf(f, "%18sTokens passed                        = %d\n", BLANK, sm_epb->mac.stats[0]);

			fprintf(f, "%18sTokens heard                         = %d\n", BLANK, sm_epb->mac.stats[1]);

			fprintf(f, "%18sTokens passed through no successor 8 = %d\n", BLANK, sm_epb->mac.stats[2]);

			fprintf(f, "%18sWho follows                          = %d\n", BLANK, sm_epb->mac.stats[3]);

			fprintf(f, "%18sToken passes that failed             = %d\n", BLANK, sm_epb->mac.stats[4]);

			fprintf(f, "%18sNon silence                          = %d\n", BLANK, sm_epb->mac.stats[5]);

			fprintf(f, "%18sFCS errors                           = %d\n", BLANK, sm_epb->mac.stats[6]);

			fprintf(f, "%18sE bit errors                         = %d\n", BLANK, sm_epb->mac.stats[7]);

			fprintf(f, "%18sFrame fragments                      = %d\n", BLANK, sm_epb->mac.stats[8]);

			fprintf(f, "%18sFrame too long                       = %d\n", BLANK, sm_epb->mac.stats[9]);

			fprintf(f, "%18sNumber of residual (FD/BD) errors    = %d\n", BLANK, sm_epb->mac.stats[10]);

			fprintf(f, "%18sOverruns                             = %d\n\n", BLANK, sm_epb->mac.stats[11]);

			fprintf(f, "%13sTransmitted frames = %d", BLANK, sm_epb->tx_ctr);

			fprintf(f, "%10sReceived frames = %d\n", BLANK, sm_epb->rx_ctr);

			break;
		}

		case 147:
		case 374:
		{
			/*
			**  Transmit related statistics.
			*/

			fprintf(f, "%6sPackets transmitted - more than one collision       = %d\n", BLANK, sm_epb->mac.stats[0]);

			fprintf(f, "%6sPackets transmitted - exactly one collision         = %d\n", BLANK, sm_epb->mac.stats[1]);

			fprintf(f, "%6sPacket transmissions deferred - channel is busy     = %d\n", BLANK, sm_epb->mac.stats[2]);

			fprintf(f, "%6sPacket transmissions aborted - lack of ownership    = %d\n", BLANK, sm_epb->mac.stats[3]);

			fprintf(f, "%6sPacket transmissions aborted - underflow error      = %d\n", BLANK, sm_epb->mac.stats[4]);

			fprintf(f, "%6sPacket transmissions aborted - late collision       = %d\n", BLANK, sm_epb->mac.stats[5]);

			fprintf(f, "%6sPacket transmissions aborted - loss of carrier      = %d\n", BLANK, sm_epb->mac.stats[6]);

			fprintf(f, "%6sPacket transmissions aborted - excessive collisions = %d\n", BLANK, sm_epb->mac.stats[7]);

			/*
			**  Receive related statistics.
			*/

			fprintf(f, "%6sPackets received - framing error                    = %d\n", BLANK, sm_epb->mac.stats[9]);

			fprintf(f, "%6sPackets received - overflow error                   = %d\n", BLANK, sm_epb->mac.stats[10]);

			fprintf(f, "%6sPackets received - CRC error                        = %d\n", BLANK, sm_epb->mac.stats[11]);

			fprintf(f, "%6sPackets received - lost due to lack of ownership    = %d\n", BLANK, sm_epb->mac.stats[12]);

			fprintf(f, "%6sPackets received - lost due to lack of buffers      = %d\n", BLANK, sm_epb->mac.stats[15]);

			/*
			**  Hardware related statistics.
			*/

			fprintf(f, "%6sTime Domain Reflectometry Counter                   = %d\n", BLANK, sm_epb->mac.stats[8]);

			fprintf(f, "%6sTransmitter timed out                               = %d\n", BLANK, sm_epb->mac.stats[13]);

			fprintf(f, "%6sTransmission transceiver test collision failed      = %d\n", BLANK, sm_epb->mac.stats[14]);

			fprintf(f, "%6sMemory addressing errors                            = %d\n\n", BLANK, sm_epb->mac.stats[16]);

			fprintf(f, "%13sTransmitted packets = %d", BLANK, sm_epb->tx_ctr);

			fprintf(f, "%10sReceived packets = %d\n", BLANK, sm_epb->rx_ctr);

			break;
		}
	}
}
