/* @(#)def.h	35.2 */

/*IH*********************** INCLUDE HEADER ****************************
**
**  INCLUDE NAME:	def.h
**
**  DESCRIPTION:	This file includes the defines for Station
**			Management Console program.
**
**  NOTES:
**
**  UPDATE LOG:
**********************************************************************/

#define	BLANK			" "

/*
**	M E N U   N A M E S
*/

#define	MAIN_MENU			'1'
#define	CONFIGURATION_MENU		'2'
#define	DIAGNOSTIC_MENU			'3'
#define	LOG_MENU			'4'
#define	TRMON_MENU			'5'
#define	SYSTEM_PARMS_MENU		'6'
#define	XPORT_PARMS_MENU		'7'
#define	LANCE_PARMS_MENU		'8'
#define	TBC_PARMS_MENU			'9'

/*
**	M E N U   S E L E C T I O N S
*/

/* Main Menu							*/

#define	NODE_RESTART			'r'
#define	CONFIGURATION_UTILITIES		'c'
#define	DIAGNOSTIC_UTILITIES		'd'

/* Configuration Utilities Menu					*/

#define	NVRAM				'1'
#define	MAC_PARMS			'2'
#define	SYSTEM_PARMS			'3'
#define	TRANSPORT_PARMS			'4'

/* Diagnostic Utilities Menu					*/

#define	MAC_STATS			'1'
#define	LOGGING				'2'
#define	TRMON				'3'

/* System Parameters Menu					*/

#define	BDB_COUNT			'1'
#define	USER_LIMIT			'2'
#define	MGMT_LIMIT			'3'
#define	NETW_LIMIT			'4'

/* Transport Parameters Menu					*/

#define	MAX_CONNECTS			'1'
#define	MIN_CREDIT			'2'
#define	MAX_CREDIT			'3'
#define	MAX_RETRIES			'4'
#define	RETRY_TICKS			'5'
#define	RETRY_TICKS_EXP			'6'
#define	WINDOW_TICKS			'7'
#define	REF_WAIT_TICKS			'8'

/*
** Log mask selections
*/

#define	HOST_LOGGING			'a'
#define	DEBUG_LOGGING			'b'
#define	SYSTEM_LOGGING			'c'
#define	MAC_LOGGING			'd'
#define	LLC_LOGGING			'e'
#define	INTERNET_LOGGING		'f'
#define	XPORT_LOGGING			'g'
#define	SESSION_LOGGING			'h'
#define	PRESENTATION_LOGGING		'i'
#define	ACSE_LOGGING			'j'
#define	FTAM_LOGGING			'k'
#define	NET_AGENT_LOGGING		'l'
#define	DIRSVS_LOGGING			'm'
#define	STA_MGR_LOGGING			'n'
#define	NO_CHANGE			'o'
#define	SET_LOG_MASK			'p'


/* MVME372 MAC/TBC Controller Menu				*/

#define	TBC_PRIORITY			'1'

/* MVME374/MVME147 MAC/LANCE Controller Menu			*/

#define	RING_SIZE			'1'
#define	LANCE_MODE			'2'
#define	STATION_ADDRESS			'3'
#define	GROUP_ADDRESS			'4'

/*
** Monitor layer traffic flow selections
*/

#define M_STRT				'1'
#define M_READ				'2'
#define M_SHOW				'3'
#define M_WRTE				'4'

/* Other Selections						*/

#define	MAIN				'm'
#define	QUIT				'q'
#define	SHELL				'!'


/*
**	L O G   M A S K  D E F I N E S
*/

#define	HOST_LOG_MASK		0x7fffffff
#define	DEBUG_LOG_MASK		0xbfffffff
#define	PRESENTATION_LOG_MASK	0xff3fffff
#define	STA_MGR_LOG_MASK	0xffcfffff
#define	DIRSVS_LOG_MASK		0xfff3ffff
#define	NET_AGENT_LOG_MASK	0xfffcffff
#define	FTAM_LOG_MASK		0xffff3fff
#define	ACSE_LOG_MASK		0xffffcfff
#define	SESSION_LOG_MASK	0xfffff3ff
#define	XPORT_LOG_MASK		0xfffffcff
#define	INTERNET_LOG_MASK	0xffffff3f
#define	LLC_LOG_MASK		0xffffffcf
#define	MAC_LOG_MASK		0xfffffff3
#define	SYSTEM_LOG_MASK		0xfffffffc

/*
** 			DEFINES USED BY DOWNLOAD FUNCTION
*/

/*
** The following is the structure used to pass parameters
** to the download function
*/

typedef struct dl_parm_blk
{
    DEFAULT	type;
    union
    {
	    struct				/* a.out download and/or exec */
	    {
		    BYTE        *file;	/* a.out file name */
		    BYTE       **xsect;	/* sections to be excluded */
		    UBYTE	exec;	/* execution flag */
		    UBYTE	load;	/* load flag */
	    } aout;

	    struct				/* execute at address */
	    {
		    ULONG	address;/* execution address */
		    ULONG	arg;	/* execution argument */
	    } addr;

	    /* This structure is not used at present since the code
	    ** for executing at a symbol is not yet in the downloader.
	    */
	    struct				/* execute symbol     */
	    {
		    BYTE       *symbol;	/* function to be executed */
		    ULONG	arg;	/* execution argument */
		    BYTE       *file;	/* a.out containing symbol */
	    } sym;
    } t;
} DL_PARM_BLK;

#define	NUM_SECT_NAMES	16

/*
** Defines used in the download parameter block.
*/

#define AOUT			1
#define ADDRESS			2
#define SYMBOL			3	/* for use when execute at symbol
					   implemented			*/

/*
**	S T A T I O N   M A N A G E R   R E G I S T R A T I O N   I D
**
**	KLUDGE  	ATTENTION	KLUDGE		ATTENTION
**
**	The Station Manager is forced to HARD CODE an id number with
**	which to register with the Common Environment because when
**	a board reset occurs the Station Manager immediately 
**	re-registers with the Common Environment.  It receives the
**	registration id = 1.  This id is hard coded into the map demon
**	because map demon needs it since this id was HARD CODED into
**	the logging function.  When map demon is activated after this,
**	station manager has its id and map demon dies.  When things are
**	properly fixed, Station Manager should be changed.
*/
#define	ID_NUM	25

/*
**		O B J E C T   F I L E S   F O R   D O W N L O A D I N G
**
**	The following files can be downloaded during a node reset.
*/

#define NETWORK_RTE_TBL	"/map/uMAP.rte"	/* network routing table file	*/
