#ident "@(#)nvram374.c	35.3"

/*MH************************ MODULE HEADER ****************************
**
**  MODULE NAME:	nvram374.c
**
**  DESCRIPTION:	This module contains code to manipulate MVME374 NVRAM.
**
**  CONTENTS: 		menu374()	menu driver
**			nvram374()	sets the field variables
**
**  SYSTEM GLOBALS:
**
**  MODULE GLOBALS:
**
**  NOTES:
**
**********************************************************************/

#include <stdio.h>
#include <curses.h>
#include <term.h>
#include <sys/c37x/ci_driver.h>
#include <sys/osi/board/mvme374.h>
#include <sys/osi/common/types.h>
#include <sys/osi/common/selsizes.h>
#include <sys/osi/common/system.h>
#include <sys/osi/common/epb.h>
#include <sys/osi/common/sm_epb.h>
#include "def.h"

/*
**	All the strings printed by MVME374 NVRAM
*/

extern	BYTE	*menu_prompt;
extern	BYTE	*field_hdr;

/*
**	Station Manager Variables
*/

extern	BOOLEAN	scold_user;

/*
**	External Functions
*/

extern	VOID	display_field();

/*
**	MVME374 NVRAM Menu
*/

BYTE *field374[] =
{
	" ",
	"     A. Station Address           ",
	"     B. Group Address Mask        "
};

/*FH*********************** FUNCTION HEADER ***************************
**
**  FUNCTION NAME:	menu374()
**
**  DESCRIPTION:	This is the menu driven function that displays
**			the MVME374 NVRAM fields.
**
**  PARAMETERS:		
**
**	Input:		none
**
**	Output:		none
**
**	Returns:	nothing
**
**  SYSTEM GLOBALS:
**
**  METHOD:
**
**  NOTES:
**
**********************************************************************/

VOID
menu374(epb)

register SM_EPB *epb;
{
	putp(tparm(clear_screen));

	fprintf(stdout, field_hdr);

	display_field(TS_ADDR, TS_ADDR_INDEX, TS_ADDR_SIZE, epb);
	display_field(GA_MASK, GA_MASK_INDEX, GA_MASK_SIZE, epb);

	fprintf(stdout, menu_prompt);
}

/*FH*********************** FUNCTION HEADER ***************************
**
**  FUNCTION NAME:	nvram374()
**
**  DESCRIPTION:	This function will set the field variables for
**			the passed menu selection value.
**
**  PARAMETERS:		
**
**	Input:		none
**
**	Output:		none
**
**	Returns:	nothing
**
**  SYSTEM GLOBALS:
**
**  METHOD:
**
**  NOTES:
**
**********************************************************************/

VOID
nvram374(l, field, field_ndx, field_len)

register BYTE	 l;
register DEFAULT *field;
register DEFAULT *field_ndx;
register DEFAULT *field_len;
{
	switch (l)
	{
		/*
		**	Station address.
		*/

		case 'a':
		case 'A':
		{
			*field     = TS_ADDR;
			*field_ndx = TS_ADDR_INDEX;
			*field_len = TS_ADDR_SIZE;

			break;
		}

		/*
		**	Group address mask.
		*/

		case 'b':
		case 'B':
		{
			*field     = GA_MASK;
			*field_ndx = GA_MASK_INDEX;
			*field_len = GA_MASK_SIZE;

			break;
		}

		default:
		{
			scold_user = TRUE;
		}
	}
}
