#ident "@(#)smc.mk	35.1"

TESTDIR = .
ROOT=
INCRT = $(ROOT)/usr/include
INSDIR = $(ROOT)/usr/bin
DFLAGS = -DCOMMON_INTERFACE
CFLAGS = -O 
LDFLAGS = -s 
INS=cpset
LIBS=-lci -lld -lcurses
RM = rm
FRC =

#
#  Macro defining C source files
#

SOURCE	=	cnfg.c			\
		diag.c			\
		init.c			\
		main.c			\
		menus.c			\
		nvram.c			\
		nvram372.c		\
		nvram374.c		\
		read.c			\
		string.c		\
		sys.c			\
		util.c

#
#  Macro defining object files
#

OBJECTS	=				\
		cnfg.o			\
		diag.o			\
		init.o			\
		main.o			\
		menus.o			\
		nvram.o			\
		nvram372.o		\
		nvram374.o		\
		read.o			\
		string.o		\
		sys.o			\
		util.o



all:	smc 

.c.o:
	$(CC) -c $(CFLAGS) $(DFLAGS) $<

smc: 	$(OBJECTS)
	$(CC) $(OBJECTS) $(LDFLAGS) $(LIBS) -o smc 

install: all
	$(INS) smc $(INSDIR) 755 bin bin

main.o:		$(INCRT)/sys/osi/common/types.h     		\
               	$(INCRT)/sys/osi/common/selsizes.h   		\
               	$(INCRT)/sys/osi/common/system.h    		\
               	$(INCRT)/sys/osi/common/epb.h    		\
               	$(INCRT)/sys/osi/common/sm_epb.h    		\
		$(INCRT)/sys/c37x/ci_driver.h		\
		$(INCRT)/stdio.h	\
		$(INCRT)/term.h	\
		$(INCRT)/curses.h	\
		def.h

init.o:		$(INCRT)/sys/osi/common/types.h		\
               	$(INCRT)/sys/osi/common/selsizes.h    		\
               	$(INCRT)/sys/osi/common/system.h    		\
               	$(INCRT)/sys/osi/common/epb.h    		\
               	$(INCRT)/sys/osi/common/sm_epb.h    		\
		$(INCRT)/sys/c37x/ci_driver.h			\
		$(INCRT)/stdio.h	\
		$(INCRT)/term.h	\
		$(INCRT)/curses.h	\
		$(INCRT)/signal.h

menus.o:	$(INCRT)/sys/osi/common/types.h		\
		$(INCRT)/sys/c37x/ci_driver.h		\
		$(INCRT)/stdio.h	\
		$(INCRT)/term.h	\
		$(INCRT)/curses.h	\
		def.h

read.o:		$(INCRT)/sys/osi/common/types.h     		\
		$(INCRT)/sys/c37x/ci_driver.h		\
		$(INCRT)/stdio.h	\
		$(INCRT)/string.h	\
		$(INCRT)/ctype.h	\
		$(INCRT)/termio.h	\
		def.h

sys.o:		$(INCRT)/sys/osi/common/types.h		\
               	$(INCRT)/sys/osi/common/selsizes.h    		\
               	$(INCRT)/sys/osi/common/system.h    		\
               	$(INCRT)/sys/osi/common/epb.h    		\
               	$(INCRT)/sys/osi/common/sm_epb.h    		\
		$(INCRT)/sys/c37x/ci_driver.h		\
		$(INCRT)/string.h	\
		$(INCRT)/stdio.h	\
		$(INCRT)/term.h	\
		$(INCRT)/curses.h	\
		$(INCRT)/errno.h	\
		def.h

cnfg.o:		$(INCRT)/sys/osi/common/types.h		\
               	$(INCRT)/sys/osi/common/selsizes.h    		\
               	$(INCRT)/sys/osi/common/system.h    		\
               	$(INCRT)/sys/osi/common/bdb.h    		\
               	$(INCRT)/sys/osi/common/epb.h    		\
               	$(INCRT)/sys/osi/common/sm_epb.h    		\
               	$(INCRT)/sys/osi/common/ma_epb.h    		\
		$(INCRT)/sys/c37x/ci_driver.h		\
		$(INCRT)/stdio.h	\
		$(INCRT)/term.h	\
		$(INCRT)/curses.h	\
		def.h

diag.o:		$(INCRT)/sys/osi/common/types.h		\
               	$(INCRT)/sys/osi/common/selsizes.h    		\
               	$(INCRT)/sys/osi/common/system.h    		\
               	$(INCRT)/sys/osi/common/epb.h    		\
               	$(INCRT)/sys/osi/common/sm_epb.h    		\
		$(INCRT)/sys/c37x/ci_driver.h		\
		$(INCRT)/stdio.h	\
		$(INCRT)/term.h	\
		$(INCRT)/curses.h	\
		$(INCRT)/ctype.h	\
		$(INCRT)/time.h	\
		def.h

util.o:		$(INCRT)/sys/osi/common/types.h		\
               	$(INCRT)/sys/osi/common/selsizes.h    		\
               	$(INCRT)/sys/osi/common/system.h    		\
               	$(INCRT)/sys/osi/common/epb.h    		\
               	$(INCRT)/sys/osi/common/sm_epb.h    		\
		$(INCRT)/sys/c37x/ci_driver.h		\
		$(INCRT)/stdio.h	\
		$(INCRT)/term.h	\
		$(INCRT)/curses.h	\
		def.h

string.o:	$(INCRT)/sys/osi/common/types.h

nvram.o:	$(INCRT)/sys/osi/common/types.h		\
               	$(INCRT)/sys/osi/common/selsizes.h    		\
               	$(INCRT)/sys/osi/common/system.h    		\
               	$(INCRT)/sys/osi/common/epb.h    		\
               	$(INCRT)/sys/osi/common/sm_epb.h    		\
		$(INCRT)/sys/osi/board/nvram.h		\
		$(INCRT)/sys/osi/board/mvme372.h		\
		$(INCRT)/sys/c37x/ci_driver.h		\
		$(INCRT)/stdio.h	\
		$(INCRT)/term.h	\
		$(INCRT)/curses.h	\
		def.h

nvram372.o:	$(INCRT)/sys/osi/common/types.h		\
               	$(INCRT)/sys/osi/common/selsizes.h    		\
               	$(INCRT)/sys/osi/common/system.h    		\
               	$(INCRT)/sys/osi/common/epb.h    		\
               	$(INCRT)/sys/osi/common/sm_epb.h    		\
		$(INCRT)/sys/osi/board/mvme372.h		\
		$(INCRT)/sys/c37x/ci_driver.h		\
		$(INCRT)/stdio.h	\
		$(INCRT)/term.h	\
		$(INCRT)/curses.h	\
		def.h

nvram374.o:	$(INCRT)/sys/osi/common/types.h		\
               	$(INCRT)/sys/osi/common/selsizes.h    		\
               	$(INCRT)/sys/osi/common/system.h    		\
               	$(INCRT)/sys/osi/common/epb.h    		\
               	$(INCRT)/sys/osi/common/sm_epb.h    		\
		$(INCRT)/sys/osi/board/mvme374.h		\
		$(INCRT)/sys/c37x/ci_driver.h		\
		$(INCRT)/stdio.h	\
		$(INCRT)/term.h	\
		$(INCRT)/curses.h	\
		def.h

clean:
		$(RM) -f $(OBJECTS)

clobber:	clean
		$(RM) -f $(TESTDIR)/smc

FRC:

