/*******************************************************************************
/
/  Copyright (c) 1988 by Motorola Computer Systems
/
/	Filter to convert ASCII text into format for output via PostScript
/	printer.  Appends begining and closing parenthesis to all lines of
/	text.  Prints 60 lines per page.
/
/	3/2/88   MCM	When a formfeed is received, set Nextline to TopStart
*/

#ident	"@(#)pstext.c	35.1"

#include	<stdio.h>

#define		TRUE	1
#define		FALSE	0

main()
{
	int	ch, i;
	int	BeginLine = TRUE;
	int	nlines = 0;
	int	nchar = 0;
	char	backs = '\\';

	fputs("/inch\n{72 mul} def \n", stdout);
	fputs("/line\n{12 mul} def\n", stdout);
	fputs("/advanceLine\n{/Nextline\nNextline LineSpace sub\ndef}\ndef\n", stdout);
	fputs("/printText \n{LeftMargin Nextline moveto\nshow}\ndef\n", stdout);
	fputs("/printLine\n{printText\nadvanceLine}\ndef\n", stdout);
	fputs("/TopStart 10.38 inch def\n", stdout);
	fputs("/LineSpace 12 def\n", stdout);
	fputs("/LeftMargin .33 inch def\n", stdout);

	fputs("/Courier findfont 12 scalefont setfont\n", stdout);
	fputs("/Nextline TopStart def\n", stdout);

	while ((ch = getc(stdin)) != EOF)
	{
		switch(ch)
		{
			case '\f':
				if (BeginLine == FALSE)
				{
					fputs(") printLine\n", stdout);
					BeginLine = TRUE;
					nchar = 0;
					++nlines;
				}
				if (nlines != 0)
				{
					nlines = 0;
					fputs("showpage\n", stdout);
					fputs("/Nextline TopStart def\n", stdout);
				}
				break;
			case '\n':
				if (BeginLine == TRUE)
				{
					putc('(', stdout);
					BeginLine = FALSE;
				}
				fputs(") printLine\n", stdout);
				BeginLine = TRUE;
				nchar = 0;
				if (++nlines >= 60)
				{
					nlines = 0;
					fputs("showpage\n", stdout);
					fputs("/Nextline TopStart def\n", stdout);
				}
				break;
			case '\r':
				break;
			case '\t':
				if (BeginLine == TRUE)
				{
					putc('(', stdout);
					BeginLine = FALSE;
				}
				for (i = 8 - (nchar & 7); i > 0; nchar++, i--)
					putc(' ', stdout);
				break;
			case '\\':
			case '(':
			case ')':
				if (BeginLine == TRUE)
				{
					putc('(', stdout);
					BeginLine = FALSE;
				}
				putc(backs, stdout);
			default:
				if (BeginLine == TRUE)
				{
					putc('(', stdout);
					BeginLine = FALSE;
				}
				putc(ch, stdout);
				++nchar;
		}
	}

	exit (0);
}
