
/*
 *		Motorola (c) 1987
 *		All Rights Reserved
 *		@(#)m323conv.c	35.2
 *
 *	Convert the volumeid and config block of R3V3 BOS to BSE
 */

#include	<stdio.h>
#include	<fcntl.h>
#include	<sys/dk.h>
#include	"r3dk.h"

#define CHAR	0x4e	/* special character */
#define USS	0x8a	/* unformatted sector size */

struct dk {
	struct volumeid vid;
	struct dkconfig config;
};

struct r3dk {
	struct r3volumeid r3vid;
	struct r3dkconfig r3config;
};

static char	*me;			/* name of program */
static char	*dev;			/* device name */
static struct	r3dk r3dkbuf;		/* old volid and config  buffer */
static struct	dk dkbuf;		/* new volid and config  buffer */

main( argc, argv )
int argc;
register char **argv;
{	int optchar;
	register arg;
	register fd;
	register struct dk *dp = &dkbuf;
	register struct r3dk *r3dp = &r3dkbuf;
	register struct dk   *r2dp;
	extern	char	*optarg;
	extern	int	optind;

	me = argv[0];
	while(( optchar = getopt( argc, argv, "" )) != EOF ) {
		switch(optchar) {
		case '?':
		default:	usage();
				break;
		}
	}
	if(( arg = optind ) == argc ) {
		fprintf( stderr,"Missing device file\n");
		usage();
	}
	dev = argv[arg];

	if(( fd = open( dev, O_RDONLY|O_NDELAY )) == -1 ) {
		fprintf( stderr,"Can't open %s\n",dev);
		exit(1);
	}
	/* read in the old (r3) dk block */
	memset(r3dp,0,sizeof(r3dkbuf));
	if( read(fd,r3dp,sizeof(struct r3dk)) == -1) {
		fprintf(stderr,"Volume id read error %s\n",dev);
		exit(1);
	}
	close(fd);
	/* check for previous conversion */
	r2dp = (struct dk *) &r3dkbuf;
	if (( r2dp->config.ios_uss != 0)
		|| r2dp->config.ios_f6[115] == CHAR)
		exit(0);
#ifdef DEBUG
	printf("%x\n",r2dp->config.ios_uss);
#endif
	/* set the new dk block  */
	memcpy(&dp->vid,&r3dp->r3vid,sizeof(struct volumeid));
	/* set the new config block  */
	dp->config.ios_atm = r3dp->r3config.ios_atm; /* Attributes Mask */
	dp->config.ios_atw = r3dp->r3config.ios_atw; /* Attributes Word */
	dp->config.ios_rec = r3dp->r3config.ios_rec; /* Logical sector size */
	dp->config.ios_rsz = r3dp->r3config.ios_rsz; /* Number of logical sectors */
	dp->config.ios_spt = r3dp->r3config.ios_spt; /* Sectors per track */
	dp->config.ios_hds = r3dp->r3config.ios_hds; /* Heads */
	dp->config.ios_trk = r3dp->r3config.ios_trk; /* Number of cylinders */
	dp->config.ios_ilv = r3dp->r3config.ios_ilv; /* Interleave factor of media */
	dp->config.ios_sof = r3dp->r3config.ios_sof; /* Spiral offset of media */
	dp->config.ios_psm = r3dp->r3config.ios_psm; /* Physical sector size */
	dp->config.ios_shn = r3dp->r3config.ios_shn; /* Starting head number of drive */
	dp->config.ios_pcom = r3dp->r3config.ios_pcom; /* Precompensation cylinder */
	dp->config.ios_sr = r3dp->r3config.ios_sr; /* Stepping rate */
	dp->config.ios_ecc = r3dp->r3config.ios_ecc; /* ECC data burst length */
	dp->config.ios_eatm = r3dp->r3config.ios_eatm; /* Extended attributes mask */
	dp->config.ios_eprm = r3dp->r3config.ios_eprm; /* Extended paramaters mask */
	dp->config.ios_eatw = r3dp->r3config.ios_eatw; /* Extended attributes word */
	dp->config.ios_gpb1 = r3dp->r3config.ios_gpb1; /* Gap byte 1 */
	dp->config.ios_gpb2 = r3dp->r3config.ios_gpb2; /* Gap byte 2 */
	dp->config.ios_gpb3 = r3dp->r3config.ios_gpb3; /* Gap byte 3 */
	dp->config.ios_gpb4 = r3dp->r3config.ios_gpb4; /* Gap byte 4 */
	dp->config.ios_ssc = r3dp->r3config.ios_ssc; /* Sector slip count */

	/* set special char to flag BSE */
	dp->config.ios_f6[115] = CHAR;

	if(( fd = open( dev, O_WRONLY|O_TRUNC|O_NDELAY )) == -1 ) {
		fprintf( stderr,"Can't open %s\n", dev );
		exit(1);
	}
	if(ioctl(fd,DKSETCFG,&dkbuf.config) == -1) {
#ifdef NOBOS
		fprintf(stderr,"Config block ioctl error.\n");
		exit(1);
#endif
	}
	if( write(fd,dp,sizeof(struct dk)) == -1) {
		fprintf(stderr,"Volume id write error \n");
		close(fd);
		exit(1);
	}
	close(fd);
}

/*
 *	usage: print out usage string
 */

usage()
{
	fprintf( stderr, "Usage: %s rawdev\n",me);
	exit(2);
}
