/*	@(#)m336ioctl.c	35.1	*/
#include "sys/param.h"
#include "sys/types.h"
#include "sys/sysmacros.h"
#include "sys/fs/s5dir.h"
#include "sys/file.h"
#include "sys/signal.h"
#include "sys/tty.h"
#include "sys/user.h"
#include "sys/errno.h"
#include "sys/termio.h"
#include "sys/conf.h"
#include "sys/sysinfo.h"
#include "sys/mvme336s.h"
#include "sys/mvme336c.h"
#include "sys/immu.h"
#include "sys/mvme336t.h"
#include <fcntl.h>

/* #define PRT */

#ifdef PRT
#define PRINTF1(a,b) printf(a,b)
#define PRINTF2(a,b,c) printf(a,b,c)
#else
#define PRINTF1(a,b) 
#define PRINTF2(a,b,c)
#endif


main(argc, argv)
int argc;
char *argv[];
{

	int stat = 0;
	unsigned char result = 0;
	int fd;
	int request;
	char *string = "status";
	char *port = 0;

	PRINTF1("argv1: %s, %d\n", argv[1]);
	PRINTF1("argv2: %s, %d\n", argv[2]);

	if(argc < 2) /* m336ioctl is only arg */
	{
		printf("m336ioctl: Not enough arguments\n");
		printf("m336ioctl [romrev] [on] [off] [status] device\n");
		exit(0);
	}
	if(argc == 2) /* m336ioctl /dev/ttya01 */
	{
		port = argv[1];
		/* status is default */
	}
	else if (argc == 3) /* m336ioctl request /dev/ttya01 */ 
	{
		string = argv[1];
		port = argv[2];
	}
	else
	{
		printf("m336ioctl: too many arguments\n");
		exit(0);
		
	}

	if(!strcmp("romrev", string))
		request = MGETROMREV;
	else  if(!strcmp("on", string))
		request = MSETHWHAND;
	else if(!strcmp("off", string))
		request = MRESETHWHAND;
	else if(!strcmp("status", string))
		request = MGETHWHAND;
	else
		request = MGETHWHAND;

	PRINTF1("string: %s\n", string);

	fd = open(port, O_RDWR);

	if(fd < 0)
	{
		printf("m336ioctl: Cannot open: %s\n", port);
		exit(0);
	}

	PRINTF2("fd: %x, request: %d\n", fd, request);

	stat = ioctl(fd, request, &result);
 
	if(stat < 0)
	{
		printf("m336ioctl: Cannot issue ioctl to: %s\n", port);
		exit(0);
	}

	if(request == MGETROMREV)
	{
		printf("m336ioctl: The ROM revision is: %d.%d\n", 
		((result & 0xf0) >> 4), (result & 0x0f));
	}
	if(request == MGETHWHAND)
	{
		printf("m336ioctl: hardware hand shake is: %s\n",
			(result ? "on" : "off"));
	}
}
