#ident	"@(#)mkcomply.c	35.3"
/*	Copyright (c) 1987 Motorola Inc
 *	All Rights Reserved
 */
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <filehdr.h>
#include <ar.h>
#include <setjmp.h>

#define BLOCK   1024
#define FAILED  (-1)

extern int Mval[];
extern void exit();
extern long strtol(), lseek();
int errcnt = 0;
int bflag = 0, cflag = 0, fflag = 0, lflag = 0, vflag = 0;
char usage[] = "usage: %s [-bclv] [<file>]\n", *argv0;
FILE *fp;
char sowner[6], sgroup[6], smode[7], sdevice[5], slinks[4], ssize[9],
    scheck[5], sname[512];

main (argc, argv)
int argc;
char *argv[];
{
	struct stat stbuf;
	extern int check_sum();
	int doscan();
	register int owner, group, mode, device, link, check;
	register long size;
	int type, check2;
	char *curargv, c, *bom, *strptr;

	argv0 = *argv++;
	while ( --argc ) {
		curargv = *argv++;
		if ( *curargv == '-' ) {
			if ( *(++curargv) == '\0' ) {
				fprintf ( stderr, usage, argv0 );
				return ( 1 );
			}
			while ( ( c = *curargv++ ) != '\0' ) {
				if ( c == 'b' )
					bflag++;
				else if ( c == 'c' )
					cflag++;
				else if ( c == 'l' )
					lflag++;
				else if ( c == 'v' )
					vflag++;
				else {
					fprintf ( stderr, usage, argv0 );
					return ( 1 );
				}
			}
		}
		else {
			bom = curargv;
			fflag++;
		}
	}
	if ( bflag > 1 || cflag > 1 || fflag > 1 || lflag > 1 || vflag > 1 ) {
		fprintf ( stderr, usage, argv0 );
		return ( 1 );
	}
	if ( fflag ) {
		if ( ( fp = fopen ( bom, "r" ) ) == NULL ) {
			fprintf ( stderr, "%s: can't open \"%s\"\n",
			    argv0, bom );
			return ( 1 );
		}
	}
	else {
		fp = stdin;
	}

	while ( doscan() != EOF ) {
		if ( stat ( sname, &stbuf ) == -1 ) {
			fprintf ( stderr, "%s: can't stat %s\n",
			    argv0, sname );
			errcnt++;
			continue;
		}
		if ( bflag ) {
			if ( ( type = stbuf.st_mode & 0170000 ) == 0100000 ||
		     	    type == 0 ) {
				size = stbuf.st_size;
				check = check_sum ( sname );
			}
			else {
				size = 0;
				check = 0;
			}
			fprintf ( stdout,
			    "%5d %3d %6.6o %4.4x %3d %7d %4.4x %s\n",
			    stbuf.st_uid,
			    stbuf.st_gid,
			    stbuf.st_mode,
			    stbuf.st_rdev & 0xffff,
			    stbuf.st_nlink,
			    size,
			    check,
			    sname );
			continue;
		}
		if ( vflag ) {
			puts ( sname );
		}
		owner = (int) strtol ( sowner , &strptr, 10 );
		if ( strptr == sowner || *strptr != '\0' ) {
			fprintf ( stderr,
			    "%s: can't convert owner field %s\n",
			    argv0, sowner );
			errcnt++;
			continue;
		}
		group = (int) strtol ( sgroup , &strptr, 10 );
		if ( strptr == sgroup || *strptr != '\0' ) {
			fprintf ( stderr,
			    "%s: can't convert group field %s\n",
			    argv0, sgroup );
			errcnt++;
			continue;
		}
		mode = (int) strtol ( smode, &strptr, 8 );
		if ( strptr == smode || *strptr != '\0' ) {
			fprintf ( stderr,
			    "%s: can't convert mode field %s\n",
			    argv0, smode );
			errcnt++;
			continue;
		}
		if ( cflag ) {
			/*
 			 * Reset all owners, groups, modes
 			 */
			if ( ( ( (ushort) owner != stbuf.st_uid ) ||
			       ( (ushort) group != stbuf.st_gid ) ) &&
			     ( chown ( sname, owner, group ) == -1 ) ) {
				fprintf ( stderr, "%s: can't chown %s\n",
				    argv0, sname );
				errcnt++;
			} else if ( ( (ushort) mode != stbuf.st_mode ) &&
			            ( chmod ( sname, mode & 07777 ) == -1 ) ) {
				fprintf ( stderr, "%s: can't chmod %s\n",
				    argv0, sname );
				errcnt++;
			}
			continue;
		}
		if ( ( type = stbuf.st_mode & 0170000 ) == 020000 ||
		     type == 060000 ) {
			device = (int) strtol ( sdevice, &strptr, 16 );
			if ( strptr == sdevice || *strptr != '\0' ) {
				fprintf ( stderr,
				    "%s: can't convert device field %s\n",
				    argv0, sdevice );
				errcnt++;
				continue;
			}
		}
		else {
			device = stbuf.st_rdev & 07777;
		}
		link = (int) strtol ( slinks, &strptr, 10 );
		if ( strptr == slinks || *strptr != '\0' ) {
			fprintf ( stderr,
			    "%s: can't convert link field %s\n",
			    argv0, slinks );
			errcnt++;
			continue;
		}
		if ( type == 0100000 || type == 0 ) {
			size = strtol ( ssize, &strptr, 10 );
			if ( strptr == ssize || *strptr != '\0' ) {
				fprintf ( stderr,
				    "%s: can't convert size field %s\n",
				    argv0, ssize );
				errcnt++;
				continue;
			}
			check = check_sum ( sname );
			check2 = (int) strtol ( scheck, &strptr, 16 );
			if ( strptr == scheck || *strptr != '\0' ) {
				fprintf ( stderr,
				    "%s: can't convert checksum field %s\n",
				    argv0, scheck );
				errcnt++;
				continue;
			}
		}
		else {
			size = stbuf.st_size;
			check = 0;
			check2 = 0;
		}

		if ( (ushort) owner != stbuf.st_uid ) {
			fprintf ( stderr,
			    "%s: owner is %d, expected %d\n",
			    sname, stbuf.st_uid, owner );
			errcnt++;
		}
		if ( (ushort) group != stbuf.st_gid ) {
			fprintf ( stderr,
			    "%s: group is %d, expected %d\n",
			    sname, stbuf.st_gid, group );
			errcnt++;
		}
		if ( (ushort) mode != stbuf.st_mode ) {
			fprintf ( stderr,
			    "%s: mode is %06o, expected %06o\n",
			    sname, stbuf.st_mode, mode );
			errcnt++;
		}
		if ( type == 020000 || type == 060000 ) {
			if ( (ushort) device != stbuf.st_rdev ) {
				fprintf ( stderr,
				    "%s: device is %04x, expected %04x\n",
				    sname, stbuf.st_rdev, device );
				errcnt++;
			}
		}
		if (lflag && (short) link != stbuf.st_nlink ) {
			fprintf ( stderr,
			    "%s: link count is %d, expected %d\n",
			    sname, stbuf.st_nlink, link );
			errcnt++;
		}
		if ( size != stbuf.st_size ) {
			fprintf ( stderr,
			    "%s: size is %d, expected %d\n",
			    sname, stbuf.st_size, size );
			errcnt++;
		}
		if ( check != check2 ) {
			fprintf ( stderr,
			    "%s: check is %04x, expected %04x\n",
			    sname, check, check2 );
			errcnt++;
		}
	}
	return ( errcnt );
}

int
doscan ()
{
	if ( bflag ) {
		return ( fscanf ( fp, "%s", sname ) );
	}
	else {
		return ( fscanf ( fp, "%s%s%s%s%s%s%s%s", sowner,
		    sgroup, smode, sdevice, slinks, ssize, scheck,
		    sname ) );
		}
}
