
/*
 *	Copyright (c)  Motorola Inc.  1986,1987
 *	All rights Reserved
 */

char	ident[] = "@(#)chk.c	35.1 created: 8/24/88";

#include	<errno.h>
#include	<mnt.h>
#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/stat.h>

#define EBUG
#undef  EBUG

static	char	*chkpgm = "/etc/fsck";
static	char	*argv0;
static	struct	stat stbuf;

main( argc, argv )
register int	argc;
register char	*argv[];
{	register arg;
	register i;
	register c;
	register yflag = 0;	/*  trying for read/write execution	    */
	char *argt[ARG_CNT];	/*  argv for the exec			    */
	register int arg_cnt;	/*  argc for the exec			    */
	struct usrdev  disk;	/*  Information on the disk to format       */
	int getperms();		/*  Function to read the PERMS_FILE         */

	argv0 = argv[0];

	arg_cnt = 0;			/*  Set argt[0] */
	argt[arg_cnt++] = chkpgm;

	for(c = 1; c < argc ; c++){	/* copy arguments */
		if(strcmp("-?",argv[c]) == 0)
			usage();
		if(strcmp("-y",argv[c]) == 0) {
			if(yflag)	/* only one -y allowed */
				continue;
			yflag = c; 
		}
		argt[arg_cnt++] = argv[c];
	}

	if  ( argc == 1 ) 
		strcpy( disk.alias, DEFAULT );
	else {
		strcpy( disk.alias, argv[c-1] );
		argt[--arg_cnt] = NULL;	/* remove alias name */
	}

	if  ( getperms( &disk )  ) {
		fprintf( stderr, "Restricted device or Unknown alias\n" );
		errno = EINVAL;
		usage();
	}

#ifdef	EBUG
	fprintf( stderr, "%s: Found the following device\n", argv[0] );
	fprintf( stderr, "slice	=  %s\n",  disk.slice );
	fprintf( stderr, "alias	=  %s\n",  disk.alias );
	fprintf( stderr, "fsize	=  %s\n",  disk.fsize );
	fprintf( stderr, "modes	=  %s\n",  disk.modes );
	fprintf( stderr, "pgm	=  %s\n",  disk.pgm );
#endif

	if (  ckmode( &disk, 'W' ) )  {
		if (  ckmode( &disk, 'R' ) )  {
			fprintf( stderr,
			"%s does not have check permissions\n", disk.alias );
			exit( EACCES );
		}
		if( yflag )		/* force nowrite flag */
			argt[yflag] = "-n";
		else
			argt[arg_cnt++] = "-n";
	}


	strins( disk.slice, "/dev/dsk/", 0 );
	if ( stat( disk.slice, &stbuf )  == -1 ) {
		fprintf( stderr, "%s: %s does not exist\n", argv0, disk.slice );
		exit( errno );
	}

	argt[arg_cnt++]  =  disk.slice;

	argt[arg_cnt] = NULL;             /* The execvp expects a null terminated list. */

#ifdef  EBUG
	fprintf( stderr, "Arguments for exec to %s are:\n", argt[0] );
	for ( i = 0 ;  i < arg_cnt   ;  i++ )
		fprintf( stderr,  " argt[%d]  =  %s\n", i, argt[i] );
#endif
 

	/*	
	 *	Set the real user id to root.  This is needed as the
	 *	dinit command executes the access(2) routine several
	 *	times which uses the real user id.
	 */

	if  (  setuid( ROOT )  == -1 ) {
		fprintf( stderr, "Could not set real user id to root\n" );
		exit( errno );
	}

	/*	Perform the actual format */

	execvp( chkpgm, argt );
	fprintf( stderr, "%s:  Exec to %s failed\n", argv0, argt[0] );
	exit( errno );
}

usage()
{
	fprintf(stderr,"Usage: %s [[ -y -n -sX -SX -t file -q -D alias] |  [alias]]\n",argv0);
	exit(errno);
}

