
/*
 *	Copyright (c)  Motorola Inc.  1986,1987
 *	All rights Reserved
 */

char	ident[] = "@(#)dcpy.c	35.1		created: 8/24/88";

#include	<errno.h>
#include	<mnt.h>
#include	<stdio.h>

#define		USAGE	"Usage:  %s  from  to\n", argv[0]

main(argc, argv)
register char **argv;
{
	struct   usrdev   indev;	/*  Info about the disk to be READ    */
	struct   usrdev   outdev;	/*  Info about the disk to be WRITTEN */
	int	getperms();		/*  Function to read the PERMS_FILE   */
	register int	Fsize;		/*  Size of output file sys - 1k blks */
  


	if ( argc != 1 )
		if ( strcmp( argv[1], "-?" )  == 0 ) {
			fprintf( stderr, USAGE );
			exit( EINVAL );
		}

	/*
	 *	If the wrong number of arguments is given then
	 *	report the error and exit.
	 */
	if (  argc != 3 ) {
		fprintf( stderr, USAGE );
		exit( EINVAL );
	}

	/*
	 *	Determine the input device, and see if it is readable
	 */
	strcpy( indev.alias, argv[1] );
	getperms( &indev );
	if ( ckmode( &indev, 'R' ) ) {
		fprintf(  stderr, "No read permission on input file.\n" );
		exit( EACCES );
	}  
	strins( indev.slice, "r", 5 );	/* Make input a raw device */
#ifdef EBUG
	printf( "input file arg: %s\n", indev.slice );
#endif

	/*
	 *	Determine the output device, and see if it is writable
	 */
	strcpy( outdev.alias, argv[2] );
	getperms( &outdev );
	if ( ckmode( &outdev, 'W' ) ) {
		fprintf(  stderr, "No write permission on output file.\n" );
		exit( EACCES );
	}  
#ifdef EBUG
       printf( "output file arg: %s\n", outdev.slice );
#endif

	/*
	 *	Make the output filesystem the same size as that given
	 *	by the fsize parameter.  Remember dcopy uses 1k blocks.
	 */
	Fsize = getnum( outdev.fsize ) /  2;
	sprintf( outdev.fsize, "-f%d", Fsize );
	execl( "/etc/dcopy", "dcopy", outdev.fsize, indev.slice, outdev.slice, 0 );
	fprintf( stderr, "Failed to exec dcopy \n" );
	exit( errno );
}
