
/*
 *	Copyright (c)  Motorola Inc.  1986,1987
 *	All rights Reserved
 */

char	ident[] = "@(#)fmt.c	35.1		created: 8/24/88";

#include	<errno.h>
#include	<mnt.h>
#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/stat.h>

#define	USAGE	"Usage %s:  The same options as dinit\n", argv[0]

main( argc, argv )
register int	argc;
register char	*argv[];
{
	struct usrdev  disk;	/*  Information on the disk to format        */
	int getperms();		/*  Function to read the PERMS_FILE          */
	register int flag = 1;	/*  if format device is not given set to 0   */
	register char *options;	/*  Pointer into options from PERMS_FILE     */
	register char *sp;	/*  string pointer			     */
	char *argt[ARG_CNT];	/*  argv for the exec			     */
	register int arg_cnt;	/*  argc for the exec			     */
	register int c;		/*  A scan char for getopt	             */
	int	getopt();	/*  Need to sift options for device          */
	char	*strpbrk();
	register  int   i;	/*  Loop counter                    */
	static struct stat stbuf;
	char buff[10];



	if ( argc != 1 )
		if ( (strcmp( argv[1], "-?" )  == 0)  ||  argc > 2 ) {
			fprintf( stderr, USAGE );
			exit( EINVAL );
		}

	if  ( argc == 2 )
		strcpy( disk.alias, argv[1] );
	else {
		strcpy( disk.alias, DEFAULT );
		flag=0;
	}

	if  ( getperms( &disk )  ) {
		fprintf( stderr, "Restricted device or Unknown alias\n" );
		exit( EINVAL );
	}

#ifdef	EBUG
	fprintf( stderr, "%s: Found the following device\n", argv[0] );
	fprintf( stderr, "slice	=  %s\n",  disk.slice );
	fprintf( stderr, "alias	=  %s\n",  disk.alias );
	fprintf( stderr, "fsize	=  %s\n",  disk.fsize );
	fprintf( stderr, "modes	=  %s\n",  disk.modes );
	fprintf( stderr, "pgm	=  %s\n",  disk.pgm );
#endif

	if  ( ckmode( &disk, 'F' ) ) {
		fprintf( stderr, "%s does not have format permissions\n", disk.alias );
		exit( EACCES );
	}



	/*
	 *		Set up the argt[] array.
	 *
	 *	This is done by finding where each word
	 *	(options) starts in the disk.pgm string and
	 *	changing all of the spaces to nulls.  This
	 *	transforms each space seperated word in the
	 *	disk.pgm string, to null terminated options.
	 *	Each of which is pointed at a pointer in argt.
	 */

	arg_cnt = 0;			/*  Set argt[0] */
	argt[arg_cnt++] = disk.pgm;

	options = disk.pgm ;		/*  Get the rest of the options */
	while ( (options = strpbrk( options, SPC_TAB ))  != NULL ) {
		options[0]='\0';
		argt[arg_cnt++] = ++options;
	}
	sp = &disk.slice[strlen(disk.slice) - 1];
	while(*sp >= '0' && *sp <= '9')
		sp--;
	*++sp = NULL;
	if((i = gslice(&disk,'F')) == 0) {
		*sp++ = FMT;		/* default slice */
		*sp = NULL;
	} else {
		sprintf(buff,"%d",i);
		strcat(disk.slice,buff);
	}
	
	strins( disk.slice, "/dev/rdsk/", 0 );
	if ( stat( disk.slice, &stbuf )  == -1 ) {
		fprintf( stderr, "fmt error: %s does not exist\n", disk.slice );
		exit( errno );
	}

	if ( (stbuf.st_mode & S_IFMT) != S_IFCHR ) {
		fprintf( stderr, "fmt error: %s is not a character device.\n", disk.slice );
		exit( ENOTTY );
	}
	argt[arg_cnt++]  =  disk.slice;

	argt[arg_cnt] = NULL;             /* The execvp expects a null terminated list. */

#ifdef  EBUG
	fprintf( stderr, "Arguments for exec to %s are:\n", argt[0] );
	for ( i = 0 ;  i < arg_cnt   ;  i++ )
		fprintf( stderr,  " argt[%d]  =  %s\n", i, argt[i] );
#endif
 


	/*	
	 *	Set the real user id to root.  This is needed as the
	 *	dinit command executes the access(2) routine several
	 *	times which uses the real user id.
	 */

	if  (  setuid( ROOT )  == -1 ) {
		fprintf( stderr, "Could not set real user id to root\n" );
		exit( errno );
	}

	/*	Perform the actual format */

	printf( "Formatting %s with %s\n", disk.alias,disk.pgm );
	execvp( disk.pgm, argt );
	fprintf( stderr, "%s:  Exec to %s failed\n", argv[0], argt[0] );
	exit( errno );
}
