
/*
 *	Copyright (c)  Motorola Inc.  1986,1987
 *	All rights Reserved
 */

static char	sccs[] = "@(#)fs.c	35.1		created: 8/24/88";

#include	<errno.h>
#include	<mnt.h>
#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/stat.h>

#define		USAGE	"Usage:  %s  [ dev  [ blocks[:inodes] ] ]\n", argv[0]

main( argc, argv )
register int argc;
register char *argv[];
{
	struct  usrdev  disk;		/*  Information on the disk         */
	int	getperms();		/*  Function to read the PERMS_FILE */
	register fsize;			/*  Size of requested file system   */
	register char *inodes;		/*  The number of inodes requested  */
	register char *colon_pt;	/*  Pointer : int disk.fsize	    */
	char *strchr();
	static struct	stat stbuf;



	if ( argc != 1 )
		if ( strcmp( argv[1], "-?" )  == 0 ) {
			fprintf( stderr, USAGE );
			exit( EINVAL );
		}

	if  ( argc > 3  )	/* If to many args */ {
		fprintf( stderr, USAGE );
		exit( EINVAL );
	}

	if  ( argc > 1 )	/*  If the device was given */
		strcpy( disk.alias, argv[1] );
	else
		strcpy( disk.alias, DEFAULT );

	if  ( getperms( &disk )  ) {
		fprintf( stderr, "Restricted device or Unknown alias\n" );
		exit( ENOENT );
	}

#ifdef	EBUG
	fprintf( stderr, "%s: Found the following device.\n", argv[0] );
	fprintf( stderr, "	slice	=  %s\n",  disk.slice );
	fprintf( stderr, "	alias	=  %s\n",  disk.alias );
	fprintf( stderr, "	fsize	=  %s\n",  disk.fsize );
	fprintf( stderr, "	modes	=  %s\n",  disk.modes );
	fprintf( stderr, "	mnt dir	=  %s\n",  disk.mnt_pt );
	fprintf( stderr, "	pgm	=  %s\n",  disk.pgm );
#endif

	if  ( ckmode( &disk, 'M' ) ) {
		fprintf( stderr,  "%s error: %s does not have permission to build a file system\n", argv[0], disk.alias );
		exit ( EACCES );
	}

	strins( disk.slice, "/dev/dsk/", 0 );	/* Build the block device */
	if (  stat( disk.slice, &stbuf )  == -1 ) {
		fprintf( stderr, "%s error: %s does not exist\n", argv[0], disk.slice );
		exit( errno );
	}
	if ( (stbuf.st_mode & S_IFMT) != S_IFBLK ) {
		fprintf( stderr, "%s error:  %s is not a block device.\n", argv[0], disk.slice );
		exit( ENOTBLK );
	}



	/*	
	 *	If the number of blocks are given, determine if this is
	 *	greater than the Maximum allowable size. 
	 *	If so exit, else use the number asked for.
	 */

	if  ( argc == 3 ) {
		if ( strncmp(argv[2], "-", 1)  == 0 ) {
			fprintf( stderr, "%s: %s file system size must be positive\n", argv[0], disk.alias );
			exit( EINVAL );
		}
		if ( (fsize = getnum( argv[2] )) > getnum( disk.fsize ) ) {
			fprintf( stderr, "%s: %s supports a max file system size of %d\n", argv[0], disk.alias, getnum(disk.fsize)  );
			exit( EINVAL );
		}
		if ( fsize > 0 )
			strcpy( disk.fsize, argv[2] );
		else
			if (  (colon_pt = strchr( disk.fsize, ':' )) == NULL )
				strcat( disk.fsize, argv[2] );
			else
				strcpy( colon_pt, argv[2] );
	}

	printf( "Executing  mkfs %s=%s  %s\n", disk.alias, disk.slice, disk.fsize );
	execl( "/etc/mkfs", "mkfs", disk.slice, disk.fsize, 0  );
	fprintf( stderr, "%s:  Exec failed\n", argv[0] );
	exit( errno );
}
