
/*
 *	Copyright (c)  Motorola Inc.  1986,1987
 *	All rights Reserved
 */

static char	sccs[] = "@(#)mnt.c	35.1		created: 8/24/88";

#include	<errno.h>
#include	<mnt.h>
#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/stat.h>

#define	USAGE	"Usage:\t%s [ -123abflr -d alias ] [ dev [ dir ]]\n"

main( argc, argv )
register argc;
register char *argv[];
{
	register struct	mnt_que	*mptr;
	register struct	mnt_que	**tbl;
	register struct	mnt_que	**tbl_b;
	static struct	stat stbuf;

	struct	usrdev	disk;		/*  Info on the requested disk.	*/
	char	mntpt[PATH_SZ];		/*  The directory mount point	*/
	register readonly  = 0;		/*  If 1 then mount readonly	*/
	register cpid;			/*  fork returns Child's pid	*/
	register c;			/*  Loop control		*/
	register n = 0;			/*  Number qued			*/
	int wait_stat;			/*  Status of terminating child	*/
	int	ret_val = 0;
	int	oflg = 0;		/*  If non-zero some option specifing the device(s) to be mounted was given */

	int	getperms();
	int	gdevs();
	char	*gdir();
	int	cmpstr();

	extern	struct	mnt_que	*mnt_head;
	extern	struct	mnt_que	*mnt_tail;
	extern	char	*optarg;
	extern	int	optind;



	while ( (c = getopt(argc, argv, "123abd:flr")) != EOF )
		switch (c)	{
			case '1':	oflg++;
					n = n + gdevs( '1' ); 
					break;
			case '2':	oflg++;
					n = n + gdevs( '2' ); 
					break;
			case '3':	oflg++;
					n = n + gdevs( '3' ); 
					break;
			case 'a':	oflg++;
					n = n + gdevs( 'a' ); 
					break;
			case 'b':	oflg++;
					n = n + gdevs( 'b' ); 
					break;
			case 'd':	oflg++;
					strcpy( disk.alias, optarg );
					if ( argc == optind || argv[optind][0] == '-' ) n = n + addq( disk.alias, gdir(disk.alias, disk.mnt_pt) );
					else	 n = n + addq( disk.alias, argv[optind++] );
					break;
			case 'f':	oflg++;
					strcpy( disk.alias, DEFAULT );
					if ( argc == optind || argv[optind][0] == '-' ) n = n + addq( disk.alias, gdir(disk.alias, disk.mnt_pt) );
					else	 n = n + addq( disk.alias, argv[optind++] );
					break;
			case 'l':	oflg++;
					while ( argv[optind][0] != '-' && argc > optind ) {
						strcpy( disk.alias, argv[optind++] );
						n = n + addq( disk.alias, gdir(disk.alias, disk.mnt_pt) );
					}
					break;
			case 'r':	readonly++;
					break;
			case '?':	
					fprintf( stderr, USAGE, argv[0], argv[0] );
					exit( EINVAL );
					break;
		}
	/*
	 *	If there were no devices specified by options OR
	 *	there are more command arguements to process.
	 */
	if ( !oflg || ( argc > optind )) { 
		if  ( argc > (optind + 2) ) {	/*  More than one device given */
		    fprintf( stderr, "%s: More than one device given.  Try -l or -d  \n", argv[0] );
		    exit( EINVAL );
		}
		/*
		 *	If the device was not specified use DEFAULT.
		 *	If the dir was not given use NULL, and calculate 
		 *	later in getperms
		 */
		strcpy( disk.alias, ((argc!=optind) ? argv[optind++]:DEFAULT));
		n = n + addq( disk.alias, ((argc != (optind+1)) ? gdir(disk.alias, disk.mnt_pt) : argv[optind++] ));
	}
		
	if  ( !( tbl = (struct mnt_que **)malloc( (unsigned)(n*sizeof( struct mnt_que)))))   {
	    fprintf( stderr, "%s: Could not allocate space for the sort\n", argv[0] );
	    exit( errno );
	}
#ifdef	TRACEQ
	printf( "tbl is %x\n", tbl );
#endif
	tbl_b = tbl;
	if  ( (mptr = mnt_head)  != NULL ) 
		do {
		    *tbl = (struct mnt_que *)mptr;
		    tbl++;
		    mptr = mptr->m_next;
		} while  ( mptr != NULL );
	qsort( (char *)tbl_b, n, sizeof(struct mnt_que *), cmpstr);



	while ( n ) {	/*  While there are still devices to be mounted */
#ifdef	TRACEQ
		prstruct( *tbl_b );
#endif
		strcpy( disk.alias, (*tbl_b)->m_dev );
		strcpy( mntpt, (*tbl_b)->m_dir );

		if  ( getperms( &disk )  ) {
			fprintf( stderr, "mnt error:  %s is an unknown device or alias\n", (*tbl_b)->m_dev );
			ret_val = ENOENT;
			tbl_b++; 	/*  Get ready to do the next device */
			n--;
			continue;
		}
#ifdef	EBUG
		fprintf( stderr, "  %s: Found the following device.\n", argv[0] );
		fprintf( stderr, "	slice	=  %s\n",  disk.slice );
		fprintf( stderr, "	alias	=  %s\n",  disk.alias );
		fprintf( stderr, "	fsize	=  %s\n",  disk.fsize );
		fprintf( stderr, "	modes	=  %s\n",  disk.modes );
		fprintf( stderr, "	mnt_pt	=  %s\n",  disk.mnt_pt );
		fprintf( stderr, "	pgm	=  %s\n",  disk.pgm );
#endif

		strins( disk.slice, "/dev/dsk/", 0 );	/* build the block device */
		if (  stat( disk.slice, &stbuf )  == -1 ) {
			fprintf( stderr, "mnt error: %s does not exist\n", disk.slice );
			ret_val = errno ;
			tbl_b++; 	/*  Get ready to do the next device */
			n--;
			continue;
		}
		if ( (stbuf.st_mode & S_IFMT) != S_IFBLK ) {
			fprintf( stderr, "mnt error:  %s is not a block device.\n", disk.slice );
			ret_val = ENOTBLK;
			tbl_b++; 	/*  Get ready to do the next device */
			n--;
			continue;
		}

		if (  ckmode( &disk, 'W' )  &&  ckmode( &disk, 'R' )  )  {
			fprintf( stderr, "mnt error: %s does not have mount permission\n", disk.slice );
			ret_val = EACCES;
			tbl_b++; 	/*  Get ready to do the next device */
			n--;
			continue;
		}

		/*   
		 *   If the user asked for readonly or the device does NOT have write 
		 *   permission then mount it readonly  ( -r ), Else mount it r/w
		 */

		readonly = readonly  ||  ckmode( &disk, 'W' );
		printf( "Mounting  %s  as  %s %s\n", (*tbl_b)->m_dev, mntpt, 
			readonly? "readonly":"" );
		if ( (cpid = fork()) == -1 ) {
			fprintf( stderr, "%s: Fork failed\n", argv[0] );
			exit( errno );
		}
		if ( !cpid )  {
			execl( "/etc/mount", "mount", disk.slice, mntpt, readonly? "-r":0, 0 );
			fprintf( stderr, "%s:  Exec failed\n", argv[0] );
			exit( errno );
		}
#ifdef EBUG
		fprintf( stderr, "%s:  Waiting for child, pid=%d\n", argv[0], cpid );
#endif
		if ( wait(&wait_stat) != cpid ) { /* wait failed or wrong child returned */
			fprintf( stderr, "%s:  WARNING: %s may not be mounted\n", argv[0], (*tbl_b)->m_dev );
			ret_val = errno;
			tbl_b++; 	/*  Get ready to do the next device */
			n--;
			continue;
		}
#ifdef EBUG
		fprintf( stderr, "%s:  Child returned.\n", argv[0] );
#endif
		if ( wait_stat & 0xff ) {		/* if child did not exit */
			fprintf( stderr, "%s:  WARNING caught a signal.  %s may not be mounted\n", argv[0], (*tbl_b)->m_dev );
			ret_val = ECHILD;
			tbl_b++; 	/*  Get ready to do the next device */
			n--;
			continue;
		}
		if ( (wait_stat>>8) ) {
			fprintf( stderr, "%s:  WARNING %s may not be mounted.\n", argv[0], (*tbl_b)->m_dev );
			ret_val = ( wait_stat>>8 );
			tbl_b++; 	/*  Get ready to do the next device */
			n--;
			continue;
		}
	 tbl_b++; 	/*  Get ready to do the next device */
	 n--;

	}
	exit( ret_val );
}


cmpstr( p1, p2 )
register struct mnt_que **p1, **p2;
{
#ifdef	TRACES
	printf( "Comparing %s and %s\n", (*p1)->m_dir, (*p2)->m_dir );
#endif
	return(strcmp( (*p1)->m_dir, (*p2)->m_dir ));
}
