
/*
 *	Copyright (c)  Motorola Inc.  1986,1987
 *	All rights Reserved
 */

char	ident[] = "@(#)tt.c	35.1		created: 8/24/88";

#include	<errno.h>
#include	<mnt.h>
#include	<stdio.h>

#define		USAGE	"Usage  %s if=  of=  [ bs= ]  [ count= ]\n", argv[0]

main(argc, argv)
register char **argv;
{
	struct   usrdev indev;	/*  Infor about the disk to be READ	*/
	struct   usrdev outdev;	/*  Infor about the disk to be WRITTEN	*/
	int	getperms();	/*  Function to read the PERMS_FILE	*/
	register char *bsize;	/*  The block size of transfer.		*/
	register char *bcount;	/*  Number of transfers.		*/
	register int tsize =  1;/*  Number of 512-byte blks transferred	*/
	register int i;
  
	if ( argc != 1 )
		if ( strcmp( argv[1], "-?" )  == 0 ) {
			fprintf( stderr, USAGE );
			exit( EINVAL );
		}

	if ( argc != 5 ) {
		fprintf( stderr, USAGE );
		exit( EINVAL );
	}



	for ( i = 1; i < argc; i++ ) {
		if  ( strncmp( argv[i], "if=", 3 )  == 0 ) {
			strcpy( indev.alias, (argv[i]+3) );
			getperms( &indev );
			if ( ckmode( &indev, 'R' ) ) {
				fprintf(  stderr, "No read permission on input file.\n" );
				exit( EACCES );
			}  
			strins( indev.slice, "if=", 0 ); /* Make if= a raw dev */
			strins( indev.slice, "r", 8 );
#ifdef EBUG
			printf( "input file arg: %s\n", indev.slice );
#endif
			continue;
		}
		if  ( strncmp( argv[i], "of=", 3 )  == 0 ) {
			strcpy( outdev.alias, (argv[i]+3) );
			getperms( &outdev );
			if ( ckmode( &outdev, 'W' ) ) {
				fprintf(  stderr, "No write permission on output file.\n" );
				exit( EACCES );
			}  
			strins( outdev.slice, "of=", 0 ); /* Make of= a raw dev */
			strins( outdev.slice, "r", 8 );
#ifdef EBUG
			printf( "output file arg: %s\n", outdev.slice );
#endif
			continue;
		}
		if  ( strncmp( argv[i], "bs=", 3 )  == 0 ) {
			bsize = argv[i];
			tsize *= getnum( bsize );	/* Multiply transfer count by transfer block size and   */
			tsize /= BS;			/*  Divide out physical block size  */
							/*  gives the number of physical blocks transferred */
#ifdef EBUG
			printf( "block size arg: %s\n", bsize );
#endif
			continue;
		}
		if  ( strncmp( argv[i], "count=", 6 )  == 0 ) {
			bcount = argv[i];
			tsize *= getnum( bcount );
#ifdef EBUG
			printf( "count arg: %s\n", bcount );
#endif
			continue;
		}
		fprintf(stderr,"dd: bad arg %s\n", argv[i]);
		exit( EINVAL );
	}



	if (  tsize > getnum( indev.fsize )  ) {
		if ( tsize > getnum( indev.modes )  ) {
			fprintf( stderr, "Cannot read this much on input file %s\n", indev.slice  );
			exit( EINVAL );
		} else {
			i =  tsize  -  getnum( indev.fsize );
			fprintf( stderr, "WARNING: reading past end of the file system\n" );
			fprintf( stderr, "         by %d    512-byte blocks\n", i );
		}
	}

	if (  tsize > getnum( outdev.fsize )  ) {
		if ( tsize > getnum( outdev.modes )  ) {
			fprintf( stderr, "Cannot write this much on output file %s\n", outdev.slice );
			exit( EINVAL );
		} else {
			i =  tsize  -  getnum( outdev.fsize );
			fprintf( stderr, "WARNING: writing past end of the file system\n" );
			fprintf( stderr, "         by %d    512-byte blocks\n", i );
		}
	}

	execl( "/bin/dd", "dd", indev.slice, outdev.slice, bsize, bcount, 0 );
	fprintf( stderr, "Failed to exec dd \n" );
	exit( errno );
}
