

/*
 *	Copyright (c)  Motorola Inc.  1986,1987
 *	All rights Reserved
 */

static char	sccs[] = "@(#)umnt.c	35.1		created: 8/24/88";

#include	<errno.h>
#include	<ctype.h>
#include	<mnt.h>
#include	<stdio.h>
#include	<string.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<mnttab.h>


#define	USAGE	"Usage:\t%s [ -123Aabfl -d alias ] [ dev [ dir ]]\n"

main( argc, argv )
register int argc;
register char *argv[];
{
	register struct	mnt_que	*mptr;
	register struct	mnt_que	**tbl;
	register struct	mnt_que	**tbl_b;
	static struct	stat stbuf;

	struct	usrdev	disk;		/*  Info on the requested disk.	*/
	register cpid;			/*  fork returns Child's pid	*/
	register c;			/*  Loop control		*/
	register n = 0;			/*  Number qued			*/
	int wait_stat;			/*  Status of terminating child	*/
	int ret_val = 0;		/*  Return value of program	*/
	int	Aflg = 0;		/*  If set the all mounted device will be unmounted */
	int	oflg = 0;		/*  If non-zero some option specifing the device(s) to be un-mounted was given */

	int	getperms();
	int	gdevs();
	int	alldirs();
	int	mdirs();
	int	mdevs();
	int	cmpstr();

	extern	struct	mnt_que	*mnt_head;
	extern	struct	mnt_que	*mnt_tail;
	extern	char	*optarg;
	extern	int	optind;



	while ( (c = getopt(argc, argv, "123Aabd:fl")) != EOF )
		switch (c)	{
			case '1':	oflg++;
					n = n + gdevs( '1' ); 
					break;
			case '2':	oflg++;
					n = n + gdevs( '2' ); 
					break;
			case '3':	oflg++;
					n = n + gdevs( '3' ); 
					break;
			case 'A':	oflg++;Aflg++;
					n = n + alldirs( ); 
					break;
			case 'a':	oflg++;
					n = n + gdevs( 'a' ); 
					break;
			case 'b':	oflg++;
					n = n + gdevs( 'b' ); 
					break;
			case 'd':	oflg++;
					strcpy( disk.alias, optarg );
					n = n + addq( disk.alias, NULL );
					break;
			case 'f':	oflg++;
					strcpy( disk.alias, DEFAULT );
					n = n + addq( disk.alias, NULL );
					break;
			case 'l':	oflg++;
					while ( argv[optind][0] != '-' && argc > optind ) {
						strcpy( disk.alias, argv[optind++] );
						n = n + addq( disk.alias, NULL );
					}
					break;
			case '?':	
					fprintf( stderr, USAGE, argv[0], argv[0] );
					exit( EINVAL );
					break;
		}

	if ( Aflg && (oflg && (argc > optind)) )
		fprintf( stderr, "%s:  WARNING: something will be unmounted more than once\n", argv[0] );

	/*
	 *	If there were no devices specified by options OR
	 *	there are more command arguements to process.
	 */
	if ( !oflg || ( argc > optind )) { 
		if  ( argc > (optind + 2) ) {	/*  More than one device given */
		    fprintf( stderr, "%s: More than one device given.  Try -l or -d  \n", argv[0] );
		    exit( EINVAL );
		}
		strcpy( disk.alias, ((argc!=optind) ? argv[optind++]:DEFAULT));
		n = n + addq( disk.alias, NULL );
	}
		
	if  ( !( tbl = (struct mnt_que **)malloc( (unsigned)(n*sizeof( struct mnt_que)))))   {
	    fprintf( stderr, "%s: Could not allocate space for the sort\n", argv[0] );
	    exit( errno );
	}
	tbl_b = tbl;
	if  ( (mptr = mnt_head)  != NULL ) 
		do {
		    *tbl = (struct mnt_que *)mptr;
		    tbl++;
		    mptr = mptr->m_next;
		} while  ( mptr != NULL );
	mdevs();
	mdirs();
	qsort( (char *)tbl_b, n, sizeof(struct mnt_que *), cmpstr);



	while ( n ) {	/*  While there are still devices to be un-mounted */
#ifdef	EBUG
		prstruct( *tbl_b );
#endif
		strcpy( disk.alias, (*tbl_b)->m_dev );

		if  ( getperms( &disk )  ) {
			fprintf( stderr, "mnt error:  %s is an unknown device or alias\n", (*tbl_b)->m_dev );
			ret_val = ENOENT;
	 		tbl_b++; 	/*  Get ready to do the next device */
	 		n--;
			continue;
		}
		strins( disk.slice, "/dev/dsk/", 0 );	/* build the block device */
		if (  stat( disk.slice, &stbuf )  == -1 ) {
			fprintf( stderr, "umnt error: %s does not exist\n", disk.slice );
			ret_val = errno;
	 		tbl_b++; 	/*  Get ready to do the next device */
	 		n--;
			continue;
		}
		if ( (stbuf.st_mode & S_IFMT) != S_IFBLK ) {
			fprintf( stderr, "umnt error:  %s is not a block device.\n", disk.slice );
			ret_val = errno;
	 		tbl_b++; 	/*  Get ready to do the next device */
	 		n--;
			continue;
		}

		if ( ckmode( &disk, 'R' ) &&  ckmode( &disk, 'W' ) ) {
			fprintf( stderr, "umnt error:  %s does not have unmount permission\n", disk.slice );
			ret_val = EACCES;
	 		tbl_b++; 	/*  Get ready to do the next device */
	 		n--;
			continue;
		}

		if ( (cpid = fork()) == -1 ) {
			fprintf( stderr, "%s: Fork failed\n", argv[0] );
			exit( errno );
		}
		if ( !cpid )  {
			printf( "Un-mounting  %s\n", (*tbl_b)->m_dev );
			execl( "/etc/umount", "umount", disk.slice, 0  );
			fprintf( stderr, "%s:  Exec failed\n", argv[0] );
			exit( errno );
		}
		if ( wait(&wait_stat) != cpid ) { /* wait failed or wrong child returned */
			fprintf( stderr, "%s:  WARNING: %s may not be mounted\n", argv[0], (*tbl_b)->m_dev );
			ret_val = errno;
	 		tbl_b++; 	/*  Get ready to do the next device */
	 		n--;
			continue;
		}
		if ( wait_stat & 0xff ) {		/* if child did not exit */
			fprintf( stderr, "%s:  WARNING: caught a signal.  %s may not be mounted\n", argv[0], (*tbl_b)->m_dev );
			ret_val = ECHILD;
	 		tbl_b++; 	/*  Get ready to do the next device */
	 		n--;
			continue;
		}
		if ( (wait_stat>>8) ) {
			fprintf( stderr, "%s:  WARNING:  %s may not be mounted.\n", argv[0], (*tbl_b)->m_dev );
			ret_val = ( wait_stat>>8 );
	 		tbl_b++; 	/*  Get ready to do the next device */
	 		n--;
			continue;
		}
	 tbl_b++; 	/*  Get ready to do the next device */
	 n--;

	}
	exit( ret_val );
}


cmpstr( p1, p2 )
struct mnt_que **p1, **p2;
{
#ifdef	EBUG
	printf( "Comparing %s and %s\n", (*p2)->m_dir, (*p1)->m_dir );
#endif
	return(strcmp( (*p2)->m_dir, (*p1)->m_dir ));
}



/*
 *	Reads the mount table, /etc/mnttab, and for each entry:
 *	scans through the mnt_que for a match on the device specified.
 *	If a match is found the m_dev entry in the mnt_que structure
 *	for that device is set to the directory on which the device
 *	is mounted.
 */

mdirs( )
{
	FILE	*mnttab;
	char	*svstr();
	struct	mnttab	tab;
	struct	mnt_que	*ptr;
	extern	struct	mnt_que	*mnt_head;
	extern	struct	mnt_que	*mnt_tail;

	if ( (mnttab = fopen( "/etc/mnttab", "r" ))  ==  NULL ) {
		fprintf( stderr, "Could not open mnttab.\n" );
		return( NULL );
	}

	while ( fgets( &tab, (int)(sizeof(struct mnttab)+1), mnttab) != NULL ) {
		if  ( (ptr = mnt_head)  != NULL ) 
		do {
			if ( strcmp(ptr->m_dev, (tab.mt_dev+4) ) == 0 ) {
				ptr->m_dir = svstr( tab.mt_filsys );
#ifdef	EBUG
				fprintf( stderr, "%s is mounted as %s\n", ptr->m_dev, ptr->m_dir );
#endif
				break;
			}
		} while ( (ptr = ptr->m_next) != NULL );
	}
}



mdevs( )
{
	FILE	*map;
	struct	usrdev	tmp;		/*  temp spot to read perms file into */
	struct	usrdev	*dsk;		/*  Pointer to the temp spot above    */
	static char line[BUFSIZ];
	char	*svstr();
	struct	mnt_que *ptr;
	extern	struct	mnt_que *mnt_head;
	extern	struct	mnt_que *mnt_tail;
	char	*strrchr();
	register n = 0;			/*  Number of devices with requested perm */

	if ( (map = fopen( PERMS_FILE, "r" ))  ==  NULL ) {
		fprintf( stderr, "Could not open the permissions file.\n" );
		return( 0 );
	}

	dsk = &tmp;	
	while (  fgets( line, BUFSIZ, map) != NULL )
	if ( (sscanf( line, "%s%s%s%s%s%*[^']'%[^']'", dsk->slice, dsk->alias, dsk->fsize, dsk->modes, dsk->mnt_pt, dsk->pgm )  !=  EOF )  ) {
		if (  strncmp(dsk->slice, "#", 1) == 0 ) {
			continue;
		}
		if  ( (ptr = mnt_head)  != NULL ) 
		do {
			if ( (strcmp(ptr->m_dev, dsk->alias) == 0) || (strcmp(ptr->m_dev, dsk->slice) == 0) ) {
				ptr->m_dev = svstr( dsk->slice );
#ifdef	EBUG
				fprintf( stderr, "mdevs found %s\n", ptr->m_dev );
#endif
				break;
			}
		} while ( (ptr = ptr->m_next) != NULL );
	}
}

/*
 *	Reads the mount table, /etc/mnttab, and for each entry:
 *	adds an entry onto the mnt_que.
 */

alldirs( )
{
	register int n = 0;
	FILE	*mnttab;
	struct	mnttab	tab;

	if ( (mnttab = fopen( "/etc/mnttab", "r" ))  ==  NULL ) {
		fprintf( stderr, "Could not open mnttab.\n" );
		return( NULL );
	}

	while ( fgets( &tab, (int)(sizeof(struct mnttab)+1), mnttab) != NULL )
		if ( strcmp( tab.mt_filsys, "/" ) != 0 )
			n = n + addq( (tab.mt_dev+4), tab.mt_filsys );
	return( n );
}
