
/* 
	@(#)openodel.c	35.1
**
** Open a device with O_NDELAY.  Used to determine if a port
** (i.e. board) is configured, without hanging up on lines without
** attached devices.
** We assume that drivers return ENXIO for attempts to open non-existent
** devices, and all unused entries in cdevsw contain nodev().
**
** Exit values:
**	0	Successful open
**	1	Syntax error
**	2	No driver configured or nonexistent device (ie. board)
**	3	Other open error (No such file, permissions, etc.)
*/

#include <fcntl.h>
#include <stdio.h>
#include <sys/errno.h>

main(argc, argv)
int argc;
char *argv[];
{

    register exitval = 3;  /* Implies an error other than nonexistent device */
    extern int errno;

    if ( argc == 1 )  {
	fprintf (stderr, "Syntax:  %s  <device>", argv[0]);
	exit (1);
    }

    if (open (argv[1], (O_RDONLY|O_NDELAY)) == -1) {
	if ( (errno == ENODEV) || (errno == ENXIO) ) exitval = 2;
	perror (argv[1]);
	exit (exitval);
    } else {
	fprintf (stderr, "%s: Success\n", argv[1]);
	exit (0);
    }
}
