/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"@(#)prfstat.c	35.1"
/*
 *	prfstat - change and/or report profiler status
 */

#include <sys/param.h>


# define DEF_RATE   (0xA << 8)	/* 15.5ms */

main(argc, argv)
	char	**argv;
{
	register  int  prf, rate, ioctrtn;

	if((prf = open("/dev/prf", 2)) < 0) {
		printf("cannot open /dev/prf\n");
		exit(1);
	}
	if(argc > 3) {
		printf("usage: prfstat  [ on|off ]  [clk rate]\n");
		exit(1);
	}

	rate = DEF_RATE;

	switch (argc) {
	case 3:
	    rate = atoi (argv[2]);
	    if (rate <0 || rate > 15)  {
		printf("Bad clock rate: %d\n", rate);
		printf("usage: prfstat  [ on|off ]  [clk rate]\n");
		exit(1);
	    }
	    rate <<= 8;

	case 2:
		if(strcmp("off", argv[1]) == 0)
			ioctl(prf, 3, 0);
		else if(strcmp("on", argv[1]) == 0)
			ioctl(prf, 3, (PRF_ON | rate));
		else {
			printf("usage: prfstat  [on|off]  [clk rate]\n");
			exit(1);
		}
	}
	ioctrtn = ioctl(prf, 1, 0);
	if (ioctrtn & PRF_ON)  {
		printf ("profiling enabled:  ");
		if (ioctrtn & PRF_INT)
			printf ("Internal clock\n");
		else
			printf ("External clock: rate = %d\n", ioctrtn>>8);
	}
	else printf ("profiling disabled\n");

	if(ioctl(prf, 1, 0) & PRF_VAL)
		printf("%d kernel text addresses\n", ioctl(prf, 2, 0));
	exit(0);
}
