#ident "@(#)gencode.c	35.1     88/08/26     "
#ident "Copyright (c) 1984 AT&T, INC."
#ident "Copyright (c) 1985 MOTOROLA, INC."

#include	<stdio.h>
#include	"symbols.h"
#include	"instab.h"
#include	"gendefs.h"
#include	"expand.h"
#include	"expand2.h"
#include	"dbug.h"
#ifdef	M68881
#include        "fpnum.h"       /* floating point constants definations */
extern		 do_fp_num();
#endif	/* M68881 */

extern symbol   *dot;           /* pc at beginning of current instruction. */
extern long	newdot;
extern short	opt;		/* No span-dependent optimization flag.	*/
extern upsymins lookup();

#ifdef MC68

#ifdef M68010
int		as10 =  1 ;
#else
int		as10 =  0 ;	/* if '0' -> issue warning if 68010 instr */
#endif /* M68010 */

#ifdef M68020
int             as20 =  1 ;
#else
int		as20 =  0 ;	/* if '0' -> issue warning if 68020 instr */
#endif  /* M68020 */

#ifdef  M68030
int             as30 =  1 ;     /* if '0' -> warn if CALLM, RTM instr and */
#else                           /* if '0' -> warn if certain 68851 instr */
int             as30 =  0 ;
#endif  /* M68030 */

int             as51 = 1;       /* suppress warnings for PMMU instructions */
int             as81 = 1;       /* MC68881 floating point coprocessor      */
int             as82 = 0;       /* future use (68030) */
int             as83 = 0;       /* future use (68040) */
int             as40 = 0;       /* future use (68040) */
long            pc_dot;         /* like newdot but computed earlier in order*/
				/* to adjust pc-relative displacements */
#endif /* MC68 */

#ifndef	M68020
long 		object;		/* the instruction op-code+ */
int		numwords;
long		word;
symbol		*symptr;
unsigned short	action;

#else

/*
 *
 *	68020 ADDITIONS:
 *
 *	structure to contain the effective address information
 *	for the M68020 addressing modes.
 */
long 		object;		/* the instruction op-code+ */
struct eatype
{
	short           len1;
	unsigned short	action1;
	long            ext1;
	symbol          *sym1;
	/* */
	short           len2;
	unsigned short	action2;
	long            ext2;
	symbol          *sym2;
	/* */
	short           len3;
	unsigned short	action3;
	long            ext3;
	symbol          *sym3;
};

struct eatype	ea;	/* all inst use this, "mov" has additional instance */

#define INVALID 0	/* lenx identifiers */
#define EA_BYTE 0       /* BITSPBY for a byte */
#define EA_WORD 1       /* 1*BITSPOW for a word */
#define EA_LONG 2       /* 2*BITSPOW for a long word */
/*	68020:	Format of full format indexing extension words 	*/ 
#define BASE_SUPPRESS	(1<<7)
#define INDEX_SUPPRESS	(1<<6)

#define NULL_BASE_DISP	(01<<4)
#define LONG_BASE_DISP	(03<<4)		/* displacement off the base, bits 5-4 */
#define WORD_BASE_DISP	(02<<4)		/* NULL_BASE_DISP is "no displacement" */

#define NULL_IND_DISP	01	/* if we have a displacement for mem indirect */
#define WORD_IND_DISP	02	/* if "00", then we have no mem indirection   */
#define LONG_IND_DISP	03

#define FULL_FORM_INDEX	(1<<8)	/* turn on bit 8  indicating full format */
#define BRIEF_FORM_INDEX 0	/* for no mem indir & less than signed byte */

/*
 *
 *	END 68020 additional declarations.
 *
 */

#endif /* M68020 */

#ifdef M68881	
/*
 *	M68881 additions
 */
#	define cp_id	1	/* define default co_processor id */
	/* source format table used by 68881 co-processor
 	 * they are B,W,L,UNSPEC,S,X,P and D corespondently
 	 */
	int SRCFMT[8] = { 6,4,0,7,1,2,3,5 };
/*
 *	END 68881 additional declarations.
 */
#endif /* M68881 */


eff_add(arg,tag,size)
register struct arg	*arg;
register int            tag;    /* addressing mode category */
register int		size;
{
	extern int    px;        /* correction for pc-relative displacemnt*/
	register int	sdiflag;
	register int sdisize;

	DBUG_ENTER ("eff_add");
#ifndef	M68020
	numwords = 0;
	action = 0;
#else
	ea.len1 = ea.len2 = ea.len3 = INVALID;
	ea.action1 = ea.action2 = ea.action3 = 0;
	ea.ext1 = ea.ext2 = ea.ext3 = 0;
	ea.sym1 = ea.sym2 = ea.sym3 = NULLSYM;
#endif
	pc_dot += 2; /* position program counter at start of e.a. */

	switch (arg->atype)
	{
	case ADREG:
		if ((tag & 0x800) == 0)
		{
			yyerror("attempt to use incorrect addressing mode (%dn)");
			DBUG_VOID_RETURN;
		}
		object |= arg->atype;
		object |= arg->areg1->opcode;
		DBUG_VOID_RETURN;

	case AAREG:
		if ((tag & 0x400) == 0)
		{
			yyerror("attempt to use incorrect addressing mode (%an)");
			DBUG_VOID_RETURN;
		}

	case AIREG:
		object |= arg->atype;
		object |= arg->areg1->opcode;
		DBUG_VOID_RETURN;

	case AINC:
		if ((tag & 0x100) == 0)
		{
			yyerror("attempt to use incorrect addressing mode ((%an)+)");
			DBUG_VOID_RETURN;
		}
		object |= arg->atype;
		object |= arg->areg1->opcode;
		DBUG_VOID_RETURN;

	case ADEC:
		if ((tag & 0x80) == 0)
		{
			yyerror("attempt to use incorrect addressing mode (-(%an))");
			DBUG_VOID_RETURN;
		}
		object |= arg->atype;
		object |= arg->areg1->opcode;
		DBUG_VOID_RETURN;

	case APCOFF:
		if ((tag & 0x4) == 0)
		{
			yyerror("attempt to use incorrect addressing mode (d(%pc))");
			DBUG_VOID_RETURN;
		}
		if( arg->xp->xsymptr == NULLSYM )
			arg->xp->xvalue -= pc_dot - dot->value;

	case AOFF:
#ifndef M68020
		pc_dot += 2; /* count 1 displacement word */
		numwords = 1;
		if (arg->atype == AOFF)
			action = (arg->xp->xsymptr == NULLSYM) ? 0 : GENRELOC;
		else /* APCOFF */
			action = (arg->xp->xsymptr == NULLSYM) ? 0 : BRLOC;
#else
		ea.len1 = 1;
		if (arg->atype == AOFF)
			ea.action1 = (arg->xp->xsymptr == NULLSYM) ? 0 : GENRELOC;
		else /* APCOFF */
			ea.action1 = (arg->xp->xsymptr == NULLSYM) ? 0 : BRLOC;
#endif
		object |= arg->atype;
		if (arg->atype == AOFF)
			object |= arg->areg1->opcode;
#ifndef	M68020
		word = arg->xp->xvalue;
		if (word > 32767L || word < -32768L)
			yyerror("displacement exceeds 16 bits");
		symptr = arg->xp->xsymptr;
#else
		ea.ext1 = arg->xp->xvalue;
		if (ea.ext1 > 32767L  || ea.ext1 < -32768L)
			yyerror("displacement exceeds 16 bits signed");
		ea.sym1 = arg->xp->xsymptr;
#endif

		DBUG_VOID_RETURN;

#ifndef M68020
	case APCNDX:
		if ((tag & 0x2) == 0)
		{
			yyerror("attempt to use incorrect addressing mode (d(%pc,%rn.A))");
			DBUG_VOID_RETURN;
		}
		if( arg->xp->xsymptr == NULLSYM )
			arg->xp->xvalue -= pc_dot - dot->value;
	case ANDX:
		pc_dot += 2; /* count 1 extension word */
		numwords = 1;
		action = (arg->xp->xsymptr == NULLSYM) ? 0 : NDXRELOC;
		object |= arg->atype;
		if (arg->atype == ANDX)
			object |= arg->areg1->opcode;
		word = (arg->areg2->tag == AAREG) ? (1 << 15) : 0;
		word |= (arg->areg2->opcode << 12);
		word |= (arg->asize == L) ? (1 << 11) : 0;
		word |= (arg->xp->xvalue & 0xff);
		if (arg->xp->xvalue > 127 || arg->xp->xvalue < -128)
			yyerror("index displacement exceeds 8 bits");
		symptr = arg->xp->xsymptr;
		DBUG_VOID_RETURN;
#else
	case APCNDX:
		if( (tag & 0x2 ) == 0 )
		{
			yyerror("attempt to use incorrect addressing mode (%pc,%rn.A,d)");
			DBUG_VOID_RETURN;
		}	/* else drop thru to ANDX */
		if( arg->xp->xsymptr == NULLSYM )
			arg->xp->xvalue -= pc_dot - dot->value;
	case ANDX:
	{
		long distance = 0;

		/* common codes for brief and full format */
		ea.len1 = EA_WORD;            /* first extension only 1 wd */
		object  |= arg->atype;
		if( arg->atype == ANDX && arg->areg1 != NULL)
			object  |= arg->areg1->opcode;
		ea.ext1 |= (arg->ascale << 9);
		if( arg->areg2) 	/* if there is an index */
		{
			ea.ext1 |= (arg->areg2->tag == AAREG) ? (1<<15) : 0;
			ea.ext1 |= (arg->areg2->opcode << 12);
			ea.ext1 |= (arg->asize == L) ? (1 << 11) : 0;
		}
		/* recompute BFINDIRECT */
		if( arg->aflags == BFINDIRECT || (arg->aflags == INDIRECT &&
#ifdef M68020
						 !arg->xp2 &&
#endif
				      arg->areg2  && arg->xp1 && arg->areg1) )
		{
			if( arg->atype == APCNDX )
				distance = (arg->xp->xsymptr ?
				    arg->xp->xsymptr->value : dot->value )
						   + arg->xp->xvalue - pc_dot;
			else
				distance = arg->xp->xvalue;
			if( ( arg->xp->xsymptr != NULLSYM && arg->atype == APCNDX
			     && (arg->xp->xsymptr->styp & TYPE) == dot->styp
				     && distance <= 127 && distance >= -128 )
				   || arg->xp1->xsize == EA_BYTE ||
			    ( arg->xp->xsymptr == NULLSYM
				 && distance <= 127 && distance >= -128L ) )
				arg->aflags = BFINDIRECT;
			else
				arg->aflags = INDIRECT;
		}
		/* if not as20 then it MUST be Brief Format ! */
		if( !as20 ) arg->aflags = BFINDIRECT;
		/* generate brief format */
		if ( arg->aflags == BFINDIRECT )
		{
			if( distance > 127 || distance < -128 )
				yyerror("displacement exceeds 8 bits");
			/* Scale factor must be *1 for 68000/10 */
			if( arg->ascale != X1 && !as20 )
				wxerror("a 68020/30 addressing mode");

			ea.len1 = BITSPBY;
			if( arg->xp1->xsymptr != NULLSYM )
			{
				if( arg->atype == APCNDX )
				{
					ea.action1 = BRLOC;
					arg->xp1->xvalue += 2;
				}
				else
					ea.action1 = GENRELOC;
				ea.sym1 = arg->xp1->xsymptr;
			}
			ea.ext1 |= ( arg->xp1->xvalue  & 0xff );
			DBUG_VOID_RETURN;
		}
		/* Removed this test since we must assume compiler knows */
		/* else if( !as20 )                                      */
		/*        wxerror("a 68020/30 addressing mode");         */

		pc_dot += 2; /* count 1 extension word */
		/* generate full format */
		ea.ext1 |= FULL_FORM_INDEX;	/* set full format bit */
		ea.ext1 |= (arg->areg1 ? 0: BASE_SUPPRESS);
		ea.ext1 |= (arg->areg2 ? 0: INDEX_SUPPRESS);
		ea.action2 = 0;
		ea.action3 = 0;

		/*
		 *	Check base displacement, if set - store in ea.
		 *	For the 68020, this displacement could be null,
		 *	in that case set the `NULL' displacement bits.
		 */

		if( arg->xp1 )	/* if there is a base displacement	*/
		{
			if ( arg->xp1->xvalue == 0 && arg->xp1->xsymptr == NULLSYM )
				ea.ext1 |= NULL_BASE_DISP;
			else
			{
				if(arg->xp1->xsize == UNSPEC)
					if(arg->xp1->xsymptr)
					{
						pc_dot += 4; /* base disp */
						ea.len2 = EA_LONG;
					}
					else
					if(arg->xp1->xvalue < -32768L || 
						arg->xp1->xvalue > 32767L )
					{
						pc_dot += 4; /* base disp */
						ea.len2 = EA_LONG;
					}
					else
					{
						pc_dot += 2; /* base disp */
						ea.len2 = EA_WORD;
					}
				else if( arg->xp1->xsize == EA_LONG )
				{
					pc_dot += 4; /* base disp */
					ea.len2 = EA_LONG;
				}
				else
				{
					pc_dot += 2; /* base disp */
					ea.len2 = EA_WORD;
				}
				ea.action2 = ( arg->xp1->xsymptr == NULLSYM ) ? 0 :
					(arg->atype == ANDX?GENRELOC:BRLOC) ;
				ea.ext2 = arg->xp1->xvalue;
				ea.sym2 = arg->xp1->xsymptr;
				ea.ext1 |= (ea.len2 == EA_LONG)? LONG_BASE_DISP: WORD_BASE_DISP;
			}
		}
		else
			ea.ext1 |= NULL_BASE_DISP;

		/*
		 *	are we using memory indirect?
		 *
		 *	if so, we may have a displacement off the 
		 *	memory indirect.  the extension words (1 or 2)
		 *	would follow the first extension word and
		 *	base displacement (again 1 or 2 words, if any).
		 */

		if( arg->aflags == POSTNDXMI || arg->aflags == PRENDXMI )
		{
			/* set memory indirect and indexing options */
			ea.ext1 |= ((arg->aflags == POSTNDXMI && arg->areg2) ? 0x4 : 0 );

			if( arg->xp2 )	/* we have an indirect displacement */
			{
				if ( arg->xp2->xvalue == 0 && arg->xp2->xsymptr == NULLSYM )
					ea.ext1 |= NULL_IND_DISP;
				else
				{
					if(arg->xp2->xsize == UNSPEC)
						if(arg->xp2->xsymptr)
						{
							pc_dot += 4;/* od */
							ea.len3 = EA_LONG;
						}
						else
						if (arg->xp2->xvalue < -32768L || 
							arg->xp2->xvalue > 32767L )
						{
							pc_dot += 4;/* od */
							ea.len3 = EA_LONG;
						}
						else
						{
							pc_dot += 2;/* od */
							ea.len3 = EA_WORD;
						}
					else if( arg->xp2->xsize == EA_LONG )
					{
						pc_dot += 4;/* od */
						ea.len3 = EA_LONG;
					}
					else
					{
						pc_dot += 2;/* od */
						ea.len3 = EA_WORD;
					}
					ea.action3 = ( arg->xp2->xsymptr == NULLSYM ? 0 : GENRELOC );
					ea.ext3 = arg->xp2->xvalue;
					ea.sym3 = arg->xp2->xsymptr;
					ea.ext1 |= (ea.len3 == EA_LONG) ? LONG_IND_DISP : WORD_IND_DISP;
				}
			}
			else		/* no indirect displacement */
				ea.ext1 |= NULL_IND_DISP;
		}
		DBUG_VOID_RETURN;
	}
#endif
	case ABSW:
	{
		if( arg->xp->xsymptr == NULLSYM &&
		   ( arg->xp->xvalue < -32768L || arg->xp->xvalue > 32767L ) )
		{
			werror("Absolute value larger than word made long");
			arg->xp->xsize = EA_LONG;
			arg->atype = ABSL;
		}
	}
	case ABSU:
	{
		if( arg->atype == ABSU && arg->xp->xsymptr == NULLSYM
		 && arg->xp->xvalue >= -32768L && arg->xp->xvalue <=  32767L )
		{
			arg->xp->xsize = EA_WORD;
			arg->atype = ABSW;
		}
		else
		{
			arg->xp->xsize = EA_LONG;
			arg->atype = ABSL;
		}
	}
	case ABSL:
	{

		pc_dot += arg->xp->xsize == EA_WORD ? 2 : 4;
#ifdef M68020
		ea.len1 = arg->xp1->xsize == EA_WORD ? EA_WORD: EA_LONG;
		ea.action1 = arg->xp1->xsymptr == NULLSYM ? 0 : GENRELOC;
#else
		numwords =  arg->xp->xsize == EA_WORD ? EA_WORD: EA_LONG;;
		action = arg->xp->xsymptr == NULLSYM ? 0 : GENRELOC;
#endif
		object |= arg->atype == ABSW ? ABSW : ABSL;

#ifndef M68020
		word = arg->xp1->xvalue;
		symptr = arg->xp1->xsymptr;
#else
		ea.ext1 = arg->xp->xvalue;
		ea.sym1 = arg->xp->xsymptr;
#endif
		DBUG_VOID_RETURN;
	}
	case AIMM:
		if ((tag & 0x1) == 0)
		{
			yyerror("attempt to use incorrect addressing mode (immediate)");
			DBUG_VOID_RETURN;
		}
		object |= AIMM;
#ifndef M68020
		symptr = arg->xp->xsymptr;
		action = (symptr == NULLSYM) ? 0 : GENRELOC;
#else
		ea.sym1 = arg->xp->xsymptr;
		ea.action1 = (ea.sym1 == NULLSYM) ? 0 : GENRELOC;
#endif
		switch (size)
		{
		case B:
			pc_dot += 2; /* immediate word */
#ifndef M68020
			numwords = 1;
			word = arg->xp->xvalue & 0xff;
#else
			ea.len1 = EA_WORD;
			if ( arg->xp->xsymptr == NULLSYM  &&
						 arg->xp->xvaltype == FP_DEC )
			{
				get_fp_value(size);
				werror("Floating point fraction ignored");
			}
			else
				ea.ext1 = arg->xp->xvalue & 0xff;
#endif
			DBUG_VOID_RETURN;
		case W:
		case UNSPEC:
			pc_dot += 2; /* immediate word */
#ifndef M68020
			numwords = 1;
			word = arg->xp->xvalue & 0xffff;
#else
			ea.len1 = EA_WORD;
			if ( arg->xp->xsymptr == NULLSYM  &&
						 arg->xp->xvaltype == FP_DEC )
			{
				get_fp_value(size);
				werror("Floating point fraction ignored");
			}
			else
				ea.ext1 = arg->xp->xvalue & 0xffff;
#endif
			DBUG_VOID_RETURN;
		case L:
			pc_dot += 4; /* immediate long */
#ifndef M68020
			numwords = 2;
			word = arg->xp->xvalue;
#else
			ea.len1 = EA_LONG;
			if ( arg->xp->xsymptr == NULLSYM  &&
						 arg->xp->xvaltype == FP_DEC )
			{
				get_fp_value(size);
				werror("Floating point fraction ignored");
			}
			else
				ea.ext1 = arg->xp->xvalue;
#endif
			DBUG_VOID_RETURN;
		}
	case AIMM_FP:
		if ((tag & 0x1) == 0)
		{
			yyerror("attempt to use incorrect addressing mode (immediate)");
			DBUG_VOID_RETURN;
		}
		object |= AIMM;
#ifndef M68020
		symptr = arg->xp->xsymptr;
		action = (symptr == NULLSYM) ? 0 : GENRELOC;
#else
		ea.sym1 = arg->xp->xsymptr;
		ea.action1 = (ea.sym1 == NULLSYM) ? 0 : GENRELOC;
#endif
		switch (size)
		{
		case B:
			pc_dot += 2; /* immediate word */
#ifndef M68020
			numwords = 1;
			word = arg->xp->xvalue & 0xff;
#else
			ea.len1 = EA_WORD;
			if ( arg->xp->xsymptr == NULLSYM  &&
						 arg->xp->xvaltype == FP_DEC )
			{
				get_fp_value(size);
				werror("Floating point fraction ignored");
			}
			else
				ea.ext1 = arg->xp->xvalue & 0xff;
#endif
			DBUG_VOID_RETURN;
		case W:
		case UNSPEC:
			pc_dot += 2; /* immediate word */
#ifndef M68020
			numwords = 1;
			word = arg->xp->xvalue & 0xffff;
#else
			ea.len1 = EA_WORD;
			if ( arg->xp->xsymptr == NULLSYM  &&
						 arg->xp->xvaltype == FP_DEC )
			{
				get_fp_value(size);
				werror("Floating point fraction ignored");
			}
			else
				ea.ext1 = arg->xp->xvalue & 0xffff;
#endif
			DBUG_VOID_RETURN;
		case L:
			pc_dot += 4; /* immediate long */
#ifndef M68020
			numwords = 2;
			word = arg->xp->xvalue;
#else
			ea.len1 = EA_LONG;
			if ( arg->xp->xsymptr == NULLSYM  &&
						 arg->xp->xvaltype == FP_DEC )
			{
				get_fp_value(size);
				werror("Floating point fraction ignored");
			}
			else
				ea.ext1 = arg->xp->xvalue;
#endif
			DBUG_VOID_RETURN;
#ifdef M68881
		case S:	/* single precision 32 bits */
/*add check for floating point address imm ok here. **/
			pc_dot += 4; /* immediate single precision */
			ea.len1 = EA_LONG;
			if ( arg->xp->xsymptr == NULLSYM  &&
						 arg->xp->xvaltype == FP_DEC )
				get_fp_value(size);
			else
				ea.ext1 = arg->xp->xvalue;
			DBUG_VOID_RETURN;
		case D:	/* double precision 64 bits */
			pc_dot += 8; /* immediate double precision */
			ea.len1 = EA_LONG;
			ea.len2 = EA_LONG;
			if ( arg->xp->xsymptr != NULLSYM )
				werror("please set constant value");
			if ( arg->xp->xsymptr == NULLSYM  &&
						 arg->xp->xvaltype == FP_INT )
			{
				werror("Immediate value extended to 64 bits");
				arg->xp->xvalue2 = arg->xp->xvalue;
				arg->xp->xvalue  = 0;
			}

			if ( arg->xp->xsymptr == NULLSYM  &&
						 arg->xp->xvaltype == FP_DEC )
				get_fp_value(size);
			else
			{
				ea.ext1 = arg->xp->xvalue;
				ea.ext2 = arg->xp->xvalue2;
			}
			DBUG_VOID_RETURN;

		case X:	/* extended precision 96 bits */
			pc_dot += 12; /* immediate extended precision */
			ea.len1 = EA_LONG;
			ea.len2 = EA_LONG;
			ea.len3 = EA_LONG;
			if ( arg->xp->xsymptr != NULLSYM )
				werror("please set constant value");
			if ( arg->xp->xsymptr == NULLSYM  &&
						 arg->xp->xvaltype == FP_INT )
				werror("size code/extension is invalid");

			if ( arg->xp->xsymptr == NULLSYM  &&
						 arg->xp->xvaltype == FP_DEC )
				get_fp_value(size);
			else
			{
				ea.ext1 = arg->xp->xvalue;
				ea.ext2 = arg->xp->xvalue2;
				ea.ext3 = arg->xp->xvalue3;
			}
			DBUG_VOID_RETURN;

		case P:	/* packed BCD 96 bits */
			pc_dot += 12; /* immediate packed BCD */
			ea.len1 = EA_LONG;
			ea.len2 = EA_LONG;
			ea.len3 = EA_LONG;
			if ( arg->xp->xsymptr != NULLSYM )
				werror("please set constant value");
			if ( arg->xp->xsymptr == NULLSYM  &&
						 arg->xp->xvaltype == FP_INT )
				werror("size code/extension is invalid");

			if ( arg->xp->xsymptr == NULLSYM  &&
						 arg->xp->xvaltype == FP_DEC )
				get_fp_value(size);
			else
			{
				ea.ext1 = arg->xp->xvalue;
				ea.ext2 = arg->xp->xvalue2;
				ea.ext3 = arg->xp->xvalue3;
			}
			DBUG_VOID_RETURN;
#endif /* M68881 */
		}
		break;
	default:
		yyerror("invalid effective address type for instruction");
	}
	DBUG_VOID_RETURN;
}	/* eff_add()	*/

gen0op(inst)
register instr		*inst;
{
	DBUG_ENTER ("gen0op");
	switch ((int)(unsigned char)inst->tag)
	{

#ifdef M68881
	case CPTCC:
	case CPTPCC:
	/*      co-processor trap condition without operand     */
	{
		if( !as20 )
			wxerror("a 68020/30 instruction");
		generate (BITSPOW,0,(0xf07c | cp_id << 9),NULLSYM);
		generate (BITSPOW,0,inst->opcode,NULLSYM);
		DBUG_VOID_RETURN;
	}       /* cpTcc */
	
	case FNOP:
	/* floating point no operation */
	{
		generate (BITSPOW,0,(0xf080 | cp_id << 9),NULLSYM);
		generate (BITSPOW,0,0,NULLSYM);
		DBUG_VOID_RETURN;
	}       /* fnop */

#endif /* M68881 */

#ifdef M68851
	case PFLUSHA:
	{
		register int inst2wd;  /* second word of instruction format */
			/* PFLUSHA */
		object = inst->opcode  ;
		generate(BITSPOW,0,object,NULLSYM);
		inst2wd = 0x2400; /* 0x400 is mode for flush all */
		generate(BITSPOW,0,inst2wd,NULLSYM);
		DBUG_VOID_RETURN;
	}       /* PFLUSHA */
	case PTRAPCC:
	{       /* PTRAPcc */
		if (as30 && !as51)
			wxerror("PTRAPcc is a 68851 instruction");
		generate(BITSPOW,0,0xf07c,NULLSYM);
		generate(BITSPOW,0,inst->opcode,NULLSYM);
		DBUG_VOID_RETURN;
	}       /* PTRAPcc */
#endif /* M68851 */

	case TPCC:
		{       /* TRAPcc -- no operands */
			generate (BITSPOW,0,(inst->opcode | 4),NULLSYM);
			DBUG_VOID_RETURN;
		}       /* TRAPcc */
	default:
			generate (BITSPOW,0,inst->opcode,NULLSYM);
	}	/* end switch */
	DBUG_VOID_RETURN;
}	/* gen0op */


gen1op(inst,size,arg1)
register instr		*inst;
register int		size;
register struct arg	*arg1;
{
	DBUG_ENTER ("gen1op");
	pc_dot = newdot;
	switch ((int)(unsigned char)inst->tag)
	{
#ifdef M68881
	case FOP:
	{	/* fop %fpn */
		register int inst1wd,		/* first word of instruction format */
		             inst2wd;		/* second word of instruction format */

		if (arg1->atype != FPREG)
			yyerror ("floating point register required as operand for monadic floating point operation");
		if ( size != X && size != UNSPEC)
			werror ("instruction requires size X, if source is from a floating point register");
		size = X;
		inst1wd = 0xf000 | cp_id << 9;
		inst2wd = inst->opcode | arg1->areg1->opcode << 7 | arg1->areg1->opcode << 10;
		generate (BITSPOW, 0, inst1wd, NULLSYM);
		generate (BITSPOW, 0, inst2wd, NULLSYM);
		DBUG_VOID_RETURN;
	}	/* fop */

	case FTST:
	{
		register int inst2wd;		/* second word of instruction format */
		if ( size != UNSPEC && size != B && size != W && size != L &&
			size != S && size != D && size != X && size != P)
			yyerror("instruction has illegal size attribute");
		if (arg1->atype == FPREG && size != X && size != UNSPEC)
			werror ("instruction requires size X, if source is a floating point register");
		object = inst->opcode |  cp_id << 9;
		if (arg1->atype == FPREG)
		{
			size = X;
			inst2wd = (0x003a | arg1->areg1->opcode << 10);
			generate (BITSPOW, 0, object, NULLSYM);
			generate (BITSPOW, 0, inst2wd, NULLSYM);
		}
		else
		{
			if ( size == UNSPEC )
			{
				size = W;
				werror("No size specified for floating point instruction, W used");
			}
			pc_dot += 2; /* adjust for larger instruction */
			if ( size==B || size == W || size == L || size == S)
				eff_add (arg1,DATAA,size);
			else
				eff_add (arg1,MEMORY,size);
			generate(BITSPOW,0,object,NULLSYM);
			inst2wd = (0x403a | SRCFMT[size] << 10);  
			generate(BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
		}
		DBUG_VOID_RETURN;
	}	/* ftst */
#endif /* M68881 */


#ifdef M68881
	case CPBCC:
		/* cpBcc <label> */
		if( !as20 )
			wxerror("a 68020/30 instruction");
		if ( size != W && size != L  && size != UNSPEC)
			yyerror("instruction has illegal size attribute");

		object = inst->opcode  | cp_id << 9  ;

		if ( size == W )
		{
			generate (BITSPOW,0,object,NULLSYM);
			generate(BITSPOW,BRLOC,arg1->xp->xvalue & 0xffff,
				arg1->xp->xsymptr);
			DBUG_VOID_RETURN;
		}
		else
		if ( size == L )        /* explicit long cpbranch */
		{
			generate(BITSPOW,0,object | 0x40 ,NULLSYM);     /* turn on bit 6 */
			generate(2*BITSPOW,BRLOC,arg1->xp->xvalue,arg1->xp->xsymptr);
			DBUG_VOID_RETURN;
		}
		else
		{
			if (opt)
			switch (shortsdi(arg1->xp->xsymptr,arg1->xp->xvalue,SDI2))
			{
			case S_SDI:     /* cpbcc.w guaranteed to work.  */
				generate(BITSPOW,0,object,NULLSYM);
				generate(BITSPOW,BRLOC,arg1->xp->xvalue,arg1->xp->xsymptr);
				DBUG_VOID_RETURN;
			case U_SDI:     /* Don't know, so generate a    */
					/*      short for now.          */
				generate(BITSPOW,CPBCCOPT,object,NULLSYM);
				generate(BITSPOW,BRLOC,arg1->xp->xvalue,arg1->xp->xsymptr);
				DBUG_VOID_RETURN;
			case L_SDI:
				break;
				/* Fall through to no-optimize code.    */
			}       /* end switch */
			generate(BITSPOW,0,object | 0x40 ,NULLSYM);     /* turn on bit 6 */
			generate(2*BITSPOW,BRLOC,arg1->xp->xvalue,arg1->xp->xsymptr);
			DBUG_VOID_RETURN;
		}       /* end size = L or UNSPEC */
		/* cpBcc */


	case CPGEN:
		/* cpGEN <co_processor command> */
		if( !as20 )
			wxerror("a 68020/30 instruction");
		if ( size != UNSPEC )
			yyerror("cpGEN instruction is unsized");
		object = inst->opcode |  cp_id << 9;
		/* need more information to generate effective address,
		 * coprocessor command, and extension words
		 */

		DBUG_VOID_RETURN;
		/* cpGEN */

	case CPSCC:
	{       /* cpScc  <ea> */
		if( !as20 )
			wxerror("a 68020/30 instruction");
		if ( size != B && size !=UNSPEC )
			werror("instruction has illegal size attribute, size set to byte");

		size = B;
		object  = 0xf040 | cp_id << 9;
		pc_dot += 2; /* adjust for larger instruction */
		eff_add (arg1,DATALT,size);

		generate(BITSPOW,0,object,NULLSYM);
		generate (BITSPOW,0,inst->opcode,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
	}       /* cpScc */
	 
	case CPRESTORE:
	case CPSAVE:
		/* cpRESTORE  <ea> */
		/* cpSAVE     <ea> */
		if( !as20 )
			wxerror("a 68020/30 instruction");
		if ( size != UNSPEC )
			werror("cpRESTORE/cpSAVE instruction are unsized");
		size = UNSPEC;
		object = inst->opcode |  cp_id << 9;
		if ( (int)(unsigned char)inst->tag == CPSAVE )
			eff_add (arg1,CONALTPRE,size);
		else
			eff_add (arg1,CONPOST,size);

		generate(BITSPOW,0,object,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
		/* cpRESTORE, cpSAVE */


	case CPTPCC:
	{       /* cpTPcc &### */
		/* Trap on co_processor condition with no argument is
		 * implemented in gen0op routine.
		 */
		register int inst1wd,   /* first word of instruction format */
			     inst2wd;   /* second word of instruction format */
		if( !as20 )
			wxerror("a 68020/30 instruction");
		if ( size != W && size != L && size != UNSPEC )
			yyerror("cpTPcc has illegal size attribute");
		if (arg1->atype != AIMM)
			yyerror ("co_processor trap instruction required an absolute, immediate operand");
		inst1wd =  cp_id << 9;
		inst2wd = inst->opcode;
		if ( size == W ||
			(size == UNSPEC &&
			(arg1->xp->xvalue >= -(1<<15) && arg1->xp->xvalue < (1<<15)) ) )
		{
			inst1wd |= 0xf07a;
			generate(BITSPOW,0,inst1wd,NULLSYM);
			generate(BITSPOW,0,inst2wd,NULLSYM);
			generate(BITSPOW,(arg1->xp->xsymptr  == NULLSYM)?0:GENRELOC,
					arg1->xp->xvalue &= 0xffff,arg1->xp->xsymptr);
		}
		else
		{
			inst1wd |= 0xf07b;
			generate(BITSPOW,0,inst1wd,NULLSYM);
			generate(BITSPOW,0,inst2wd,NULLSYM);
			generate(2*BITSPOW,(arg1->xp->xsymptr == NULLSYM)?0:GENRELOC,
					arg1->xp->xvalue,arg1->xp->xsymptr);
		}
		DBUG_VOID_RETURN;
	}       /* cpTPcc */
#endif /* M68881 */

#ifdef M68851
        case PFLUSHR:
        {
		register int inst2wd;   /* 2nd word of instruction format */
                        /* PFLUSHR */
		if (as30 && !as51)
			wxerror("PFLUSHR is a 68851 instruction");
                if ( size != UNSPEC )
		{
			yyerror("PFLUSHR instructions are unsized");
			size = UNSPEC;
		}
		object = inst->opcode;
		pc_dot += 2; /* adjust for larger instruction */
		eff_add (arg1,MEMORY,size);
		generate(BITSPOW,0,object,NULLSYM);
		inst2wd = 0xa000;
		generate(BITSPOW,0,inst2wd,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
        }	/* PFLUSHR */
	case PBCC:
		/* PBcc <label> */
		if (as30 && !as51)
			wxerror("PBcc is a 68851 instruction");
		if ( size != W && size != L  && size != UNSPEC)
			yyerror("instruction has illegal size attribute");

		object = inst->opcode   ;

		if ( size == W )
		{
			generate (BITSPOW,0,object,NULLSYM);
			generate(BITSPOW, BRLOC, arg1->xp->xvalue & 0xffff,
							   arg1->xp->xsymptr);
				DBUG_VOID_RETURN;
		}
		else
		if ( size == L )        /* explicit long cpbranch */
		{       /* turn on bit 6 */
			generate(BITSPOW,0,object | 0x40 ,NULLSYM);
			generate(2*BITSPOW, BRLOC, arg1->xp->xvalue,
							   arg1->xp->xsymptr);
			DBUG_VOID_RETURN;
		}
		else
		{
			if (opt) /* short branch optimization code */
			switch ( shortsdi( arg1->xp->xsymptr,
						      arg1->xp->xvalue, SDI2))
			{
			case S_SDI:     /* pbcc.w guaranteed to work.   */
				generate(BITSPOW,0,object,NULLSYM);
				generate(BITSPOW, BRLOC, arg1->xp->xvalue,
							   arg1->xp->xsymptr);
				DBUG_VOID_RETURN;
			case U_SDI:     /* Don't know, so generate a    */
					/*      short for now.          */
				generate(BITSPOW, CPBCCOPT, object, NULLSYM);
				generate(BITSPOW, BRLOC, arg1->xp->xvalue,
							   arg1->xp->xsymptr);
				DBUG_VOID_RETURN;
			case L_SDI:
				break;
				/* Fall through to no-optimize code.    */
			}       /* end switch */     /* turn on bit 6 */
			generate(BITSPOW, 0, object | 0x40, NULLSYM);
			generate(2*BITSPOW, BRLOC, arg1->xp->xvalue,
							   arg1->xp->xsymptr);
			DBUG_VOID_RETURN;
		}       /* end size = L or UNSPEC */
		/* PBcc */

	case PSCC:
	{       /* PScc  <ea> */
		if (as30 && !as51)
			wxerror("PScc is a 68851 instruction");
		if ( size != B && size !=UNSPEC )
			werror("instruction has illegal size attribute, size set to byte");

		size = B;
		object  = 0xf040;
		pc_dot += 2; /* adjust for larger instruction */
		eff_add (arg1,DATALT,size);

		generate(BITSPOW,0,object,NULLSYM);
		generate (BITSPOW,0,inst->opcode,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
	}       /* PScc */
	 
	case PRESTORE:
	case PSAVE:
		/* PRESTORE  <ea> */
		/* PSAVE     <ea> */
		if (as30 && !as51)
			wxerror("prestore/psave are 68851 instructions");
		if ( size != UNSPEC )
			yyerror("PRESTORE/PSAVE instructions are unsized");
		size = UNSPEC;
		object = inst->opcode;
		if ( (int)(unsigned char)inst->tag == PSAVE )
			eff_add (arg1,CONALTPRE,size);
		else
			eff_add (arg1,CONPOST,size);

		generate(BITSPOW,0,object,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
		/* PRESTORE, PSAVE */


	case PTRAPCC:
	{       /* PTRAPcc &### */
		/* Trap on PMMU co_processor condition with no
		 * argument is implemented in gen0op routine.
		 */
		register int inst1wd,   /* 1st word of instruction format */
			     inst2wd;   /* 2nd word of instruction format */
		if (as30 && !as51)
			wxerror("PTRAPcc is a 68851 instruction");
		if ( size != W && size != L && size != UNSPEC )
			yyerror("PTRAPcc has illegal size attribute");
		if (arg1->atype != AIMM)
			yyerror ("co_processor trap instruction requires an \
absolute, immediate operand");
		inst1wd =  0;
		inst2wd = inst->opcode;
		if ( size == W   ||   ( size == UNSPEC  &&
			      (arg1->xp->xvalue >= -(1<<15)  &&
					       arg1->xp->xvalue < (1<<15)) ) )
		{
			inst1wd |= 0xf07a;
			generate(BITSPOW,0,inst1wd,NULLSYM);
			generate(BITSPOW,0,inst2wd,NULLSYM);
			generate(BITSPOW,
				    (arg1->xp->xsymptr  == NULL)?0:GENRELOC,
			       arg1->xp->xvalue &= 0xffff, arg1->xp->xsymptr);
		}
		else
		{
			inst1wd |= 0xf07b;
			generate(BITSPOW,0,inst1wd,NULLSYM);
			generate(BITSPOW,0,inst2wd,NULLSYM);
			generate(2*BITSPOW,
				     (arg1->xp->xsymptr == NULLSYM)?0:GENRELOC,
					  arg1->xp->xvalue,arg1->xp->xsymptr);
		}
		DBUG_VOID_RETURN;
	}       /* PTRAPcc */
#endif /* M68851 */

	case BKPT:
		if (size != UNSPEC)
			yyerror("bkpt instruction should have no size attribute");
		if (arg1->atype != AIMM || arg1->xp->xtype != ABS)
			yyerror("bkpt vector must be absolute, immediate operand");
		if (arg1->xp->xvalue < 0 || arg1->xp->xvalue > 7)
		{
			yyerror("bkpt vector must be between 0 and 7");
			arg1->xp->xvalue &= 0x7;
		}
		object = inst->opcode | arg1->xp->xvalue;
		generate(BITSPOW,0,object,NULLSYM);
		DBUG_VOID_RETURN;

	case TRAP:
		if (size != UNSPEC)
			werror("trap instruction should have no size attribute");
		if (arg1->atype != AIMM || arg1->xp->xtype != ABS)
			yyerror("trap vector must be absolute, immediate operand");
		if (arg1->xp->xvalue < 0 || arg1->xp->xvalue > 15)
		{
			werror("trap vector must be between 0 and 15");
			arg1->xp->xvalue &= 0xf;
		}
		object = inst->opcode | arg1->xp->xvalue;
		generate(BITSPOW,0,object,NULLSYM);
		DBUG_VOID_RETURN;

	case TPCC:
		/* Trap on condition with no argument is
		 * implemented in gen0op routine.
		 */
		if (!as20)
			wxerror("a 68020/30 instruction");
		if (size != W && size != L && size != UNSPEC)
			yyerror("TPcc instruction has incorrect size attribute");

		if (arg1->atype != AIMM)
			yyerror("TPcc instruction requires an immediate operand");

		object = inst->opcode;
		if ( size == W || (size == UNSPEC && (arg1->xp->xvalue >=  -(1<<15) &&  arg1->xp->xvalue < (1<<15) )) )
		{
			generate (BITSPOW,0,object |= 2,NULLSYM);
			generate(BITSPOW,(arg1->xp->xsymptr == NULLSYM)?0:GENRELOC,
				arg1->xp->xvalue & 0xffff, arg1->xp->xsymptr);
		}
		else
		{
			generate (BITSPOW,0,object |= 3,NULLSYM);
			generate(2*BITSPOW,(arg1->xp->xsymptr == NULLSYM)?0:GENRELOC,
				arg1->xp->xvalue, arg1->xp->xsymptr);
		}
		DBUG_VOID_RETURN;


	case RTM:
		if (!as20 || as30)
			wxerror ("a 68020 instruction");
		if (size != UNSPEC)
			yyerror("rtm instruction should have no size attribute");
		object = inst->opcode ;
		if (arg1->atype == AAREG )	/* set bit 3 for an address register */
			object |= 8;
		else
		if (arg1->atype != ADREG )
			yyerror("rtm instruction operand must be an address or data register");
		object |=  arg1->areg1->opcode;
		generate(BITSPOW,0,object,NULLSYM);
		DBUG_VOID_RETURN;

	case STOP:
		if (size != UNSPEC)
			yyerror("stop instruction should have no size attribute");
		if (arg1->atype != AIMM || arg1->xp->xtype != ABS)
			yyerror("stop operand must be absolute, immediate operand");
		if (arg1->xp->xvalue < -(1<<15) || arg1->xp->xvalue >= (1<<15))
		{
			werror("stop operand must fit into a word (masked)");
			arg1->xp->xvalue &= 0xffff;
		}
		generate(BITSPOW,0,inst->opcode,NULLSYM);
		generate(BITSPOW,0,arg1->xp->xvalue,NULLSYM);
		DBUG_VOID_RETURN;

	case SWAP:
		if (size == B || size == L)
			yyerror("only word size attribute allowed for swap instruction");
		if (arg1->atype != ADREG)
			yyerror("swap instruction operand must be a data register");
		object = inst->opcode | arg1->areg1->opcode;
		generate(BITSPOW,0,object,NULLSYM);
		DBUG_VOID_RETURN;

	case EXT:
		/* ext, extb, extw */
		/* for as20
		 * if size is unspecified
		 * extb  is translated as extend byte to word
		 * extw  is translated as extend word to long
		 */
		if( !as20 && size == L && strcmp( "extb", inst->name) == 0 )
			wxerror("a 68020/30 instruction");
		if (size != UNSPEC && size != W && size != L)
			yyerror("ext instruction only allows word or long size attribute");
		if (arg1->atype != ADREG)
			yyerror("ext instruction operand must be a data register");
		object = inst->opcode | arg1->areg1->opcode;
		object |= (size == L) ? 0xc0 : 0x80;
		object &= ((size == W || size == UNSPEC) ? 0xfeff : 0xffff);
			
		if ( inst->name[3] == 'w' )
			object |= 0xc0;	/* word to long */

		generate(BITSPOW,0,object,NULLSYM);
		DBUG_VOID_RETURN;
	
	case UNLK:
		if (size != UNSPEC)
			yyerror("unlk instruction should have no size attribute");
		if (arg1->atype != AAREG)
			yyerror("unlk instruction operand must be an address register");
		object = inst->opcode | arg1->areg1->opcode;
		generate(BITSPOW,0,object,NULLSYM);
		DBUG_VOID_RETURN;

	case BR:
	case BRA:
	case BSR:
	{
		extern unsigned long symcnt;
		extern upsymins lookup();
		extern int deflab();
		long    val;
		symbol *sym;

		val = arg1->xp->xvalue;
		sym = arg1->xp->xsymptr;
		switch( arg1->atype )
		{
		case ABSU:
		case ABSW:
		case ABSL:
			if( sym == NULLSYM )
			{
			    /* make absolute literal into a symbol          */
			    /* which will be eliminated in outsyms()<obj.c> */
			    /* but which will be literally interpreted in   */
			    /* brloc(): not optimized to avoid confusion    */
			    /* for as programmer; also difficult to do.     */
				char lbl[12];
				(void) sprintf( lbl, "(%d", symcnt );
				sym = lookup( lbl, INSTALL, USRNAME ).stp;
				sym->styp    = dot->styp;
				sym->sectnum = dot->sectnum;
				sym->value   = val;
				val = 0;
			}
			/* what follows is a kludge until optimizer goes */
			/* down to byte width branches */
			else if( sym == dot && size == UNSPEC && opt )
			{
				if( val <= 130 && val >= -126 )
					size = B;
			}
			break;
		default:
			yyerror("Illegal address mode");
		}
		if (size == B)
		{
			if( val > 128 || val < -126 )
				werror("Larger address/offset masked to 8 bits");
			generate(BITSPBY,0,inst->opcode >> BITSPBY,NULLSYM);
			generate(BITSPBY,BRLOC,val & 0xff,sym);
			DBUG_VOID_RETURN;
		}
		else
		if (size == W)
		{
			if( val > 32768 || val < -32766 )
				werror("Larger address/offset masked to 16 bits");
			generate(BITSPOW,0,inst->opcode,NULLSYM);
			generate(BITSPOW,BRLOC,val & 0xffff,sym);
			DBUG_VOID_RETURN;
		}
		else
		{
			if (opt && size == UNSPEC)
			switch( shortsdi( sym, val, (inst->tag == BR ? SDI2 :
					 (inst->tag == BRA ? SDI1 : SDI3)) ) )
			{
			case S_SDI:     /* .w guaranteed to work.    */
				generate(BITSPOW,0,inst->opcode,NULLSYM);
				generate(BITSPOW,BRLOC,val,sym);
				DBUG_VOID_RETURN;
			case U_SDI:	/* Don't know, so generate a	*/
					/*	short for now.		*/
				generate(BITSPOW,(inst->tag == BR ? BCCOPT :
					(inst->tag == BRA ? BRAOPT : BSROPT)),
							inst->opcode,NULLSYM);
				generate(BITSPOW,BRLOC,val,sym);
				DBUG_VOID_RETURN;
			case L_SDI:
				break;
				/* Fall through to no-optimize code.	*/
			}
			if( !as20 )
			{
				if( inst->tag == BR )
				{
				    /* Negate the direction of the branch,  */
				    /* then use this to branch around a     */
				    /* jmp.  Direction is reversed by       */
				    /* toggling eighth bit.                 */
					object = inst->opcode ^ 0x100;

				    /* Add a displacement which will get    */
				    /* past the jmp.                        */
					object |= 6;
					generate(BITSPOW,0,object,NULLSYM);
				}
				generate(BITSPOW,0,(inst->tag == BSR ?
						    0x4eb9 : 0x4ef9),NULLSYM);
				generate(2*BITSPOW,GENRELOC,val,sym);
			}
			else
			{
			    /* 68020 allows size=L */
				generate(BITSPOW,0,inst->opcode | 0xff,NULLSYM);
				generate(2*BITSPOW,BRLOC,val,sym);
			}
			DBUG_VOID_RETURN;
		}
	}
	case ASHFT:
	case LSHFT:
	case ROT:
	case ROTX:
			/* rotate/shift <ea> */
			if (size != W && size != UNSPEC)
			{
				size = W;
				werror("rotate/shift of memory requires word attribute only");
			}
			object = inst->opcode;
			eff_add(arg1,ALTMEM,size);
#ifndef M68020
			generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;

	case RTD:
		if( !as10 )
			wxerror("a 68010/20/30 instruction");
		if (size != UNSPEC)
			yyerror("rtd is unsized");
		if (arg1->xp->xvalue < -(1<<15) || arg1->xp->xvalue >= (1<<15))
		{
			werror("rtd displacement is 16 bit signed (masked)");
			arg1->xp->xvalue &= 0xffff;
		}
		generate(BITSPOW,0,inst->opcode,NULLSYM);
		if (arg1->atype != AIMM)
			yyerror("rtd instruction requires immediate operand");
		else
			generate(BITSPOW,(arg1->xp->xsymptr == NULL) ? 0 : GENRELOC,
				 arg1->xp->xvalue,arg1->xp->xsymptr);
		DBUG_VOID_RETURN;

	case OPTSIZE:		/*	clr, neg, negx, not.	*/
		if (size == UNSPEC)
			size = W;
		object = inst->opcode | (size << 6);
		eff_add(arg1,DATALT,size);
#ifndef	M68020
		generate(BITSPOW,action,object,NULLSYM);
		if (numwords == 1)
			generate(BITSPOW,action,word,symptr);
		else if (numwords == 2)
			generate(2*BITSPOW,action,word,symptr);
#else
		generate(BITSPOW,0,object,NULLSYM);
		gen_eff_add();
#endif
		DBUG_VOID_RETURN;

	case TST:		
		if (size == UNSPEC)
			size = W;
		object = inst->opcode | (size << 6);

#ifndef M68020
		/* 68000 allows data alterable addressing only */
		eff_add(arg1,DATALT,size);
		generate(BITSPOW,action,object,NULLSYM);
		if (numwords == 1)
			generate(BITSPOW,action,word,symptr);
		else if (numwords == 2)
			generate(2*BITSPOW,action,word,symptr);
#else
		/* 68020 allows data addressing for size = B */
		if( !as20 && (arg1->atype == APCOFF || arg1->atype == APCNDX) )
			wxerror("a 68020/30 addressing mode for tst");
		if (size == B)
			eff_add(arg1,DATAA,size);
		else
			eff_add(arg1,ALL,size);
		generate(BITSPOW,0,object,NULLSYM);
		gen_eff_add();
#endif /* M68020 */

		DBUG_VOID_RETURN;

	default:	/* jmp, jsr, nbcd, pea, scc, tas		*/
		if (   size != UNSPEC		/* check for correct size */
		    && size != ((int)(unsigned char)inst->tag - DEFAULT))
			yyerror("incorrect size specification for instruction");
		object = inst->opcode;
		if ((int)(unsigned char)inst->tag == DEFAULT+B)
			eff_add(arg1,DATALT,size);
		else
			eff_add(arg1,CONTROL,size);
#ifndef M68020
		generate(BITSPOW,action,object,NULLSYM);
		if (numwords == 1)
			generate(BITSPOW,action,word,symptr);
		else if (numwords == 2)
			generate(2*BITSPOW,action,word,symptr);
#else
		generate(BITSPOW,0,object,NULLSYM);
		gen_eff_add();
#endif
		DBUG_VOID_RETURN;
	}
}	/* gen1op()	*/


gen2op(inst,size,arg1,arg2)
register instr		*inst;
register int		size;
register struct arg	*arg1,
			*arg2;
{
	DBUG_ENTER ("gen2op");
	pc_dot = newdot;
	object = inst->opcode;

	switch ((int)(unsigned char)inst->tag)
	{

#ifdef M68881 /* co_processor instructions */
	case CPDBCC:
	{       /* cpDBcc  Dn,label */
		register int inst1wd,           /* first word of instruction format */
			     inst2wd;           /* second word of instruction format */
		if( !as20 )
			wxerror("a 68020/30 instruction");
		if ( size != W && size != UNSPEC)
			yyerror("instruction has illegal size attribute");
		if ( size == UNSPEC ) size = W;
		if (arg1->atype != ADREG)
			yyerror ("cpDBcc instruction requires data register for first operand");
		inst1wd = (0xf048 | cp_id << 9 | arg1->areg1->opcode);
		inst2wd = object;

		generate (BITSPOW, 0, inst1wd, NULLSYM);
		generate (BITSPOW, 0, inst2wd, NULLSYM);

		if ( size == W )
			generate(BITSPOW,BRLOC,arg2->xp->xvalue & 0xffff,
				arg2->xp->xsymptr);
		/*      leave the following, in case of cpDBcc allows size L
		else
			generate(2*BITSPOW,BRLOC,arg2->xp->xvalue,
				arg2->xp->xsymptr);
		*/
		DBUG_VOID_RETURN;
	}       /* cpDBcc */

	case FCMP:
	{	/* syntactic change in operand ordering, consistent with other cmp
		 * fcmp %fpn,<ea>
		 * fcmp %fpn,%fpm
		 */
		register int inst2wd;		/* second word of instruction format */
		if (size != UNSPEC && size != B && size != W && size != L &&
			size != S && size != D && size != X && size != P)
			yyerror("instruction has illegal size attribute");

		if (arg1->atype != FPREG)
			yyerror ("floating point register required for first operand");
		if (arg2->atype == FPREG && size != X && size != UNSPEC)
			werror ("instruction requires size X, if source is from a floating point register");

		object |= cp_id << 9;
		inst2wd = arg1->areg1->opcode << 7;
		if (arg2->atype == FPREG)
		{	/* source is from a floating point register */
			size = X;
			inst2wd |= (0x0038 |  arg2->areg1->opcode << 10);
			generate (BITSPOW, 0, object , NULLSYM);
			generate (BITSPOW, 0, inst2wd, NULLSYM);
		}
		else
		{
			if ( size == UNSPEC )
			{
				size = W;
				werror("No size specified for floating point instruction, W used");
			}
			pc_dot += 2; /* adjust for larger instruction */
			if (size == B || size == W || size == L || size == S)
				eff_add (arg2,DATAA,size);
			else
				eff_add (arg2,MEMORY,size);
			generate(BITSPOW,0,object,NULLSYM);
			inst2wd |= (0x4038 | SRCFMT[size] << 10);
			generate(BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
		}
		DBUG_VOID_RETURN;
	}	/* fcmp */


	case FMOV:
	{
		register int inst2wd;		/* second word of instruction format */
		if (size != UNSPEC && size != B && size != W && size != L &&
			size != S && size != D && size != X && size != P)
			yyerror("instruction has illegal size attribute");

		object  |=  cp_id << 9;
		if (arg2->atype == FPREG)
		{	/* fmov %fpm,%fpn
			 * fmov <ea>,%fpn
			 */
			if (arg1->atype == FPREG)
			{
				if ( size != UNSPEC && size != X )
				{
					werror ("instruction requires size X");
				}
				size = X;
				inst2wd=  arg1->areg1->opcode<<10 | arg2->areg1->opcode<<7;
				generate (BITSPOW, 0, object, NULLSYM);
				generate (BITSPOW, 0, inst2wd, NULLSYM);
				DBUG_VOID_RETURN;
			}
			else
			{	if (arg1->atype == FPCONTROL || arg1->atype == FPIADDR ||
					arg1->atype == FPSTATUS )
					yyerror ("instruction has illegal register for source operand");
				if ( size == UNSPEC )
				{
					size = W;
					werror("No size specified for floating point instruction, W used");
				}
				pc_dot += 2; /* adjust for larger instruction */
				if (size == B || size == W || size == L || size == S)
					eff_add (arg1,DATAA,size);
				else
					eff_add (arg1,MEMORY,size);
				generate(BITSPOW,0,object,NULLSYM);
				inst2wd = (0x4000 | SRCFMT[size]<<10 | arg2->areg1->opcode <<7);
				generate(BITSPOW,0,inst2wd,NULLSYM);
				gen_eff_add();
				DBUG_VOID_RETURN;
			}
		}
		else
		if (arg1->atype == FPCONTROL || arg1->atype == FPSTATUS)
		{ /* fmov %control,<ea> 
		   * fmov %status,<ea>
		   */
			if (size == UNSPEC) size = L;
			if (size != L )
				yyerror("instruction has illegal size attribute");
			if (arg2->atype == FPREG)
				yyerror ("instruction has illegal register for second operand");
			if(arg1->atype == FPCONTROL)
				inst2wd = 0xb000;
			else
				inst2wd = 0xa800;
			pc_dot += 2; /* adjust for larger instruction */
			eff_add (arg2,DATALT,size);
			generate(BITSPOW,0,object,NULLSYM);
			generate(BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
			DBUG_VOID_RETURN;
		}
		else
		if (arg1->atype == FPIADDR)
		{	/* fmov %iaddr,<ea> */
			if (size == UNSPEC) size = L;
			if (size != L )
				yyerror("instruction has illegal size attribute");
			if (arg2->atype == FPREG)
				yyerror ("instruction has illegal register for second operand");
			inst2wd = 0xa400;
			pc_dot += 2; /* adjust for larger instruction */
			eff_add (arg2,ALT,size);
			generate(BITSPOW,0,object,NULLSYM);
			generate(BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
			DBUG_VOID_RETURN;
		}
		else
		if (arg2->atype == FPCONTROL || arg2->atype == FPSTATUS)
		{ /* fmov <ea>,%control
		   * fmov <ea>,%status
		   */
			if ( size == UNSPEC) size = L;
			if (size != L )
				yyerror("instruction has illegal size attribute");
			if (arg1->atype == FPREG)
				yyerror ("instruction has illegal register for first operand");
			if(arg2->atype == FPCONTROL)
				inst2wd = 0x9000;
			else
				inst2wd = 0x8800;
			pc_dot += 2; /* adjust for larger instruction */
			eff_add (arg1,DATAA,size);
			generate(BITSPOW,0,object,NULLSYM);
			generate(BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
			DBUG_VOID_RETURN;
		}
		else
		if (arg2->atype == FPIADDR)
		{ /* fmov <ea>,%iaddr */
			if ( size == UNSPEC) size = L;
			if (size != L )
				yyerror("instruction has illegal size attribute");
			if (arg1->atype == FPREG)
				yyerror ("instruction has illegal register for first operand");
			inst2wd = 0x8400;
			pc_dot += 2; /* adjust for larger instruction */
			eff_add (arg1,ALL,size);
			generate(BITSPOW,0,object,NULLSYM);
			generate(BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
			DBUG_VOID_RETURN;
		}
		else
		if (arg1->atype == FPREG)
		{	/* fmov %fpn,<ea> */
			if (arg2->atype == FPCONTROL || arg2->atype == FPIADDR ||
				arg2->atype == FPSTATUS)
				yyerror("instruction has illegal register for second operand");
			if ( size == UNSPEC )
			{
				size = W;
				werror("No size specified for floating point instruction, W used");
			}
			pc_dot += 2; /* adjust for larger instruction */
			if (size == B || size == W || size == L || size == S)
				eff_add (arg2,DATALT,size);
			else
				eff_add (arg2,ALTMEM,size);
			generate(BITSPOW,0,object,NULLSYM);
			inst2wd = 0x6000 | SRCFMT[size] << 10 | arg1->areg1->opcode <<7;
			generate(BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
			DBUG_VOID_RETURN;
		}
		else
		{
			yyerror("FMOV instruction has illegal operands");
			DBUG_VOID_RETURN;
		}
	}	/* fmov */

	case FMOVCR:
	{	/* fmovcr &I,%fpn */
		register int inst2wd;
		if ( size != X && size != UNSPEC)
			werror("instruction has illegal size attribute, size set to X");		
		if ( arg1->atype != AIMM )
			yyerror("instruction required immediate value for first operand");
		if ( arg2->atype != FPREG )
			yyerror("instruction required floating point register for second operand");
		if ( arg1->xp->xvalue != 0 && 
			 ! (arg1->xp->xvalue >= 0xb  && arg1->xp->xvalue <= 0xf) &&
			 ! (arg1->xp->xvalue >= 0x30 && arg1->xp->xvalue <= 0x3f))
			yyerror("instruction has illegal constant value");
		
		size = X;
		object |= cp_id << 9;
		inst2wd = (0x5c00 | arg2->areg1->opcode << 7 | arg1->xp->xvalue & 0x7f);
		generate(BITSPOW,0,object,NULLSYM);
		generate(BITSPOW,(arg1->xp->xsymptr==NULLSYM?0:GENRELOC),
				inst2wd,arg1->xp->xsymptr);
		DBUG_VOID_RETURN;
	}	/* fmovcr */
		
	case FMOVM:
	{	long inst2wd;

		object |= cp_id << 9;

		if ( arg2->atype == FPCONTROL || arg2->atype == FPIADDR ||
			arg2->atype == FPSTATUS )
		{	/* fmovm <ea>,%control
			 * fmovm <ea>,%iaddr
			 * fmovm <ea>,%status
			 */
			if ( size != L && size != UNSPEC )
				werror("instrucion has illegal size attribute, size set to L");
			size = L;
			pc_dot += 2; /* adjust for larger instruction */
			if (arg2->atype == FPIADDR)
				eff_add (arg1,ALL,size); 
			else
				eff_add (arg1,DATAA,size);
			inst2wd = 0x8000|arg2->areg1->opcode << 10;
			generate(BITSPOW,0,object,NULLSYM);
			generate(BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
			DBUG_VOID_RETURN;
		}
		else
		if ( arg1->atype == FPCONTROL || arg1->atype == FPIADDR ||
			arg1->atype == FPSTATUS )
		{	/* fmovm %control,<ea>
			 * fmovm %iaddr,<ea>
			 * fmovm %status,<ea>
			 */
			if ( size != L && size != UNSPEC )
				werror("instrucion has illegal size attribute, size set to L");
			size = L;
			pc_dot += 2; /* adjust for larger instruction */
			if (arg1->atype == FPIADDR)
				eff_add (arg2,ALT,size); 
			else
				eff_add (arg2,DATALT,size);
			inst2wd = 0xa000|arg1->areg1->opcode << 10;
			generate(BITSPOW,0,object,NULLSYM);
			generate(BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
			DBUG_VOID_RETURN;
		}
		else
		if ( arg1->atype == AIMM  || arg1->atype == ADREG)
		{	/* fmovm register list,<ea>	*/
			/* fmovm %dn,<ea>	*/
			if ( size != X && size != UNSPEC)
				werror("instrucion has illegal size attribute, size set to X");
			size = X;
			if (arg1->atype == AIMM)
				inst2wd = (arg2->atype == ADEC?0xe000:0xf000)|
						(arg1->xp->xvalue & 0xff);
			else
				inst2wd = (arg2->atype == ADEC?0xe800:0xf800)| arg1->areg1->opcode << 4;
			pc_dot += 2; /* adjust for larger instruction */
			eff_add (arg2,CONALTPRE,size);
			generate(BITSPOW,0,object,NULLSYM);
			if ( arg1->xp->xsymptr != NULLSYM && arg1->atype == AIMM)
			{
				/* only relocate the lower 8 bits */
				generate(BITSPBY,0,inst2wd>>BITSPBY,NULLSYM);
				generate(BITSPBY,GENRELOC,arg1->xp->xvalue,arg1->xp->xsymptr);
			}
			else
				generate (BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
			DBUG_VOID_RETURN;
		}
		else
		if ( arg2->atype == AIMM  || arg2->atype == ADREG)
		{	/* fmovm <ea>,register list	*/
			/* fmovm <ea>,%dn	*/
			if ( size != X && size != UNSPEC)
				werror("instrucion has illegal size attribute, set to X");
			size = X;
			if (arg2->atype == AIMM)
				inst2wd = 0xd000 | arg2->xp->xvalue & 0xff;
			else
				inst2wd = 0xd800 | arg2->areg1->opcode << 4;
			pc_dot += 2; /* adjust for larger instruction */
			eff_add (arg1,CONPOST,size);
			generate(BITSPOW,0,object,NULLSYM);
			if ( arg2->atype == AIMM && arg2->xp->xsymptr != NULLSYM )
			{
				/* only relocate the lower 8 bits */
				generate(BITSPBY,0,inst2wd>>BITSPBY,NULLSYM);
				generate(BITSPBY,GENRELOC,arg2->xp->xvalue,arg2->xp->xsymptr);
			}
			else
				generate (BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
			DBUG_VOID_RETURN;
		}
		else
		{
			yyerror("instruction has illegal operand combinations");
			DBUG_VOID_RETURN;
		}
	}	/* fmovm */

	case FSGLDIV:
	case FSGLMUL:
	case FOP:
	{
		register int inst1wd,		/* first word of instruction format */
		             inst2wd;		/* second word of instruction format */

		if (arg2->atype != FPREG)
			yyerror ("floating point register required for second operand");

		inst1wd = 0xf000 | cp_id << 9;
		inst2wd = object | arg2->areg1->opcode << 7;
		if (arg1->atype == FPREG)
		{
			if ( size == UNSPEC )
			{
				size = X;
				werror("No size specified for floating point instruction, X used");
			}
			else
			if ( size != X )
			{
				werror ("instruction requires size X, if source is from a floating point register");
				size = X;
			}
			inst2wd |= arg1->areg1->opcode << 10;
			generate (BITSPOW, 0, inst1wd, NULLSYM);
			generate (BITSPOW, 0, inst2wd, NULLSYM);
		}
		else
		{
			if ( size == UNSPEC )
			{
				size = W;
				werror("No size specified for floating point instruction, W used");
			}
			object = inst1wd;
			pc_dot += 2; /* adjust for larger instruction */
			if (size == B || size == W || size == L || size == S)
				eff_add (arg1,DATAA,size);
			else
				eff_add (arg1,MEMORY,size);
			generate(BITSPOW,0,object,NULLSYM);
			inst2wd |= (0x4000 | (SRCFMT[size] << 10));
			generate(BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
		}
		DBUG_VOID_RETURN;
	}	/* fop */
#endif /* M68881 */

#ifdef M68851 /* PMMU co_processor instructions */
	case PDBCC:
	{       /* PDBcc  Dn,label */
		register int inst1wd,   /* 1st word of instruction format */
			     inst2wd;   /* 2nd word of instruction format */
		if (as30 && !as51)
			wxerror("PDBcc is a 68851 instruction");
		if ( size != W && size != UNSPEC)
			yyerror("instruction has illegal size attribute");
		if ( size == UNSPEC ) size = W;
		if (arg1->atype != ADREG)
			yyerror ("PDBcc instruction requires data register for first operand");
		inst1wd = (0xf048 | arg1->areg1->opcode);
		inst2wd = object;

		generate (BITSPOW, 0, inst1wd, NULLSYM);
		generate (BITSPOW, 0, inst2wd, NULLSYM);

		if ( size == W )
			generate(BITSPOW,BRLOC,arg2->xp->xvalue & 0xffff,
				arg2->xp->xsymptr);
		/*      leave the following, in case of PDBcc allows size L
		else
			generate(2*BITSPOW,BRLOC,arg2->xp->xvalue,
				arg2->xp->xsymptr);
		*/
		DBUG_VOID_RETURN;
	}       /* PDBcc */
        case PFLUSHS:
		if (as30 && !as51)
			wxerror("PFLUSHS is a 68851 instruction");
        case PFLUSH:
        {
		register int inst2wd;  /* second word of instruction format */
		register int fcmask;
                        /* PFLUSH, PFLUSHS */
                if ( size != UNSPEC )
		{
			yyerror("PFLUSH instructions are unsized");
			size = UNSPEC;
		}
		object = inst->opcode;
		switch (arg1->atype) {
		case AIMM:
		case ADREG:
			break;
		case CTLREG:
			if ((arg1->areg1->opcode | 1) == 1)  /* == 0 or 1 */
				break;
		default:
			yyerror ("function code must be immediate/data register/SFC or DFC register");
			break;
		}
		if ( arg2->atype != AIMM )
			yyerror ("PFLUSH mask must be an immediate value");
		generate(BITSPOW,0,object,NULLSYM);
		fcmask = arg2->xp->xvalue & ( as30 ? 0x7 : 0xf );
		if ( fcmask != arg2->xp->xvalue )
			yyerror ("PFLUSH mask is too large for MMU");
		inst2wd = 0x3000 | fcmask << 5;
                if ( (int)(unsigned char)inst->tag == PFLUSHS )
		      inst2wd |= 0x400;
                if ( arg1->atype == AIMM )
                {
		      inst2wd |= 0x10 | arg1->xp->xvalue;
                }
                else
                if ( arg1->atype == ADREG )
                {
		      inst2wd |= 8 | arg1->areg1->opcode;
                }
                else
                   inst2wd |= arg1->areg1->opcode;
		generate(BITSPOW,0,inst2wd,NULLSYM);
		DBUG_VOID_RETURN;
	}       /* PFLUSH, PFLUSHS */
        case PLOADR:
        case PLOADW:
	{       /* PLOAD */
		register int inst1wd,  /* first  word of instruction format */
			     inst2wd;  /* second word of instruction format */

                if ( size != UNSPEC )
		{
			yyerror("PLOAD instructions are unsized");
			size = UNSPEC;
		}
		object = inst->opcode  ;
		pc_dot += 2; /* adjust for larger instruction */
		eff_add (arg2,(CONTROL & ALT),size);
		generate(BITSPOW,0,object,NULLSYM);
		switch (arg1->atype) {
		case AIMM:
			inst2wd = 0x2010 | arg1->xp->xvalue;
			break;
		case ADREG:
			inst2wd = 0x2008 | arg1->areg1->opcode;
			break;
		case CTLREG:
			if ((arg1->areg1->opcode | 1) == 1 )  {
				inst2wd = 0x2000 | arg1->areg1->opcode;
				break;
			}
		default:
			yyerror ("function code must be immediate/data register/SFC or DFC register");
			break;
		}

                if ( (int)(unsigned char)inst->tag == PLOADR )
			inst2wd |= 0x200;
		generate(BITSPOW,0,inst2wd,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
        }	/* PLOADR/PLOADW */
	case PMOVE:
	case PMOVEFD:
	{       /* PMOVE, PMOVEFD */
		register int inst2wd;  /* second word of instruction format */
		register int preg, eamode, modes;
		register struct arg     *parg, *eaarg;
                        /* PMOVE */
		/* check for arg1 or arg2 being a PMMU reg */
		switch (arg1->atype) {
		case TT0:
		case TT1:
			if( strcmp( "%tt0", arg1->areg1->name )  &&
					 strcmp( "%tt1", arg1->areg1->name ) )
				goto really_aN;
			if (!as30) wxerror("arg 1 is a 68030 register");
		case DRP:
		case CAL:
		case VAL:
		case SCC:
		case AC:
		case PCSR:
		case BAD:
		case BAC:
			if (as30 && arg1->atype < TT0 )
				wxerror("arg 1 not a 68030 register");
		case TC:
		case SRP:
		case CRP:
		case PSR:
			preg = arg1->atype;
			parg = arg1;
			eamode = arg2->atype;
			eaarg = arg2;
			break;
		default:
		really_aN:
			switch (arg2->atype) {
			case PCSR:
				yyerror("PMOVE to PCSR register not allowed");
			case TT0:
			case TT1:
				if (!as30) wxerror("arg 2 is a 68030 register");
			case DRP:
			case CAL:
			case VAL:
			case SCC:
			case AC:
			case BAD:
			case BAC:
				if (as30 && arg2->atype < TT0 )
					wxerror("arg 2 not a 68030 register");
			case TC:
			case SRP:
			case CRP:
			case PSR:
				if ((int)(unsigned char)inst->tag == PMOVEFD
						       && arg2->atype == PSR )
				{
					yyerror("PMOVEFD cannot move to the MMUSR");
				}
				preg = arg2->atype;
				parg = arg2;
				eamode = arg1->atype;
				eaarg = arg1;
				break;
			default:
				yyerror("PMOVE requires a PMMU reg as an arg");
				break;
			}
			break;
		}
		if ( size == UNSPEC )
		{
			switch (preg)
			{
			case DRP:
			case CRP:
			case SRP:
				size = D;
				break;
			case TC:
			case TT0:
			case TT1:
				size = L;
				break;
			case BAC:
			case BAD:
			case PCSR:
			case AC:
			case PSR:
				size = W;
				break;
			case CAL:
			case VAL:
			case SCC:
				size = B;
				break;
			default:		/* first arg not PMMU reg */
				break;
			}
		}
		/* do cross-checking, now that size is specified */
		switch (size) {
		case D:
                {
			switch (preg) {
			case CRP:
			case SRP:
			case DRP:
				switch (eamode) {
				case ADREG:
				case AAREG:
					yyerror("data or address register direct addressing not allowed for CRP, SRP, and DRP registers");
					break;
				}
				break;
			default:
				yyerror("PMOVE requires CRP/SRP/DRP register for size D");
				break;
			}
			break;
                }
		case L:
                { 
			switch (preg) {
			case TT0:
			case TT1:
			case TC:
				break;
			default:
				if (as30)
					yyerror("PMOVE requires TC/TT0/TT1 reg for size L");
				else
					yyerror("PMOVE requires TC register for size L");
				break;
			}
			break;
                }
		case W:
                {
			switch (preg) {
			case BAC:
			case BAD:
			case AC:
			case PSR:
			case PCSR:
				break;
			default:
				yyerror("PMOVE requires BAC/BAD/AC/PSR/PCSR register for size W");
				break;
			}
			break;
                }
		case B:
                {
			switch (preg) {
			case CAL:
			case VAL:
			case SCC:
				break;
			default:
				yyerror("PMOVE requires CAL/VAL/SCC register for size B");
				break;
			}
			break;
                }
		default:
			break;
		}
		object = inst->opcode; /* must be set before eff_add() */
		inst2wd = 0; /* now included in atype << 8 */
		if ((int)(unsigned char)inst->tag == PMOVEFD)
		{
			if (!as30)
				wxerror("PMOVEFD is a 68030 instruction");
			inst2wd |= 0x100;
		}
		switch (preg) {
		case BAD:
		case BAC:
			inst2wd |= (parg->areg1->opcode << 2);
		case TC:
		case DRP:
		case SRP:
		case CRP:
		case CAL:
		case VAL:
		case SCC:
		case AC:
		case PSR:
		case PCSR:
		case TT0:
		case TT1:
			/* position bit pattern, fix for TT0, TT1 registers */
			/*     and set R/~W bit if necessary */
			inst2wd |= (preg << 8)
					  | (preg == arg1->atype ? 0x200 : 0);
			if(as30 || preg == TT0 || preg == TT1)
			{
				register int eamodcat;

				/* convert ea mode to mode category */
				eamodcat =
				      0x800 >> ((eamode & 7) + (eamode >> 3));
				modes = (CONTROL & ALT);
				if( !(modes & eamodcat) )
				{
					wxerror( "68030 PMOVE address mode must be control alterable");
					modes = ALL;
				}
			}
			else if (preg == arg1->atype)
				modes = ALT;
			else /* (preg == arg2->atype) */
				modes = ALL;
			pc_dot += 2; /* adjust for larger instruction */
			eff_add (eaarg,modes,size);
			break;
		default:
			break;
		}

		generate(BITSPOW,0,object,NULLSYM);
		generate(BITSPOW,0,inst2wd,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
	}       /* PMOVE, PMOVEFD */
        case PVALID:
	{       /* PVALID */
		register int inst2wd;  /* second word of instruction format */
		if (as30 && !as51)
			wxerror("PVALID is a 68851 instruction");
		if (size != UNSPEC && size != L)
			yyerror("PVALID size must be long");

                size = L;
		object = inst->opcode  ;
		if ( arg1->atype != AAREG && arg1-> atype != VAL )
			yyerror ("PVALID first argument not an address register or VAL register");
		pc_dot += 2; /* adjust for larger instruction */
		eff_add (arg2,(CONTROL & ALT),size);
		generate(BITSPOW,0,object,NULLSYM);
                if ( arg1->atype == AAREG )
                {
			inst2wd = 0x2c00 | arg1->areg1->opcode;
                }
                else
			inst2wd = 0x2800;
		generate(BITSPOW,0,inst2wd,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
        }	/* PVALID */

#endif /* M68851 */
	case CHK:
		/* 68020 allows size = L */
		object = 0x4000;
		switch( size )
		{
		case W:
		case UNSPEC:
			break;
		case L:
			if( !as20 )
				wxerror("a 68020/30 size attribute");
			break;
		default:
			yyerror("instruction has incorrect size attribute");
			break;
		}
		if (arg2->atype != ADREG)
			yyerror("instruction requires data register for second operand");
		else
			object |= (arg2->areg1->opcode << 9);

		object |= ( size == L )  ?  0x100 :  0x180 ;  
		eff_add(arg1,DATAA,size);

#ifndef M68020
		generate(BITSPOW,action,object,NULLSYM);
		if (numwords == 1)
			generate(BITSPOW,action,word,symptr);
		else if (numwords == 2)
			generate(2*BITSPOW,action,word,symptr);
#else
		generate(BITSPOW,0,object,NULLSYM);
		gen_eff_add();
#endif
		DBUG_VOID_RETURN;

#ifdef M68020
	case CHK2:			
		{
		register int inst2wd;		/* second word of instruction format */
		if (!as20)
			wxerror("a 68020/30 instruction");
		if (size == UNSPEC)
		{
			size = W;
			werror("size needed on CHK2 instruction,size default to word");
		}
		if (  size != B && size != W && size != L )
			yyerror("illegal size attribute");

		object |= size << 9;
		inst2wd = 0x800;     /* turn on bit 11 for instruction CHK2 */
		if (arg2->atype == AAREG)	/* An */
		{
			inst2wd |= arg2->areg1->opcode << 12;
			inst2wd |= 0x8000;	/* turn on bit 15 */
		}
		else
		if (arg2->atype == ADREG)	/* Dn */
			inst2wd |= arg2->areg1->opcode << 12;
		else
			yyerror("second operand must be a general register");

		pc_dot += 2; /* adjust for larger instruction */
		eff_add(arg1,CONTROL,size);
		generate(BITSPOW,0,object,NULLSYM);
		generate(BITSPOW,0,inst2wd,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
		}
	case CMP2:
		{	/* cmp2 %rn,<ea> 
		 	 * syntactic change in the operand ordering. 
			 * make it consistent with other cmp instructions.
			 */
		register int inst2wd;		/* second word of instruction format */
		if (!as20)
			wxerror("a 68020/30 instruction");
		if (size == UNSPEC)
		{
			size = W;
			werror("size needed on CMP2 instruction,size default to word");
		}
		if (  size != B && size != W && size != L )
			yyerror("illegal size attribute");

		object |= size << 9;
		inst2wd = 0;
		if (arg1->atype == AAREG)	/* An */
		{
			inst2wd |= 0x8000;	/* turn on bit 15 */
			inst2wd |= arg1->areg1->opcode << 12;
		}
		else
		if (arg1->atype == ADREG)	/* Dn */
			inst2wd |= arg1->areg1->opcode << 12;
		else
			yyerror("first operand must be a general register %dn or %an");

		pc_dot += 2; /* adjust for larger instruction */
		eff_add(arg2,CONTROL,size);
		generate(BITSPOW,0,object,NULLSYM);
		generate(BITSPOW,0,inst2wd,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
		}
#endif /* M68020 */

#ifdef M68020
	case CALLM:		
		if (!as20 || as30)
			wxerror("a 68020 instruction");
		if ( size != UNSPEC )
			yyerror("callm instruction should have no size attribute");
		if (arg1->atype != AIMM)
			yyerror("callm first operand must be absolute, immediate operand");
		if ( arg1->xp->xvalue < 0 || arg1->xp->xvalue > 255 )
		{
			werror("callm argument count must fit into a byte");
			arg1->xp->xvalue &= 0xff;
		}
		pc_dot += 2; /* adjust for larger instruction */
		eff_add (arg2,CONTROL,size);
		generate(BITSPOW,0,object,NULLSYM);
		generate(BITSPOW,
				(arg1->xp->xsymptr == NULLSYM) ? 0 : GENRELOC,
				arg1->xp->xvalue,arg1->xp->xsymptr);
		gen_eff_add();
		DBUG_VOID_RETURN;
#endif /* M68020 */

	case EXG:
	    {
		register unsigned short regs = (arg1->areg1->opcode << 9) | arg2->areg1->opcode;
					/* assume normal register placement */

		if (size != L && size != UNSPEC)
			yyerror("exg requires long attribute, if any");
		if (arg1->atype == ADREG && arg2->atype == ADREG)
			object |= 0x40;		/* Data <==> data.	*/
		else if (arg1->atype == AAREG && arg2->atype == AAREG)
			object |= 0x48;		/* Address <==> address.*/
		else				/* Address <==> data */
		{
			object |= 0x88;
			if (arg1->atype == AAREG) /* must reverse regs. */
			    regs = (arg2->areg1->opcode << 9) | arg1->areg1->opcode;
		}
		object |= regs;
		generate(BITSPOW,0,object,NULLSYM);
		DBUG_VOID_RETURN;
	    }

	case LINK:
	{
		/* 68000/68010 allow UNSPEC or W, 68020 allow size = L or W */
		/* Until we can optimize, kludge the UNSPEC according to cpu*/
		if( size == UNSPEC )
			if( as20 ) size = L;
			else size = W;
		switch( size )
		{
		case W:
			if( arg2->xp->xvalue < -32768
						  || arg2->xp->xvalue > 32767)
			{
				if( !as20 )
					wxerror("Link displacement too large");
				size = L;
			}
			break;
		case L:
			if( !as20 )
				wxerror("a 68020/30 size attribute");
			break;
		default:
			yyerror("link instruction has incorrect size attribute");
			break;
		}
		if (size == L)
			object = 0x4808;
		if (arg1->atype != AAREG)
			yyerror("address register required as first operand of link instruction");
		else
			object |= arg1->areg1->opcode;
		generate(BITSPOW,0,object,NULLSYM);
		if (arg2->atype != AIMM)
			yyerror("immediate operand required as second operand of link instruction");
		else
		if ( size == L )
			generate(2*BITSPOW,(arg2->xp->xsymptr == NULLSYM) ? 0 : GENRELOC,
				arg2->xp->xvalue,arg2->xp->xsymptr);
		else
			generate(BITSPOW,(arg2->xp->xsymptr == NULLSYM) ? 0 : GENRELOC,
				arg2->xp->xvalue &= 0xffff,arg2->xp->xsymptr);
		DBUG_VOID_RETURN;
	}
	case DADD:
		if (size != UNSPEC && size != B)
			yyerror("BCD instructions are byte instructions");
		size = B;
	case XADD:
		if (size == UNSPEC)
			size = W;
		if (arg1->atype == ADEC && arg2->atype == ADEC)
			object |= 0x8;
		else if (arg1->atype != ADREG || arg2->atype != ADREG)
		{
			yyerror("only data register or predecrement address register pairs allowed as operands");
			DBUG_VOID_RETURN;
		}
		object |= (arg2->areg1->opcode << 9);
		object |= (size << 6);
		object |= arg1->areg1->opcode;
		generate(BITSPOW,0,object,NULLSYM);
		DBUG_VOID_RETURN;

	case LOGAND:
	case LOGOR:
	case LOGEOR:
		if (arg1->atype == AIMM)
		{
			    /* Already ANDi/ORi/EORi */
			if( inst->name[2] != 'i' && inst->name[3] != 'i' )
			{
			    char    instr_buf[NCPS];

			    strcpy(instr_buf,inst->name);
			    strcat(instr_buf,"i");
			    inst = (lookup(instr_buf,N_INSTALL,MNEMON)).itp;
			}
			object = inst->opcode;
			if (arg2->atype == CCREG)
			{
				object |= 0x3c;
				generate(BITSPOW,0,object,NULLSYM);
				if(arg1->xp->xvalue < -128 || arg1->xp->xvalue > 127)
					werror("immediate value must fix into a signed byte");
				generate(BITSPOW,(arg1->xp->xsymptr == NULL) ? 0 : GENRELOC,
					 arg1->xp->xvalue&=0xff,arg1->xp->xsymptr);
				DBUG_VOID_RETURN;
			}
			else if (arg2->atype == SRREG)
			{
				object |= 0x7c;
				generate(BITSPOW,0,object,NULLSYM);
				if(arg1->xp->xvalue < 0 || arg1->xp->xvalue > 65535)
					werror("immediate value must fix into a word");
				generate(BITSPOW,(arg1->xp->xsymptr == NULL) ? 0 : GENRELOC,
					 arg1->xp->xvalue&=0xffff,arg1->xp->xsymptr);
				DBUG_VOID_RETURN;
			}
			if (size == UNSPEC)
				if( arg1->xp->xsymptr == NULLSYM &&
				       arg1->xp->xvalue > 32767 &&
					  arg1->xp->xvalue < -32768 )
					size = L;
				else
					size = W;
			object |= (size << 6);
			eff_add(arg2,DATALT,size);
			generate(BITSPOW,0,object,NULLSYM);        /* preparation for second word */
			if (size == B)
				generate(BITSPOW,(arg1->xp->xsymptr == NULLSYM) ? 0 : GENRELOC,
					 arg1->xp->xvalue & 0xff,arg1->xp->xsymptr);
			else if (size == W)
				generate(BITSPOW,(arg1->xp->xsymptr == NULLSYM) ? 0 : GENRELOC,
					 arg1->xp->xvalue & 0xffff,arg1->xp->xsymptr);
			else
				generate(2*BITSPOW,(arg1->xp->xsymptr == NULLSYM) ? 0 : GENRELOC,
					 arg1->xp->xvalue,arg1->xp->xsymptr);
#ifndef M68020
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}
		else if ( inst->name[2] == 'i' || inst->name[3] == 'i')
			yyerror("illegal operator/operand combination");
		if (size == UNSPEC)
			size = W;
		if (inst->tag == LOGEOR)
		{
			if (arg1->atype != ADREG)
			{
				yyerror("first operand for eor must be a data register");
				DBUG_VOID_RETURN;
			}
			object |= (arg1->areg1->opcode << 9);
			object |= (1 << 8);
			object |= (size << 6);
			eff_add(arg2,DATALT,size);
#ifndef M68020
			generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}
		else if (arg2->atype == ADREG)
		{
			/* and/or <ea>,Dn */
			/* Check for Already ANDi/ORi */
			object |= (arg2->areg1->opcode << 9);
			object |= (size << 6);
			eff_add(arg1,DATAA,size);
#ifndef M68020
			generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}
		else
		{
			/* and/or Dn,<ea> */
			object |= (arg1->areg1->opcode << 9);
			object |= (1 << 8);
			object |= (size << 6);
			eff_add(arg2,ALTMEM,size);
#ifndef M68020
			generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}

	case ASHFT:
	case LSHFT:
	case ROT:
	case ROTX:
		if (arg1->atype == AIMM && 
		    arg2->atype != ADREG && arg2->atype != AAREG &&
		    arg2->atype != APCOFF && arg2->atype != APCNDX &&
		    arg2->atype != AIMM)
		{
			if(arg1->xp->xvalue != 1)
				yyerror("rotate/shift of memory only by 1");
			if (size != W && size != UNSPEC)
				yyerror("rotate/shift of memory requires word attribute, if any");
			eff_add(arg2,ALTMEM,size);
#ifndef M68020
			generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}
		else
		{
			/* Turn off the immedate, size and i/r	*/
			/*	fields so they can be set.	*/
			if(arg2->atype != ADREG)
				yyerror("rotate/shift greater than 1 req's (%d) register");
			object &= ~0xeff;
			if (inst->tag == LSHFT)
				object |= 0x8;
			else if (inst->tag == ROT)
				object |= 0x18;
			else if (inst->tag == ROTX)
				object |= 0x10;
			if (size == UNSPEC)
				size = W;
			object |= (size << 6);
			if (arg1->atype == ADREG)
			{
				object |= 0x20;
				object |= (arg1->areg1->opcode << 9);
				object |= arg2->areg1->opcode;
				generate(BITSPOW,0,object,NULLSYM);
				DBUG_VOID_RETURN;
			}
			else if (arg1->atype == AIMM)
			{
				object |= arg2->areg1->opcode;

				/* Shift amount has upper limit of 8.	*/
				/* Eight is encoded as 0 (since a shift	*/
				/* by zero makes little sense).  Shifts	*/
				/* are broken up into groups of shift-	*/
				/* by-eight plus any remaining shift.	*/
				/* Note that the shift amount must be	*/
				/* known in the first pass.		*/

				if (arg1->xp->xvalue <= 0 )
					yyerror("rotate/shift range is 1-8");
				while (arg1->xp->xvalue >= 8)
				{
					generate(BITSPOW,0,object,NULLSYM);
					arg1->xp->xvalue -= 8;
				}
				if (arg1->xp->xvalue > 0)
				{
					object |= (arg1->xp->xvalue << 9);
					generate(BITSPOW,0,object,NULLSYM);
				}
				DBUG_VOID_RETURN;
			}
			else
				yyerror("invalid operands for shift/rotate instruction");
			DBUG_VOID_RETURN;
		}

	case LEA:
		if (size != UNSPEC && size != L)
			yyerror("lea instruction has incorrect size attribute");
		if (arg2->atype != AAREG)
			yyerror("lea instruction requires an address register for second operand");
		else
			object |= (arg2->areg1->opcode << 9);
		eff_add(arg1,CONTROL,size);
#ifndef M68020
		generate(BITSPOW,action,object,NULLSYM);
		if (numwords == 1)
			generate(BITSPOW,action,word,symptr);
		else if (numwords == 2)
			generate(2*BITSPOW,action,word,symptr);
#else
		generate(BITSPOW,0,object,NULLSYM);
		gen_eff_add();
#endif
		DBUG_VOID_RETURN;

	case MULS:
	case MULU:
	case DIVS:
	case DIVU:
	case TMULS:
	case TMULU:
	case TDIVS:
	case TDIVU:
	{
		/*	mulx.w   <ea>,Dn	16*16 -> 32      
		 *	divx.w   <ea>,Dn	32/16 -> 32
		 *	mulx.l   <ea>,Dn	32*32 -> 32
		 *	divx.l   <ea>,Dn	32/32 -> 32
		 *	tmulx.l  <ea>,Dn	32*32 -> 32
		 *	tdivx.l  <ea>,Dn	32/32 -> 32
		 */
		register int inst2wd;
		switch( size )
		{
		case L:
			if( !as20 )
				wxerror("a 68020/30 size attribute");
			pc_dot += 2; /* adjust for larger instruction */
			break;
		case W:
		case UNSPEC:
			break;
		default:
			yyerror("instruction has incorrect size attribute");
		}
		if (arg2->atype != ADREG)
			yyerror("instruction requires data register for second operand");

		if  ((size == UNSPEC || size == W) &&
		     (inst->tag == MULS || inst->tag == MULU ||
			  inst->tag == DIVS || inst->tag == DIVU)
			)	/* generate word form format */
		{
			object |= (arg2->areg1->opcode << 9);
			eff_add(arg1,DATAA,size);
#ifndef M68020
		   	generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif /* M68020 */
			DBUG_VOID_RETURN;
		}

#ifdef M68020
		if (  ((size == UNSPEC || size == L) && 
			  (inst->tag == TMULS || inst->tag == TMULU ||
			   inst->tag == TDIVS || inst->tag == TDIVU ) )
			||((size == L) && 
			  (inst->tag == MULS || inst->tag == MULU ||
			   inst->tag == DIVS || inst->tag == DIVU ) )

			)	/* generate long form format */
		{
			/* mulx.l and divx.l will be equivalent to tmulx.l and tdivx.l
			 * respectively
			 */
		    if ( inst->tag == MULS || inst->tag == MULU )
			   object = 0x4c00;
		    if ( inst->tag == DIVS || inst->tag == DIVU )
			   object = 0x4c40;

			eff_add(arg1,DATAA,size);

			inst2wd = arg2->areg1->opcode << 12;	
			if ( (inst->tag == DIVS || inst->tag == TDIVS) ||
			     (inst->tag == DIVU || inst->tag == TDIVU) )
			        inst2wd |= arg2->areg1->opcode;	
			if ( (inst->tag == TMULS || inst->tag == TDIVS) ||
				 (inst->tag == MULS || inst->tag == DIVS) )
				inst2wd |= 0x800;  /* turn on bit 11 for signed mul/div */

			generate(BITSPOW,0,object,NULLSYM);
			generate (BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
			DBUG_VOID_RETURN;
		}
		else
		{
			yyerror("instruction has incorrect size attribute");
			DBUG_VOID_RETURN;
		}
#endif /* M68020 */
	}
	case DBCC:
		if (size != UNSPEC && size != W)
			yyerror("dbCC instruction requires word attribute, if any");
		if (arg1->atype != ADREG)
			yyerror("dbCC instruction requires data register for first operand");
		else
			object |= arg1->areg1->opcode;
		generate(BITSPOW,0,object,NULLSYM);
		generate(BITSPOW,BRLOC,arg2->xp->xvalue,arg2->xp->xsymptr);
		DBUG_VOID_RETURN;

	case CMP:
		/* Keep in mind the syntactic change in the operand	*/
		/*	ordering.					*/
		if (arg2->atype == AIMM)
		{
			if (size == UNSPEC)
				if( arg2->xp->xsymptr == NULLSYM &&
				      (arg2->xp->xvalue > 32767 ||
					  arg2->xp->xvalue < -32768) )
					size = L;
				else
					size = W;
		}
		else
		if (size == UNSPEC)
		{
		     werror("Size needed on compare instruction, .w assumed");
		     size = W;
		}
		if ( (arg1->atype!=AAREG) && (strcmp("cmpa",inst->name)==0) )
		{
			yyerror("cmpa instruction's first operand must be an A register");
		}
		if (arg1->atype == AINC && arg2->atype == AINC)
		{
			/*		cmpm				*/
			object |= (arg1->areg1->opcode << 9);
			object |= 0x108;
			object |= (size << 6);
			object |= arg2->areg1->opcode;
			generate(BITSPOW,0,object,NULLSYM);
			DBUG_VOID_RETURN;
		}
		else if (arg1->atype == AAREG)
		{
			/*		cmpa				*/
			if (size == B)
			{
				yyerror("byte size attribute illegal for compare address instruction");
				DBUG_VOID_RETURN;
			}
			object |= (arg1->areg1->opcode << 9);
			object |= (size == W) ? 0xc0 : 0x1c0;
			eff_add(arg2,ALL,size);
#ifndef M68020
			generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}
		else if (arg2->atype == AIMM)
		{
			/*		cmpi				*/
			object = 0xc00;
			object |= (size << 6);
			if( !as20 && (arg1->atype == APCOFF || arg1->atype == APCNDX) )
				wxerror("a 68020/30 addressing mode for cmpi");
			if (size == L)
			{
				pc_dot += 4;    /* adjust for operand order */
				eff_add(arg1,DATNIM | 0x4000,size);
			}
			else
			{
				pc_dot += 2;    /* adjust for operand order */
				eff_add(arg1,DATNIM | 0x2000,size);
			}
			generate(BITSPOW,0,object,NULLSYM);        /* preparation for second word */
			if (size == B)
				generate(BITSPOW,(arg2->xp->xsymptr == NULLSYM) ? 0 : GENRELOC,
					 arg2->xp->xvalue & 0xff,arg2->xp->xsymptr);
			else if (size == W)
				generate(BITSPOW,(arg2->xp->xsymptr == NULLSYM) ? 0 : GENRELOC,
					 arg2->xp->xvalue & 0xffff,arg2->xp->xsymptr);
			else
				generate(2*BITSPOW,(arg2->xp->xsymptr == NULLSYM) ? 0 : GENRELOC,
					 arg2->xp->xvalue,arg2->xp->xsymptr);
#ifndef M68020
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}
		else if (arg1->atype == ADREG)
		{
			object |= (arg1->areg1->opcode << 9);
			object |= (size << 6);
			eff_add(arg2,ALL,size);
#ifndef M68020
			generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}
		else
		{
			yyerror("invalid operands for compare instruction");
			DBUG_VOID_RETURN;
		}

	case BCHG:
	case BTST:
		if (arg1->atype == ADREG)
		{
			if ( (size != UNSPEC)  && (size != L ) )
			    werror("Bad size for dynamic bit instruction, .L used");
			size = L;
			object |= (arg1->areg1->opcode << 9);
			if (inst->tag == BTST)
				eff_add(arg2,DATNIM,size);
			else
				eff_add(arg2,DATALT,size);
#ifndef M68020
			generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif
		}
		else if (arg1->atype == AIMM)
		{
			/* Object code for bit instructions is 0x01?0	*/
			/*	when the bit number is dynamic (in a	*/
			/*	register), but 0x08?0 for a static bit	*/
			/*	number (bit number is immediate).	*/
			/*	Object code is converted by turning off	*/
			/*	the 1 bit and turning on the 8 bit.	*/
			if ( (size != UNSPEC)  && (size != B ) )
			    werror("wrong size for bit instruction, .B used");
			size = B;
			object ^= 0x0100;
			object |= 0x0800;
			pc_dot += 2; /* adjust for larger instruction */
			if (inst->tag == BTST)
				eff_add(arg2,DATNIM,size);
			else
				eff_add(arg2,DATALT,size);
			generate(BITSPOW,0,object,NULLSYM);
			generate(BITSPOW,
				(arg1->xp->xsymptr == NULLSYM) ? 0 : GENRELOC,
				   arg1->xp->xvalue & 0xff,arg1->xp->xsymptr);
#ifndef M68020
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			gen_eff_add();
#endif
		}
		else
			yyerror("incorrect first operand to bit instruction");
		DBUG_VOID_RETURN;

	case ADD:
		if (arg1->atype == AIMM &&
			    arg1->xp->xsymptr == NULLSYM &&
			    arg1->xp->xvalue > 0 &&
			    arg1->xp->xvalue <= 8)
		{ /* addq/subq */
			if( inst->name[3] != 'q' ) /* Already addq or subq? */
			{
				char    instr_buf[NCPS];

				strcpy(instr_buf,inst->name);
				if( instr_buf[3] == 'i' ) /* Already addi or subi? */
					werror("immediate data is <= 8. Quick is used instead of immediate");
				instr_buf[3] = 'q';   /* replace it by addq/subq */
				instr_buf[4] = 0;   /* make sure */
				inst = (lookup(instr_buf,N_INSTALL,MNEMON)).itp;
			}
			object = inst->opcode;
			if (arg1->xp->xvalue != 8)
				object |= (arg1->xp->xvalue << 9);
			if (size == UNSPEC)
				size = W;
			if (size == B && arg2->atype == AAREG)
			{
				yyerror("additive instruction with address destination cannot have byte attribute");
				size = W;
			}
			object |= (size << 6);
			eff_add(arg2,ALT,size);
#ifndef M68020
			generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}
		else if (arg2->atype == AAREG)
		{ /* adda/suba	*/
			if (size == B)
				yyerror("additive instruction with address destination cannot have byte attribute");
			object |= (arg2->areg1->opcode << 9);
			object |= (size == L) ? 0x1c0 : 0xc0;
			eff_add(arg1,ALL,size);
#ifndef M68020
			generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}
		else if (arg1->atype == AIMM)
		{
			/* addi/subi, where destination is not %an, and
			** literal is not between 1 and 8
			*/
			if( inst->name[3] != 'i' ) /* Already addi or subi? */
			{
				char    instr_buf[NCPS];

				strcpy(instr_buf,inst->name);
				if( instr_buf[3] == 'q' ) /* Already addq or subq? */
					werror("immediate data is > 8. Immediate is used instead of quick");
				instr_buf[3] = 'i';   /* replace it by addi/subi */
				instr_buf[4] = 0;   /* make sure */
				inst = (lookup(instr_buf,N_INSTALL,MNEMON)).itp;
			}
			object = inst->opcode;
			if (size == UNSPEC)
				if( arg2->xp->xsymptr == NULLSYM &&
				       arg2->xp->xvalue > 32767 &&
					  arg2->xp->xvalue < -32768 )
					size = L;
				else
					size = W;
			object |= (size << 6);
			if (size == L)
				eff_add(arg2,DATALT | 0x4000,size);
			else
				eff_add(arg2,DATALT | 0x2000,size);
			generate(BITSPOW,0,object,NULLSYM);
			if (size == B)
				generate(BITSPOW,(arg1->xp->xsymptr == NULLSYM) ? 0 : GENRELOC,
					 arg1->xp->xvalue & 0xff,arg1->xp->xsymptr);
			else if (size == W)
				generate(BITSPOW,(arg1->xp->xsymptr == NULLSYM) ? 0 : GENRELOC,
					 arg1->xp->xvalue & 0xffff,arg1->xp->xsymptr);
			else
				generate(2*BITSPOW,(arg1->xp->xsymptr == NULLSYM) ? 0 : GENRELOC,
					 arg1->xp->xvalue,arg1->xp->xsymptr);
#ifndef M68020
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}
		else if (arg2->atype == ADREG)
		{
			/* add/sub <ea>,Dn */
			object |= (arg2->areg1->opcode << 9);
			if (size == UNSPEC)
				size = W;
			object |= (size << 6);
			eff_add(arg1,ALL,size);
#ifndef M68020
			generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}
		else if (arg1->atype == ADREG)
		{
			/* add/sub Dn,<ea> */
			object |= (arg1->areg1->opcode << 9);
			object |= 0x100;
			if (size == UNSPEC)
				size = W;
			object |= (size << 6);
			eff_add(arg2,ALTMEM,size);
#ifndef M68020
			generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}
		else
			yyerror("illegal operand combination for additive instruction");
		DBUG_VOID_RETURN;

	case MOVM:
		if (size == B)
			yyerror("movm instruction allows only word and long attribute");
		if (size == L)
			object |= 0x40;
		pc_dot += 2; /* adjust for larger instruction */
		if (arg2->atype == AIMM)
		{
			object |= 0x400;
			eff_add(arg1,CONPOST | 0x2000,size);
			generate(BITSPOW,0,object,NULLSYM);
			generate(BITSPOW,
			(arg2->xp->xsymptr==NULLSYM)?0:GENRELOC,
				 arg2->xp->xvalue,arg2->xp->xsymptr);
#ifndef M68020
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			gen_eff_add();
#endif
		}
		else if (arg1->atype != AIMM)
			yyerror("incorrect operands for movm instruction");
		else
		{
			eff_add(arg2,CONALTPRE | 0x2000,size);
			generate(BITSPOW,0,object,NULLSYM);
			generate(BITSPOW,
				(arg1->xp->xsymptr == NULLSYM) ? 0 : GENRELOC,
				arg1->xp->xvalue,arg1->xp->xsymptr);
#ifndef M68020
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			gen_eff_add();
#endif
		}
		DBUG_VOID_RETURN;

	case MOVS:
	{
		register int inst2wd;

		if( !as10 )
			wxerror("a 68010/20/30 instruction");
		pc_dot += 2; /* adjust for larger instruction */
		if ((inst2wd=(arg1->atype == AAREG)) || arg1->atype == ADREG)
		{
			eff_add(arg2,ALTMEM,size);
			inst2wd = (inst2wd << 15) | (arg1->areg1->opcode<< 12) | (1 << 11);
		}
		else if ((inst2wd=(arg2->atype == AAREG)) || arg2->atype == ADREG)
		{
			eff_add(arg1,ALTMEM,size);
			inst2wd = (inst2wd << 15) | (arg2->areg1->opcode<< 12);
		}
		else
			yyerror("one register operand req'd for movs");
		object |= (size == UNSPEC ? W : size) << 6;
		generate(BITSPOW,0,object,NULLSYM);
		generate(BITSPOW,0,inst2wd,NULLSYM);
#ifndef M68020
		if (numwords == 1)
			generate(BITSPOW,action,word,symptr);
		else if (numwords == 2)
			generate(2*BITSPOW,action,word,symptr);
#else
		gen_eff_add();
#endif
		DBUG_VOID_RETURN;
	}

	case MOVP:
		if (size == B)
			yyerror("movp instruction allows only word and long attribute");
		if (arg1->atype == ADREG && arg2->atype == AOFF)
		{
			object |= (arg1->areg1->opcode << 9);
			object |= (((size == L) ? 7 : 6) << 6);
			object |= arg2->areg1->opcode;
			generate(BITSPOW,0,object,NULLSYM);
			generate(BITSPOW,(arg2->xp->xsymptr == NULLSYM) ? 0 : GENRELOC,
				 arg2->xp->xvalue,arg2->xp->xsymptr);
		}
		else if (arg1->atype == AOFF && arg2->atype == ADREG)
		{
			object |= (arg2->areg1->opcode << 9);
			object |= (((size == L) ? 5 : 4) << 6);
			object |= arg1->areg1->opcode;
			generate(BITSPOW,0,object,NULLSYM);
			generate(BITSPOW,(arg1->xp->xsymptr == NULLSYM) ? 0 : GENRELOC,
				 arg1->xp->xvalue,arg1->xp->xsymptr);
		}
		else
			yyerror("incorrect operands for movp instruction");
		DBUG_VOID_RETURN;

	case MOV:
		if (arg2->atype == CCREG)
		{
			/* move to CCR */
			object = 0x44c0;
			eff_add(arg1,DATAA,size);
#ifndef M68020
			generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}
		else if (arg1->atype == CCREG)
		{
			if( !as10 )
				wxerror("a 68010/20/30 instruction");
			object = 0x42c0;
			eff_add(arg2,DATALT,size);
#ifndef M68020
			generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}
		else if (arg1->atype == CTLREG )
		{
			if (size == UNSPEC )
				size = L;
			else if(size != L)
				yyerror("only long size attribute allowed");
			switch( arg1->areg1->opcode )
			{
			case MSPREG:
			case ISPREG:
			case CACREG:
			case CAAREG:
				if( !as20 )
					wxerror("a 68020/30 control register");
				break;
			case SFCREG:
			case DFCREG:
			case VBRREG:
				if( !as10 )
					wxerror("a 68010/20/30 control register");
				break;
			case USPREG:
				break;
			default:
				if( !as10 )
					wxerror("a 68010/20/30 control register");
			}
			if (arg2->atype == AAREG)
			{
				if (arg1->areg1->opcode == USPREG)
				{	/* old form is one word */
					object = 0x4e68;
					object |= arg2->areg1->opcode;
					generate(BITSPOW,0,object,NULLSYM);
					DBUG_VOID_RETURN;
				}
				object = (0x8 | arg2->areg1->opcode) << 12;
			}
			else if (arg2->atype == ADREG)
				object = (arg2->areg1->opcode) << 12;
			else
				yyerror("destination operand must be a register");
			object |= arg1->areg1->opcode;
			generate(BITSPOW,0,0x4e7a,NULLSYM);
			generate(BITSPOW,0,object,NULLSYM);
			DBUG_VOID_RETURN;
		}
		else if (arg2->atype == CTLREG )
		{
			if (size == UNSPEC )
				size = L;
			else if(size != L)
				yyerror("only long size attribute allowed");
			if (arg1->atype == AAREG)
			{
				if (arg2->areg1->opcode == USPREG)
				{
					object = 0x4e60;
					object |= arg1->areg1->opcode;
					generate(BITSPOW,0,object,NULLSYM);
					DBUG_VOID_RETURN;
				}
				object = (0x8 | arg1->areg1->opcode) << 12;
			}
			else if (arg1->atype == ADREG)
				object = (arg1->areg1->opcode) << 12;
			else
				yyerror("source operand must be a register");
			if( !as10 )
				wxerror("a 68010/20/30 instruction");
			object |= arg2->areg1->opcode;
			generate(BITSPOW,0,(0x4e7a | 0x1),NULLSYM);
			generate(BITSPOW,0,object,NULLSYM);
			DBUG_VOID_RETURN;
		}
		else if (arg2->atype == SRREG)
		{
			/* move to SR */
			object = 0x46c0;
			eff_add(arg1,DATAA,size);
#ifndef M68020
			generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}
		else if (arg1->atype == SRREG)
		{
			object = 0x40c0;
			eff_add(arg2,DATALT,size);
#ifndef M68020
			generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}
		else if (arg1->atype == AIMM && arg2->atype == ADREG &&
			 (size == L || size == UNSPEC) &&
		 arg1->xp->xsymptr == NULLSYM && arg1->xp->xvaltype == FP_INT
		      &&  arg1->xp->xvalue >= -128 && arg1->xp->xvalue <= 127)
		{
			/* move quick */
			object = 0x7000;
			object |= (arg2->areg1->opcode << 9);
			object |= (arg1->xp->xvalue & 0xff);
			generate(BITSPOW,0,object,NULLSYM);
			DBUG_VOID_RETURN;
		}
		else if (arg2->atype == AAREG)
		{
			/* movea */
			object = 0x0040;
			if (size == B)
				yyerror("mov to address register cannot have byte attribute");
			object |= (((size == L) ? 0x2 : 0x3) << 12);
			object |= (arg2->areg1->opcode << 9);
			eff_add(arg1,ALL,size);
#ifndef M68020
			generate(BITSPOW,action,object,NULLSYM);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			generate(BITSPOW,0,object,NULLSYM);
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}
		else
		{
#ifndef M68020
			register unsigned short	savaction;
			register long		savword;
			register int		savnum;
			register symbol		*savsym;
#else
			struct eatype           sav_ea, tmp_ea;
			register long		tmpobject;
#endif
			if (size == UNSPEC)
				if( arg1->atype == AIMM &&
					 arg1->xp->xsymptr == NULLSYM &&
					    (arg1->xp->xvalue > 32767 ||
						  arg1->xp->xvalue < -32768) )
					size = L;
				else
					size = W;
			object = inst->opcode;
			if( size == B )
				object |= 0x1000;
			else if( size == L )
				object |= 0x2000;
			else /* default to word size */
				object |= 0x3000;
			eff_add( arg1, ALL | 0x1000, size );
#ifndef M68020
			savword = object;
			object = 0;
			savnum = numwords;
			savaction = action;
			savsym = symptr;
			savword = word;
#else
			tmpobject = object;
			object = 0;
			sav_ea = ea;
#endif
			eff_add( arg2, DATALT | 0x1000, size );
			/* Pick off mode and register for destination,  */
			/*      and move them up to where they belong.  */
#ifndef M68020
			savword |= ((object & 07) << 9);
			savword |= ((object & 070) << 3);
			object = savword;
#else
			tmpobject |= ((object & 07) << 9);
			tmpobject |= ((object & 070) << 3);
			object = tmpobject;
#endif
#ifndef M68020
			if (savaction == BRLOC) /* pc-relative addressing */
				generate(BITSPOW,savaction,object,NULLSYM);
			else
			if (action == 0 && savaction == 0)
				generate(BITSPOW,0,object,NULLSYM);
			else
				generate(BITSPOW,MOVE,object,NULLSYM);
			if (savnum == 1)
				generate(BITSPOW,savaction,savword,savsym);
			else if (savnum == 2)
				generate(2*BITSPOW,savaction,savword,savsym);
			if (numwords == 1)
				generate(BITSPOW,action,word,symptr);
			else if (numwords == 2)
				generate(2*BITSPOW,action,word,symptr);
#else
			if (sav_ea.action1 == BRLOC) /* pc-relative addressing */
				generate(BITSPOW,sav_ea.action1,object,NULLSYM);
			else
			if (ea.action1 == 0 && sav_ea.action1 == 0)
				generate(BITSPOW,0,object,NULLSYM);
			else
				generate(BITSPOW,MOVE,object,NULLSYM);
			tmp_ea = ea;
			ea = sav_ea;    /* first eff_add must go first */
			sav_ea = tmp_ea;
			gen_eff_add();
			ea = sav_ea;
			gen_eff_add();
#endif
			DBUG_VOID_RETURN;
		}

	default:
		yyerror("unknown two-operand instruction usage");
	}	/* end switch */
	DBUG_VOID_RETURN;
}	/* gen2op()	*/

gen3op(inst,size,arg1,arg2,arg3)
register instr		*inst;
register int		size;
register struct arg	*arg1,
			*arg2,
			*arg3;
{
	DBUG_ENTER ("gen3op");
	pc_dot = newdot;
	object = inst->opcode;
    
	switch ((int)(unsigned char)inst->tag)
	{

#ifdef M68881
	case FMOV:
	{	/* fmov %fpm,<ea>{&k}
		 * fmov %fpm,<ea>{%dn}
		 */
		register int inst2wd;		/* second word of instruction format */
		if (size == UNSPEC) size = P;
		if ( size != P)
			yyerror("instruction has illegal size attribute");

		object |=  cp_id << 9;
		if (arg1->atype != FPREG)
			yyerror ("instruction has illegal register for first operand");
		if (arg2->atype == FPREG)
			yyerror ("instruction has illegal register for second operand");

		pc_dot += 2; /* adjust for larger instruction */
		eff_add(arg2,ALTMEM,size);
		inst2wd = arg1->areg1->opcode << 7;
		if (arg3->atype == AIMM)
			inst2wd |= (0x6c00 | arg3->xp->xvalue & 0x7f);
		else
		if (arg3->atype == ADREG)
			inst2wd |= (0x7c00 | arg3->areg1->opcode << 4);
		else
			yyerror("instruction has illegal register for third operand");
		generate(BITSPOW,0,object,NULLSYM);
		generate(BITSPOW,0,inst2wd,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
	} /* fmov */

	case FMOVM:
	{	register int csi,	/* control,status,iaddr combination */
		inst2wd;

		if ( size != L && size != UNSPEC )
			werror("instrucion has illegal size attribute, size set to L");
		size = L;
		object |= cp_id << 9;

		/* fmovm <ea>,%control/%status
		 * fmovm <ea>,%control/%iaddr
		 * fmovm <ea>,%status/%iaddr
		 */
		pc_dot += 2; /* adjust for larger instruction */
		if ((arg2->atype == FPCONTROL || arg2->atype == FPSTATUS ||
			arg2->atype == FPIADDR ) &&
			(arg3->atype == FPCONTROL || arg3->atype == FPSTATUS ||
			arg3->atype == FPIADDR ) )
		{
			csi = (arg2->areg1->opcode | arg3->areg1->opcode) ;
			if ( csi != 0x6 && csi != 0x5 && csi !=  0x3 )
				yyerror("instruction has illegal operand combinations");
			eff_add (arg1,MEMORY,size); 
			inst2wd = 0x8000 | csi << 10;
			generate(BITSPOW,0,object,NULLSYM);
			generate(BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
			DBUG_VOID_RETURN;
		}
		else
		/* fmovm %control/%status,<ea>
		 * fmovm %control/%iaddr,<ea>
		 * fmovm %status/%iaddr,<ea>
		 */
		if ((arg1->atype == FPCONTROL || arg1->atype == FPSTATUS ||
			arg1->atype == FPIADDR ) &&
			(arg2->atype == FPCONTROL || arg2->atype == FPSTATUS ||
			arg2->atype == FPIADDR ) )
		{
			csi = (arg1->areg1->opcode | arg2->areg1->opcode) ;
			if ( csi != 0x6 && csi != 0x5 && csi !=  0x3 )
				yyerror("instruction has illegal operand combinations");
			eff_add (arg3,ALTMEM,size); 
			inst2wd = 0xa000 | csi << 10;
			generate(BITSPOW,0,object,NULLSYM);
			generate(BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
			DBUG_VOID_RETURN;
		}
		else
		{
			yyerror("instruction has illegal operand combinations");
			DBUG_VOID_RETURN;
		}
	}	/* fmovm */

	case FSINCOS:
	{	/* fsincos <ea>,%fpn:%fpq
		 * fsincos %fpm,%fpn:%fpq
		 */
		register int inst2wd;
		if (size != UNSPEC && size != B && size != W && size != L &&
			size != S && size != D && size != X && size != P)
			yyerror("instruction has illegal size attribute");
		if ( arg2->atype != FPREG)
			yyerror("instruction requires floating point register for second operand");
		if ( arg3->atype != FPREG)
			yyerror("instruction requires floating point register for third operand");
		object |= cp_id << 9;
		inst2wd = (arg3->areg1->opcode << 7 | arg2->areg1->opcode);
		if ( arg1->atype == FPREG)
		{
			if ( size != UNSPEC && size != X )
				werror ("instruction requires size X, if source is a floating point register");
		
			size = X;
			inst2wd |= (0x0030 | arg1->areg1->opcode << 10);
			generate (BITSPOW,0,object,NULLSYM);
			generate (BITSPOW,0,inst2wd,NULLSYM);
			DBUG_VOID_RETURN;
		}
		else
		{
			if (arg1->atype == FPCONTROL ||
				arg1->atype == FPIADDR ||
				arg1->atype == FPSTATUS )
				yyerror("instruction has illegal register for first operand");
			if ( size == UNSPEC )
			{
				size = W;
				werror("No size specified for floating point instruction, W used");
			}
			inst2wd |= (0x4030 | SRCFMT[size] << 10);
			pc_dot += 2; /* adjust for larger instruction */
			if ( size == B || size == W || size == L || size == S)
				eff_add (arg1,DATAA,size);
			else
				eff_add (arg1,MEMORY,size);
			generate(BITSPOW,0,object,NULLSYM);
			generate(BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
			DBUG_VOID_RETURN;
		}
	} /* fsincos */
#endif /* M68881 */

#ifdef M68851
        case PFLUSHS:
		if (as30)
			wxerror("PFLUSHS is not a 68030 instruction");
	case PFLUSH:
        {
		register int inst2wd;  /* second word of instruction format */
		register int fcmask;
                        /* PFLUSH, PFLUSHS */
                if ( size != UNSPEC )
		{
			yyerror("PFLUSH instructions are unsized");
			size = UNSPEC;
		}
		object = inst->opcode  ;
		switch (arg1->atype) {
		case AIMM:
		case ADREG:
			break;
		case CTLREG:
			if ((arg1->areg1->opcode | 1) == 1)  /* == 0 or 1 */
				break;
		default:
			yyerror ("function code must be immediate/data register/SFC or DFC register");
			break;
		}

		if ( arg2->atype != AIMM )
			yyerror ("mask must be an immediate value");
		pc_dot += 2; /* adjust for larger instruction */
		eff_add (arg3,(CONTROL & ALT),size);
		generate(BITSPOW,0,object,NULLSYM);
		fcmask = arg2->xp->xvalue & ( as30 ? 0x7 : 0xf );
		if ( fcmask != arg2->xp->xvalue )
			yyerror ("PFLUSH mask is too large for MMU");
		inst2wd = 0x3800 | fcmask << 5;
                if ( (int)(unsigned char)inst->tag == PFLUSHS )
		      inst2wd |= 0x400;
                if ( arg1->atype == AIMM )
                {
		      inst2wd |= 0x10 | arg1->xp->xvalue;
                }
                else
                if ( arg1->atype == ADREG )
                {
		      inst2wd |= 8 | arg1->areg1->opcode;
                }
                else
			inst2wd |= arg1->areg1->opcode;
		generate(BITSPOW,0,inst2wd,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
        }	/* PFLUSH, PFLUSHS */
        case PTESTR:
        case PTESTW:
	{       /* PTESTR, PTESTW */
		register int inst2wd;  /* second word of instruction format */

                if ( size != UNSPEC )
		{
			yyerror("PTEST instructions are unsized");
			size = UNSPEC;
		}
		object = inst->opcode  ;
		switch (arg1->atype) {
		case AIMM:
		case ADREG:
			break;
		case CTLREG:
			if ((arg1->areg1->opcode | 1) == 1)  /* == 0 or 1 */
				break;
		default:
			yyerror ("function code must be immediate/data register/SFC or DFC register");
			break;
		}
		if ( arg3->atype != AIMM )
			yyerror ("level must be an immediate value");
		pc_dot += 2; /* adjust for larger instruction */
		eff_add (arg2,(CONTROL & ALT),size);
		generate(BITSPOW,0,object,NULLSYM);
                if ( arg1->atype == AIMM )
			inst2wd = 0x8010 | arg1->xp->xvalue;
                else
                if ( arg1->atype == ADREG )
			inst2wd = 0x8008 | arg1->areg1->opcode;
                else
		   inst2wd = 0x8000 | arg1->areg1->opcode;
                inst2wd |= arg3->xp->xvalue << 10;
                if ( (int)(unsigned char)inst->tag == PTESTR )
		      inst2wd |= 0x200;
		generate(BITSPOW,0,inst2wd,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
        }	/* PTESTR/PTESTW */
#endif /* M68851 */

#ifdef M68020
	case BFTST:
	case BFCHG:
		/* bfchg, bfclr, bfset, bftst <ea>{offset:width} */
		{
		register int inst2wd;		/* second word of instruction format */

		if (!as20)
			wxerror("a 68020/30 instruction");
		if (size != UNSPEC)
			yyerror("bit field instructions are unsized");

		pc_dot += 2; /* adjust for larger instruction */
		if (inst->tag == BFTST)
			eff_add(arg1,DnCONTROL,size);	/* allow data register direct or */
		                            		/* control addressing mode */
		else
			eff_add(arg1,DnALTCON,size);	/* allow data register direct or */
		                            		/* alterable control addressing mode */
		
		if (arg2->atype == AIMM)	/* offset is an immediate value */
		{
			inst2wd = (arg2->xp->xvalue & 0x001f) << 6;
			if ( arg2->xp->xvalue < 0 || arg2->xp->xvalue > 31 )
				werror("offset must be between 0 and 31");
		}
		else
		if (arg2->atype == ADREG)	/* offset is from a data register */
			inst2wd = arg2->areg1->opcode << 6 | 0x800;
		else
			yyerror("bit field instruction offset should be either immediate operand  or data register");

		if (arg3->atype == AIMM)	/* width  is an immediate value */
		{
			inst2wd |= (arg3->xp->xvalue & 0x001f) ;
			if ( arg3->xp->xvalue < 1 || arg3->xp->xvalue > 32 )
				werror("width must be between 1 and 32");
		}
		else
		if (arg3->atype == ADREG)	/* width is from a data register */
			inst2wd |= arg3->areg1->opcode  | 0x20;
		else
			yyerror("bit field instruction width requires immediate operand or data register");

		generate(BITSPOW,0,object,NULLSYM);
		generate(BITSPOW,0,inst2wd,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
		} /* bfchg, bfclr, bfset, bftst */
#endif /* M68020 */

#ifdef M68020
	case CAS:
	{	/* cas dn,dn,<ea> */	
		register int inst2wd;	/* second word of instruction format */
		if (!as20)
			wxerror("a 68020/30 instruction");
		if ( size == B )
			object |= 0x200;
		else
		if ( size == W )
			object |= 0x400;
		else
		if ( size == L )
			object |= 0x600;
		else
		if ( size == UNSPEC )
		{
			size = W;
			object |= 0x400;
			werror("No size for CAS, .W assumed");
		}
		else
			yyerror("Bad size code for CAS instruction");
	
		inst2wd = 0;
		if ( arg1->atype != ADREG )
			yyerror ("data register required as first operand of cas instruction");
		else
			inst2wd |= arg1->areg1->opcode;

		if ( arg2->atype != ADREG )
			yyerror ("data register required as second operand of cas instruction");
		else
			inst2wd |= arg2->areg1->opcode << 6;
		pc_dot += 2; /* adjust for larger instruction */
		eff_add (arg3,ALTMEM,size);
		generate(BITSPOW,0,object,NULLSYM);
		generate (BITSPOW, 0, inst2wd, NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
	}	/* cas */
#endif /* M68020 */
#ifdef M68020
	case MULS:
	case MULU:
	case DIVS:
	case DIVU:
	case TDIVS:
	case TDIVU:
	{
		/*	mulx.l  <ea>,Dh:Dl	32*32 ->64
		 *	divx.l  <ea>,Dr:Dq	64/32 ->32r:32q
		 *	tdivx.l <ea>,Dr:Dq	32/32 ->32r:32q
		 */
		register int inst2wd;

		if ( size != L && size != UNSPEC )
			yyerror("instruction has incorrect size attribute");
		if ( arg2->areg1->opcode == arg3->areg1->opcode )
			werror("Identical registers specified for 64-bit register pair");

		/* generate long form format */
		if (inst->tag == MULS || inst->tag == MULU)
			object = 0x4c00;
		else
			object = 0x4c40;

		inst2wd = 0;
		if (( inst->tag != TDIVS && inst->tag != TDIVU ) && 
		   (( arg2->areg1->opcode ) != ( arg3->areg1->opcode )))
			inst2wd =   0x400;	/* turn on bit 10 for 64 bit dividend */
			                 	/* or 64 bit product */
		inst2wd |=  (arg3->areg1->opcode << 12);
		inst2wd |=  arg2->areg1->opcode ;
		if (inst->tag == MULS || inst->tag == DIVS || inst->tag == TDIVS) 
			inst2wd |= 0x800;	/* turn on bit 11 for signed */
				                /* multiply or division */

		pc_dot += 2; /* adjust for larger instruction */
		eff_add(arg1,DATAA,size);
		generate(BITSPOW,0,object,NULLSYM);
		generate (BITSPOW,0,inst2wd,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
	} /* muls, mulu, divs, divu */
#endif /* M68020 */

	case PACK:
	case UNPK:
		/* pack -(%ax),-(%ay),&xxx */
		/* pack %dx,%dy,&xxx */
		/* unpk -(%ax),-(%ay),&xxx */
		/* unpk %dx,%dy,&xxx */
		if ( !as20 ) 
			wxerror("a 68020/30 instruction");
		if ( size != UNSPEC )
			werror("PACK/UNPK instructions are unsized");

		if (arg1->atype == ADEC && arg2->atype == ADEC)  /* -(Ax) */
			object |= 0x8;              /* set R/M field */
		else
		if (arg1->atype != ADREG || arg2->atype != ADREG)
			yyerror("only data register or predecrement address register pairs allowed as operands");

		if (arg3->atype != AIMM)
			yyerror("immediate value required for the third operand");
		else
		if ( arg3->xp->xvalue < -(1<<15) || arg3->xp->xvalue >= (1<<15))
			werror("extension must fit into a word (masked)");

		/* pack destination and source registers */
		object |= (arg2->areg1->opcode << 9 );          
		object |=  arg1->areg1->opcode;
		generate(BITSPOW,0,object,NULLSYM);
		generate(BITSPOW,(arg3->xp->xsymptr == NULLSYM) ? 0 : GENRELOC,
			arg3->xp->xvalue &= 0xffff,arg3->xp->xsymptr);
		DBUG_VOID_RETURN;

	default:
		yyerror("unknown three-operands instruction usage");
	}	/* end switch */
	DBUG_VOID_RETURN;
}	/* gen3op() */
gen4op(inst,size,arg1,arg2,arg3,arg4)
register instr		*inst;
register int		size;
register struct arg	*arg1,
			*arg2,
			*arg3,
			*arg4;
{
	DBUG_ENTER ("gen4op");
	pc_dot = newdot;
	object = inst->opcode;
    
	switch ((int)(unsigned char)inst->tag)
	{
#ifdef M68881
	case FMOVM:
	{	register int	csi,	/* control,status,iaddr */
			inst2wd;

		if ( size != L && size != UNSPEC )
			werror("instrucion has illegal size attribute, size set to L");
		size = L;
		object |= cp_id << 9;

		/* fmovm <ea>,%control/%status/%iaddr
		 */
		if ( (arg2->atype == FPCONTROL || arg2->atype == FPSTATUS ||
				arg2->atype == FPIADDR)
			&& (arg3->atype == FPCONTROL || arg3->atype == FPSTATUS ||
				arg3->atype == FPIADDR)
			&& (arg4->atype == FPCONTROL || arg4->atype == FPSTATUS ||
				arg4->atype == FPIADDR) )
		{
			csi = (arg2->areg1->opcode|arg3->areg1->opcode|arg4->areg1->opcode);
			if ( csi != 0x7 )
				yyerror("instruction has illegal operand combinations");

			pc_dot += 2; /* adjust for larger instruction */
			eff_add (arg1,MEMORY,size); 
			inst2wd = 0x8000 | csi << 10;
			generate(BITSPOW,0,object,NULLSYM);
			generate(BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
			DBUG_VOID_RETURN;
		}
		else
		/* fmovm %control/%status/%iaddr,<ea>
		 */
		if ( (arg1->atype == FPCONTROL || arg1->atype == FPSTATUS ||
				arg1->atype == FPIADDR)
			&& (arg2->atype == FPCONTROL || arg2->atype == FPSTATUS ||
				arg2->atype == FPIADDR)
			&& (arg3->atype == FPCONTROL || arg3->atype == FPSTATUS ||
				arg3->atype == FPIADDR) )
		{
			csi = (arg1->areg1->opcode|arg2->areg1->opcode|arg3->areg1->opcode);
			if ( csi != 0x7 )
				yyerror("instruction has illegal operand combinations");
		 
			pc_dot += 2; /* adjust for larger instruction */
			eff_add (arg4,ALTMEM,size); 
			inst2wd = 0xa000 | csi << 10;
			generate(BITSPOW,0,object,NULLSYM);
			generate(BITSPOW,0,inst2wd,NULLSYM);
			gen_eff_add();
			DBUG_VOID_RETURN;
		}
		else
		{
			yyerror("instruction has illegal operand combinations");
			DBUG_VOID_RETURN;
		}
	}	/* fmovm */

#endif /* M68881 */

#ifdef M68851
        case PTESTR:
        case PTESTW:
	{       /* PTESTR, PTESTW */
                register int inst2wd;        /* second word of instruction format */

                if ( size != UNSPEC )
		{
			yyerror("PTEST instructions are unsized");
			size = UNSPEC;
		}
		object = inst->opcode  ;
		switch (arg1->atype) {
		case AIMM:
		case ADREG:
			break;
		case CTLREG:
			if ((arg1->areg1->opcode | 1) == 1)  /* == 0 or 1 */
				break;
		default:
			yyerror ("function code must be immediate/data register/SFC or DFC register");
			break;
		}
		if ( arg3->atype != AIMM )
			yyerror ("level must be an immediate value");
                if ( arg4->atype != AAREG )
			yyerror("only address register is allowed");
		pc_dot += 2; /* adjust for larger instruction */
		eff_add (arg2,(CONTROL & ALT),size);
		generate(BITSPOW,0,object,NULLSYM);
                if ( arg1->atype == AIMM )
			inst2wd = 0x8010 | arg1->xp->xvalue;
                else
                if ( arg1->atype == ADREG )
			inst2wd = 0x8008 | arg1->areg1->opcode;
                else
		   inst2wd = 0x8000 | arg1->areg1->opcode;
                inst2wd |= arg3->xp->xvalue << 10;
                if ( (int)(unsigned char)inst->tag == PTESTR )
		      inst2wd |= 0x200;
		inst2wd |= 0x100 | arg4->areg1->opcode << 5;
		generate(BITSPOW,0,inst2wd,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
        }	/* PTESTR/PTESTW */
#endif /* M68851 */

#ifdef M68020
	case BFFFO:
		/* bfffo,bfexts,bfextu  <ea>{offset:width},Dn */
		{
		register int inst2wd;		/* second word of instruction format */

		if (!as20)
			wxerror("a 68020/30 instruction");
		if (size != UNSPEC)
			yyerror("bit field instructions are unsized");

		pc_dot += 2; /* adjust for larger instruction */
		eff_add(arg1,DnCONTROL,size);	/* allow data register direct or */
		                            	/* control addressing mode */

		if (arg2->atype == AIMM)	/* offset is an immediate value */
		{
			inst2wd = (arg2->xp->xvalue & 0x001f) << 6;
			if ( arg2->xp->xvalue < 0 || arg2->xp->xvalue > 31 )
				werror("offset must be between 0 and 31");
		}
		else
		if (arg2->atype == ADREG)	/* offset is from a data register */
			inst2wd = arg2->areg1->opcode << 6 | 0x800;
		else
			yyerror("bit field instruction offset requires immediate operand or data register");

		if (arg3->atype == AIMM)	/* width  is an immediate value */
		{
			inst2wd |= (arg3->xp->xvalue & 0x001f) ;
			if ( arg3->xp->xvalue < 1 || arg3->xp->xvalue > 32 )
				werror("width must be between 1 and 32");
		}
		else
		if (arg3->atype == ADREG)	/* width is from a data register */
			inst2wd |= arg3->areg1->opcode  | 0x20;
		else
			yyerror("bit field instruction width requires immediate operand or data register");

		if (arg4->atype == ADREG)
			inst2wd |= arg4->areg1->opcode  << 12;
		else
			yyerror("destination should be a data register");

		generate(BITSPOW,0,object,NULLSYM);
		generate(BITSPOW,0,inst2wd,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
		}

	case BFINS:
		{  /* bfins Dn,<ea>{offset:width} */
		register int inst2wd;		/* second word of instruction format */

		if (!as20)
			wxerror("a 68020/30 instruction");
		if (size != UNSPEC)
			yyerror("BFINS instructions are unsized");

		pc_dot += 2; /* adjust for larger instruction */
		eff_add(arg2,DnALTCON,size);	/* allow data register direct or */
		                            	/* alterable control addressing mode */
		if (arg1->atype == ADREG)
			inst2wd = arg1->areg1->opcode  << 12;
		else
			yyerror("source should be from a data register");

		if (arg3->atype == AIMM)	/* offset is an immediate value */
		{
			inst2wd |= (arg3->xp->xvalue & 0x001f) << 6;
			if ( arg3->xp->xvalue < 0 || arg3->xp->xvalue > 31 )
				werror("offset must be between 0 and 31");
		}
		else
		if (arg3->atype == ADREG)	/* offset is from a data register */
			inst2wd |= arg3->areg1->opcode << 6 | 0x800;
		else
			yyerror("BFINS instruction offset requires either immediate operand or data register");

		if (arg4->atype == AIMM)	/* width  is an immediate value */
		{
			inst2wd |= (arg4->xp->xvalue & 0x001f) ;
			if ( arg4->xp->xvalue < 1 || arg4->xp->xvalue > 32 )
				werror("width must be between 1 and 32");
		}
		else
		if (arg4->atype == ADREG)	/* width is from a data register */
			inst2wd |= arg4->areg1->opcode  | 0x20;
		else
			yyerror("BFINS instruction width requires immediate operand or data register");


		generate(BITSPOW,0,object,NULLSYM);
		generate(BITSPOW,0,inst2wd,NULLSYM);
		gen_eff_add();
		DBUG_VOID_RETURN;
		}
#endif /* M68020 */
	default:
		yyerror("unknown four-operands instruction usage");
	}	/* end switch */
	DBUG_VOID_RETURN;
}	/* gen4op() */

gen6op(inst,size,arg1,arg2,arg3,arg4,arg5,arg6)
register instr		*inst;
register int		size;
register struct arg	*arg1,
			*arg2,
			*arg3,
			*arg4,
			*arg5,
			*arg6;
{
	DBUG_ENTER ("gen6op");
	object = inst->opcode;
    
	switch ((int)(unsigned char)inst->tag)
	{
		case CAS2:
		{	/* cas2 Dw1:Dw2,Do1:Do2,(Rz1):(Rz2) */
			register int inst2wd,	/* second word of instruction format */
			             inst3wd;	/* third word of instruction format  */
				
			long longword;
		if (!as20)
			wxerror("a 68020/30 instruction");
		if ( size == B )
			object |= 0x200;
		else
		if ( size == W )
			object |= 0x400;
		else
		if ( size == L )
			object |= 0x600;
		else
		if ( size == UNSPEC )
		{
			size = W;
			object |= 0x400;
			werror("No size for CAS2, .W assumed");
		}
		else
			yyerror ("Bad size for CAS2 instruction");
	
		inst2wd = 0;
		inst3wd = 0;
		if ( arg1->atype != ADREG || arg2->atype != ADREG )
			yyerror ("test values to be compared against memory operands must be contained in data registers");
		else
		{
			inst2wd |= arg1->areg1->opcode;
			inst3wd |= arg2->areg1->opcode;
		}

		if ( arg3->atype != ADREG || arg4->atype != ADREG )
			yyerror ("update values to be written to memory operand locations must be held in data registers");
		else
		{
			inst2wd |= arg3->areg1->opcode << 6;
			inst3wd |= arg4->areg1->opcode << 6;
		}

		if ( arg5->atype == ADREG )
			inst2wd |= arg5->areg1->opcode << 12;
		else
		if ( arg5->atype == AAREG )
			inst2wd |= arg5->areg1->opcode << 12 | 0x8000;
		else
			yyerror ("address of tested operands must be contained in either data or address register");

		if ( arg6->atype == ADREG )
			inst3wd |= arg6->areg1->opcode << 12;
		else
		if ( arg6->atype == AAREG )
			inst3wd |= arg6->areg1->opcode << 12 | 0x8000;
		else
			yyerror ("address of tested operands must be contained in either data or address register");

		generate (BITSPOW, 0, object, NULLSYM);
		longword = ( longword = inst2wd ) << 0x10 | inst3wd;
		generate (2*BITSPOW, 0, longword, NULLSYM);
		DBUG_VOID_RETURN;
		}	/* cas2 */
	default:
		yyerror("unknown six-operands instruction usage");
	}	/* end switch */
	DBUG_VOID_RETURN;
}	/* gen6op() */

flags(flag)
char	flag;
{
	char	errmsg[28];

	DBUG_ENTER ("flags");
	sprintf(errmsg,"illegal flag (%c) - ignored",flag);
	werror(errmsg);
	DBUG_VOID_RETURN;
}       /* flags()      */


#ifdef M68020
/*
 *	gen_eff_add()
 *
 *	common generation for effective address 
 *	created in eff_add()
 */

gen_eff_add()
{

	DBUG_ENTER ("gen_eff_add");
	if( ea.len1 == BITSPBY )
	{	/* only the low order 8 bits need to be relocated */
		generate(BITSPBY,0,ea.ext1>>BITSPBY,NULLSYM);
		generate(BITSPBY,ea.action1,ea.ext1 & 0xff,ea.sym1);
	}
	else if( ea.len1 != INVALID )
		generate(ea.len1*BITSPOW,ea.action1,ea.ext1,ea.sym1);

	if( ea.len2 != INVALID )
		generate(ea.len2*BITSPOW,ea.action2,ea.ext2,ea.sym2);
	if( ea.len3 != INVALID )
		generate(ea.len3*BITSPOW,ea.action3,ea.ext3,ea.sym3);
	DBUG_VOID_RETURN;
} /* gen_eff_add() */
#endif /* M68020 */

#ifdef	M68881
/*
 *	GET_FP_VALUE
 *		Calls  do_fp_num, which converts a floating point ascii
 *	string to its binary value, and puts the returned result into
 *	3 long extension words.
 *
 *	Inputs:
 *		size		instruction extension 
 *
 *	Other parameters:
 *		FP_STR		global variables containing
 *			mantissa string, exponent string,
 *			sign of mantissa, sign of exponent, and
 *			number of digits to the right of the decimal point.
 *
 *		Returns	ea.ext1, ea.ext2, ea.ext3
 */
get_fp_value( size )
register int size;
{
	int     fp_num[ 6 ];
	register unsigned long d1, d2;
	register long ex, mt, s;

	DBUG_ENTER ("get_fp_value");
	switch(size)
	{
	case S:
		fp_extension = FP_S;
		fp_precision = FP_S;
		break;
	case UNSPEC:
	case B:
	case W:
	case L:
	case D:
		fp_extension = FP_D;
		fp_precision = FP_D;
		break;
	case X:
		fp_extension = FP_X;
		fp_precision = FP_X;
		break;
	case P:
		fp_extension = FP_P;
		fp_precision = FP_P;
		break;
	default:
		aerror("Assembler Error: bad size in get_fp_value");
		break;
	}	/* end switch */

	do_fp_num(fp_num);

	switch(size)
	{
	case S:
	case D:
	case X:
	case P:
		ea.ext1 = (fp_num[5] & 0xffff) ;
		ea.ext1 = (ea.ext1 << 16 | fp_num[4] & 0xffff);

		ea.ext2 = (fp_num[3] & 0xffff) ;
		ea.ext2 = (ea.ext2 << 16 | fp_num[2] & 0xffff);

		ea.ext3 = (fp_num[1] & 0xffff) ;
		ea.ext3 = (ea.ext3 << 16 | fp_num[0] & 0xffff);
		break;
	case UNSPEC:
	case B:
	case W:
	case L:
		d1 = fp_num[5] & 0xffff ;
		d1 = d1 << 16 | fp_num[ 4 ] & 0xffff;

		d2 = fp_num[3] & 0xffff ;
		d2 = d2 << 16 | fp_num[ 2 ] & 0xffff;

		s  = 0x80000000 & d1;
		/* exponent unmasked, shifted to lsb then unbiased, and ... */
		/*                 adjusted for shift of mantissa to bit 30 */
		ex = ( ( (int) 0x7ff00000 & d1 ) >> 20 ) - 1023 - 30;
		/* shift and add to get 31 significant bits */
		mt = ( ( 0x00100000 + ( d1 & 0x000fffff ) ) << 10 ) +
					       ( ( d2 >> 22 ) /* & 0x3ff */ );
		switch( size )
		{
		case B:
			s = s ? 0x80 : 0;
			if( ex < -23 ) break;
			else mt =  s ? 0x80 : 0x7f;
			ea.ext1 = mt;
			werror( "Immediate value is too large; maximized");
			DBUG_VOID_RETURN;
		case W:
		case UNSPEC:
			s = s ? 0x8000 : 0;
			if( ex < -15 ) break;
			else mt = s ? 0x8000 : 0x7fff;
			ea.ext1 = mt;
			werror( "Immediate value is too large; maximized");
			DBUG_VOID_RETURN;
		case L:
			s = s ? 0x80000000 : 0;
			if( ex < 1 ) break;
			else mt = s ? 0x80000000 : 0x7fffffff;
			ea.ext1 = mt;
			werror( "Immediate value is too large; maximized");
			DBUG_VOID_RETURN;
		}
		if( ex < 0 )
			mt >>= -ex;
		if( s ) mt = -mt;
		switch( size )
		{
		case B:
			mt &= 0xff;
			break;
		case W:
		case UNSPEC:
			mt &= 0xffff;
			break;
		case L:
			break;
		}
		ea.ext1 = mt;
		break;
	}	/* end switch */
	DBUG_VOID_RETURN;
}	/* end get_fp_value */
#endif	/* M68881 */
