/*      Copyright (c)   1985,1987,1988       AT&T; MOTOROLA, INC.    */
#ident "@(#)instab.h	35.1     88/08/26     "

/*		Header file for mc68000 assembler.			*/

typedef	enum
	{
		FALSE,
		TRUE
	}	BOOL;


#define	B	0		/* Size attribute .b == BYTE.		*/
#define W	1		/* Size attribute .w == WORD.		*/
#define L	2		/* Size attribute .l == LONG.		*/
#define UNSPEC	3		/* No size attribute specified.		*/
#define S	4		/* Size attribute .s == Single precision	*/
#define X	5		/* Size attribute .x == Extended precision	*/
#define P	6		/* Size attribute .p == Packed BCD	*/
#define D	7		/* Size attribute .d == Double precision	*/
#define	RN	8		/* round type .n == round to nearest		*/
#define	RM	9		/* round type .n == round to minus		*/
#define	RZ	10		/* round type .n == round to zero		*/


/* These must fit within a byte */

#define PSEUDO	0x40
#define DADD	0x41
#define ADD	0x42
#define XADD	0x43
#define LOGAND	0x44
#define ASHFT	0x45
#define BRA	0x46
#define	BR	0x47
#define BCHG	0x48
#define BTST	0x49
#define BSR	0x4a
#define MULT	0x4b
#define OPTSIZE	0x4c
#define CMP	0x4d
#define DBCC	0x4e
#define LOGEOR	0x4f
#define EXG	0x50
#define EXT	0x51
#define LEA	0x52
#define LINK	0x53
#define LSHFT	0x54
#define MOV	0x55
#define MOVM	0x56
#define MOVP	0x57
#define LOGOR	0x58
#define ROT	0x59
#define ROTX	0x5a
#define STOP	0x5b
#define SWAP	0x5c
#define TRAP	0x5d
#define UNLK	0x5e
#define LOGSRC	0x5f
#define LOGDST	0x60
#define ADDQ	0x61
#define MOVMMR	0x62
#define MOVMRM	0x63
#define ADDSRC	0x64
#define ADDDST	0x65
#define RTD	0x66
#define MOVS	0x67
#define BFCHG	0x68
#define BFFFO	0x69
#define BFINS	0x6a
#define BFTST	0x6b
#define BKPT	0x6c
#define CAS 	0x6d
#define CAS2	0x6e
#define CALLM	0x6f
#define CHK	0x70 
#define CHK2	0x71
#define CMP2	0x72
#define DIVS	0x73
#define DIVU	0x74
#define MULS	0x75
#define MULU	0x76
#define PACK	0x77
#define RTM	0x78
#define TDIVS	0x79
#define TDIVU	0x7a
#define TMULS	0x7b
#define TMULU	0x7c
#define TPCC	0x7d
#define TST	0x7e
#define UNPK	0x7f
#define	DEFAULT	0x80			/* default; size (B,W,L) added in */
/* Allow for DEFAULT+[B|W|L|UNSPEC] */
#ifdef M68881	/* define FP co_processor instructions */
#	define	CPBCC	0x84
#	define	CPDBCC	0x85
#	define	CPRESTORE	0x86
#	define	CPSAVE	0x87
#	define	CPGEN	0x88
#	define	CPSCC	0x89
#	define	CPTCC	0x8a
#	define	CPTPCC	0x8b
#	define	FCMP	0x8c
#	define	FMOV	0x8d
#	define	FMOVCR	0x8e
#	define	FMOVM	0x8f
#	define	FNOP	0x90
#	define	FOP	0x91
#	define	FSGLDIV	0x92
#	define	FSGLMUL	0x93
#	define	FSINCOS	0x94
#	define	FTST	0x95
#endif /* M68881 */

#ifdef M68851	/* define PMMU co_processor instructions */
#	define	PBCC	 0x9a
#	define	PDBCC	 0x9b
#	define	PFLUSH   0x9c
#	define	PFLUSHA  0x9d
#	define	PFLUSHR  0x9e
#	define	PFLUSHS  0x9f
#	define	PLOADR   0xa0
#	define	PLOADW   0xa1
#	define	PMOVE	 0xa2
#	define	PRESTORE 0xa3
#	define	PSAVE    0xa4
#	define	PSCC  	 0xa5
#	define	PTESTR	 0xa6
#	define	PTESTW	 0xa7
#	define	PTRAPCC  0xa8
#	define	PVALID   0xa9
#endif /* M68851 */

#ifdef M68030
#       define  PMOVEFD  0xaa
#endif /* M68030 */

#ifdef M68020
/*	define register type */
#	define NULAREG	001
#	define NULDREG	002
#	define NULPCREG 003
#endif /* M68020 */

#ifdef M68881
#	define	FPREG		4	/* floating point register	*/
#	define	FPCONTROL	5	/* floating point control register	*/
#	define	FPIADDR		6	/* floating point iaddr register	*/
#	define	FPSTATUS	7	/* floating point status register	*/
#endif /* M68881
		*/
#ifdef M68851   /* Codes are the (shifted) bit patterns for these registers */
#       define  TC              0x40    /* pmmu Translation Control register     */
#       define  DRP             0x44    /* pmmu DMA root pointer register */
#       define  SRP             0x48    /* pmmu Supervisor root pointer register*/
#       define  CRP             0x4c    /* pmmu CPU root pointer register */
#       define  CAL             0x50    /* pmmu Current Access Level register   */
#       define  VAL             0x54    /* pmmu Validate Access Level register  */
#       define  SCC             0x58    /* pmmu Stack Change Control register   */
#       define  AC              0x5c    /* pmmu Access Control register */
#       define  PSR             0x60    /* pmmu Status register */
#       define  PCSR            0x64    /* pmmu Cache Status register   */
#       define  BAD             0x70    /* pmmu Brkpt Ack Data register */
#       define  BAC             0x74    /* pmmu Brkpt Ack Cont register */
#endif /* M68851 */

#ifdef M68030   /* Codes are the (shifted) bit patterns for these registers */
#       define  MMUSR           0x60    /* M68030 MMU Status register */
#       define  TT0             0x08    /* M68030 Xparent Xlation reg. 0 */
#       define  TT1             0x0c    /* M68030 Xparent Xlation reg. 1 */
#endif /* M68030 TT0, TT1 have two extra bits which must be masked off */

/* define effective addressing modes */
#define ADREG   0x00  /* Data Register Direct */
#define AAREG   0x08  /* Address Register Direct */
#define AIREG   0x10  /* Address Register Indirect */
#define AINC    0x18  /* Address Register Indirect with Postincrement */
#define ADEC    0x20  /* Address Register Indirect with Predecrement */
#define AOFF    0x28  /* Address Register Indirect with Displacement */
#define ANDX    0x30  /* Addr. Reg. Ind. with Index, or Memory Ind. Post/Pre */
#define ABSU    0x34  /* Absolute Unspecified Size */
#define ABSW    0x38  /* Absolute Short */
#define ABSL    0x39  /* Absolute Long */
#define APCOFF  0x3a  /* Program Counter Indirect with Displacement */
#define APCNDX  0x3b  /* PC Ind. with Index, or PC Memory Ind. Post/Pre */
#define AIMM    0x3c  /* Immediate */
#define AIMM_FP 0x3d  /* Floating point immediate expression */
/* Addressing modes, related to mode categories below. below */
#define XDREG   0x800  /* Data Register Direct */
#define XAREG   0x400  /* Address Register Direct */
#define XIREG   0x200  /* Address Register Indirect */
#define XINC    0x100  /* Address Register Indirect with Postincrement */
#define XDEC    0x080  /* Address Register Indirect with Predecrement */
#define XOFF    0x040  /* Address Register Indirect with Displacement */
#define XNDX    0x020  /* Addr. Reg. Ind. with Index, or Memory Ind. Post/Pre */
#define XBSW    0x010  /* Absolute Short */
#define XBSL    0x008  /* Absolute Long */
#define XPCOFF  0x004  /* Program Counter Indirect with Displacement */
#define XPCNDX  0x002  /* PC Ind. with Index, or PC Memory Ind. Post/Pre */
#define XIMM    0x001  /* Immediate */


#define PCREG   0x70L
#define CCREG   0x72L
#define SRREG   0x73L
#define CTLREG	0x74L
#define SFCREG  0x000L  /* this is an opcode, not a type! (i.e. > byte) */
#define DFCREG  0x001L  /* this is an opcode, not a type! (i.e. > byte) */
#define CACREG  0x002L  /* this is an opcode, not a type! (i.e. > byte) */
#define USPREG	0x800L	/* this is an opcode, not a type! (i.e. > byte) */
#define VBRREG  0x801L  /* this is an opcode, not a type! (i.e. > byte) */
#define CAAREG  0x802L  /* this is an opcode, not a type! (i.e. > byte) */
#define MSPREG  0x803L  /* this is an opcode, not a type! (i.e. > byte) */
#define ISPREG  0x804L  /* this is an opcode, not a type! (i.e. > byte) */


/* define addressing mode categories related to modes above */
#define CONTROL	0x27e	/* control addressing mode only */
#define CONPRE  0x2fe   /* control or predecrement */
#define CONALTPRE 0x2f8 /* control alterable or predecrement */
#define CONPOST	0x37e	/* control or postincrement */
#define ALTMEM	0x3f8	/* alterable memory addressing */
#define DATALT	0xbf8	/* data alterable addressing */
#define DATNIM	0xbfe	/* data but not immediate */
#define DATAA	0xbff	/* data addressing */
#define ALT	0xff8	/* alterable addressing */
#define ALL	0xfff	/* all addresssing mode */
#define DnALTCON 0xa78	/* data register direct or alterable control */
#define DnCONTROL 0xa7e	/* data register direct or control */
#define	MEMORY	0x3ff	/* memory addressing mode	*/

#ifdef	M68020		
#	define X1	0	/* define scales for indexed addressing */
#	define X2	1
#	define X4	2
#	define X8	3

#	define INDIRECT  0	/* no memory indirection */
#	define POSTNDXMI 1	/* post indexed memory indirect */
#	define PRENDXMI  2	/* pre indexed memory indirect */
#	define BFINDIRECT  3	/* no memory indirection,brief format */

#	define SET	1	/* as in "ss" in sized registers */
#	define NOTSET	0
#endif


#	define FP_INT	1	/* integer value, don't need any conversion	*/
#	define FP_BIN	2	/* floating point constant in binary format	*/
#	define FP_DEC	3	/* floating point constant in dec. ASCII	*/

struct	arg
	{
 		BYTE		atype;
		instr		*areg1;
		instr		*areg2;
		BYTE		asize;		/* associated with index reg */
#ifdef	M68020
		BYTE		ascale;		/* associated with index reg */
		short		aflags;
#endif
#ifndef	M68020
		struct exp	*xp;
#else
		struct exp	*xp1;
		struct exp	*xp2;
#define xp	xp1
#endif
	};

struct	exp
	{
		short	xtype;
		symbol	*xsymptr;
		long	xvalue;
#ifdef	M68020
		BYTE	xsize;			/* sized displacements	*/
#endif
#ifdef M68881
		short	xvaltype;		/* value type, FP_BIN,FP_DEC	*/
		long	xvalue2;		/* double, extended, and	*/
		long	xvalue3;		/* packed BCD extension	*/
#endif /* M68881 */
	};

typedef union
	{
		long		ylong;
 		int		yint;
		symbol		*yname;
		instr		*yinst;
		struct exp	*yexp;
		struct arg	*yarg;
		char		*ystr;
	} YYSTYPE;

extern  YYSTYPE		yylval;
extern struct arg	*ap;
extern struct exp	*xp;

