#ident "@(#)dis:M68020/851_gen.c	35.1       88/08/26     "
#define Copyright (c) /* 1984 AT&T, INC. and MOTOROLA, INC. */

/* MC68020 Disassembler - Generalized Coprocessor Support */
/* 	MC68851 Support */


#include	<stdio.h>
#include	"dis.h"
#include	"names.h"
#ifndef SDB
#	include	<setjmp.h>
#	include	<filehdr.h>
#	include	<ldfcn.h>
#	include	<sgs.h>		/* for definition of SGS */
#	include	<scnhdr.h>
#endif

#include	"disdefs.h"
#define		FSIZE_SHIFT	8

char	*pmmu_cc[] =
	{
		"bs",
		"bc",
		"ls",
		"lc",
		"ss",
		"sc",
		"as",
		"ac",
		"ws",
		"wc",
		"is",
		"ic",
		"gs",
		"gc",
		"cs",
		"cc"
	};

char	*pmmu_regs[] =
	{ "%tc", "%drp", "%srp", "%crp", "%cal", "%val", "%scc", "%ac",
	  "%psr", "%pcsr", "%p??", "%p??", "%bad", "%bac", "p??", "p??",
	  "%tt0",  "%tt1" 
	};

				/* Changes to fp_op should be reflected here */
#define FMOV	0
#define FCMP	0x38
#define FTEST	0x3a
#define FRESERVED 0x3b
#define	FYTOX	0x3c
#define FMOVM	"fmovm   "
#define FMOVCR	"fmovcr"
				/* sincos requires specail decoding */
#define FSINCOS_first	0x30
#define FSINCOS_last	0x37

char	*pmmu_op[] =		/* Generic PMMU ops, bits 11..6==0 */
    {
	"pmove",		/* 030 pmove to/from tt0, tt1 */
	"",			/* pvalid, pload, pflush */
	"pmove",		/* format 1 */
	"pmove",		/* formats 2 and 3 */
	"ptest",
	"pflushr",
	"???",
	"???"
    };
char	*pmmu_op2[] =		/* extended, bits 15..13 == 001 */
    {
	"pload",
	"pflusha",
	"pvalid.l",		/* format 1 */
	"pvalid.l",		/* format 2 */
	"pflush",		/* function code only */
	"pflushs",		/* fc and shared */
	"pflush",		/* fc and ea */
	"pflushs"		/* fc, ea, and shared */
    };

char	*pmmu_size[] =
    { ".l", ".d", ".d", ".d", ".b", ".b", ".b", ".w",
      ".w", ".w", ".?", ".?", ".w", ".w", ".?", ".?",
      ".l", ".l" };

int	pmmu_sz[] =
    { LONG, FDOUBLE, FDOUBLE, FDOUBLE, BYTE, BYTE, BYTE, WORD,
      WORD, WORD, NULL, NULL, WORD, WORD, NULL, NULL,
      LONG, LONG };

char	*num[] = { "0", "1", "2", "3", "4", "5", "6", "7",
		   "8", "9",  "0xa", "0xb", "0xc", "0xd", "0xe", "0xf" 
		 };


char *func_code(fc_val)
int fc_val;
{
    static char fc_buff[10];

    if( (fc_val&0x10)==0x10 )				/* 1DDDD */
	 sprintf(fc_buff,"&0x%x", (fc_val&0xf) );
    else if( (fc_val&0x8)==0x8 )			/* 01RRR */
	 sprintf(fc_buff,"%%d%d", (fc_val&0x7) );
    else if( fc_val==1 )				/* 00001 */
	 strcpy(fc_buff, "%dfc" );
    else strcpy(fc_buff, "%sfc" );			/* 00000 */

    return( fc_buff );
	
}

void
cp_851(idsp)
int	idsp;
{
    int		    cp_id, cp_cmd;
    unsigned long   val;
    char	    *conv_temp[100];
    int		fp_index, rx, ry, cp_command;


    switch( cp_cmd = BITS8_6(curinstr) ) {

    case 0:			/* General instruction */
	GET2BYTES;

	fp_index = BITS6_0(cur2bytes);
	rx = BITS13_10(cur2bytes);
	ry = BITS4_2(cur2bytes);

	switch( cp_command = BITS15_13(cur2bytes) )  {
	case 1:				/* pload, pflush, pvalid */
		cp_command = BITS12_10(cur2bytes);
		strcat(mneu, pmmu_op2[cp_command] );
		switch( cp_command ) /* process args */
		{
		case 0:		/* pload */
			strcat(mneu, ( (BIT9(cur2bytes)==1)?"r":"w") );
			PAD(mneu);
			strcat(mneu, func_code(BITS4_0(cur2bytes)) );
			strcat(mneu, "," );
			strcat(mneu, std_eff_add(LONG,NULL) );
			break;
		case 3:		/* pvalid %val,<ea> */
		case 2:		/* pvalid %an,<ea> */
			PAD(mneu);
			if( cp_command == 2 )
			    strcat(mneu,"%val,");
			else
			{
			    strcat(mneu,"%a");
			    strcat(mneu,num[BITS2_0(cur2bytes)]);
			    strcat(mneu,",");
			}
			strcat(mneu, std_eff_add(LONG,NULL) );
			break;
		case 1:
			break;	/* pflusha has no args */

		case 4:
		case 5:		/* flush without ea */
			PAD(mneu);
			strcat(mneu, func_code(BITS4_0(cur2bytes)) );
			strcat(mneu, ",&" );
			strcat(mneu, num[BITS8_5(cur2bytes)] );
			break;
		case 6:
		case 7:		/* flush with ea */
			PAD(mneu);
			strcat(mneu, func_code(BITS4_0(cur2bytes)) );
			strcat(mneu, ",&" );
			strcat(mneu, num[BITS8_5(cur2bytes)] );
			strcat(mneu, "," );
			strcat(mneu, std_eff_add(LONG,NULL) );
			break;
		}
		break;
	case 0:				/* Unimplemented */
			/* 030, pmove tt registers */

		rx = 16 + BIT10(cur2bytes);	/* fake reg num */
		/* FALL THROUGH */
	case 2:				/* pmove format 1 */			
	case 3:				/* pmove formats 2 and 3 */
		strcat(mneu, pmmu_op[BITS15_13(cur2bytes)] );
		if( BIT8(cur2bytes)==1 )	/* 030 Flush Disable */
		    strcat(mneu, "fd" );
		strcat(mneu, pmmu_size[rx] );
		PAD(mneu);
		if( BIT9(cur2bytes)==1 )
		{			/* move to ea from reg */
			strcat(mneu,pmmu_regs[rx]);
			if( ( cp_command == 3) &&
			    ( (rx==0xc) || (rx==0xd ) ) )
				strcat(mneu, num[ry] );
			strcat(mneu,",");
			strcat(mneu, std_eff_add(pmmu_sz[rx],NULL) );
		}
		else
		{			/* move from ea to reg */
			strcat(mneu, std_eff_add(pmmu_sz[rx],NULL) );
			strcat(mneu,",");
			strcat(mneu,pmmu_regs[rx]);
			if( ( cp_command == 3) &&
			    ( (rx==0xc) || (rx==0Xd ) ) )
				strcat(mneu, num[ry] );
		}
		break;
	case 4:				/* PTEST */
		cp_command = cur2bytes;
		strcat(mneu, pmmu_op[BITS15_13(cp_command)] );
		strcat(mneu, ( (BIT9(cp_command)==1) ? "r" : "w" ) );
		PAD(mneu);
		strcat(mneu, func_code( BITS4_0(cp_command) ) );
		strcat(mneu, "," );
		strcat(mneu, std_eff_add(LONG,NULL) );
		strcat(mneu, ",&" );
		strcat(mneu, num[ BITS12_10(cp_command) ] );
		if( BIT8(cp_command)==1 )			/* ,An */
		{
		    strcat(mneu, ",%a");
		    strcat(mneu, num[ BITS7_5(cp_command) ] );
		}
		break;
	case 5:				/* PFLUSHR */
		strcat(mneu, pmmu_op[BITS15_13(cur2bytes)] );
		PAD(mneu);
		strcat(mneu, "," );
		strcat(mneu, std_eff_add(LONG,NULL) );
		break;
	case 6:				
	case 7:				/* MoveM from FP regs */
		strcat(mneu, "UNKNOWN pmmu operand form");
		break;
	};
	return;

    case 1:				/* pdbcc */
	GET2BYTES;
	if( BITS5_3(curinstr)==1) {
	    sprintf(mneu,"pdb%s", pmmu_cc[BITS3_0(cur2bytes)] );
	    PAD(mneu);
	    sprintf(mneu,"%s%s,", mneu, reg_names[BITS2_0(curinstr)] );
	    GET2BYTES;
	    if (BIT15(cur2bytes)) strcat(mneu,"-");
	    convert(BIT15(cur2bytes) ? -(short) cur2bytes : 
		    cur2bytes,conv_temp,LEAD);
	    strcat(mneu,conv_temp);
	    compoff((BIT15(cur2bytes) ? ((long) (short) cur2bytes) :
		    (long) cur2bytes) -2, conv_temp);
		    /* the -2 above is needed because loc has been 
		       updated when getting the displacement, but 
		       for Motorola the pc is the address of the 
		       extension word */
	    return;
	};

	if( BITS5_3(curinstr)==7 ) {				/* TRAPcc */
	    sprintf(mneu,"ptrap%s", pmmu_cc[BITS3_0(cur2bytes)] );

	    switch( BITS2_0(curinstr) ) {
	    case 4:
		return;
	    case 2:
		GET2BYTES;
		val = cur2bytes;
		strcat(mneu,".w");
		break;
	    case 3:
		GET4BYTES;
		val = cur4bytes;
		strcat(mneu,".l");
		break;
	    case 0:		/* abs.w for pscc */
	    case 1:		/* abs.l for pscc */
		goto pscc;	/* will reset mnue to pscc */
	    default:
		sprintf(mneu,"ERROR in PTRAP instruction");
	    };
	    PAD(mneu);
	    strcat(mneu, imm_string(val,UNSIGNED) );
	    return;

	};
pscc:
	sprintf(mneu,"ps%s", pmmu_cc[BITS3_0(cur2bytes)] );
	PAD(mneu);
	strcat(mneu,std_eff_add(BYTE,UNSIGNED) );
	return;

    case 2:
    case 3:				/* PBcc.w or PBcc.l */
	sprintf(mneu,"pb%s", pmmu_cc[BITS3_0(cur2bytes)] );
   
	if( cp_cmd == 2 )	/* word disp */
	{
		strcat(mneu,opt_size[WORD]);
		PAD(mneu);
		GET2BYTES;
		convert(BIT15(cur2bytes) ? -((short) cur2bytes) :
			cur2bytes,conv_temp,LEAD);
		compoff((BIT15(cur2bytes) ? ((long) (short) cur2bytes) :
			(long) cur2bytes) -2, conv_temp);
				/* the -2 above is needed because loc has been 
				   updated when getting the displacement, but 
				   for Motorola the pc is the address of the 
				   extension word */
		if (BIT15(cur2bytes))
			strcat(mneu,"-");
	}
	else		/* long disp */
	{
		long	fourbytes;

		strcat(mneu,opt_size[LONG]);
		PAD(mneu);

		GET4BYTES;

		convert(  (HIOF32(cur4bytes) ? -cur4bytes : cur4bytes ),
				conv_temp,LEAD);
		compoff( (HIOF32(cur4bytes)?-cur4bytes:cur4bytes)-2, conv_temp);
				/* the -2 above is needed because loc has been 
				   updated when getting the displacement, but 
				   for Motorola the pc is the address of the 
				   extension word */
		if (HIOF32(cur4bytes))
			strcat(mneu,"-");
	}
	strcat(mneu,conv_temp);
	return;

    case 4:
	strcat(mneu,"psave   ");
	strcat(mneu,std_eff_add(NULL,NULL));
	return;
    
    case 5:
	strcat(mneu,"prestore ");
	strcat(mneu,std_eff_add(NULL,NULL));
	return;

    };
};
