#ident "@(#)main.c	35.1       88/08/26     "
#ident "Copyright (c) 1984 AT&T, INC. and MOTOROLA, INC."

# include "defin.h"
extern char* getenv();

/*F*********************** FUNCTION HEADER *******************************

FUNCTION NAME:

	main

ACTION:

	Controls the execution of the optimizer.

PARAMETERS:

	Receives:

		argc: number of arguments on command line

		argv: array of pointers to command line entries

	Returns:

		nothing

EXTERNAL DATA REFERENCES:

	symflag
	clseonly
	bbflag
	labelsht
	lcseht
	constht

COMPLEX LOCALS:

	none

FUNCTIONS CALLED:

	p2init
	hcreate
	initfunc
	gatherfunc
	scopedump
	optimize
	writefunc
	writestats
	prflowgraph

CALLED BY:

	no body

METHOD:

	self explanatory

NOTES:

	none

*FE********************************************************************/

main( argc, argv ) 

int argc;
char *argv[]; 
{
	register files;
	int noteof;
	int fdef=0;

	files = p2init( argc, argv );
	tinit();

	if( files ){
		while( files < argc ) {
			if( *(argv[files]) != '-' ) switch( ++fdef )
			{
			case 1:
			case 2:
				if( freopen(argv[files], fdef==1 ? "r" : "w", fdef==1 ? stdin : stdout) == NULL)
				{
					fprintf(stderr, "ccom:can't open %s\n", argv[files]);
					exit(1);
				}
				break;

			default:
				cerror("usage error: coptim [<options>] [<source file> [<destination file>]] : \"%s\" purpose unknown", argv[files]);
			}
			++files;
		}
	    }
	hcreate(&labelsht, 64);
	hcreate(&lcseht, 31);
	hcreate(&constht, 31);
	for (;;)
	   {
	   initfunc();
	   if (gatherfunc())
	      {
	      if (symflag)
		 scopedump(); /* dump scope information */
	      if ( ! clseonly)
	         optimize();
	      writefunc();
	      writestats();
	      if (bbflag)
		 prflowgraph();
	      }
	   else
	      break;
	   }
}


/*F*********************** FUNCTION HEADER *******************************

FUNCTION NAME:

	p2init

ACTION:

	Process command line options

PARAMETERS:

	Receives:

		argc
		argv

	Returns:

		number of file names encountered

EXTERNAL DATA REFERENCES:

	regflag
	lcseflag
	statsflag
	bbflag
	lcsedbflg
	symflag
	odebug
	is_m68881
	align_val

COMPLEX LOCALS:

	none

FUNCTIONS CALLED:

	mkdope
	getenv
	strcmp

CALLED BY:

	main

METHOD:

	self explanatory

NOTES:

	none

*FE********************************************************************/

int
p2init( argc, argv )
char *argv[];
{
	register int c;
	register char *cp;
	register files;
	register char* statsname;
	char *strval;

	files = 0;

	for( c=1; c<argc; ++c )
	{
		if( *(cp=argv[c]) == '-' )
		{
			while( *++cp )
			{
				switch( *cp )
				{

				case 'R':  /* Turn off register allocation */
					regflag = FALSE;
					break;

				case 'L':  /* Turn off lcse */
					lcseflag = FALSE;
					break;

				case 'S':  /* Statistics */
					++statsflag;
					if (statsflag == 1)
					   {
					   if ((statsname = getenv("STATSFILE")) == NULL)
					      cerror("STATSFILE not defined within current environment,\n\t statistics can not be collected.");
					   if ((statsfile = fopen(statsname,"a")) == NULL)
					      cerror("%s can not be opened",statsname);
					   fprintf(statsfile, "\n\tfuncname          nodesout    aregstat    fpregstat   lcsestat    scopestat   loopstat\n");
					   fprintf(statsfile, "\t            nodesin     bbcnt       dregstat    symtabndx   valueno     tempstat\n");
					   }
					break;

				case 'b':  /* basic blocks */
					++bbflag;
					break;

				case 'l':  /* local common subexpression flag */
					++lcsedbflg;
					break;

				case 's':  /* symbol table */
					++symflag;
					break;

				case 'o':  /* orders */
					++odebug;
					break;

				default:
					cerror( "bad option: %c", *cp );
				}
			}
		}
		else files = 1;  /* assumed to be a ftitle */
	}

	if( ( ( strval = getenv( "DBLALIGN" ) ) != NULL ) &&
	    ( ! strcmp( strval, "YES" ) ) )
	{
		align_val = 32;	/* double word align */
	}

	if ( ( strval = getenv( "FP" ) ) != NULL ) 
	{
	    if (strval[0] == 'm')
		strval[0] = 'M'; /* reduce # of cases to cover */

	    if ( ( ! strcmp( strval, "M68881" ) ) ||
	         ( ! strcmp( strval, "M68881u") ) ||
	         ( ! strcmp( strval, "M68881U") ) )
	    {
		++is_m68881;	/* generate code for M68881 */
	    }
	}

	mkdope();
	return( files );
}
