#ident "@(#)symtab.h	35.1       88/08/26     "
#define Copyright (c) /* 1984 AT&T, INC. and MOTOROLA, INC. */
/*		Copyright (c) 1985 AT&T		*/
/*		All Rights Reserved		*/
/*	Copyright 1985 Motorola,1987 Inc.			*/

/* flag settings for opn.flags */
#define SIMPLE 1
#define ARRAY 2
#define LCSEFLAG 4
#define ADDRESSTAKEN 1
#define ISSIMPLE( p ) ( p->opn.flags & SIMPLE && ( ! ((symtab + p->opn.sourceno)->flags & ADDRESSTAKEN)))

/* The following data structure, SYMENT (SYMbol table ENTry), is used to 
   describe the declaration of a simple local variable or parameter.   
   The symbols are identified in the Ctrees by VAUTO or PARAM
   nodes whose offsets match a offset in the symbol table. The "sourceno"
   associated with each Ctree node will be the index into the symbol
   table. 
   The symbols declared within the same scope are linked together in
   a linked list order from the positive (parameters) to negative (locals)
   offset.
*/                        

typedef struct Tlevel
   {                 
   struct Tlevel *higher;       /* pointer to higher scope level */
   struct Tlevel *same;         /* pointer to same scope level */
   struct Tlevel *lower;        /* pointer to lower scope level */
   int scopehead;               /* index into symbol table of first variable
                                ** declared in this block
                                */
   int maxoffset;               /* max offset of VAUTOs in block */
   int regexport;               /* exported register mask */
   int regavail;                /* available register mask */
   NODE *sblock;                /* pointer to '[' node which starts block */
   NODE *eblock;                /* pointer to ']' node which ends block */
   int qnode;                   /* offset of temporary used as qnode */
   } SCOPE;

typedef struct syment {
   int offset;          /* stack offset for a simple variable in bytes */
   char *name;          /* name of variable - for debug purposes only*/
   TWORD type;          /* type of variable */
   char flags;          /* bit flags */
   char sclass;         /* storage class */
   int reg;             /* bit mask designating register used by variable */ 
   int weight;          /* dependent upon static usage and loop depth */
   ENTRY *valueno;      /* current value number for variable */
   int scopendx;        /* index of next variable in same scope level */
   SCOPE *scope;	/* pointer to scope where the variable was declared */
   } SYMENT;

typedef struct Tsorted
   {
   int weight;		/* weight of the variable */
   int ndx;		/* index into the symbol table */
   } SORTED;

