#ident "Copyright (c) 1984 AT&T, INC. and MOTOROLA, INC."
# keywords are just below, in the BEGIN action.
#
BEGIN           { FS = "\t"; OFS = ""; ORS = "";
		  print \
			"#ident \"@(#)optab.h    88/08/26     \"\n", \
			"#ident \"@(#)optab.awk	35.1     88/08/26     \"\n" ;
		  print \
			"#ident \"@(#)opdefs.h    88/08/26     \"\n", \
			"#ident \"@(#)optab.awk	35.1     88/08/26     \"\n" >"opdefs.h" ;
		  false = 0;
		  true = 1;
		  endif = 3;
		  condition = endif;
		  first = "t";
		  opnum = 10; # low numbers 0..9 reserved for optim.c use
			      # to flag special opcode types
		  print "#define OP_MIN\t\t",opnum, \
			"\t/* Min. opcode no. */\n\n" >>"opdefs.h";
		}
$1 == "/*"	{ print; print "\n"; next }
/#[ \t]*ident/ { print $0 "\n" ; print $0 "\n" >>"opdefs.h" ; next }
#
# ${PROCESSOR} ifdefs, ifndefs, cannot handle nested, expr. or space after "#"
# "condition" defaults to "endif" always
#
/^#[ \t]*if/    { \
		if ( condition != endif ) { \
			print condition "\nError online " NR  ": Unbalanced #if" ;
			exit  1 } \
		}
$1 ~ /#[ \t]*ifdef/  && p != $2 { \
		condition = false ;
		next ;
		}
$1 ~ /#[ \t]*ifdef/  && p == $2 { \
		condition = true ;
		next ;
		}
$1 == "#ifndef" && p == $2 { \
		condition = false ;
		next ;
		}
$1 == "#ifndef" && p != $2 { \
		condition = true ;
		next ;
		}
$1 == "#else" { \
		if ( condition == endif ) { \
			print condition "\nError on line " NR  ": Ifless #else\n" ;
			exit  1 \
		} ;
		if ( condition == true ) condition = false ;
		else condition = true;
		next ;
		}
/^#[ \t]*endif/ { condition = endif ; next }
# Delete all lines which are "false"
		{ if ( condition == false ) next }
#
#
#
first == "f"	{ print "," }
first == "t"    { print "{"; comment = "" }
		 #beginning of line processing
length(comment) != 0 \
		{ print "\t/* ", comment, " */"; comment = "" }
		# add an opcode equate to ops.tail
		  { print "#define ", $2, "      \t", opnum, \
			"\t/* ",$1," */\n" >>"opdefs.h";
		  opnum++;
		  print "\n" ;
		  print "    { \"", $1, "\",\t" ;
		  print $2, ",\t" ;
		  print $3, ",\t", $4, ",\t{", $5, "},\t", $6, ",\t" $7, \
			",\t", $8, " }" ;
		  first = "f" }
NF > 8		{ comment = $9 }
END		{ print "\n};\n";
		  opnum--;
		  print "\n#define OP_MAX\t\t",opnum, \
			"\t/* Max. opcode no. in the 'op' table */\n\n"\
			>>"opdefs.h";
		  opnum++;
		  print "/* The following two directives need opcode numbers",\
			",    */\n" >>"opdefs.h";
		  print "/* but they do not lie in the normal opcode table ",\
			"'op'. */\n\n" >>"opdefs.h";
		  print "#define LABEL\t\t",opnum, \
			"\t/* Label directive opcode num. */\n\n" >>"opdefs.h";
		  opnum++;
		  print "#define SWITCH\t\t",opnum, \
			"\t/* Switch directive opcode num. */\n\n" >>"opdefs.h";
		}
