/*
 *		Motorola (c) 1986,1987
 *		All Rights Reserved
 *		@(#)sledit.h	35.2
 *		sledit.h
 */

#define	SLICES		16		/* max number of slices per screen */
#define FIELDS		5		/* number of fields in edit win */
#define MAXCOL		80		/* maximum columns in window */
#define MAXSCREEN	16		/* maximum number of screens */
#define BOTTOM		25		/* bottom of screen */
#define HEADER		3		/* first line of header */
#define LINE1		6		/* first line of display */
#define COL1		5		/* first col of display */
#define NSIZE		6		/* size of name colunms */
#undef	SSIZE
#define SSIZE		10		/* size of size colunms */
#define SPACE		4		/* space between columns */
#define SLCNUM		3		/* slice number column  */

/* header columns */

#define FIELD1		COL1				/* slice number */
#define FIELD2		(FIELD1+SPACE+3)		/* slice offset */
#define FIELD3		(FIELD2+SPACE+SSIZE)		/* slice size	*/
#define FIELD4		(FIELD3+SPACE+SSIZE)		/* filsys size  */
#define FIELD5		(FIELD4+SPACE+SSIZE)		/* filsys name	*/
#define FIELD6		(FIELD5+SPACE+NSIZE)		/* filsys vol id */

#define WINLEN	(FIELD6+NSIZE-COL1)			/* window length */

/* window columns */

#define WFIELD1		0				/* slice number */
#define WFIELD2		(WFIELD1+SPACE+3)		/* slice offset */
#define WFIELD3		(WFIELD2+SPACE+SSIZE)		/* slice size	*/
#define WFIELD4		(WFIELD3+SPACE+SSIZE)		/* filsys size  */
#define WFIELD5		(WFIELD4+SPACE+SSIZE)		/* filsys name	*/
#define WFIELD6		(WFIELD5+SPACE+NSIZE)		/* filsys vol id */

struct field {
	unsigned char f_off;		/* field offset */
	unsigned char f_size;		/* field size */
};

struct sledit {
	unsigned char s_flag;		/* readonly flag */
	short slice;			/* slice */
	struct slice s_tab;		/* slice table entry */
	struct filsys fs;		/* file system superblock */
};

struct undo {				/* for undo and unundo commands */
	char u_row;
	char u_col;
	char u_buff[SSIZE+1];
};

#define WARNING		1
#define FATAL		(-1)
#define OKAY		0
#define UNDO		2
#define RDONLY 		0x1		/* readonly */
#define MODIFIED	0x2		/* modified */
#define FSMOD		0x4		/* filesystem modified */
#define NMMOD		0x8		/* filesys name modified */
#define FSKILL		0x10		/* kill filesystem */
#define OVERLAP		0x20		/* Slice overlaps */
#define MOUNTED		0x40		/* Mounted slice */
