/*
 *                  Copyright (c) 1988 Ferranti Plc.
 *                      All Rights Reserved
 *
 *
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF FERRANTI PLC THE COPYRIGHT 
 *                   OF WHICH VESTS IN FERRANTI PLC.
 *
 *   The copyright notice above does not evidence any actual or intended 
 *                   publication of such source code.
 *
 * This source code and the information contained herein is supplied without
 * liability for errors or ommissions and no part may be copied, re-produced, 
 * used or disclosed except as authorised by the Ferranti organisation by 
 *                contract or by other written permission.
 */

/******************************************************************************

	Rev = 5.1		Date of 'get'   = 11:10:53 1/26/89
				Date of 'delta' = 15:22:38 12/22/88

	File = duartchan.h

******************************************************************************/


#ifndef	ASSEMBLY

#ident "@(#)scc-common:include/local/scc/duartchan.h Rev 5.1 15:22:38 12/22/88"

struct duart_channel {

/* offset */

/*  0*/ struct duart_channel *dc_other;     /* Ptr to associated channel    */
/*  4*/ struct mc68681	     *dc_duart_ptr; /* Ptr to actual DUART device   */
/*  8*/ short                 dc_pid;	    /* RTX process id               */

/* 10*/ ushort                dc_16_sp1;    /* 16 bit, reserved future use  */
/* 12*/ ushort                dc_working;
/* 14*/ ushort                dc_number;    /* Channel number 0 to 15       */

	/* Alignment test point 1 */

/* 16*/ ulong                 dc_state;     /* Channel status               */

	/*
	 * Channel interrupt data, for multi-interrupt mode
	 */
/* 20*/ ushort                dc_vector;
/* 22*/ ushort                dc_level;

	/* Alignment test point 2 */
	
	union {
/* 24*/		struct { ushort p0_proc_error; ushort p0_cmd_error; } dc_p0;
/* 24*/ 	ulong dc_p1;
	} error_union;

	/*
	 * Error #define's for easy union access
	 */
#define	dc_cmd_error	error_union.dc_p0.p0_cmd_error
#define	dc_proc_error	error_union.dc_p0.p0_proc_error 
#define	dc_error	error_union.dc_p1

/* 28*/ ulong                 dc_errslost;
	
	/* Alignment test point 3 */

/* 32*/ ulong                 dc_rawtim;
/* 36*/ ulong                 dc_brktim;
/* 40*/ ushort                dc_delay;

	/*
	 * Horizontal movement control
	 */
/* 42*/ ushort                dc_column;
/* 44*/ ushort                dc_width;

	/* Alignment test point 4 */	
/* 46*/	ushort                dc_padatp4;

/* 48*/ ulong                 dc_cflag;
/* 52*/ ulong                 dc_lflag;
/* 56*/ ulong                 dc_iflag;
/* 60*/ ulong                 dc_oflag;
/* 64*/ unchar                dc_c_cc[16];
/* 80*/ ushort                dc_brgss;	/* baud rate gen set sel */
/* 82*/ unchar                dc_flags[32];

/*114*/ unchar                dc_line;
	
	/* Alignment test point 5 */	

	/*
	 * Drain support variables
	 */
/*116*/ ulong                 dc_def_draintout;
/*120*/ ulong                 dc_draintout;
/*124*/ ulong                 dc_dstart;

	
	/*
	 * The dc_tmprawrd index is used as a tempory read index into the
	 * raw input fifo in order to allow for scaning of the fifo for
	 * 'interrupt' characters even though the fifo is not being fully
	 * processed. This variable is only used in ICANON mode. Its value
	 * is only valid while dc_current_fw_fifo is NULL.
	 */
/*128*/ short                 dc_tmprawrd;	/* Temp raw read index    */
/*130*/ char                  dc_tmprawrd_invalid;	

/*131*/ char                  dc_havedcd;
/*132*/ char                  dc_lostdcd;

/*133*/ char                  dc_8_sp1;	    /*  8 bit, reserved future use  */
/*134*/ char                  dc_8_sp2;	    /*  8 bit, reserved future use  */
/*135*/ char                  dc_8_sp3;	    /*  8 bit, reserved future use  */
/*136*/ char                 *dc_echotbl;
	
	/* Alignment test point 6 */	

/*140*/	ulong                 dc_lchar;	/* Last charcater state	  */

/*144*/ ulong                 dc_32_sp0;    /* 32 bit, reserved future use  */
/*148*/ ulong                 dc_32_sp1;    /* 32 bit, reserved future use  */
/*152*/ ulong                 dc_32_sp2;    /* 32 bit, reserved future use  */
/*156*/ ulong                 dc_32_sp3;    /* 32 bit, reserved future use  */
/*160*/ ulong                 dc_32_sp4;    /* 32 bit, reserved future use  */

	/* Alignment test point 7 */

/*164*/ struct term_control  *dc_tcp;
/*168*/ struct input_fifo_control 
                             *dc_ifc;
/*172*/ struct fifo          *dc_current_fw_fifo;
	
	/* Alignment test point 8 */

/*176*/ struct fifo          *dc_hostinf;
/*180*/ struct fifo          *dc_hostoutf;
/*184*/ struct port          *dc_paddr;

	/* Alignment test point 9 */

 	struct scan {
/*188*/         struct scan     *sc_link;	/*  0 link to next struct   */
/*192*/         ushort           sc_outcnt;	/*  4 output delay counter  */
/*194*/         ushort           sc_iflag16;	/*  6 copy of control flags */
/*196*/         ushort           sc_odly;	/*  8 per char output delay */
/*198*/         unchar           sc_pad0;	/* 10 pad character         */
/*199*/         char             sc_halt;	/* 11 output halted flag    */
/*200*/         char            *sc_saddr;	/* 12 duart status register */
/*204*/         char            *sc_daddr;	/* 16 duart data register   */
/*208*/         struct fifo     *sc_priority;	/* 20 priority output fifo  */
/*212*/         struct fifo     *sc_rawf;	/* 24 raw input fifo        */
/*216*/         struct fifo     *sc_outf;	/* 28 normal output fifo    */
/*220*/         unchar           sc_vstop;	/* 32 stop character        */
/*221*/         unchar           sc_vstart;	/* 33 start character       */
/*222*/	        unchar           sc_overflow; 	/* 34 rawf overflow flag    */
/*223*/	        unchar           sc_iflagn8;	/* 35 iflag bits 16-23	    */

		/* Alignment test point 10 */

/*224*/		ulong            sc_chout;	/* 36 char transmit counter */
/*228*/         ulong            sc_pchout;	/* 40 prio transmit counter */
/*232*/         ulong            sc_chin;	/* 44 char receive counter  */
/*236*/         ulong            sc_ctrlcnt;	/* 48 ctrl char counter     */
/*240*/         unchar           sc_ctrlchar;   /* 52 */
/*241*/         unchar           sc_sp0;        /* 53 */
/*242*/         ushort           sc_sp1;        /* 54 */
	} dc_scan;

	struct ics
	{
/*244*/         ushort          ics_tas;
/*246*/		ushort		ics_cmd;
/*248*/		ushort		ics_modifier;
/*250*/		ushort		ics_arg1;
/*252*/		ushort		ics_arg2;
/*254*/		ushort		ics_arg3;
/*256*/		ushort		ics_arg4;
/*258*/		ushort		ics_signal;
/*260*/		ulong 	ics_response;
/*264*/ } dc_ics;
};


/*
 * #defines for dc_flags[]
 */

#define	HOSTIPWAIT		0	/* Host waiting for data from SIOP   */
#define	FWREADINTR		1	/* F/w interrupt, data ready to read */
#define	HOSTOPWAIT		2	/* Host waiting for output to drain  */
#define	FWWRITEINTR		3	/* F/w interrupt, data written	     */
#define	HOSTCMDWAIT		4	/* Host waiting for command done.
					   Will always generate an interrupt */
#define	FWCMDDONE		5	/* F/w interrupt, command done	     */
#define	FWSIGNAL		6	/* Have a dc_signal or HOSTSWITCH */

#define WAIT_HOSTIN_EMPTY	26
#define	SYNCHAND		27	/* SIOSYNC hand shake */
#define	HOSTLOSTDCD		28
#define	HOSTCLIST		29	/* Host is using clists 	*/
#define	HOSTINZAP		30	/* Set by f/w to indicate hostinf zap*/
#define	HOSTOFLUSH		31	/* Set by f/w to indicate host oflush */


#define	dc_cmd_lock	dc_ics.ics_tas
#define	dc_cmd		dc_ics.ics_cmd
#define	dc_modifier	dc_ics.ics_modifier
#define	dc_arg1		dc_ics.ics_arg1
#define	dc_arg2		dc_ics.ics_arg2
#define	dc_arg3		dc_ics.ics_arg3
#define	dc_arg4		dc_ics.ics_arg4
#define	dc_signal	dc_ics.ics_signal

/*
 * dc_modifier #define bits
 */
#define	OFLUSH	0x0001
#define	IFLUSH	0x0002
#define	ODRAIN	0x0004

#define	WAIT_DSR	0x0001
#define	WAIT_DCD	0x0002
#define	WAIT_NEVER	0x8000		/* Never wait - O_NDELAY */

/* struct scn member names */
#define	dc_link		dc_scan.sc_link
#define	dc_outcnt	dc_scan.sc_outcnt
#define	dc_fwiflag	dc_scan.sc_iflag16
#define	dc_odly		dc_scan.sc_odly
#define	dc_fill		dc_scan.sc_pad0
#define	dc_halt		dc_scan.sc_halt
#define	dc_saddr	dc_scan.sc_saddr
#define	dc_daddr	dc_scan.sc_daddr
#define	dc_rawinf	dc_scan.sc_rawf
#define	dc_rawoutf	dc_scan.sc_outf
#define	dc_rawpoutf	dc_scan.sc_priority
#define	dc_vstop   	dc_scan.sc_vstop
#define	dc_vstart   	dc_scan.sc_vstart
#define dc_overflow	dc_scan.sc_overflow
#define dc_iflagn8 	dc_scan.sc_iflagn8
#define	dc_ctrlcnt	dc_scan.sc_ctrlcnt
#define	dc_ctrlchar	dc_scan.sc_ctrlchar


/*
 * dc_lchar
 */
#define LCHAR_CR    0x0002  /* last char CR; next must be NL */
#define LCHAR_BS    0x0004  /* last char BS; next must be ' ' and BS */
#define LCHAR_ESC   0x0008  /* last char ESC */
#define LCHAR_TAB   0x1000  /* last char horizontal tab */

/* dc_state */
#define	CHANNEL_SUSP	0x80000000	/* Channel suspened by an SIOSUSP cmd
					 */
#define	CHAN_NO_OPEN	0x40000000	/* nochan_init called by sinittab. Do
					 * not run channel process.
					 */
#define	READ_INTR_FLAG	0x20000000	/* Read interrupt flag	
					 */
#define	TMP_BLK_OPEN	0x10000000	/* temp stop open, baud flip active */
#define	SEND_SIGINTR	0x08000000	/* Ready to send a dc_signal intr */
#define	HIFNF_MSG	0x04000000	/* Host input fifo msg sent */

#define CHANNEL_AVAILABLE	0x8000  /* channel process is available to run
					 */
#define CHANNEL_OPEN		0x4000  /* DUART is 'open' - do I/P processing
					 */

#define	RAW_TIMEOUT_ACTIVE	0x00000001

#define CMD_DONE		0x0010 	/* command request done
					 */
#define BLOCK   0x0200  /* input blocked while rawq filled */
#define WAIT_OUTFIFO_EMPTY 	0x0400  	/* wait for raw output fifo  *
						 * empty 		     */
#define WBRK    0x2000  /* wait for break complete */
#define WAIT_DRAIN  0x0800  /* wait for drain to complete, 
				possible with timeout */

/* 
 * dc_proc_error 
 */
#define	IN_OVERRUN	0x0001	/* DUART input data overrun 		*/
#define	RIF_OFLOW	0x0002	/* Raw input fifo overflow		*/
#define	HIF_128		0x0004	/* Host in less than 128 free		*/
#define	RIF_FHCPY	0x0008	/* Rawinf full on copy of hostinf data 	*/

/*
 * MC68681 status register bit codes
 */
#define	RECV_BRK	0x80	/* received break	*/
#define	FRAME_ERR	0x40	/* framing error	*/
#define	PARITY_ERR	0x20	/* parity error		*/
#define	OVERRUN_ERR	0x10	/* overrun error	*/
#define	DUART_ERR	0xF0	/* All the 68681 errors	*/


#define	NONEUNIXET	1
#define	UNIXET		2

#define	FWSIG_VINTR	0x02	/* interrupt (rubout) */
#define	FWSIG_VQUIT	0x03	/* quit (ASCII FS) */
#define	FWSIG_VSWTCH	0x7F	/* shl */

extern struct duart_channel duart_channel[];

#else

	ident "@(#)scc-common:include/local/scc/duartchan.h Rev 5.1 15:22:38 12/22/88"

#define	SCLINK		0
#define	SCOUTCNT	4
#define	SCIFLAG		6
#define	SCODLY		8
#define	SCHALT		11
#define	SCSADDR		12
#define	SCDADDR		16
#define	SCPRIO		20
#define	SCRAWF		24
#define	SCOUTF		28
#define	SCVSTOP		32
#define	SCVSTART	33 
#define	SCOVERFL	34 
#define	SCCHOUT		36 
#define	SCPCHOUT	40
#define	SCCHIN		44
#define	SCCTRLCNT	48
#define	SCCTRLCHAR	52

#define	A1A4BLK		12

#define	D0D1BLK		4

#endif

