/*
 *                  Copyright (c) 1988 Ferranti Plc.
 *                      All Rights Reserved
 *
 *
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF FERRANTI PLC THE COPYRIGHT 
 *                   OF WHICH VESTS IN FERRANTI PLC.
 *
 *   The copyright notice above does not evidence any actual or intended 
 *                   publication of such source code.
 *
 * This source code and the information contained herein is supplied without
 * liability for errors or ommissions and no part may be copied, re-produced, 
 * used or disclosed except as authorised by the Ferranti organisation by 
 *                contract or by other written permission.
 */

/******************************************************************************

	Rev = 5.1		Date of 'get'   = 11:10:54 1/26/89
				Date of 'delta' = 14:57:47 12/8/88

	File = lowmem.h

******************************************************************************/

#ident "@(#)scc-common:include/local/scc/lowmem.h Rev 5.1 14:57:47 12/8/88"

/*
 * CHK_32 : 16 bits check code for 32 bits longs. Top 16 bits should be
 *          CHK_32 and the bottom 16 bits the valid data.
 */
#define	CHK_32		0x62AE0000


/*
 *                  Memory addresses and casts
 */
#define	LM		0x400	/* Location monitor address	*/
#define ID_CODE		0x404	/* Offset to board id code in RAM */
#define TYPE_CODE	0x40c	/* Offset to board type code in RAM */


/*
 * STATUS    : Address of card status word in local memory
 * UL_STATUS : unsigned long pointer to status long word
 */
#define	STATUS		0x00000408
#define	UL_STATUS	(unsigned long *)STATUS

#define	SCCS		0x00000418
#define	UL_SCCS		(unsigned long *)SCCS

#define	SRESET		0x0000042C
#define	UL_SRESET	(unsigned long *)SRESET

#define	GO_QUALIFIER	0x484
#define	GO_ADDR		0x488

/*
 * DEBUG_FLAG    : Address of debug location in local memory. Read by siopinit()
 * UL_DEBUG_FLAG : unsigned long pointer to debug long word
 */
#define	DEBUG_FLAG	0x00002F00
#define	UL_DEBUG_FLAG	(unsigned long *)DEBUG_FLAG

/*
 * GERROR    : Address of card global error location in local memory.
 * UL_GERROR : unsigned long pointer to error long word
 */
#define	GERROR		0x00002F04
#define	UL_GERROR	(unsigned long *)GERROR

/*
 * Card base level commands. Used at boot time and to reset the card.
 */

#define	BF_CMD		0x00002F10		/* Base Function Command */
#define	UL_BF_CMD	(unsigned long *)BF_CMD

#define	BF_MODIFIER	0x00002F14		/* Command modifier	 */
#define	UL_BF_MODIFIER	(unsigned long *)BF_MODIFIER

#define	BF_ARG1		0x00002F18		/* Command Argument 1	 */
#define	UL_BF_ARG1	(unsigned long *)BF_ARG1
#define	BF_ARG2		0x00002F1C		/* Command Argument 2	 */
#define	UL_BF_ARG2	(unsigned long *)BF_ARG2
#define	BF_ARG3		0x00002F20		/* Command Argument 3	 */
#define	UL_BF_ARG3	(unsigned long *)BF_ARG3
#define	BF_ARG4		0x00002F24		/* Command Argument 4	 */
#define	UL_BF_ARG4	(unsigned long *)BF_ARG4


/*
 * Firmware structure pointers
 */

#define	FSBP		0x00002F40		/* Firmware struct base ptr */
#define	UL_FSBP		(unsigned long *)FSBP

/*
 * Interrupt lockout flag
 */
#define	ILFLAG		0x00002F44
#define	UL_ILFLAG	(unsigned long *)ILFLAG

/*
 * Pointer to server delay timer variable 'sdelay'
 */
#define	SDLYADRS	0x00002F48
#define	UL_SDLYADRS	(unsigned long *)SDLYADRS

/*
 * Pointer to RTX iclock variable 
 */
#define	ICLKADRS	0x00002F4C
#define	UL_ICLKADRS	(unsigned long *)ICLKADRS

