/*
 *                  Copyright (c) 1988 Ferranti Plc.
 *                      All Rights Reserved
 *
 *
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF FERRANTI PLC THE COPYRIGHT 
 *                   OF WHICH VESTS IN FERRANTI PLC.
 *
 *   The copyright notice above does not evidence any actual or intended 
 *                   publication of such source code.
 *
 * This source code and the information contained herein is supplied without
 * liability for errors or ommissions and no part may be copied, re-produced, 
 * used or disclosed except as authorised by the Ferranti organisation by 
 *                contract or by other written permission.
 */

/******************************************************************************

	Rev = 5.1		Date of 'get'   = 11:10:55 1/26/89
				Date of 'delta' = 14:57:48 12/8/88

	File = scccmd.h

******************************************************************************/

#ident "@(#)scc-common:include/local/scc/scccmd.h Rev 5.1 14:57:48 12/8/88"

#define		SIOOPEN		0x0001
#define			SOPEN_TAIL	0x0001
#define			SOPEN_PLACE	0x0002
#define			WAIT_DSR	0x0001
#define			WAIT_DCD	0x0002
#define			UNIXLD0		0
#define		SIOCLOSE	0x0002
#define		SIOSET		0x0003

/*
 * Suspend command
 */
#define		SIOSUSP		0x0004
/*
 * Flags for SIOSUSP
 */
#define		SIORAWIN	0x0001

#define		SIOREACT	0x0005

/*
 * Common error codes, top 16 bits of dc_error (dc_error_cmd). These are
 * absolute error code numbers as opposed to bit patterns.
 */
#define		CHAN_NOT_OPEN	0x00010000
#define		CHAN_NOT_SUSP	0x00020000
#define		ECHAN_NOT_OPEN	0x00010000
#define		ECHAN_NOT_SUSP	0x00020000

#define		ECHAN_OPEN	0x0003
#define		ECHAN_SUSP	0x0004
#define		ENOICANON	0x0005
#define		ESPEED		0x0006
#define		ENODSR		0x0007
#define		EHARDWARE	0x0008
#define		ENOT_IMP	0xFFFF


/*
 * Command modifier codes, FLUSH
 */

#define		MOD_OFLUSH	0x0001
#define		MOD_IFLUSH	0x0002


/*
 * Command modifier codes, DRAIN
 */

#define		MOD_ODRAIN	0x0004

/*
 * Pre-command modifier mask. All the specified modifier bits MUST be zero
 * before the command will be executed.
 */

#define		MOD_CMDMASK	(MOD_ODRAIN)

#define	SIODUMMY	0x0006

#define	SIOBRK		0x0007

#define	SIOSYNC		0xFFFF

/*
 * #defines that are common to both the driver(s) and the firmware, other than
 * actual commands and parameters.
 */

/*
 * Valid intr_type settings
 */
#define	SINGLE_INTR	0x00000001	/* Single interrupt to host  */
#define	DEFAULT_INTR	0x00000002	/* Use default in sinittab.c */

/*
 * Valid FIFO command settings
 */
#define	F_DEFAULT	0x44464C54 	/* DFLT */
#define	F_CONFIG 	0x434e4647 	/* CNFG */

/*
 * Valid BF_CMD settings
 */
#define	INITINTR	0x62AE0001
#define	INITFMEM	0x62AE0002
#define	INITFIFO	0x62AE0003

/*
 * Location monitor test result flags
 */
#define	LM_TEST_PASS	0x50415353	/* 'PASS - Must NOT be zero */
#define	LM_TEST_FAIL	0x4641494c	/* 'FAIL - Must NOT be zero */

/*
 * Software reset
 */
#define	SWRESET		0x4b494c4c	/* 'KILL */
