/*
 *                  Copyright (c) 1988 Ferranti Plc.
 *                      All Rights Reserved
 *
 *
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF FERRANTI PLC THE COPYRIGHT 
 *                   OF WHICH VESTS IN FERRANTI PLC.
 *
 *   The copyright notice above does not evidence any actual or intended 
 *                   publication of such source code.
 *
 * This source code and the information contained herein is supplied without
 * liability for errors or ommissions and no part may be copied, re-produced, 
 * used or disclosed except as authorised by the Ferranti organisation by 
 *                contract or by other written permission.
 */

/******************************************************************************

	Rev = 5.1		Date of 'get'   = 11:10:55 1/26/89
				Date of 'delta' = 14:57:54 12/8/88

	File = scctermio.h

******************************************************************************/


#ident "@(#)scc-common:include/local/scc/scctermio.h Rev 5.1 14:57:54 12/8/88"


/* 
 * Offsets into control characters array
 */
#define	SIO_VINTR	0
#define	SIO_VQUIT	1
#define	SIO_VERASE	2
#define	SIO_VKILL	3
#define	SIO_VEOF	4
#define	SIO_VEOL	5
#define	SIO_VEOL2	6
#define	SIO_VMIN	4
#define	SIO_VTIME	5
#define	SIO_VSWTCH	7

#define	SIO_VSTOP	8
#define	SIO_VSTART	9
#define	SIO_VSUSP	10

/*
 * Define the NUL and DEL characters
 */
#define	SIO_CNUL	0
#define	SIO_CDEL	0377

/* 
 * Define default control chars 
 */
#define	SIO_CESC	'\\'
#define	SIO_CINTR	0177	/* DEL */
#define	SIO_CQUIT	034	/* FS, cntl | */
#define	SIO_CERASE	'#'
#define	SIO_CKILL	'@'
#define	SIO_CEOF	04	/* cntl d */
#define	SIO_CSTART	021	/* cntl q */
#define	SIO_CSTOP	023	/* cntl s */
#define	SIO_CSWTCH	032	/* cntl z */
#define	SIO_CNSWTCH	0


/*
 * INPUT modes:
 *
 * Input mode defines for dc_iflag (unsigned long)
 * Bottom 16 bits are normal UNIX defines from termio(7)
 */
#define	SIO_IGNBRK	000000000001
#define	SIO_BRKINT	000000000002
#define	SIO_IGNPAR	000000000004
#define	SIO_PARMRK	000000000010
#define	SIO_INPCK	000000000020
#define	SIO_ISTRIP	000000000040
#define	SIO_INLCR	000000000100
#define	SIO_IGNCR	000000000200
#define	SIO_ICRNL	000000000400
#define	SIO_IUCLC	000000001000
#define	SIO_IXON	000000002000
#define	SIO_IXANY	000000004000
#define	SIO_IXOFF	000000010000

/*
 * dc_iflag top 16 bits for extended functionality. Not available to
 * binary standard UNIX applications, but may be manipulated by ioctl interface
 * Bit 16 is at octal address 0200000.
 */
#define	SIO_IMAX	000000200000
#define	SIO_IMAXBELL	000000400000
#define	SIO_IECHOTBL	000001000000
#define	SIO_IMSG	000002000000


/* 
 * OUTPUT modes:
 *
 * Output mode defines for dc_oflag (unsigned long)
 * Bottom 16 bits are normal UNIX defines from termio(7)
 */
#define	SIO_OPOST	000000000001
#define	SIO_OLCUC	000000000002
#define	SIO_ONLCR	000000000004
#define	SIO_OCRNL	000000000010
#define	SIO_ONOCR	000000000020
#define	SIO_ONLRET	000000000040
#define	SIO_OFILL	000000000100
#define	SIO_OFDEL	000000000200
#define	SIO_NLDLY	000000000400
#define	SIO_NL0		0
#define	SIO_NL1		000000000400
#define	SIO_CRDLY	000000003000
#define	SIO_CR0		0
#define	SIO_CR1		000000001000
#define	SIO_CR2		000000002000
#define	SIO_CR3		000000003000
#define	SIO_TABDLY	000000014000
#define	SIO_TAB0	0
#define	SIO_TAB1	000000004000
#define	SIO_TAB2	000000010000
#define	SIO_TAB3	000000014000
#define	SIO_BSDLY	000000020000
#define	SIO_BS0		0
#define	SIO_BS1		000000020000
#define	SIO_VTDLY	000000040000
#define	SIO_VT0		0
#define	SIO_VT1		000000040000
#define	SIO_FFDLY	000000100000
#define	SIO_FF0		0
#define	SIO_FF1		000000100000

/*
 * dc_oflag top 16 bits for extended functionality. Not available to
 * binary standard UNIX applications, but may be manipulated by ioctl interface
 */
#define	SIO_OWRAP	000000200000


/* 
 * CONTROL modes:
 *
 * Control mode defines for dc_cflag (unsigned long)
 * Bottom 16 bits are normal UNIX defines from termio(7)
 */
#define	SIO_CBAUD	000000000017
#define	SIO_B0		0
#define	SIO_B50		000000000001
#define	SIO_B75		000000000002
#define	SIO_B110	000000000003
#define	SIO_B134	000000000004
#define	SIO_B150	000000000005
#define	SIO_B200	000000000006
#define	SIO_B300	000000000007
#define	SIO_B600	000000000010
#define	SIO_B1200	000000000011
#define	SIO_B1800	000000000012
#define	SIO_B2400	000000000013
#define	SIO_B4800	000000000014
#define	SIO_B9600	000000000015
#define	SIO_B19200	000000000016
#define	SIO_B38400	000000000017
#define	SIO_CSIZE	000000000060
#define	SIO_CS5		0
#define	SIO_CS6		000000000020
#define	SIO_CS7		000000000040
#define	SIO_CS8		000000000060
#define	SIO_CSTOPB	000000000100
#define	SIO_CREAD	000000000200
#define	SIO_PARENB	000000000400
#define	SIO_PARODD	000000001000
#define	SIO_HUPCL	000000002000
#define	SIO_CLOCAL	000000004000

/*
 * dc_cflag top 16 bits for extended functionality. Not available to
 * binary standard UNIX applications, but may be manipulated by ioctl interface
 */

#define	SIO_RCBAUD	000003600000
#define	SIO_RNOSPLIT	0
#define	SIO_RB50	000000200000
#define	SIO_RB75	000000400000
#define	SIO_RB110	000000600000
#define	SIO_RB134	000001000000
#define	SIO_RB150	000001200000
#define	SIO_RB200	000001400000
#define	SIO_RB300	000001600000
#define	SIO_RB600	000002000000
#define	SIO_RB1200	000002200000
#define	SIO_RB1800	000002400000
#define	SIO_RB2400	000002600000
#define	SIO_RB4800	000003000000
#define	SIO_RB9600	000003200000
#define	SIO_RB19200	000003400000
#define	SIO_RB38400	000003600000

#define	SIO_BMASK	000003600017	/* Speed mask bits */

#define	SIO_NORTSCTS	000004000000
#define	SIO_IGNNODSR	000010000000
#define	SIO_IGNNODCD	000020000000

/* line discipline 0 modes */
#define	SIO_ISIG	0000001
#define	SIO_ICANON	0000002
#define	SIO_XCASE	0000004
#define	SIO_ECHO	0000010
#define	SIO_ECHOE	0000020
#define	SIO_ECHOK	0000040
#define	SIO_ECHONL	0000100
#define	SIO_NOFLSH	0000200

#define	SIO_IFTORAW	000001000000
#define	SIO_IFTOCAN	000002000000

#define	SIO_SSPEED	7	/* default speed: 300 baud */
