/*
 *                  Copyright (c) 1988 Ferranti Plc.
 *                      All Rights Reserved
 *
 *
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF FERRANTI PLC THE COPYRIGHT 
 *                   OF WHICH VESTS IN FERRANTI PLC.
 *
 *   The copyright notice above does not evidence any actual or intended 
 *                   publication of such source code.
 *
 * This source code and the information contained herein is supplied without
 * liability for errors or ommissions and no part may be copied, re-produced, 
 * used or disclosed except as authorised by the Ferranti organisation by 
 *                contract or by other written permission.
 */

/******************************************************************************

	Rev = 5.1		Date of 'get'   = 11:10:56 1/26/89
				Date of 'delta' = 14:57:55 12/8/88

	File = status.h

******************************************************************************/

#ident "@(#)scc-common:include/local/scc/status.h Rev 5.1 14:57:55 12/8/88"

#ifndef	CHK_32
/*
 * CHK_32 : 16 bits check code for 32 bits longs. Top 16 bits should be
 *          CHK_32 and the bottom 16 bits the valid data.
 */
#define	CHK_32		0x62AE0000
#endif


#define	NOSTATUS	0x000

#define	HOST_LOAD_WAIT	0x001
#define	READ_LOAD	0x002
#define	READY_GO	0x003

/*
 * siopinit()
 */
#define	FWBOOTING	0x010		/* Firmware has loaded, executing has
					   begun. Set in siopinit()	*/
#define	HOST_MDEF	0x014		/* Used in malloc() handshake	*/
#define	HOST_MDEF_DONE	0x018
#define	HOST_FDEF	0x01c		/* Init fifo's			*/
#define	HOST_FDEF_DONE	0x020
#define	SIO_PTRS	0x024		/* All pointers ready		*/
#define	HOST_IDEF	0x028		/* Define interrupt to host 	*/
#define	SIO_STRUCT_INIT 0x02c		/* siopinit done, fifos OK etc  */

/*
 * initproc()
 */
#define	LM_TEST		0x040		/* Location monitor test	*/
#define	LM_TEST_DONE	0x042		/* Test done			*/
#define	LM_TEST_ACK	0x044		/* Test result ack by host	*/
#define	SIO_GENTASKS	0x046		/* Creating rtx tasks 	    	*/

/*
 * server()
 */
#define	SIO_READY	0x400		/* server task running, card rdy */

/*
 * Errors
 */
#define	GERROR_SET	0xFFE		/* GERROR is set, read it	*/
#define	IN_RTM		0xFFF		/* RTM				*/


/*
 * GERROR error codes
 */
#define	BAD_BUILD1	CHK_32 | 0x00000010
#define	BAD_BUILD2	CHK_32 | 0x00000020	/* Spare */
#define	BAD_BUILD3	CHK_32 | 0x00000030
#define	BAD_BUILD4	CHK_32 | 0x00000040
#define	BAD_BUILD5	CHK_32 | 0x00000050
#define	BAD_BUILD6	CHK_32 | 0x00000060
#define	BAD_CHAN_NUM	CHK_32 | 0x00000070
#define BAD_FINIT_CALL	CHK_32 | 0x00000080
#define BAD_FIFO_INIT	CHK_32 | 0x00000090
#define BAD_TERM_CALL	CHK_32 | 0x000000A0
#define BAD_LFLG_INIT	CHK_32 | 0x000000B0
#define BAD_IFC_INIT1	CHK_32 | 0x000000C0
#define BAD_IFC_INIT2	CHK_32 | 0x000000D0
#define BAD_IFC_INIT3	CHK_32 | 0x000000E0
#define BAD_IFC_INIT4	CHK_32 | 0x000000F0
#define BAD_IFC_INIT5	CHK_32 | 0x00000100
#define BAD_IFC_INIT6	CHK_32 | 0x00000110
#define BAD_IFC_INIT7	CHK_32 | 0x00000120
#define BAD_IFC_INIT8	CHK_32 | 0x00000130
#define BAD_INITINTR	CHK_32 | 0x00000140
#define BAD_INTR_TYPE	CHK_32 | 0x00000150
#define BAD_DUART_DATA	CHK_32 | 0x00000160
#define BAD_LM_FLAG	CHK_32 | 0x00000170

#define BAD_INITFMEM	CHK_32 | 0x00000180
#define BAD_INITFIFO	CHK_32 | 0x00000190

#define	BAD_FMALLOC	CHK_32 | 0x000001A0
#define	BAD_TMALLOC	CHK_32 | 0x000001B0
#define	BAD_FALIGN4	CHK_32 | 0x000001C0
#define	BAD_FNOMEM	CHK_32 | 0x000001D0
#define	BAD_FIFOSIZE	CHK_32 | 0x000001E0
#define	BAD_ASSERT1F	CHK_32 | 0x000001F0

