/*	Copyright (c) 1987 Motorola Computer Division		*/
/*	  All Rights Reserved  					*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MOTOROLA	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"@(#)netdb.h	35.1"

/*
 * $Header: netdb.h 1.4 88/03/31 17:39:06 mat rel $
 * $Locker:  $
 *
 * netdb.h -	header file for network database routines
 */

#define NDB_HOSTS	"/etc/hosts"
#define NDB_SERVICES	"/etc/services"
#define NDB_NETWORKS	"/etc/networks"
#define NDB_PROTOCOLS	"/etc/protocols"

/*
 * hosts table entry
 */
struct hostent {
	char	*h_name;	/* `official' name of host	*/
	char   **h_aliases;	/* aliases for host		*/
	int	 h_addrtype;	/* Address type: AF_INET	*/
	int	 h_length;	/* length of address		*/
	char	*h_addr;	/* ^ to address			*/
};

/*
 * networks table entry
 */
struct netent {
	char	*n_name;	/* `official' name of net	*/
	char   **n_aliases;	/* aliases for network		*/
	int	 n_addrtype;	/* address type used on this net*/
	long	 n_net;		/* network number		*/
};

/*
 * service table entry
 */
struct servent {
	char	*s_name;	/* `official' name of service	*/
	char   **s_aliases;	/* aliases for service		*/
	long	 s_port;	/* port service resides at	*/
	char	*s_proto;	/* protocol to use		*/
};

/*
 * protocol table entry
 */
struct protoent {
	char	*p_name;	/* `official' name of protocol	*/
	char   **p_aliases;	/* aliases for proctocol	*/
	long	 p_proto;	/* protocol number		*/
};

/*
 * always annoyed me that BSD didn't put these in....
 */
struct hostent *gethostbyname(), *gethostbyaddr(), *gethostent();
struct netent *getnetent(), *getnetbyname(), *getnetbyaddr();
struct protoent *getprotoent(), *getprotobyname(), getprotobynumber();
struct servent *getservent(), *getservbyname(), *getservbyport();
