# @(#)install:dev/dev.mk	35.1
# BOS/BSE Memory-Based File-System Dev Nodes Makefile
# Copyright 1988, Motorola, Inc.

MBFS_MOUNT=/mbfs
INSDIR=$(MBFS_MOUNT)/dev
TARGETS=tty00 ramd_s0

all: $(TARGETS)

install: all
	@if [ ! -d $(INSDIR) ];						\
	then								\
		echo "\tmkdir -p $(INSDIR)";				\
		if mkdir -p $(INSDIR) &&				\
		   chmod 775 $(INSDIR) &&				\
		   chgrp sys $(INSDIR) &&				\
		   chown root $(INSDIR);				\
		then							\
			: Success;					\
		else							\
			exit 1;						\
		fi;							\
	fi;								\
	for nameModesGroupOwner in					\
		"tty00 666 root sys"					\
		"ramd_s0 660 root sys";					\
	do								\
		set -- $${nameModesGroupOwner};				\
		targetName=$${1};					\
		targetModes=$${2};					\
		targetOwner=$${3};					\
		targetGroup=$${4};					\
									\
		if [ -c $${targetName} -o -b $${targetName} ];		\
		then							\
			echo "\techo $${targetName}"			\
				"| cpio -pdum $(INSDIR)";		\
			if echo $${targetName} |			\
			   cpio -pdum $(INSDIR) &&			\
		   	   chmod $${targetModes}			\
				$(INSDIR)/$${targetName} &&		\
		   	   chgrp $${targetGroup}			\
				$(INSDIR)/$${targetName} &&		\
		   	   chown $${targetOwner}			\
				$(INSDIR)/$${targetName};		\
			then						\
				: Success;				\
			else						\
				exit 1;					\
			fi;						\
		else							\
			echo "\tinstall -f $(INSDIR) -m $${targetModes}"\
				"-u $${targetOwner} -g $${targetGroup}" \
				"-s $${targetName}";			\
			install -f $(INSDIR) -m $${targetModes}		\
				-u $${targetOwner} -g $${targetGroup}	\
				-s $${targetName};			\
		fi;							\
	done

clean:

clobber: clean
	rm -f $(TARGETS)

tty00:
	mknod $@ c 0 0

ramd_s0:
	mknod $@ b 5 0
