# @(#)install:etc/etc.mk	35.3
# Memory-Based File-System Etc Files Makefile
# Copyright 1988, Motorola, Inc.

MBFS_MOUNT=/mbfs
INSDIR=$(MBFS_MOUNT)/etc
TARGETS=inittab mnttab slfsed

all: $(TARGETS)

install: all
	@if [ ! -d $(INSDIR) ];						\
	then								\
		echo "\tmkdir -p $(INSDIR)";				\
		if mkdir -p $(INSDIR) &&				\
		   chmod 775 $(INSDIR) &&				\
		   chgrp sys $(INSDIR) &&				\
		   chown root $(INSDIR);				\
		then							\
			: Success;					\
		else							\
			exit 1;						\
		fi;							\
	fi;								\
	for nameModesGroupOwner in					\
		"inittab 444 root sys"					\
		"mnttab 644 root root"					\
		"slfsed 555 root sys";					\
	do								\
		set -- $${nameModesGroupOwner};				\
		targetName=$${1};					\
		targetModes=$${2};					\
		targetOwner=$${3};					\
		targetGroup=$${4};					\
									\
		echo "\tinstall -f $(INSDIR) -m $${targetModes}" 	\
			"-u $${targetOwner} -g $${targetGroup}"		\
			"-s $${targetName}";				\
		install -f $(INSDIR) -m $${targetModes} 		\
			-u $${targetOwner} -g $${targetGroup}		\
			-s $${targetName};				\
	done

clean:
	rm -f mkinittab

clobber: clean
	rm -f $(TARGETS)

inittab: mkinittab
	1>$@ ./mkinittab

mnttab:
	1>$@

slfsed: slfsed.c
	$(CC) $(CFLAGS) slfsed.c -o slfsed

mkinittab: mkinittab.sh
	cp $? $@
	chmod +x $@
