#ident	"@(#)install:libmerge/Dialers/wrDialers.c	35.1"
/* Write Dialers Stream
 * Copyright 1988, Motorola, Inc.
 */

#include <stdio.h>
#include <Dialers.h>

/*
 * Calling sequence:
 *	dialers_p -> an open dialer stream structure pointer
 *	arps	 -> an array of argument pointers 
 *	narps	 -> number of elements in array
 * Return value:
 *	-1	 -> Error occurred
 *	>0	 -> success - number of fields written
 *
 * Conversions:
 *      \123 style strings are collapsed into a single character
 *	\000 gets mapped into \N for further processing downline.
 *      \ at end of string is removed
 *	\t gets replaced by a tab
 *	\n gets replaced by a newline
 *	\r gets replaced by a carriage return
 *	\b gets replaced by a backspace
 *	\s gets replaced by a blank 
 *	any other unknown \ sequence is left intact for further processing
 *	downline.
 */

int
writeDialers ( dialers_p, arps, narps )
DIALERS_T *dialers_p;
char *arps[];
int narps;
{
	char *arg_p;
	int i, c;

	switch ( *arps[ 0 ] ) {
	case '#':
	case ' ':
	case '\t':
	case '\n':
		fputs ( arps[ 0 ], dialers_p -> dial_fp );
		break;
	default:
		for ( i = 0; i < narps; i++ ) {

			if ( arps[ i ] == NULL )
				break;

			if ( i )
				fputc ( ' ', dialers_p -> dial_fp );

			arg_p = arps[ i ];
			while ( c = * arg_p ++ )
				switch ( c ) {
				case '\t':
					fputs ( "\\t", dialers_p -> dial_fp );
					break;
				case '\n':
					fputs ( "\\n", dialers_p -> dial_fp );
					break;
				case '\r':
					fputs ( "\\r", dialers_p -> dial_fp );
					break;
				case '\b':
					fputs ( "\\b", dialers_p -> dial_fp );
					break;
				case ' ':
					fputs ( "\\s", dialers_p -> dial_fp );
					break;
				default:
					if ( c < ' ' ) {
						fprintf( dialers_p -> dial_fp, "\\%03o", c );
						break;
					}
					fputc ( c, dialers_p -> dial_fp );
				}
		}
		fputc ( '\n', dialers_p -> dial_fp );
	}
	return ( ferror ( dialers_p -> dial_fp ) );
}
