#ident	"@(#)install:libmerge/gettydefs/gettydefs.h	35.1"
/* Gettydefs Stream Definitions
 * Copyright 1988, Motorola, Inc.
 */

#ident	"@(#)getty:getty.c	1.7.1.1"
#define GETTY_DEFS "/etc/gettydefs"

#define	MAXIDLENGTH	15	/* Maximum length the "g_id" and "g_nextid" \
				 * strings can take.  Longer ones will be \
				 * truncated. \
				 */
#define MAXMESSAGE	79	/* Maximum length the "g_message" string \
				 * can be.  Longer ones are truncated. \
				 */


#define	GETTY_MAXLINE		255
#define	GETTY_MAXARGS		64	/*   Maximum number of arguments that can be
					 *   passed to "login"
					 */

typedef struct Gdef {
	char	*g_id;			/* identification for modes & speeds */
	struct termio	g_iflags;	/* initial terminal flags */
	struct termio	g_fflags;	/* final terminal flags */
	char	*g_message;		/* login message */
	char	*g_nextid;		/* next id if this speed is wrong */
} GETTYDEFS_T;

struct GETTY_Symbols {
	char		*s_symbol;	/* Name of symbol */
	unsigned	s_value	;	/* Value of symbol */
};

/*	The following four symbols define the "SANE" state.		*/

#define	ISANE	( BRKINT | IGNPAR | ISTRIP | ICRNL | IXON )
#define	OSANE	( OPOST | ONLCR)
#ifdef m68k
#	define	CSANE	( CS8 | CREAD )
#	define	LSANE	( ISIG | ICANON | ECHO | ECHOK | ECHOE )
#else
#	define	CSANE	( CS7 | PARENB | CREAD )
#	define	LSANE	( ISIG | ICANON | ECHO | ECHOK )
#endif /* m68k */

/*   Other structures of interest
 */
typedef struct {			/* Open gettydefs stream data */
	FILE	* getty_fp;		/* file pointer */
	char	* getty_bp;		/* buffer pointer */
	char	* getty_d_id;		/* id buffer */
	char	* getty_d_message;	/* message buffer */
	char	* getty_d_nextid;	/* next id buffer */
	GETTYDEFS_T *getty_gp;		/* buffer pointer */
} GETTYDEFS_F;

typedef struct {			/* Read/Write gettydefs packet */
	int	gfo_type;		/* type of information */
	union {
		char * gu_comment;		/* comment string */
		GETTYDEFS_T * gu_entry;		/* gettydefs entry */
	}	gfo_union;		/* information pointer */
} GETTYDEFS_P;

#define gfo_comment gfo_union.gu_comment
#define gfo_entry   gfo_union.gu_entry

/*   Values of gfo_type entry above
 */
#define GFO_COMMENT 0
#define GFO_ENTRY   1

extern GETTYDEFS_F * opengettydefs ();
extern GETTYDEFS_P * readgettydefs ();
extern int closegettydefs ();
