#ident	"@(#)install:libmerge/gettydefs/wrgttydefs.c	35.1"
/* Write Gettydefs Stream
 * Copyright 1988, Motorola, Inc.
 */

#include <stdio.h>
#include <sys/types.h>
#include <termio.h>
#include <gettydefs.h>
#include <errno.h>

int
writegettydefs ( gettydefs_f, gettydefs_p )
GETTYDEFS_F * gettydefs_f;
GETTYDEFS_P * gettydefs_p;
{
	int putword (), putfields ();

	switch ( gettydefs_p -> gfo_type ) {
	case GFO_COMMENT:
		if ( fputs ( gettydefs_p -> gfo_comment, gettydefs_f -> getty_fp ) == EOF )
			return ( 1 );
		if ( fputc ( '\n', gettydefs_f -> getty_fp ) == EOF )
			return ( 1 );
		break;
	case GFO_ENTRY:
		if ( putword ( gettydefs_f, gettydefs_p -> gfo_entry -> g_id ) )
			return ( 1 );
		if ( fputs ( "# ", gettydefs_f -> getty_fp ) == EOF )
			return ( 1 );
		if ( putfields ( gettydefs_f, & gettydefs_p -> gfo_entry -> g_iflags ) )
			return ( 1 );
		if ( fputs ( "# ", gettydefs_f -> getty_fp ) == EOF )
			return ( 1 );
		if ( putfields ( gettydefs_f, & gettydefs_p -> gfo_entry -> g_fflags ) )
			return ( 1 );
		if ( fputc ( '#', gettydefs_f -> getty_fp ) == EOF )
			return ( 1 );
		if ( putword ( gettydefs_f, gettydefs_p -> gfo_entry -> g_message ) )
			return ( 1 );
		if ( fputc ( '#', gettydefs_f -> getty_fp ) == EOF )
			return ( 1 );
		if ( putword ( gettydefs_f, gettydefs_p -> gfo_entry -> g_nextid ) )
			return ( 1 );
		if ( fputs ( "\n\n", gettydefs_f -> getty_fp ) == EOF )
			return ( 1 );
	}
	return ( 0 );
}

static int
putword ( gettydefs_f, word )
GETTYDEFS_F * gettydefs_f;
char * word;
{
	int c;

	while ( c = * word ++ ) {
		switch ( c ) {
		case '\n':
			fputs ( "\\n", gettydefs_f -> getty_fp );
			break;
		case '\r':
			fputs ( "\\r", gettydefs_f -> getty_fp );
			break;
		case '\013':
			fputs ( "\\v", gettydefs_f -> getty_fp );
			break;
		case '\b':
			fputs ( "\\b", gettydefs_f -> getty_fp );
			break;
		case '\t':
			fputs ( "\\t", gettydefs_f -> getty_fp );
			break;
		case '\f':
			fputs ( "\\f", gettydefs_f -> getty_fp );
			break;
		default:
			if ( ( c < ' ' ) || ( c > '~' ) )
				fprintf ( gettydefs_f -> getty_fp, "\\%03o", c );
			else
				fputc ( c, gettydefs_f -> getty_fp );
		}
		if ( c = ferror ( gettydefs_f -> getty_fp ) )
			return ( c );
	}
	return ( 0 );
}

static int
putfields ( gettydefs_f, termio_p )
GETTYDEFS_F * gettydefs_f;
struct termio * termio_p;
{
	extern struct GETTY_Symbols baud_rates[], imodes[], tab_modes[], cmodes[], omodes[], lmodes[];
	int outmodes ();
	int iflag, cflag, lflag, oflag;

	if ( outmodes ( gettydefs_f, termio_p -> c_cflag, baud_rates ) )
		return ( 1 );

	iflag = termio_p -> c_iflag;
	oflag = termio_p -> c_oflag;
	cflag = termio_p -> c_cflag;
	lflag = termio_p -> c_lflag;

	if ( ( ( iflag & ISANE ) == ISANE ) && ( ( oflag & OSANE ) == OSANE ) &&
	     ( ( cflag & CSANE ) == CSANE ) && ( ( lflag & LSANE ) == LSANE ) ) {
		if ( fputs ( "SANE ", gettydefs_f -> getty_fp ) == EOF )
			return ( 1 );
		iflag &= ~ISANE;
		oflag &= ~OSANE;
		cflag &= ~CSANE;
		lflag &= ~LSANE;
	}
	if ( outmodes ( gettydefs_f, iflag, imodes ) )
		return ( 1 );
	if ( outmodes ( gettydefs_f, oflag, tab_modes ) )
		return ( 1 );
	if ( outmodes ( gettydefs_f, cflag, cmodes ) )
		return ( 1 );
	if ( outmodes ( gettydefs_f, oflag, omodes ) )
		return ( 1 );
	if ( outmodes ( gettydefs_f, lflag, lmodes ) )
		return ( 1 );
	return ( 0 );
}

static int
outmodes ( gettydefs_f, flag, symbols )
GETTYDEFS_F * gettydefs_f;
int flag;
struct GETTY_Symbols * symbols;
{
	while ( symbols -> s_symbol != NULL ) {
		if ( ( symbols -> s_value & flag ) == symbols -> s_value ) {
			fprintf ( gettydefs_f -> getty_fp, "%s ", symbols -> s_symbol );
			flag &= ~ symbols -> s_value;
			if ( ferror ( gettydefs_f -> getty_fp ) )
				return ( 1 );
		}
		symbols ++;
	}
	return ( 0 );
}

static struct GETTY_Symbols imodes[] = {
	"IGNBRK",	IGNBRK,
	"BRKINT",	BRKINT,
	"IGNPAR",	IGNPAR,
	"PARMRK",	PARMRK,
	"INPCK",	INPCK,
	"ISTRIP",	ISTRIP,
	"INLCR",	INLCR,
	"IGNCR",	IGNCR,
	"ICRNL",	ICRNL,
	"IUCLC",	IUCLC,
	"IXON",		IXON,
	"IXANY",	IXANY,
	"IXOFF",	IXOFF,
	NULL,	0
};

static struct GETTY_Symbols tab_modes[] = {
	"TAB3",		TAB3,
	"TAB2",		TAB2,
	"TAB1",		TAB1,
	NULL,		0
};

static struct GETTY_Symbols omodes[] = {
	"FF1",		FF1,
	"VT1",		VT1,
	"BS1",		BS1,
	"CR3",		CR3,
	"CR2",		CR2,
	"CR1",		CR1,
	"CRDLY",	CRDLY,
	"NL1",		NL1,
	"OFDEL",	OFDEL,
	"OFILL",	OFILL,
	"ONLRET",	ONLRET,
	"ONOCR",	ONOCR,
	"OCRNL",	OCRNL,
	"OPOST",	OPOST,
	"ONLCR",	ONLCR,
	"OLCUC",	OLCUC,
	NULL,		0
};

static struct GETTY_Symbols baud_rates[] = {
				/* the following aliases should be deleted  */
				/* when cleaned out of the source */
					/**/
#ifdef m68k
	"B38400",	B38400,
	"B19200",	B19200,
#else
	"EXTB",		EXTB,		/* same as B38400 */
	"EXTA",		EXTA,		/* same as B19200 */
#endif
	"B9600",	B9600,
	"B4800",	B4800,
	"B2400",	B2400,
	"B1800",	B1800,
	"B1200",	B1200,
	"B600",		B600,
	"B300",		B300,
	"B200",		B200,
	"B150",		B150,
	"B134",		B134,
	"B110",		B110,
	"B75", 		B75,
	"B50",		B50,
	NULL,		0
};

static struct GETTY_Symbols cmodes[] = {
	"CS8",		CS8,
	"CS7",		CS7,
	"CS6",		CS6,
	"CSTOPB",	CSTOPB,
	"CREAD",	CREAD,
	"PARENB",	PARENB,
	"PARODD",	PARODD,
	"HUPCL",	HUPCL,
	"CLOCAL",	CLOCAL,
	NULL,		0
};

static struct GETTY_Symbols lmodes[] = {
	"ISIG",		ISIG,
	"ICANON",	ICANON,
	"XCASE",	XCASE,
	"ECHO",		ECHO,
	"ECHOE",	ECHOE,
	"ECHOK",	ECHOK,
	"ECHONL",	ECHONL,
	"NOFLSH",	NOFLSH,
	NULL,		0
};

/*	Terminal types set with the LDSETT ioctl command.		*/

static struct GETTY_Symbols terminals[] = {
	"none",		TERM_NONE,
#ifdef	TERM_V10
	"vt100",	TERM_V10,
#endif
#ifdef	TERM_H45
	"hp45",		TERM_H45,
#endif
#ifdef	TERM_C10
	"c100",		TERM_C100,
#endif
#ifdef	TERM_TEX
	"tektronix",	TERM_TEX,
	"tek",		TERM_TEX,
#endif
#ifdef	TERM_D40
	"ds40-1",	TERM_D40,
#endif
#ifdef	TERM_V61
	"vt61",		TERM_V61,
#endif
#ifdef	TERM_TEC
	"tec",		TERM_TEC,
#endif
	NULL,		0
};

/*	Line disciplines set by the TIOCSETD ioctl command.		*/

#ifndef	LDISC0
#define	LDISC0	0
#endif

static struct GETTY_Symbols linedisc[] = {
	"LDISC0",		LDISC0,
	NULL,		0
};

