#ident	"@(#)install:libmerge/inittab/inittab.h	35.1"
/* Inittab Stream Definitions
 * Copyright 1988, Motorola, Inc.
 */

#ident	"@(#)init:init.c	1.20"

/*	MAXCMDL		The maximum length of a command string in	*/
/*			/etc/inittab.					*/

#define	INITTAB_MAXCMDL	512

typedef struct {
	char c_id[4];	/* Four letter unique id of process to be
			 * affected by action.
				 */
	short c_levels;	/* Mask of legal levels for process */
	short c_action;	/* Mask for type of action required */
	char *c_command;	/* Pointer to init command */
} INITTAB_T;

/*	Bit Mask for each level.  Used to determine legal levels.	*/

#define	MASK0	01
#define	MASK1	02
#define	MASK2	04
#define	MASK3	010
#define	MASK4	020
#define	MASK5	040
#define	MASK6	0100
#define	MASKSU	0200
#define	MASKa	0400
#define	MASKb	01000
#define	MASKc	02000

/*   action codes
 */
#define	M_OFF		0001
#define	M_RESPAWN	0002
#define	M_ONDEMAND	M_RESPAWN
#define	M_ONCE		0004
#define	M_WAIT		0010
#define	M_BOOT		0020
#define	M_BOOTWAIT	0040
#define	M_PF		0100
#define	M_PWAIT		0200
#define	M_INITDEFAULT	0400
#define M_SYSINIT	01000

/*   Open inittab file data structure
 */
typedef struct {
	FILE	* init_fp;
	char	* init_shcmd;
	INITTAB_T * init_cmd;
} INITTAB_F;

extern INITTAB_F * openinittab ();
extern INITTAB_T * readinittab ();
extern int writeinittab (), closeinittab ();
