#ident	"@(#)install:libmerge/inittab/wrinittab.c	35.1"
/* Write Inittab Stream
 * Copyright 1988, Motorola, Inc.
 */

#include <stdio.h>
#include <inittab.h>

static struct action_words {
	short	act_mask;
	char	* act_word;
} actions[] = {
	{ M_OFF, "off" },
	{ M_RESPAWN, "respawn" },
	{ M_ONDEMAND, "ondemand" },
	{ M_ONCE, "once" },
	{ M_WAIT, "wait" },
	{ M_BOOT, "boot" },
	{ M_BOOTWAIT, "bootwait" },
	{ M_PF, "powerfail" },
	{ M_PWAIT, "powerwait" },
	{ M_INITDEFAULT, "initdefault" },
	{ M_SYSINIT, "sysinit" }
};

static struct level_chars {
	short	lev_mask;
	char	lev_char;
} levels[] = {
	{ MASKSU, 's' },
	{ MASK0,  '0' },
	{ MASK1,  '1' },
	{ MASK2,  '2' },
	{ MASK3,  '3' },
	{ MASK4,  '4' },
	{ MASK5,  '5' },
	{ MASK6,  '6' },
	{ MASKa,  'a' },
	{ MASKb,  'b' },
	{ MASKc,  'c' }
};

int
writeinittab ( inittab_f, inittab_t )
INITTAB_F * inittab_f;
INITTAB_T * inittab_t;
{
	char * ptr;
	int i;

	ptr = inittab_t -> c_id;
	while ( ( * ptr ) && ( ptr < & inittab_t -> c_id [ 4 ] ) )
		if ( fputc ( * ptr ++,  inittab_f -> init_fp ) == EOF )
			return ( -1 );
	if ( fputc ( ':', inittab_f -> init_fp ) == EOF )
		return ( -1 );
	for ( i = 0; i < ( sizeof ( levels ) / sizeof ( struct level_chars ) ); i ++ )
		if ( ( levels [ i ] . lev_mask & inittab_t -> c_levels )
		   && ( fputc ( levels [ i ] . lev_char, inittab_f -> init_fp ) == EOF ) )
			return ( -1 );
	if ( fputc ( ':', inittab_f -> init_fp ) == EOF )
		return ( -1 );
	for ( i = 0; i < ( sizeof ( actions ) / sizeof ( struct action_words ) ); i ++ )
		if ( actions [ i ] . act_mask & inittab_t -> c_action ) {
			if ( fputs ( actions [ i ] . act_word, inittab_f -> init_fp ) == EOF )
				return ( -1 );
			break;	/* only one action */
		}
	if ( fputc ( ':', inittab_f -> init_fp ) == EOF )
		return ( -1 );
	if ( fputs ( inittab_t -> c_command, inittab_f -> init_fp ) == EOF )
		return ( -1 );
	if ( fputc ( '\n', inittab_f -> init_fp ) == EOF )
		return ( -1 );
	return ( 0 );
}
