#ident	"@(#)install:libmerge/passwd/rdpasswd.c	35.1"
/* Read Passwd Stream
 * Copyright 1988, Motorola, Inc.
 */

#include <stdio.h>
#include <pwd.h>
#include <passwd.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>

PASSWD_T *
readpasswd ( passwd_f )
PASSWD_F *passwd_f;
{
	char *ptr, *qtr, ** member_p;
	extern long strtol ();

	ptr = fgets ( passwd_f -> passwd_bp, PASSWDLINE, passwd_f -> passwd_fp );
	if ( ptr == NULL )
		return ( NULL );

	passwd_f -> passwd_tp -> pw_name = ptr;
	ptr = strchr ( ptr, ':' );
	if ( ptr == NULL ) {
		errno = EINVAL;
		return ( NULL );
	}
	* ptr ++ = '\0';

	passwd_f -> passwd_tp -> pw_passwd = ptr;
	ptr = strchr ( ptr, ':' );
	if ( ptr == NULL ) {
		errno = EINVAL;
		return ( NULL );
	}
	* ptr ++ = '\0';

	passwd_f -> passwd_tp -> pw_uid = ( int ) strtol ( ptr, & qtr, 10 );
	if ( ( ptr == qtr ) || ( * qtr != ':' ) ) {
		errno = EINVAL;
		return ( NULL );
	}
	ptr = qtr + 1;

	passwd_f -> passwd_tp -> pw_gid = ( int ) strtol ( ptr, & qtr, 10 );
	if ( ( ptr == qtr ) || ( * qtr != ':' ) ) {
		errno = EINVAL;
		return ( NULL );
	}
	ptr = qtr + 1;

	passwd_f -> passwd_tp -> pw_age = qtr;
	* qtr = '\0';

	passwd_f -> passwd_tp -> pw_comment = ptr;
	ptr = strchr ( ptr, ':' );
	if ( ptr == NULL ) {
		errno = EINVAL;
		return ( NULL );
	}
	* ptr = '\0';
	passwd_f -> passwd_tp -> pw_gecos = ptr ++;

	passwd_f -> passwd_tp -> pw_dir = ptr;
	ptr = strchr ( ptr, ':' );
	if ( ptr == NULL ) {
		errno = EINVAL;
		return ( NULL );
	}
	* ptr ++ = '\0';

	passwd_f -> passwd_tp -> pw_shell = ptr;
	ptr = strchr ( ptr, '\n' );
	if ( ptr == NULL ) {
		errno = EINVAL;
		return ( NULL );
	}
	* ptr = '\0';

	return ( passwd_f -> passwd_tp );
}
