# @(#)install:sadmin/admin/admin.mk	35.1
# BOS/BSE Memory-Based File-System System Administration Utility Makefile
# Copyright 1988, Motorola, Inc.

MBFS_MOUNT=/mbfs
INSDIR=$(MBFS_MOUNT)/usr/bin
TARGETS=sysadm

all: $(TARGETS)

install: all
	@if [ ! -d $(INSDIR) ];						\
	then								\
		echo "\tmkdir -p $(INSDIR)";				\
		if mkdir -p $(INSDIR) &&				\
		   chmod 755 $(INSDIR) &&				\
		   chgrp bin $(INSDIR) &&				\
		   chown bin $(INSDIR);					\
		then							\
			: Success;					\
		else							\
			exit 1;						\
		fi;							\
	fi;								\
	for nameModesGroupOwner in					\
		"sysadm 555 bin bin";					\
	do								\
		set -- $${nameModesGroupOwner};				\
		targetName=$${1};					\
		targetModes=$${2};					\
		targetOwner=$${3};					\
		targetGroup=$${4};					\
									\
		echo "\tinstall -f $(INSDIR) -m $${targetModes}" 	\
			"-u $${targetOwner} -g $${targetGroup}"		\
			"-s $${targetName}";				\
		install -f $(INSDIR) -m $${targetModes} 		\
			-u $${targetOwner} -g $${targetGroup}		\
			-s $${targetName};				\
	done

clean:
	rm -f mksysadm

clobber: clean
	rm -f $(TARGETS)

sysadm: mksysadm
	1>$@ ./mksysadm

mksysadm: mksysadm.sh
	cp $? $@
	chmod +x $@
