# @(#)install:sadmin/menu/menu.mk	35.1
# BOS/BSE Memory-Based File-System Install/Upgrade Software Scripts Makefile
# Copyright 1988, Motorola, Inc.

ProductName=
DEBUG=

MBFS_MOUNT=/mbfs
INSDIR=$(MBFS_MOUNT)/usr/admin/menu
TARGETS=installer upgrade 
TOOLS=../tools

all: $(TARGETS)

install: all
	@if [ ! -d $(INSDIR) ];						\
	then								\
		echo "\tmkdir -p $(INSDIR)";				\
		if mkdir -p $(INSDIR);					\
		then							\
			: Success;					\
		else							\
			exit 1;						\
		fi;							\
	fi;								\
	for target in $(TARGETS);					\
	do								\
		case $${target} in					\
		installer )						\
			echo "\tinstall -f $(INSDIR) -m 555"		\
				"-u root -g sys -s install";		\
			if ln installer install &&			\
			   install -f $(INSDIR) -m 555			\
				-u root -g sys -s install &&		\
			   rm install;					\
			then						\
				: Success;				\
			else						\
				exit 1;					\
			fi;						\
			;;						\
		* )							\
			echo "\tinstall -f $(INSDIR) -m 555"		\
				"-u root -g sys -s $${target}";		\
			if install -f $(INSDIR) -m 555			\
				-u root -g sys -s $${target};		\
			then						\
				: Success;				\
			else						\
				exit 1;					\
			fi;						\
			;;						\
		esac;							\
	done

clean:
	rm -f mkinstall mkupgrade

clobber: clean
	rm -f $(TARGETS)

installer: mkinstall
	PATH=$${PATH}:$(TOOLS) 1>$@ ./mkinstall
	chmod +x $@

upgrade: mkupgrade
	PATH=$${PATH}:$(TOOLS) 1>$@ ./mkupgrade
	chmod +x $@

mkinstall: mkinstall.sh
	cp $? $@
	chmod +x $@

mkupgrade: mkupgrade.sh
	cp $? $@
	chmod +x $@
