# @(#)install:sadmin/menu/mkinstall.sh	35.43
# SVC/BSE Memory-Based File-System Install Software Script Generator
# Copyright 1988, Motorola, Inc.

if [ X"${ProductName}" = X"" ]
then
	0<<!!! 1>&2 cat -
${0}: \${ProductName} environment variable is not set; cannot proceed.
!!!
	exit 1
fi

if [ X"${DEBUG}" = X"true" ]
then
	CHMOD=:
	CP=:
	DINIT=:
	FSCK=:
	FSSTAT=:
	IXF=:
	LABELIT=:
	LN=:
	MKDIR=:
	MKFS=:
	MKLOSTFOUND=:
	MOUNT=:
	SLFSED=:
	RM=:
	SLEEP=:
	TAPECTL=:
	UMOUNTALL=:
else
	CHMOD=chmod
	CP=cp
	DINIT="1>/dev/null dinit"
	FSCK=fsck
	FSSTAT="1>/dev/null 2>&1 fsstat"
	IXF=ixf
	LABELIT="1>/dev/null labelit"
	LN=ln
	MKDIR=mkdir
	MKFS="1>/dev/null mkfs"
	MKLOSTFOUND=mklost+found
	MOUNT=mount
	SLFSED=slfsed
	RM=rm
	SLEEP=sleep
	TAPECTL=m350ctl
	UMOUNTALL=umountall
fi

ControllerTypeFiles=`diskctlrs ControllersList`

if [ X"${ControllerTypeFiles}" = X"" ]
then	
	0<<!!! 1>&2 cat -
${0}: No controller files found.
!!!
	exit 1
fi

0<<!!! cat -
# @(#)install as generated by install:sadmin/menu/mkinstall.sh	35.43
# Install ${ProductName} Software Script
# Copyright 1988, Motorola, Inc.

BosReleaseName=\${BosReleaseName:-R3}
DdefsDirectory=\${DdefsDirectory:-etc/dskdefs}
BadSpotsDirectory=\${BadSpotsDirectory:-etc/badtracks}
OptionsDirectory=\${OptionsDirectory:-usr/options}
TMPDIR=\${TMPDIR:-/tmp}

ddefsOutput=\${TMPDIR}/${ProductName}1.\${$}
rootSlfsedOutput=\${TMPDIR}/${ProductName}2.\${$}
usrSlfsedOutput=\${TMPDIR}/${ProductName}3.\${$}

trap "
	rm -f \${ddefsOutput} \${rootSlfsedOutput} \${usrSlfsedOutput}
	exit 1
" 0 1 2 3 15


stripQuestionMark ()
{
	expr "\${1}" : '\\([^?]*\\)?*'
}

isNumeric ()
{
	numericTitle=\${1}
	numericValue=\${2}

	if 1>/dev/null 2>&1 expr "\${2}" + 1
	then
		return 0
	else
		0<<DONE 1>&2 cat -

	\${numericTitle} is not a numeric entry; please try again.

DONE
		return 1
	fi
}

checkNumericEntry ()
{
	numericTitle=\${1}
	numericEntry=\${2}
	minimumValue=\${3}
	maximumValue=\${4}

	if isNumeric "\${numericTitle}" "\${numericEntry}"
	then
		: Success
	else
		return 1
	fi

	if [ \${numericEntry} -lt \${minimumValue} ] ||
	   [ \${numericEntry} -gt \${maximumValue} ]
	then
		0<<DONE 1>&2 cat -

	\${numericTitle} is out-of-range; please try again.

DONE
		return 1
	fi
	return 0
}

checkIndex ()
{
	indexValue=\${1}
	indexMaximumValue=\${2}

	checkNumericEntry "Index" "\${indexValue}" 1 "\${indexMaximumValue}"
}


0<<DONE cat -


${ProductName} INSTALLATION PROCEDURE



Phase 1.  Identify Root And Usr File Systems Installation Disk Drive(s)

DONE


# Determine root file system's disk controller type

while :
do
	0<<DONE cat -

The ${ProductName} product supports root and usr file system installations
on the disk controllers listed below.  The first column is the controller's
selection number, the second column is the name of the controller, and,
the third column is a brief description of the controller.  Identify
at the prompt the root file system's installation disk controller type.

!!!

controllerCount=1

echo "${ControllerTypeFiles}" |
while read controllerTypeFile
do
	controllerType=`diskctlrs TypeFor: ${controllerTypeFile}`

	nameLength=`echo "${controllerType}\c" | wc -c`
	spaceCount=`expr 10 - ${nameLength}`

	if [ ${spaceCount} -lt 1 ]
	then
		spaceCount=1
	fi

	0<<!!! cat -
  ${controllerCount}  ${controllerType}\
`expr "                " : "\( \{${spaceCount}\}\).*"`\
`diskctlrs TitleFor: ${controllerTypeFile}`
!!!
	controllerCount=`expr ${controllerCount} + 1`
done

typeCount=`echo "${ControllerTypeFiles}" | wc -l`

ControllerTypes=`
	echo "${ControllerTypeFiles}" |
	while read controllerTypeFile
	do
		diskctlrs TypeFor: ${controllerTypeFile}
	done`

0<<!!! cat -

DONE
	echo "\\
---> Enter a number, a name, the initial part of a name, or
     ? or <number>? for HELP, or q to QUIT [\${DefaultControllerType}]: \c"

	read userControllerType

	case \${userControllerType} in
	"" )
		userControllerType=\${DefaultControllerType}
		0<<DONE cat -

Selected default controller name, '\${userControllerType}'.

DONE
		break
		;;
	[0-9]*\\? )
		userControllerType=\`stripQuestionMark \${userControllerType}\`

		if checkIndex \${userControllerType} ${typeCount}
		then
			: Success
		else
			continue
		fi

		case \${userControllerType} in
!!!

controllerCount=1
echo "${ControllerTypeFiles}" |
while read controllerTypeFile
do
	0<<!!! cat -
		${controllerCount} )
			0<<DONE cat -

!!!
	diskctlrs DescriptionFor: ${controllerTypeFile}

	0<<!!! cat -

DONE
			;;
!!!
	controllerCount=`expr ${controllerCount} + 1`
done

0<<!!! cat -
		esac
		;;
	[0-9]* )
		if checkIndex \${userControllerType} ${typeCount}
		then
			: Success
		else
			continue
		fi

		userControllerType=\`
			0<<DONE cat - |
${ControllerTypes}
DONE
			sed -n -e "\${userControllerType}p"\`

		0<<DONE cat -

Selected the '\${userControllerType}' controller type.

DONE
		break
		;;
!!!

possibleEntries=`
	echo "${ControllerTypes}" |
	while read controllerType
	do
		letterCount=1
		maxLetterCount=\`echo "${controllerType}\c" | wc -c\`

		while [ ${letterCount} -lt ${maxLetterCount} ]
		do
			abbreviatedName=\`
	expr ${controllerType} : "\(.\{${letterCount}\}\).*"\`

			matchCount=\`
				echo "${ControllerTypes}" |
				grep "^${abbreviatedName}" |
				wc -l\`

			if [ ${matchCount} -eq 1 ]
			then
				echo ${abbreviatedName}
			fi

			letterCount=\`expr ${letterCount} + 1\`
		done

		echo ${controllerType}
	done`

0<<!!! ed -
a
${possibleEntries}
.
1;\$s/^/	/
1;\$s/\$/ | \\\\/
\$s/ | \\\\\$/ )/
1;\$p
q
!!!

0<<!!! cat -
		break
		;;
	\\? )
		0<<DONE cat -

Enter the number (first column) or name (second column) of
the root file system's disk controller.

A number followed by a '?' may be entered to obtain a more
detailed description of the controller's features and supported
disk drives.

A question mark (?) may be entered to obtain this description.
A 'q' may be entered to cause the installation procedure
to be aborted and execution to resume at the main menu.

DONE
		;;
	q\\? )
		0<<DONE cat -

Enter a 'q' to abort the installation procedure and
continue execution at the main menu.

DONE
		;;
	q )
		exit 1
		;;
	* )
		0<<DONE 1>&2 cat -

	Invalid response; please try again.

DONE
		;;
	esac
done

case \${userControllerType} in
!!!

echo "${ControllerTypeFiles}" |
while read controllerTypeFile
do
	controllerType=`diskctlrs TypeFor: ${controllerTypeFile}`

	possibleEntries=`
		letterCount=1
		maxLetterCount=\`echo "${controllerType}\c" | wc -c\`

		while [ ${letterCount} -lt ${maxLetterCount} ]
		do
			abbreviatedName=\`
	expr ${controllerType} : "\(.\{${letterCount}\}\).*"\`

			matchCount=\`
				echo "${ControllerTypes}" |
				grep "^${abbreviatedName}" |
				wc -l\`

			if [ ${matchCount} -eq 1 ]
			then
				echo ${abbreviatedName}
			fi

			letterCount=\`expr ${letterCount} + 1\`
		done

		echo ${controllerType}`

	0<<!!! ed -
a
${possibleEntries}
.
1;\$s/\$/ | \\\\/
\$s/ | \\\\\$/ )/
1;\$p
q
!!!
	controllerNumbers=`diskctlrs NumbersFor: ${controllerTypeFile}`

	0<<!!! cat -
	RootDevice=m`diskctlrs DesignationFor: ${controllerTypeFile}`_
	RootControllerType=${controllerType}
	RootControllerTitle="`diskctlrs TitleFor: ${controllerTypeFile}`"
	controllerNumbers="${controllerNumbers}"
!!!

	echo "${controllerNumbers}" |
	while read controllerNumber
	do
		driveNumbers=`diskctlrs \
DriveNumbersFor: ${controllerTypeFile} ControllerNumber: ${controllerNumber}`

		0<<!!! cat -
	driveNumbers_${controllerNumber}="${driveNumbers}"
!!!
		echo "${driveNumbers}" |
		while read driveNumber
		do
			0<<!!! cat -
	diskTypes_${controllerNumber}_${driveNumber}="`
diskctlrs DiskTypesFor: ${controllerTypeFile} \
	ControllerNumber: ${controllerNumber} DriveNumber: ${driveNumber}`"
!!!
		done
	done

	0<<!!! cat -
	;;
!!!
done

0<<!!! cat -
esac

if [ X\${RootControllerType} != X\${userControllerType} ]
then
	0<<DONE cat -

Selected the '\${RootControllerType}' controller type.

DONE
fi

unset userControllerType


# Determine root file system's disk controller number

set -- \${controllerNumbers}
case \${#} in
0 )
	0<<DONE 1>&2 cat -

ERROR:	No controller number information for \\
the \${RootControllerType} controller.

DONE
	exit 1
	;;
1 )
	RootControllerNumber=\${1}
	0<<DONE cat -

Selected \${RootControllerType} controller number \${RootControllerNumber}.
This is the only controller number for the \${RootControllerType} controller
supported by the ${ProductName} product.

DONE
	;;
* )
	defaultControllerNumber=\${1}
	controllerChoices=\`echo \${controllerNumbers} | sed -e 's/ /, /g'\`

	while :
	do
		echo "\\
---> Enter the root file system's controller number \\
(\${controllerChoices}, ?, q) [\${defaultControllerNumber}]: \c"

		read userControllerNumber

		case \${userControllerNumber} in
		"" )
			RootControllerNumber=\${defaultControllerNumber}
			0<<DONE cat 

Selected default controller number, '\${RootControllerNumber}'.

DONE
			break
			;;
		\\? )
			0<<DONE cat -

One or more \${RootControllerType} controllers may be present
in a given system.  Enter the controller number associated
with the root file system's disk drive.

DONE
			;;
		q\\? )
			0<<DONE cat -

Enter 'q' to abort the installation procedure and
resume execution at the main menu.

DONE
			;;
		q )
			exit 1
			;;
		* )
			RootControllerNumber=\`
				0<<DONE grep "^\${userControllerNumber}$"
\${controllerNumbers}
DONE\`
			if [ X"\${userControllerNumber}" = \\
				X"\${RootControllerNumber}" ]
			then
				break
			fi

			0<<DONE 1>&2 cat -

	Invalid \${RootControllerType} controller number; please try again.

DONE
			;;
		esac
	done
	;;
esac

unset userControllerNumber controllerChoices defaultControllerNumber

0<<DONE grep -v "^\${RootControllerNumber}$" |
\${controllerNumbers}
DONE
while read controllerNumber
do
	eval driveNumbers=\\\${driveNumbers_\${controllerNumber}}

	for driveNumber in \${driveNumbers}
	do
		eval unset diskTypes_\${controllerNumber}_\${driveNumber}
	done

	eval unset driveNumbers_\${controllerNumber}
done

unset controllerNumbers


case \${RootControllerNumber} in
[1-9] )
	RootDevice=\${RootDevice}\${RootControllerNumber}d
	;;
esac


eval driveNumbers=\\\${driveNumbers_\${RootControllerNumber}}
eval unset driveNumbers_\${RootControllerNumber}


# Determine root file system's disk drive number

set -- \${driveNumbers}

case \${#} in
0 )
	0<<DONE 1>&2 cat -

ERROR:	No drive number information for the \${RootControllerType} controller,
	controller number \${RootControllerNumber}.

DONE
	exit 1
	;;
1 )
	RootDriveNumber=\${1}
	0<<DONE cat -

Selected drive number \${RootDriveNumber}.
This is the only drive number supported by
the \${RootControllerType} controller on the ${ProductName} product.

DONE
	;;
* )
	defaultDriveNumber=\${1}
	driveChoices=\`echo \${driveNumbers} | sed -e 's/ /, /g'\`

	while :
	do
		echo "\\
---> Enter the root file system's disk drive number
     (\${driveChoices}, ?, q) [\${defaultDriveNumber}]: \\c"

		read userDriveNumber

		case \${userDriveNumber} in
		"" )
			RootDriveNumber=\${defaultDriveNumber}
			0<<DONE cat -

Selected default disk drive number, '\${RootDriveNumber}'.

DONE
			break
			;;
		\\? )
			0<<DONE cat -

Enter the drive number (e.g., 0, 1, 2, ...) associated with the
root file system's disk drive.  Selectable drive numbers for the
\${RootControllerType} controller are displayed in the parentheses
in the prompt.

You may abort the installation procedure and resume execution at the
main menu by entering a 'q' to the prompt below.

DONE
			;;
		q\\? )
			0<<DONE cat -

Enter 'q' to abort the installation procedure and resume execution at
the main menu.

DONE
			;;
		q )
			exit 1
			;;
		* )
			RootDriveNumber=\`0<<DONE grep "^\${userDriveNumber}$"
\${driveNumbers}
DONE\`
			if [ X"\${userDriveNumber}" = X"\${RootDriveNumber}" ]
			then
				break
			fi

			0<<DONE 1>&2 cat -

	Invalid \${RootControllerType} drive number; please try again.

DONE
			;;
		esac
	done
	;;
esac


unset userDriveNumber driveChoices defaultDriveNumber

0<<DONE grep -v "^\${RootDriveNumber}" |
\${driveNumbers}
DONE
while read driveNumber
do
	eval unset diskTypes_\${RootControllerNumber}_\${driveNumber}
done

unset driveNumbers


RootDevice=\${RootDevice}\${RootDriveNumber}


eval diskTypes=\\\${diskTypes_\${RootControllerNumber}_\${RootDriveNumber}}
eval unset diskTypes_\${RootControllerNumber}_\${RootDriveNumber}


# Determine if root file system's disk device nodes are present

missingNodes=
for sliceNumber in 0 1 2 3 4 5 6 7
do
	if [ ! -c /dev/rdsk/\${RootDevice}s\${sliceNumber} ]
	then
		missingNodes="\${missingNodes}
/dev/rdsk/\${RootDevice}s\${sliceNumber}"
	fi

	if [ ! -b /dev/dsk/\${RootDevice}s\${sliceNumber} ]
	then
		missingNodes="\${missingNodes}
/dev/dsk/\${RootDevice}s\${sliceNumber}"
	fi
done

if [ X"\${missingNodes}" != X"" ]
then
	0<<DONE 1>&2 cat -

ERROR:	The following device nodes are not found:
\${missingNodes}

ERROR:	The ${ProductName} installation procedure cannot proceed and
	is being aborted.

DONE
	exit 1
else
	unset sliceNumber missingNodes
fi


# Determine root file system's disk type

set -- \${diskTypes}

case \${#} in
0 )
	0<<DONE 1>&2 cat -

ERROR:	No disk type information for the \${RootControllerType} controller,
	controller number \${RootControllerNumber}, \
drive Number\${RootDriveNumber}.

DONE
	exit 1
	;;
1 )
	userDiskType=\${1}
	0<<DONE cat -

The root file system's disk drive must be of the '\${userDiskType}' disk type.
This is the only disk type supported by the ${ProductName} product
for the \${RootControllerType} controller on drive number \${RootDriveNumber}.

DONE
	;;
* )
	typeCount=\${#}
	defaultDiskType=\${1}

	while :
	do
		0<<DONE cat -

\${RootControllerTitle} may be used to install
the ${ProductName} product on the following disk drive types.
The first column is the selection number, the second is the disk type
name (see the disk types associated with the ddefs(1M) utility), and 
the third briefly describes the specific disk drive type:

DONE
		diskTypeCount=1

		echo "\${diskTypes}" |
		while read diskType
		do
			case \${diskType} in
!!!

DiskTypeFiles=`disktypes DiskTypesList`

if [ X"${DiskTypeFiles}" = X"" ]
then
	0<<!!! 1>&2 cat -
${0}: No disk type files found.
!!!
	exit 1
fi

echo "${DiskTypeFiles}" |
while read diskTypeFile
do
	diskType=`disktypes TypeFor: ${diskTypeFile}`

	nameLength=`echo "${diskType}\c" | wc -c`
	spaceCount=`expr 16 - ${nameLength}`

	if [ ${spaceCount} -lt 1 ]
	then
		spaceCount=1
	fi


	0<<!!! cat -
			${diskType} )
				diskTitle="\\
${diskType}\
`expr "                " : "\( \{${spaceCount}\}\).*"`\
`disktypes TitleFor: ${diskTypeFile}`"
				;;
!!!
done

0<<!!! cat -
			* )
				0<<DONE 1>&2 cat -

ERROR:	Unsupported disk type, '\${diskType}', specified for
	controller, '\${RootControllerType}',
	controller number '\${RootControllerNumber}',
	drive number '\${RootDriveNumber}'.
	Installation processing cannot proceed.

DONE
				exit 1
				;;
			esac

			0<<DONE cat -
  \${diskTypeCount} \${diskTitle}
DONE
			diskTypeCount=\`expr \${diskTypeCount} + 1\`
		done

		if [ \${?} -ne 0 ]
		then
			exit 1
		fi

		echo "\\n\\
---> Enter a number, a name, the initial part of a name, or
     ? or <number>? for HELP, or q to QUIT [\${defaultDiskType}]: \c"

		read userDiskType

		case \${userDiskType} in
		"" )
			userDiskType=\${defaultDiskType}
			0<<DONE cat -

Selected the default disk type, '\${userDiskType}'.

DONE
			break
			;;
		[0-9]*\\? )
			userDiskType=\`stripQuestionMark \${userDiskType}\`

			if checkIndex \${userDiskType} \${typeCount}
			then
				: Success
			else
				continue
			fi

			case \`echo "\${diskTypes}" |
				sed -n -e "\${userDiskType}p"\` in
!!!

echo "${DiskTypeFiles}" |
while read diskTypeFile
do
	0<<!!! cat -
			`disktypes TypeFor: ${diskTypeFile}` )
				0<<DONE cat -

!!!
	disktypes DescriptionFor: ${diskTypeFile}

	0<<!!! cat -

DONE
				;;
!!!
done

0<<!!! cat -
			esac
			continue
			;;
		[0-9]* )
			if checkIndex \${userDiskType} \${typeCount}
			then
				: Success
			else
				continue
			fi

			userDiskType=\`echo "\${diskTypes}" |
					sed -n -e "\${userDiskType}p"\`

			0<<DONE cat -

Selected the '\${userDiskType}' disk type.

DONE
			break
			;;
!!!

DiskTypes=`
	echo "${DiskTypeFiles}" |
	while read diskTypeFile
	do
		disktypes TypeFor: ${diskTypeFile}
	done`

possibleEntries=`
	echo "${DiskTypes}" |
	while read diskType
	do
		letterCount=1
		maxLetterCount=\`echo "${diskType}\c" | wc -c\`

		while [ ${letterCount} -lt ${maxLetterCount} ]
		do
			abbreviatedName=\`
	expr ${diskType} : "\(.\{${letterCount}\}\).*"\`

			matchCount=\`
				echo "${DiskTypes}" |
				grep "^${abbreviatedName}" |
				wc -l\`

			if [ ${matchCount} -eq 1 ]
			then
				echo ${abbreviatedName}
			fi

			letterCount=\`expr ${letterCount} + 1\`
		done
		
		echo ${diskType}
	done`

	0<<!!! ed -
a
${possibleEntries}
.
1;\$s/^/		/
1;\$s/\$/ | \\\\/
\$s/ | \\\\\$/ )/
1;\$p
q
!!!

0<<!!! cat -
			break
			;;
		\\? )
			0<<DONE cat -

Enter the  number (first column) or the disk type name (second column)
of the root file system's disk drive.

A selection number followed by a question mark (?) may be entered to
obtain a more detailed description of the disk's features.
A question mark (?) may be entered to obtain this help description.
A 'q' may be entered to cause the installation procedure
to be aborted and execution to resume at the main menu.

DONE
			;;
		q\\? )
			0<<DONE cat -

Enter a 'q' to abort the installation procedure and resume execution at
the main menu.

DONE
			;;
		q )
			exit 1
			;;
		* )
			0<<DONE 1>&2 cat -

	Invalid entry; please try again.

DONE
			;;
		esac
	done
	;;
esac

case \${userDiskType} in
!!!

echo "${DiskTypeFiles}" |
while read diskTypeFile
do
	diskType=`disktypes TypeFor: ${diskTypeFile}`

	possibleEntries=`
		letterCount=1
		maxLetterCount=\`echo "${diskType}\c" | wc -c\`

		while [ ${letterCount} -lt ${maxLetterCount} ]
		do
			abbreviatedName=\`
	expr ${diskType} : "\(.\{${letterCount}\}\).*"\`

			matchCount=\`
				echo "${DiskTypes}" |
				grep "^${abbreviatedName}" |
				wc -l\`

			if [ ${matchCount} -eq 1 ]
			then
				echo ${abbreviatedName}
			fi

			letterCount=\`expr ${letterCount} + 1\`
		done
		
		echo ${diskType}`

	0<<!!! ed -
a
${possibleEntries}
.
1;\$s/\$/ | \\\\/
\$s/ | \\\\\$/ )/
1;\$p
q
!!!
	0<<!!! cat -
	RootDiskType=${diskType}
	RootDiskDdefsName=`disktypes DdefsNameFor: ${diskTypeFile}`
	RootDiskReadDefectListCommand="`
		disktypes ReadDefectListCommandFor: ${diskTypeFile}`"
	RootDiskBadSpotsOptions="`
		disktypes BadSpotsOptionsFor: ${diskTypeFile}`"
	RootDiskAlternateTracks="`
		disktypes AlternateTracksFor: ${diskTypeFile}`"
	;;
!!!
done

	0<<!!! cat -
esac

if [ X\${RootDiskType} != X\${userDiskType} ]
then
	0<<DONE cat -

Selected the '\${RootDiskType}' disk type.

DONE
fi


unset userDiskType diskTitle diskType diskTypeCount defaultDiskType typeCount 
unset diskTypes


# Locate the root file system's disk type's ddefs(1M) file

if [ ! -f \${DdefsDirectory}/\${RootDiskDdefsName} ]
then
	0<<DONE 1>&2 cat -

ERROR:	The ddefs(1M) description file,
	\${DdefsDirectory}/\${RootDiskDdefsName}, is not found.
	The ${ProductName} product installation cannot proceed and
	is being aborted.

DONE
	exit 1
fi

getDdefsEntry ()
{
	prompt=\${*}

	if sed -n -e "s|^ *\${prompt}: ||p" \${ddefsOutput}
	then
		: Success
	else
		0<<DONE 1>&2 cat -

ERROR:	Failed to locate '\${prompt}' entry in
	ddefs(1M) data base for disk type '\${RootDiskDdefsName}'.
	Installation procedure cannot proceed and
	is being aborted.

DONE
		exit 1
	fi
	return 0
}


if 1>\${ddefsOutput} ddefs -p \${RootDiskDdefsName}
then
	: Success
else
	0<<DONE 1>&2 cat -

ERROR:	Unexpected ddefs(1M) error.
	Installation procedure cannot proceed and
	is being aborted.

DONE
	rm -f \${ddefsOutput}
	exit 1
fi

ddefsRootSize=\`getDdefsEntry "Root filesystem size"\`
ddefsSwapSize=\`getDdefsEntry "Swap size"\`

ddefsUsrSize=\`getDdefsEntry "/usr filesystem size"\`
ddefsUsrSlice=\`getDdefsEntry "/usr filesystem slice"\`

RootSlice=0
SwapSlice=\`getDdefsEntry "Swap slice"\`


# Determine if the root file system's disk is to be formatted

while :
do
	0<<DONE cat -

If the root file system's disk is new or needs to be formatted,
it can be formatted now.

WARNING - FORMATTING THE DISK WILL DESTROY ALL DATA ON THE DISK.

DONE
	echo "\\
---> Format the root file system's disk drive (y, n, ?, q) [n]: \c"

	read RootDiskFormatDrive

	case \${RootDiskFormatDrive} in
	\\? )
		0<<DONE cat -

Enter a 'y' to format and a 'n' not to format the root file system's
disk drive.  The default response is 'n'.

DONE
		;;
	"" | n )
		if [ X"\${RootDiskFormatDrive}" = X"" ]
		then
			0<<DONE cat -

Selected NOT to format disk drive.

DONE
		fi

		0<<DONE cat -
***> Accessing root file system's disk drive
DONE

!!!

if [ X"${DEBUG}" = X"true" ]
then
	0<<!!! cat -
		if :
!!!
else
	0<<!!! cat -
		2>/dev/null ${SLFSED} -s /dev/rdsk/\${RootDevice}s7
!!!
fi

0<<!!! cat -
		case \${?} in
		0 )
			# OK
			RootDiskFormatDrive=false
			RootHasASliceTable=true
			break
			;;
		1 | 2 )
			# Unexpected error
			0<<DONE 1>&2 cat -

ERROR:	An unexpected slfsed(internal) error occurred.
	The installation procedure cannot proceed;
	execution is being aborted.

DONE
			exit 1
			;;
		3 )
			# Could not access  the disk drive
			0<<DONE cat -

	The root file system's targeted disk drive could not be accessed;
	this may be indicative of drive in need of formatting.

DONE
			;;
		4 )
			# No slice table found
			RootHasASliceTable=false
			0<<DONE cat -

	The root file system's targeted disk drive does not
	have a slice table; the disk drive must be re-formatted
	in order for a slice table to be created on the drive.
	See your \${ProductName} Software Release Guide for
	more information about this installation procedure
	limitation.

DONE
			;;
		esac
		;;
	y )
		RootDiskFormatDrive=true
		RootHasASliceTable=true
		break
		;;
	q\\? )
		0<<DONE cat -

Enter a 'q' to terminate execution of the installation procedure
and resume execution at the main menu.

DONE
		;;
	q )
		exit 1
		;;
	* )
		0<<DONE 1>&2 cat -

	Invalid response; please try again.

DONE
		;;
	esac
done


# If the root file system's disk is to be formatted
#	Determine the root file system disk's bad spot list

appendSpots=false

while \${RootDiskFormatDrive}
do
	set -- \${RootDiskBadSpotsOptions}
	case \${#} in
	0 )
		0<<DONE 1>&2 cat -

ERROR:	No bad spots information for the '\${RootDiskType}' disk type.

DONE
		exit 1
		;;
	1 )
		badSpotsOption=\${1}
		;;
	* )
		defaultBadSpotsOption=\${1}

		while :
		do
			0<<DONE cat -

A bad spot or defect list is required for the disk format.  The bad spot
list may be read from the disk drive itself, if the manufacturer has
provided a defect list or if the disk has been previously formatted.
A bad spot list may also be entered by hand from scratch.
The following are the choices associated with the root file system's disk
drive.  Identify the creation method of the the bad spots list for the
disk drive by entering the number (in the left most column)
or the letter (in the center column) corresponding to the desired
technique (described in the right most column).


DONE
			optionCount=0
			echo "\${RootDiskBadSpotsOptions}" |
			while read optionName
			do
				optionCount=\`expr \${optionCount} + 1\`
				case \${optionName} in
!!!

BadSpotsOptions=`badspots BadSpotsList`

if [ X"${BadSpotsOptions}" = X"" ]
then
	0<<!!! 1>&2 cat -
${0}: No disk type files found.
!!!
	exit 1
fi

echo "${BadSpotsOptions}" |
while read badSpotsOption
do
	optionName=`badspots NameFor: ${badSpotsOption}`

	nameLength=`echo "${optionName}\c" | wc -c`
	spaceCount=`expr 16 - ${nameLength}`

	if [ ${spaceCount} -lt 1 ]
	then
		spaceCount=1
	fi

	0<<!!! cat -
				${optionName} )
					optionTitle="\\
${optionName}`expr "                " : "\( \{${spaceCount}\}\).*"`\\
`badspots TitleFor: ${badSpotsOption}`"
					;;
!!!
done

0<<!!! cat -
				* )
					0<<DONE 1>&2 cat -

ERROR:	Unknown bad spots option, '\${badSpotsOption}' for
	disk type, '\${RootDiskType}'.
	The ${ProductName} installation cannot proceed.

DONE
					exit 1
					;;
				esac

				0<<DONE cat -
  \${optionCount} \${optionTitle}
DONE
			done

			if [ \${?} != 0 ]
			then
				exit 1
			fi

			optionCount=\${#}

			echo "\n\\
---> Enter a number, a name, the initial part of a name, or
     ? or <number>? for HELP, or q to QUIT [\${defaultBadSpotsOption}]: \c"

			read badSpotsOption

			case \${badSpotsOption} in
			"" )
				badSpotsOption=\${defaultBadSpotsOption}
				0<<DONE cat -

Selected default bad spots list creation method, '\${badSpotsOption}'.

DONE
				break
				;;
			\\? )
				0<<DONE cat -
	
A bad spots list for the root file system's disk must be defined
using one of the methods described above.  Enter the number or
letter associated with the desired bad spots list definition
method.

Entering a question mark causes this help message to be displayed.
Entering a number or letter followed by a question mark, causes a more
detailed description of the specified method to be displayed.
Entering a 'q' followed by a question-mark causes a description of
the quit option to be displayed.
Entering a 'q' causes the execution of the installation procedure
to be aborted and execution to resume at the main menu.

DONE
				continue
				;;
			[0-9]*\\? )
				badSpotsOption=\`
					stripQuestionMark \${badSpotsOption}\`

				if checkIndex \${badSpotsOption} \${optionCount}
				then
					: Success
				else
					continue
				fi

				case \`echo "\${RootDiskBadSpotsOptions}" |
					sed -n -e \${badSpotsOption}p\` in
!!!

echo "${BadSpotsOptions}" |
while read badSpotsOption
do
	0<<!!! cat -
				`badspots NameFor: ${badSpotsOption}` )
					0<<DONE cat -

!!!
	badspots DescriptionFor: ${badSpotsOption}
	0<<!!! cat -

DONE
					;;
!!!
done

0<<!!! cat -
				esac
				;;
			[0-9]* )
				if checkIndex \${badSpotsOption} \${optionCount}
				then
					: Success
				else
					continue
				fi

				badSpotsOption=\`
			echo "\${RootDiskBadSpotsOptions}" |
			sed -n -e \${badSpotsOption}p\`
				break
				;;
!!!

OptionNames=`
	echo "${BadSpotsOptions}" |
	while read badSpotsOption
	do
		badspots NameFor: ${badSpotsOption}
	done`

possibleEntries=`
	echo "${OptionNames}" |
	while read optionName
	do
		letterCount=1
		maxLetterCount=\`echo "${optionName}\c" | wc -c\`

		while [ ${letterCount} -lt ${maxLetterCount} ]
		do
			abbreviatedName=\`
	expr ${optionName} : "\(.\{${letterCount}\}\).*"\`

			matchCount=\`
				echo "${OptionNames}" |
				grep "^${abbreviatedName}" |
				wc -l\`

			if [ ${matchCount} -eq 1 ]
			then
				echo ${abbreviatedName}
			fi

			letterCount=\`expr ${letterCount} + 1\`
		done
		
		echo ${optionName}
	done`

0<<!!! ed -
a
${possibleEntries}
.
1;\$s/^/			/
1;\$s/\$/ | \\\\/
\$s/ | \\\\\$/ )/
1;\$p
q
!!!

0<<!!! cat -
				break
				;;
			q\\? )
				0<<DONE cat -

Enter a 'q' if you wish to terminate the execution of the
installation procedure and resume execution at the main menu.

DONE
				continue
				;;
			q )
				exit 1
				;;
			esac

			0<<DONE cat -

	Invalid response; please try again.

DONE
		done
		;;
	esac

	case \${badSpotsOption} in
!!!

echo "${BadSpotsOptions}" |
while read badSpotsOption
do
	optionName=`badspots NameFor: ${badSpotsOption}`
	optionScript=`badspots ScriptFor: ${badSpotsOption}`

	possibleEntries=`
		letterCount=1
		maxLetterCount=\`echo "${optionName}\c" | wc -c\`

		while [ ${letterCount} -lt ${maxLetterCount} ]
		do
			abbreviatedName=\`
	expr ${optionName} : "\(.\{${letterCount}\}\).*"\`

			matchCount=\`
				echo "${OptionNames}" |
				grep "^${abbreviatedName}" |
				wc -l\`

			if [ ${matchCount} -eq 1 ]
			then
				echo ${abbreviatedName}
			fi

			letterCount=\`expr ${letterCount} + 1\`
		done
		
		echo ${optionName}`

	0<<!!! ed -
a
${possibleEntries}
.
1;\$s/^/	/
1;\$s/\$/ | \\\\/
\$s/ | \\\\\$/ )/
1;\$p
q
!!!
	eval "${optionScript}"

	0<<!!! cat -
		;;
!!!
done

0<<!!! cat
	esac

	if [ \${?} != 0 ]
	then
		if [ \${#} = 1 ]
		then
			0<<DONE 1>&2 cat -

ERROR:	An unexpected error occurred during the creation of
	the bad spots list for the installation disk drive.
	Installation processing cannot proceed and
	is being aborted.

DONE
			exit 1
		fi

		0<<DONE 1>&2 cat -

	An error occurred during the creation of the bad spots list
	for the root file system's disk.  This step must be repeated until
	a correct definition of the bad spots list is accomplished.

DONE
		continue
	fi
	break
done

unset badSpotsOption optionTitle optionName optionCount defaultBadSpotsOption


if \${appendSpots}
then
	badSpotsStrategy=\`getDdefsEntry "Bad spot strategy"\`

	case \${badSpotsStrategy} in
	SPOT )
		useBytesFromIndex=true
		;;
	PERFECT )
		0<<DONE 1>&2 cat -

ERROR:	Bad spot strategy for disk type, '\${RootDiskDdefsName}' is PERFECT.
	Tracks should not be appended.
	Installation processing cannot proceed and is being aborted.

DONE
		exit 1
		;;
	SOFTWARE )
		useBytesFromIndex=false
		;;
	* )
		0<<DONE 1>&2 cat -

ERROR:	Unsupported bad spot strategy, '\${badSpotsStrategy}'
	for disk type, '\${RootDiskDdefsName}'.
	Installation procedure cannot proceed.

DONE
		exit 1
		;;
	esac

	headCount=\`getDdefsEntry Heads\`

	if maxHeadNumber=\`expr \${headCount} - 1\`
	then
		: Success
	else
		0<<DONE 1>&2 cat -

ERROR:	Cannot calculate maximum number of heads for
	ddefs(1M) disk type, '\${RootDiskDdefsName}'.
	Installation procedure cannot proceed.

DONE
		exit 1
	fi

	cylinderCount=\`getDdefsEntry Cylinders\`

	if maxCylinderNumber=\`expr \${cylinderCount} - 1\`
	then
		: Success
	else
		0<<DONE 1>&2 cat -

ERROR:	Cannot calculate maximum number of cylinders for
	ddefs(1M) disk type, '\${RootDiskDdefsName}'.
	Installation procedure cannot proceed.

DONE
		exit 1
	fi

	echo "\nEnter defects in the form:"
	if \${useBytesFromIndex}
	then
		echo "<head> <cylinder> <bytes-from-index> <Return>"
	else
		echo "<head> <cylinder> <Return>"
	fi
	echo "End with <. RETURN> or <Ctrl-D>"

	while :
	do
		echo "> \c"

		if \${useBytesFromIndex}
		then
			read headNumber cylinderNumber bytesFromIndex
		else
			read headNumber cylinderNumber
		fi

		if  [ \${?} -ne 0 -o X"\${headNumber}" = X. ]
		then
			break
		fi

		if checkNumericEntry "Head number" \\
			"\${headNumber}" 0 \${maxHeadNumber}
		then
			: Success
		else
			continue
		fi

		if checkNumericEntry "Cylinder number" \\
			"\${cylinderNumber}" 0 \${maxCylinderNumber}
		then
			: Success
		else
			continue
		fi

		if \${useBytesFromIndex}
		then
			if isNumeric "Bytes-from-index" "\${bytesFromIndex}"
			then
				: Success
			else
				continue
			fi
		fi

		if \${useBytesFromIndex}
		then
			0<<DONE cat -
\${headNumber} \${cylinderNumber} \${bytesFromIndex}
DONE
		else
			0<<DONE cat -
\${headNumber} \${cylinderNumber}
DONE
		fi 1>>\${BadSpotsDirectory}/\${RootDevice}
	done
fi

unset headNumber cylinderNumber bytesFromIndex
unset maxCylinderNumber cylinderCount maxHeadNumber headCount
unset useBytesFromIndex badSpotsStrategy appendSpots


# Determine if the root and usr file systems are on the same disk

0<<DONE cat -

The usr file system is often on the same disk drive as
the root file system, but not always.  The following
questions determine where to install the usr file system.

DONE

while :
do
	echo "\\
---> Will the root and usr file systems be
     on the same disk drive? (y, n, ?, q) [y]: \\c"

	read userResponse

	case \${userResponse} in
	"" )
		usrOnRootDevice=true
		0<<DONE cat -

Indicated that the root and usr file systems will be on the same disk drive.

DONE
		break
		;;
	 y )
		usrOnRootDevice=true
		break
		;;
	n )
		usrOnRootDevice=false
		break
		;;
	\\? )
		0<<DONE cat -

The usr file system is often located in slice 2 of the same disk
on which the root file system is found (the root file system is
always in slice 0).  This need not be the case.  To properly install
the ${ProductName} software on your system it is necessary to
determine where the usr file system is to be located.
If the usr file system is found on the same disk as the root
file system then enter a 'y', otherwise, enter an 'n'.

DONE
		;;
	q\\? )
		0<<DONE cat -

Enter 'q' in order to abort the installation procedure and resume
execution at the main menu.

DONE
		;;
	q )
		exit 0
		;;
	* )
		0<<DONE 1>&2 cat -

	Invalid response; please try again.

DONE
		;;
	esac
done

unset userResponse


if \${usrOnRootDevice}
then
	UsrControllerType=\${RootControllerType}
	UsrControllerNumber=\${RootControllerNumber}
	UsrDriveNumber=\${RootDriveNumber}
	UsrDevice=\${RootDevice}
else
	# Determine usr file system's disk controller type

	0<<DONE cat -

The questions that follow refer to the controller and disk
where the usr file system is to be installed.

DONE

	while :
	do
		0<<DONE cat -

The ${ProductName} product supports usr file system installations on
the disk controllers listed below.  The first column is the controller's
selection number, the second column is the name of the controller, and
the third column is a brief description of the controller.  Identify,
at the prompt below, the usr file system's disk controller type.

!!!

controllerCount=1

echo "${ControllerTypeFiles}" |
while read controllerTypeFile
do
	controllerType=`diskctlrs TypeFor: ${controllerTypeFile}`

	nameLength=`echo "${controllerType}\c" | wc -c`
	spaceCount=`expr 10 - ${nameLength}`

	if [ ${spaceCount} -lt 1 ]
	then
		spaceCount=1
	fi

	0<<!!! cat -
  ${controllerCount}  ${controllerType}\
`expr "                " : "\( \{${spaceCount}\}\).*"`\
`diskctlrs TitleFor: ${controllerTypeFile}`
!!!
	controllerCount=`expr ${controllerCount} + 1`
done

typeCount=`echo "${ControllerTypeFiles}" | wc -l`

ControllerTypes=`
	echo "${ControllerTypeFiles}" |
	while read controllerTypeFile
	do
		diskctlrs TypeFor: ${controllerTypeFile}
	done`

0<<!!! cat -

DONE
		echo "\\
---> Enter a number, a name, the initial part of a name, or
     ? or <number>? for HELP, or q to QUIT [\${DefaultControllerType}]: \c"

		read userControllerType

		case \${userControllerType} in
		"" )
			userControllerType=\${DefaultControllerType}
			0<<DONE cat -

Selected default controller name, '\${userControllerType}'.

DONE
			break
			;;
		[0-9]*\\? )
			userControllerType=\`
				stripQuestionMark \${userControllerType}\`

			if checkIndex \${userControllerType} ${typeCount}
			then
				: Success
			else
				continue
			fi

			case \${userControllerType} in
!!!

controllerCount=1
echo "${ControllerTypeFiles}" |
while read controllerTypeFile
do
	0<<!!! cat -
			${controllerCount} )
				0<<DONE cat -

!!!
	diskctlrs DescriptionFor: ${controllerTypeFile}

	0<<!!! cat -

DONE
				;;
!!!
	controllerCount=`expr ${controllerCount} + 1`
done

0<<!!! cat -
			esac
			;;
		[0-9]* )
			if checkIndex \${userControllerType} ${typeCount}
			then
				: Success
			else
				continue
			fi

			userControllerType=\`
				0<<DONE cat - |
${ControllerTypes}
DONE
				sed -n -e "\${userControllerType}p"\`

			0<<DONE cat -

Selected the '\${userControllerType}' controller type.

DONE
			break
			;;
!!!

possibleEntries=`
	echo "${ControllerTypes}" |
	while read controllerType
	do
		letterCount=1
		maxLetterCount=\`echo "${controllerType}\c" | wc -c\`

		while [ ${letterCount} -lt ${maxLetterCount} ]
		do
			abbreviatedName=\`
	expr ${controllerType} : "\(.\{${letterCount}\}\).*"\`

			matchCount=\`
				echo "${ControllerTypes}" |
				grep "^${abbreviatedName}" |
				wc -l\`

			if [ ${matchCount} -eq 1 ]
			then
				echo ${abbreviatedName}
			fi

			letterCount=\`expr ${letterCount} + 1\`
		done

		echo ${controllerType}
	done`

0<<!!! ed -
a
${possibleEntries}
.
1;\$s/^/		/
1;\$s/\$/ | \\\\/
\$s/ | \\\\\$/ )/
1;\$p
q
!!!

0<<!!! cat -
			break
			;;
		\\? )
			0<<DONE cat -

Enter the selection number (first column) or controller name (second column)
of the usr file system's disk controller.

A selection number followed by a question mark (?) may be entered to
obtain a more detailed description of the controller's features
and supported disk drives.

A question mark (?) may be entered to obtain this description.
A 'q' may be entered to cause the installation procedure
to be aborted and execution to resume at the main menu.

DONE
			;;
		q\\? )
			0<<DONE cat -

Enter a 'q' to abort the installation procedure and resume execution at
the main menu.

DONE
			;;
		q )
			exit 1
			;;
		* )
			0<<DONE 1>&2 cat -

	Invalid response; please try again.

DONE
			;;
		esac
	done

	case \${userControllerType} in
!!!

echo "${ControllerTypeFiles}" |
while read controllerTypeFile
do
	controllerType=`diskctlrs TypeFor: ${controllerTypeFile}`

	possibleEntries=`
		letterCount=1
		maxLetterCount=\`echo "${controllerType}\c" | wc -c\`

		while [ ${letterCount} -lt ${maxLetterCount} ]
		do
			abbreviatedName=\`
	expr ${controllerType} : "\(.\{${letterCount}\}\).*"\`

			matchCount=\`
				echo "${ControllerTypes}" |
				grep "^${abbreviatedName}" |
				wc -l\`

			if [ ${matchCount} -eq 1 ]
			then
				echo ${abbreviatedName}
			fi

			letterCount=\`expr ${letterCount} + 1\`
		done

		echo ${controllerType}`

	0<<!!! ed -
a
${possibleEntries}
.
1;\$s/^/	/
1;\$s/\$/ | \\\\/
\$s/ | \\\\\$/ )/
1;\$p
q
!!!
	controllerNumbers=`diskctlrs NumbersFor: ${controllerTypeFile}`

	0<<!!! cat -
		UsrDevice=m`diskctlrs DesignationFor: ${controllerTypeFile}`_
		UsrControllerType=${controllerType}
		UsrControllerTitle="`
			diskctlrs TitleFor: ${controllerTypeFile}`"
		controllerNumbers="${controllerNumbers}"
!!!

	echo "${controllerNumbers}" |
	while read controllerNumber
	do
		driveNumbers=`diskctlrs \
DriveNumbersFor: ${controllerTypeFile} ControllerNumber: ${controllerNumber}`

		0<<!!! cat -
		driveNumbers_${controllerNumber}="${driveNumbers}"
!!!
		echo "${driveNumbers}" |
		while read driveNumber
		do
			0<<!!! cat -
		diskTypes_${controllerNumber}_${driveNumber}="`
diskctlrs DiskTypesFor: ${controllerTypeFile} \
	ControllerNumber: ${controllerNumber} DriveNumber: ${driveNumber}`"
!!!
		done
	done

	0<<!!! cat -
		;;
!!!
done

0<<!!! cat -
	esac

	if [ X\${UsrControllerType} != X\${userControllerType} ]
	then
		0<<DONE cat -

Selected the '\${UsrControllerType}' controller type.

DONE
	fi

	unset userControllerType


	# Determine usr file system's disk controller number

	set -- \${controllerNumbers}
	case \${#} in
	0 )
		0<<DONE 1>&2 cat -

ERROR:	No controller number information for \\
the \${UsrControllerType} controller.

DONE
		exit 1
		;;
	1 )
		UsrControllerNumber=\${1}
		0<<DONE cat -

Selected \${UsrControllerType} controller number \${UsrControllerNumber}.
This is the only controller number for the \${UsrControllerType} controller
supported by the ${ProductName} product.

DONE
		;;
	* )
		defaultControllerNumber=\${1}
		controllerChoices=\`echo \${controllerNumbers} |
					sed -e 's/ /, /g'\`

		while :
		do
			echo "\\
---> Enter the usr file system's controller number \\
(\${controllerChoices}, ?, q) [\${defaultControllerNumber}]: \c"

			read userControllerNumber

			case \${userControllerNumber} in
			"" )
				UsrControllerNumber=\${defaultControllerNumber}
				0<<DONE cat 

Selected default controller number, '\${UsrControllerNumber}'.

DONE
				break
				;;
			\\? )
				0<<DONE cat -

One or more \${UsrControllerType} controllers may be present
in a given system.  Enter the controller number associated
with the usr file system's disk drive.

DONE
				;;
			q\\? )
				0<<DONE cat -

Enter 'q' to abort the installation procedure and resume execution at
the main menu.

DONE
				;;
			q )
				exit 1
				;;
			* )
				UsrControllerNumber=\`
			0<<DONE grep "^\${userControllerNumber}$"
\${controllerNumbers}
DONE\`
				if [ X"\${userControllerNumber}" = \\
					X"\${UsrControllerNumber}" ]
				then
					break
				fi

				0<<DONE 1>&2 cat -

	Invalid \${UsrControllerType} controller number; please try again.

DONE
				;;
			esac
		done
		;;
	esac

	unset userControllerNumber controllerChoices defaultControllerNumber

	0<<DONE grep -v "^\${UsrControllerNumber}$" |
\${controllerNumbers}
DONE
	while read controllerNumber
	do
		eval driveNumbers=\\\${driveNumbers_\${controllerNumber}}

		for driveNumber in \${driveNumbers}
		do
			eval \\
unset diskTypes_\${controllerNumber}_\${driveNumber}
		done

		eval unset driveNumbers_\${controllerNumber}
	done

	unset controllerNumbers


	case \${UsrControllerNumber} in
	[1-9] )
		UsrDevice=\${UsrDevice}\${UsrControllerNumber}d
		;;
	esac


	eval driveNumbers=\\\${driveNumbers_\${UsrControllerNumber}}
	eval unset driveNumbers_\${UsrControllerNumber}


	# Determine usr file system's disk drive number

	set -- \${driveNumbers}

	case \${#} in
	0 )
		0<<DONE 1>&2 cat -

ERROR:	No drive number information for the \${UsrControllerType} controller,
	controller number \${UsrControllerNumber}.

DONE
		exit 1
		;;
	1 )
		UsrDriveNumber=\${1}
		0<<DONE cat -

Selected drive number \${UsrDriveNumber}.
This is the only drive number supported by
the \${UsrControllerType} controller on the ${ProductName} product.

DONE
		;;
	* )
		defaultDriveNumber=\${1}
		driveChoices=\`echo \${driveNumbers} | sed -e 's/ /, /g'\`

		while :
		do
			echo "\\
---> Enter the usr file system's disk drive number
     (\${driveChoices}, ?, q) [\${defaultDriveNumber}]: \\c"

			read userDriveNumber

			case \${userDriveNumber} in
			"" )
				UsrDriveNumber=\${defaultDriveNumber}
				0<<DONE cat -

Selected default disk drive number, '\${UsrDriveNumber}'.

DONE
				break
				;;
			\\? )
				0<<DONE cat -

Enter the disk drive number of the usr file system's disk drive.
The allowable drive numbers are presented between parentheses
in the prompt below.

You may enter a 'q' in order to abort the installation procedure and
resume execution at the main menu.

DONE
				;;
			q\\? )
				0<<DONE cat -

Enter 'q' to abort the installation procedure and resume execution at
the main menu.

DONE
				;;
			q )
				exit 1
				;;
			* )
				UsrDriveNumber=\`
					0<<DONE grep "^\${userDriveNumber}$"
\${driveNumbers}
DONE\`
				if [ X"\${userDriveNumber}" = \\
					X"\${UsrDriveNumber}" ]
				then
					break
				fi

				0<<DONE 1>&2 cat -

	Invalid \${UsrControllerType} drive number; please try again.

DONE
				;;
			esac
		done
		;;
	esac


	unset userDriveNumber driveChoices defaultDriveNumber

	0<<DONE grep -v "^\${UsrDriveNumber}" |
\${driveNumbers}
DONE
	while read driveNumber
	do
		eval unset diskTypes_\${UsrControllerNumber}_\${driveNumber}
	done

	unset driveNumbers


	UsrDevice=\${UsrDevice}\${UsrDriveNumber}


	eval \\
diskTypes=\\\${diskTypes_\${UsrControllerNumber}_\${UsrDriveNumber}}
	eval unset diskTypes_\${UsrControllerNumber}_\${UsrDriveNumber}


	if [ \${UsrDevice} = \${RootDevice} ]
	then
		while :
		do
			0<<DONE cat -

	The usr file system is on the root file system's disk drive
	as indicated by the user responses. No prompts for the
	usr file system disk type or formatting will be displayed
	as both file system's are on the same disk drive.



DONE
			echo "\\
---> Press the RETURN key when ready to continue (?, q): \\c"

			read userResponse

			case \${userResponse} in
			\\? )
				0<<DONE cat -

Press the RETURN key when you are ready to proceed with the installation
procedure.  Enter a 'q' if you wish to terminate execution of the
procedure and resume execution at the main menu.

DONE
				;;
			q\\? )
				0<<DONE cat -

Enter 'q' if you wish to terminate execution of the installation procedure.
Execution will then resume at the main menu.

DONE
				;;
			q )
				exit 1
				;;
			* )
				break
				;;
			esac
		done

		unset diskTypes userResponse

		usrOnRootDevice=true
	fi
fi


if \${usrOnRootDevice}
then
	UsrDiskFormatDrive=false
	UsrDiskType=\${RootDiskType}
	UsrDiskDdefsName=\${RootDiskDdefsName}
	UsrHasASliceTable=\${RootHasASliceTable}
else
	# Determine if usr file system's disk device nodes are present

	missingNodes=
	for sliceNumber in 0 1 2 3 4 5 6 7
	do
		if [ ! -c /dev/rdsk/\${UsrDevice}s\${sliceNumber} ]
		then
			missingNodes="\${missingNodes}
/dev/rdsk/\${UsrDevice}s\${sliceNumber}"
		fi

		if [ ! -b /dev/dsk/\${UsrDevice}s\${sliceNumber} ]
		then
			missingNodes="\${missingNodes}
/dev/dsk/\${UsrDevice}s\${sliceNumber}"
		fi
	done

	if [ X"\${missingNodes}" != X"" ]
	then
		0<<DONE 1>&2 cat -

ERROR:	The following device nodes are not found:
\${missingNodes}

ERROR:	The ${ProductName} installation procedure cannot proceed and
	is being aborted.

DONE
		exit 1
	else
		unset sliceNumber missingNodes
	fi


	# Determine usr file system's disk type

	set -- \${diskTypes}

	case \${#} in
	0 )
		0<<DONE 1>&2 cat -

ERROR:	No disk type information for the \${UsrControllerType} controller,
	controller number \${UsrControllerNumber}, \
drive Number\${UsrDriveNumber}.

DONE
		exit 1
		;;
	1 )
		userDiskType=\${1}
		0<<DONE cat -

The usr file system's disk drive must be of the '\${userDiskType}' disk type.
This is the only disk type supported by the ${ProductName} product
for the \${RootControllerType} controller on drive number \${RootDriveNumber}.

DONE
		;;
	* )
		typeCount=\${#}
		defaultDiskType=\${1}

		while :
		do
			0<<DONE cat -

\${UsrControllerTitle} may be
used to install the ${ProductName} product on the following
disk drive types.  The first column is the disk type number,
the second is the disk type name, and the third briefly
describes the disk drive type:

DONE
			diskTypeCount=1

			echo "\${diskTypes}" |
			while read diskType
			do
				case \${diskType} in
!!!

DiskTypeFiles=`disktypes DiskTypesList`

if [ X"${DiskTypeFiles}" = X"" ]
then
	0<<!!! 1>&2 cat -
${0}: No disk type files found.
!!!
	exit 1
fi

echo "${DiskTypeFiles}" |
while read diskTypeFile
do
	diskType=`disktypes TypeFor: ${diskTypeFile}`

	nameLength=`echo "${diskType}\c" | wc -c`
	spaceCount=`expr 16 - ${nameLength}`

	if [ ${spaceCount} -lt 1 ]
	then
		spaceCount=1
	fi


	0<<!!! cat -
				${diskType} )
					diskTitle="\\
${diskType}\
`expr "                " : "\( \{${spaceCount}\}\).*"`\
`disktypes TitleFor: ${diskTypeFile}`"
					;;
!!!
done

0<<!!! cat -
				* )
					0<<DONE 1>&2 cat -

ERROR:	Unsupported disk type, '\${diskType}', specified for
	controller, '\${UsrControllerType}',
	controller number '\${UsrControllerNumber}',
	drive number '\${UsrDriveNumber}'.
	Installation processing cannot proceed.

DONE
					exit 1
					;;
				esac

				0<<DONE cat -
  \${diskTypeCount} \${diskTitle}
DONE
				diskTypeCount=\`expr \${diskTypeCount} + 1\`
			done

			if [ \${?} -ne 0 ]
			then
				exit 1
			fi

			echo "\\n\\
---> Enter a number, a name, the initial part of a name, or
     ? or <number>? for HELP, or q to QUIT [\${defaultDiskType}]: \c"

			read userDiskType

			case \${userDiskType} in
			"" )
				userDiskType=\${defaultDiskType}
				0<<DONE cat -

Selected the default disk type, '\${userDiskType}'.

DONE
				break
				;;
			[0-9]*\\? )
				userDiskType=\`
					stripQuestionMark \${userDiskType}\`

				if checkIndex \${userDiskType} \${typeCount}
				then
					: Success
				else
					continue
				fi

				case \`echo "\${diskTypes}" |
					sed -n -e "\${userDiskType}p"\` in
!!!

echo "${DiskTypeFiles}" |
while read diskTypeFile
do
	0<<!!! cat -
				`disktypes TypeFor: ${diskTypeFile}` )
					0<<DONE cat -

!!!
	disktypes DescriptionFor: ${diskTypeFile}

	0<<!!! cat -

DONE
					;;
!!!
done

0<<!!! cat -
				esac
				continue
				;;
			[0-9]* )
				if checkIndex \${userDiskType} \${typeCount}
				then
					: Success
				else
					continue
				fi

				userDiskType=\`echo "\${diskTypes}" |
						sed -n -e "\${userDiskType}p"\`

				0<<DONE cat -

Selected disk type, '\${userDiskType}'.

DONE
				break
				;;
!!!

DiskTypes=`
	echo "${DiskTypeFiles}" |
	while read diskTypeFile
	do
		disktypes TypeFor: ${diskTypeFile}
	done`

possibleEntries=`
	echo "${DiskTypes}" |
	while read diskType
	do
		letterCount=1
		maxLetterCount=\`echo "${diskType}\c" | wc -c\`

		while [ ${letterCount} -lt ${maxLetterCount} ]
		do
			abbreviatedName=\`
	expr ${diskType} : "\(.\{${letterCount}\}\).*"\`

			matchCount=\`
				echo "${DiskTypes}" |
				grep "^${abbreviatedName}" |
				wc -l\`

			if [ ${matchCount} -eq 1 ]
			then
				echo ${abbreviatedName}
			fi

			letterCount=\`expr ${letterCount} + 1\`
		done
		
		echo ${diskType}
	done`

	0<<!!! ed -
a
${possibleEntries}
.
1;\$s/^/			/
1;\$s/\$/ | \\\\/
\$s/ | \\\\\$/ )/
1;\$p
q
!!!

0<<!!! cat -
				break
				;;
			\\? )
				0<<DONE cat -

Enter the selection number (first column) or the disk type name (second column)
of the usr file system's disk drive.

A selection number followed by a question mark (?) may be entered to obtain
a more detailed description of the disk's features.
A question mark (?) may be entered to obtain this description.
A 'q' may be entered to cause the installation procedure
to be aborted and execution to resume at the main menu.

DONE
				;;
			q\\? )
				0<<DONE cat -

Enter a 'q' to abort the installation procedure and resume execution at
the main menu.

DONE
				;;
			q )
				exit 1
				;;
			* )
				0<<DONE 1>&2 cat -

	Invalid entry; please try again.

DONE
				;;
			esac
		done
		;;
	esac

	case \${userDiskType} in
!!!

echo "${DiskTypeFiles}" |
while read diskTypeFile
do
	diskType=`disktypes TypeFor: ${diskTypeFile}`

	possibleEntries=`
		letterCount=1
		maxLetterCount=\`echo "${diskType}\c" | wc -c\`

		while [ ${letterCount} -lt ${maxLetterCount} ]
		do
			abbreviatedName=\`
	expr ${diskType} : "\(.\{${letterCount}\}\).*"\`

			matchCount=\`
				echo "${DiskTypes}" |
				grep "^${abbreviatedName}" |
				wc -l\`

			if [ ${matchCount} -eq 1 ]
			then
				echo ${abbreviatedName}
			fi

			letterCount=\`expr ${letterCount} + 1\`
		done
		
		echo ${diskType}`

	0<<!!! ed -
a
${possibleEntries}
.
1;\$s/^/	/
1;\$s/\$/ | \\\\/
\$s/ | \\\\\$/ )/
1;\$p
q
!!!
	0<<!!! cat -
		UsrDiskType=${diskType}
		UsrDiskDdefsName=`disktypes DdefsNameFor: ${diskTypeFile}`
		UsrDiskReadDefectListCommand="`
			disktypes ReadDefectListCommandFor: ${diskTypeFile}`"
		UsrDiskBadSpotsOptions="`
			disktypes BadSpotsOptionsFor: ${diskTypeFile}`"
		UsrDiskAlternateTracks="`
			disktypes AlternateTracksFor: ${diskTypeFile}`"
		;;
!!!
done

	0<<!!! cat -
	esac

	if [ X\${UsrDiskType} != X\${userDiskType} ]
	then
		0<<DONE cat -

Selected the '\${UsrDiskType}' disk type.

DONE
	fi


	unset userDiskType diskTitle diskType diskTypeCount \\
		defaultDiskType typeCount 
	unset diskTypes


	# Locate the usr file system's disk type's ddefs(1M) file

	if [ ! -f \${DdefsDirectory}/\${UsrDiskDdefsName} ]
	then
		0<<DONE 1>&2 cat -

ERROR:	The ddefs(1M) description file,
	\${DdefsDirectory}/\${UsrDiskDdefsName}, is not found.
	The ${ProductName} product installation procedure cannot proceed
	and is being aborted.

DONE
		exit 1
	fi


	if 1>\${ddefsOutput} ddefs -p \${UsrDiskDdefsName}
	then
		: Success
	else
		0<<DONE 1>&2 cat -
	
ERROR:	Unexpected ddefs(1M) error.
	Installation procedure cannot proceed and
	is being aborted.

DONE
		rm -f \${ddefsOutput}
		exit 1
	fi

	# Determine if the usr file system's disk is to be formatted

	while :
	do
		0<<DONE cat -

If the usr file system's disk is new or needs to be formatted,
it can be formatted now.

WARNING - FORMATTING THE DISK WILL DESTROY ALL DATA ON THE DISK.


DONE
		echo "\\
---> Format the usr file system's disk drive (y, n, ?, q) [n]: \c"

		read UsrDiskFormatDrive

		case \${UsrDiskFormatDrive} in
		\\? )
			0<<DONE cat -

Enter a 'y' to format and a 'n' not to format
the usr file system's disk drive.  The default response is 'n'.

DONE
			;;
		"" | n )
			if [ X"\${UsrDiskFormatDrive}" = X"" ]
			then
				0<<DONE cat -

Selected NOT to format disk drive.

DONE
			fi

			0<<DONE cat -
***> Accessing usr file system's disk drive
DONE

!!!

if [ X"${DEBUG}" = X"true" ]
then
	0<<!!! cat -
			if :
!!!
else
	0<<!!! cat -
			2>/dev/null ${SLFSED} -s /dev/rdsk/\${UsrDevice}s7
!!!
fi

0<<!!! cat -
			case \${?} in
			0 )
				# OK
				UsrDiskFormatDrive=false
				UsrHasASliceTable=true
				break
				;;
			1 | 2 )
				# Unexpected error
				0<<DONE 1>&2 cat -

ERROR:	An unexpected slfsed(internal) error occurred.
	The installation procedure cannot proceed;
	execution is being aborted.

DONE
				exit 1
				;;
			3 )
				# Could not access the disk drive
				0<<DONE cat -

	Could not access the usr file system's targeted disk drive.
	This may be indicate that the drive requires formatting.

DONE
				;;
			4 )
				# No slice table found
				UsrHasASliceTable=false
				0<<DONE cat -

	The usr file system's targeted disk drive does not
	have a slice table; the disk drive must be re-formatted
	in order for a slice table to be created on the drive.
	See your \${ProductName} Software Release Guide for
	more information about this installation procedure
	limitation.

DONE
				;;
			esac
			;;
		y )
			UsrDiskFormatDrive=true
			UsrHasASliceTable=true
			break
			;;
		q\\? )
			0<<DONE cat -

Enter a 'q' to terminate execution of the installation procedure
and resume execution at the main menu.

DONE
			;;
		q )
			exit 1
			;;
		* )
			0<<DONE 1>&2 cat -

	Invalid response; please try again.

DONE
			;;
		esac
	done


	# If the usr file system's disk is to be formatted
	#	Determine the usr file system disk's bad spot list

	appendSpots=false

	while \${UsrDiskFormatDrive}
	do
		set -- \${UsrDiskBadSpotsOptions}
		case \${#} in
		0 )
			0<<DONE 1>&2 cat -

ERROR:	No bad spots information for the '\${UsrDiskType}' disk type.

DONE
			exit 1
			;;
		1 )
			badSpotsOption=\${1}
			;;
		* )
			defaultBadSpotsOption=\${1}

			while :
			do
				0<<DONE cat -

A bad spot or defect list is required for the disk format.  The bad spot
list may be read from the disk drive itself, if the manufacturer has
provided a defect list or if the disk has been previously formatted.
A bad spot list may also be entered by hand from scratch.
The following are the choices associated with the usr file system's disk
drive.  Identify the creation method of the the bad spots list for the
disk drive by entering the number (in the left most column)
or the letter (in the center column) corresponding to the desired
technique (described in the right most column).


DONE
				optionCount=0
				echo "\${UsrDiskBadSpotsOptions}" |
				while read optionName
				do
					optionCount=\`expr \${optionCount} + 1\`
					case \${optionName} in
!!!

BadSpotsOptions=`badspots BadSpotsList`

if [ X"${BadSpotsOptions}" = X"" ]
then
	0<<!!! 1>&2 cat -
${0}: No disk type files found.
!!!
	exit 1
fi

echo "${BadSpotsOptions}" |
while read badSpotsOption
do
	optionName=`badspots NameFor: ${badSpotsOption}`

	nameLength=`echo "${optionName}\c" | wc -c`
	spaceCount=`expr 16 - ${nameLength}`

	if [ ${spaceCount} -lt 1 ]
	then
		spaceCount=1
	fi

	0<<!!! cat -
					${optionName} )
						optionTitle="\\
${optionName}`expr "                " : "\( \{${spaceCount}\}\).*"`\\
`badspots TitleFor: ${badSpotsOption}`"
						;;
!!!
done

0<<!!! cat -
					* )
						0<<DONE 1>&2 cat -

ERROR:	Unknown bad spots option, '\${badSpotsOption}' for
	disk type, '\${UsrDiskType}'.
	The ${ProductName} installation cannot proceed.

DONE
						exit 1
						;;
					esac

					0<<DONE cat -
  \${optionCount} \${optionTitle}
DONE
				done

				if [ \${?} != 0 ]
				then
					exit 1
				fi

				optionCount=\${#}

				echo "\n\\
---> Enter a number, a name, the initial part of a name, or
     ? or <number>? for HELP, or q to QUIT [\${defaultBadSpotsOption}]: \c"

				read badSpotsOption

				case \${badSpotsOption} in
				"" )
					badSpotsOption=\${defaultBadSpotsOption}
					0<<DONE cat -

Selected default bad spots list creation method, '\${badSpotsOption}'.

DONE
					break
					;;
				\\? )
					0<<DONE cat -
	
A bad spots list for the usr file system's disk must be defined
using one of the methods described above.  Enter a number or
a letter associated with the desired bad spots list definition
method.

Entering a question mark causes this help message to be displayed.
Entering a number or letter followed by a question mark, causes a more
detailed description of the specified method to be displayed.
Entering a 'q' followed by a question-mark causes a description of
the quit option to be displayed.
Entering a 'q' causes the execution of the installation procedure to
be aborted and execution to resume at the main menu.

DONE
					continue
					;;
				[0-9]*\\? )
					badSpotsOption=\`
				stripQuestionMark \${badSpotsOption}\`

					if checkIndex \\
				\${badSpotsOption} \${optionCount}
					then
						: Success
					else
						continue
					fi

					case \`
				echo "\${UsrDiskBadSpotsOptions}" |
				sed -n -e \${badSpotsOption}p\` in
!!!

echo "${BadSpotsOptions}" |
while read badSpotsOption
do
	0<<!!! cat -
					`badspots NameFor: ${badSpotsOption}` )
						0<<DONE cat -

!!!
		badspots DescriptionFor: ${badSpotsOption}
		0<<!!! cat -

DONE
						;;
!!!
done

0<<!!! cat -
					esac
					;;
				[0-9]* )
					if checkIndex \\
				\${badSpotsOption} \${optionCount}
					then
						: Success
					else
						continue
					fi

					badSpotsOption=\`
				echo "\${UsrDiskBadSpotsOptions}" |
				sed -n -e \${badSpotsOption}p\`
					break
					;;
!!!

OptionNames=`
	echo "${BadSpotsOptions}" |
	while read badSpotsOption
	do
		badspots NameFor: ${badSpotsOption}
	done`

possibleEntries=`
	echo "${OptionNames}" |
	while read optionName
	do
		letterCount=1
		maxLetterCount=\`echo "${optionName}\c" | wc -c\`

		while [ ${letterCount} -lt ${maxLetterCount} ]
		do
			abbreviatedName=\`
	expr ${optionName} : "\(.\{${letterCount}\}\).*"\`

			matchCount=\`
				echo "${OptionNames}" |
				grep "^${abbreviatedName}" |
				wc -l\`

			if [ ${matchCount} -eq 1 ]
			then
				echo ${abbreviatedName}
			fi

			letterCount=\`expr ${letterCount} + 1\`
		done
		
		echo ${optionName}
	done`

0<<!!! ed -
a
${possibleEntries}
.
1;\$s/^/				/
1;\$s/\$/ | \\\\/
\$s/ | \\\\\$/ )/
1;\$p
q
!!!

0<<!!! cat -
					break
					;;
				q\\? )
					0<<DONE cat -

Enter a 'q' if you wish to terminate the execution of the
installation procedure and resume execution at the main menu.

DONE
					continue
					;;
				q )
					exit 1
					;;
				esac

				0<<DONE cat -

	Invalid response; please try again.

DONE
			done
			;;
		esac

		case \${badSpotsOption} in
!!!

echo "${BadSpotsOptions}" |
while read badSpotsOption
do
	optionName=`badspots NameFor: ${badSpotsOption}`
	optionScript=`
		badspots ScriptFor: ${badSpotsOption} |
		sed -e 's/^	/&&/' -e 's/Root/Usr/g'
	`

	possibleEntries=`
		letterCount=1
		maxLetterCount=\`echo "${optionName}\c" | wc -c\`

		while [ ${letterCount} -lt ${maxLetterCount} ]
		do
			abbreviatedName=\`
	expr ${optionName} : "\(.\{${letterCount}\}\).*"\`

			matchCount=\`
				echo "${OptionNames}" |
				grep "^${abbreviatedName}" |
				wc -l\`

			if [ ${matchCount} -eq 1 ]
			then
				echo ${abbreviatedName}
			fi

			letterCount=\`expr ${letterCount} + 1\`
		done
		
		echo ${optionName}`

	0<<!!! ed -
a
${possibleEntries}
.
1;\$s/^/		/
1;\$s/\$/ | \\\\/
\$s/ | \\\\\$/ )/
1;\$p
q
!!!
	eval "${optionScript}"

	0<<!!! cat -
			;;
!!!
done

0<<!!! cat
		esac

		if [ \${?} != 0 ]
		then
			if [ \${#} = 1 ]
			then
				0<<DONE 1>&2 cat -

ERROR:	An unexpected error occurred during the creation of
	the bad spots list for the installation disk drive.
	Installation processing cannot proceed and
	is being aborted.

DONE
				exit 1
			fi

			0<<DONE 1>&2 cat -

	An error occurred during the creation of the bad spots list
	for the root file system's disk.  This step must be repeated until
	a correct definition of the bad spots list is accomplished.

DONE
			continue
		fi
		break
	done

	unset badSpotsOption optionTitle optionName optionCount \\
		defaultBadSpotsOption


	if \${appendSpots}
	then
		badSpotsStrategy=\`getDdefsEntry "Bad spot strategy"\`

		case \${badSpotsStrategy} in
		SPOT )
			useBytesFromIndex=true
			;;
		PERFECT )
			0<<DONE 1>&2 cat -

ERROR:	Bad spot strategy for disk type, '\${UsrDiskDdefsName}' is PERFECT.
	Tracks should not be appended.
	Installation processing cannot proceed and is being aborted.

DONE
			exit 1
			;;
		SOFTWARE )
			useBytesFromIndex=false
			;;
		* )
			0<<DONE 1>&2 cat -

ERROR:	Unsupported bad spot strategy, '\${badSpotsStrategy}'
	for disk type, '\${UsrDiskDdefsName}'.
	Installation procedure cannot proceed.

DONE
			exit 1
			;;
		esac

		headCount=\`getDdefsEntry Heads\`

		if maxHeadNumber=\`expr \${headCount} - 1\`
		then
			: Success
		else
			0<<DONE 1>&2 cat -

ERROR:	Cannot calculate maximum number of heads for
	ddefs(1M) disk type, '\${UsrDiskDdefsName}'.
	Installation procedure cannot proceed.

DONE
			exit 1
		fi

		cylinderCount=\`getDdefsEntry Cylinders\`

		if maxCylinderNumber=\`expr \${cylinderCount} - 1\`
		then
			: Success
		else
			0<<DONE 1>&2 cat -

ERROR:	Cannot calculate maximum number of cylinders for
	ddefs(1M) disk type, '\${UsrDiskDdefsName}'.
	Installation procedure cannot proceed.

DONE
			exit 1
		fi

		echo "\nEnter defects in the form:"
		if \${useBytesFromIndex}
		then
			echo "<head> <cylinder> <bytes-from-index> <Return>"
		else
			echo "<head> <cylinder> <Return>"
		fi
		echo "End with <. RETURN> or <Ctrl-D>"

		while :
		do
			echo "> \c"

			if \${useBytesFromIndex}
			then
				read headNumber cylinderNumber bytesFromIndex
			else
				read headNumber cylinderNumber
			fi

			if  [ \${?} -ne 0 -o X"\${headNumber}" = X. ]
			then
				break
			fi

			if checkNumericEntry "Head number" \\
				"\${headNumber}" 0 \${maxHeadNumber}
			then
				: Success
			else
				continue
			fi

			if checkNumericEntry "Cylinder number" \\
				"\${cylinderNumber}" 0 \${maxCylinderNumber}
			then
				: Success
			else
				continue
			fi

			if \${useBytesFromIndex}
			then
				if isNumeric \\
					"Bytes-from-index" "\${bytesFromIndex}"
				then
					: Success
				else
					continue
				fi
			fi

			if \${useBytesFromIndex}
			then
				0<<DONE cat -
\${headNumber} \${cylinderNumber} \${bytesFromIndex}
DONE
			else
				0<<DONE cat -
\${headNumber} \${cylinderNumber}
DONE
			fi 1>>\${BadSpotsDirectory}/\${UsrDevice}
		done
	fi

	unset headNumber cylinderNumber bytesFromIndex
	unset maxCylinderNumber cylinderCount maxHeadNumber headCount
	unset useBytesFromIndex badSpotsStrategy appendSpots
fi


# Determine the slice number of the usr file system

if \${usrOnRootDevice}
then
	defaultUsrSlice=\${ddefsUsrSlice}
else
	defaultUsrSlice=0
fi

while :
do
	if \${usrOnRootDevice}
	then
		0<<DONE cat -

The default usr file system slice number for the \${RootControllerType}
controller is slice number \${defaultUsrSlice}, but it may be changed.
Enter below, the slice number where the usr file system is to be installed.

DONE
	fi

	echo "\\
---> Enter the slice number for the usr file system \\
(0-6, ?, q) [\${defaultUsrSlice}]: \\c"

	read UsrSlice

	case \${UsrSlice} in
	"" )
		UsrSlice=\${defaultUsrSlice}
		0<<DONE cat -

Selected slice number \${UsrSlice} for the usr file system.

DONE
		break
		;;
	[0-6] )
		if \${usrOnRootDevice} &&
		   ( [ \${UsrSlice} = \${RootSlice} ] ||
		     [ \${UsrSlice} = \${SwapSlice} ] )
		then
			0<<DONE 1>&2 cat -

	The root file system and/or swap area is located on this slice.
	Please enter the usr file system slice number again.

DONE
			continue
		fi
		break
		;;
	\\? )
		0<<DONE cat -

Unlike the root file system, the usr file system may be located on 
any unoccupied slice.  You must identify the slice number for the given
disk drive where the usr file system is to be located.

DONE
		;;
	q\\? )
		0<<DONE cat -

Enter a 'q' in order to abort installation processing and resume
execution at the main menu.

DONE
		;;
	q )
		exit 0
		;;
	* )
		0<<DONE 1>&2 cat -

	Invalid response; please try again.

DONE
		;;
	esac
done

unset defaultUsrSlice


# Determine the root and usr file systems' and swap area sizes

0<<DONE cat -


Phase 2.  Configure Root And Usr File-Systems And Swap Area

DONE


getSlfsedEntry ()
{
	userSliceNumber=\${1}
	shift
	fieldName=\${*}

	while read sliceNumber sliceOffset sliceSize fsSize fsName volumeID
	do
		if [ X\${sliceNumber} = X\${userSliceNumber} ]
		then
			case \${fieldName} in
			offset )
				echo \${sliceOffset}
				;;
			"sl size" )
				echo \${sliceSize}
				;;
			"fs size" )
				echo \${fsSize}
				;;
			fsname )
				echo \${fsName}
				;;
			vol-id )
				echo \${volumeID}
				;;
			* )
				break
				;;
			esac
		fi
	done 0<\${slfsedOutput}
	return 0
}


pressReturn ()
{
	echo "\\
---> Press the RETURN key when ready to continue (?, q): \\c"

	read userResponse

	case \${userResponse} in
	\\? )
		0<<DONE cat -

Press the RETURN key when ready to proceed with the installation
procedure; enter a 'q' at the prompt to abort execution of the 
installation procedure and resume execution at the main menu.

DONE
		;;
	q\\? )
		0<<DONE cat -

Enter 'q' at the prompt to abort the installation procedure and
resume execution at the main menu.

DONE
		;;
	q )
		exit 1
		;;
	* )
		slicingErrors=true
		return 0
		;;
	esac
	return 1
}


modSliceInfo ()
{
	targetSlice=\${1}
	targetSize=\${2}
	targetName=\${3}

	{
		sliceNumber=0
		while [ \${sliceNumber} -lt \${targetSlice} ]
		do
			0<<DONE cat -





DONE
			sliceNumber=\`expr \${sliceNumber} + 1\`
		done
		0<<DONE cat -


\${targetSize}
\${targetName}
R3
w
q
DONE
	} | 1>/dev/null ${SLFSED} -o \${slfsedOutput} -e \${slfsedOutput}

	if [ \${?} -ne 0 ]
	then
		0<<DONE 1>&2 cat -

ERROR:	An unexpected slfsed(internal) error occurred;
	the installation procedure cannot proceed and is being aborted.

DONE
		exit 1
	fi

	unset targetSlice targetSize targetName
	return 0
}


if \${RootDiskFormatDrive}
then
	slfsedMode=-r

	if \${usrOnRootDevice} && [ \${UsrSlice} = \${ddefsUsrSlice} ]
	then
		slfsedMode=-u
	fi

 	slfsedMode="\\
		-n \${RootDiskDdefsName} \${slfsedMode} \${RootDiskDdefsName}"

elif \${RootHasASliceTable}
then
	slfsedMode="-d /dev/rdsk/\${RootDevice}s7"
else
	slfsedMode=UNDEFINED
fi

slfsedOutput=\${rootSlfsedOutput}

if 1>\${slfsedOutput} ${SLFSED} \${slfsedMode}
then
	: Success
else
	0<<DONE 1>&2 cat -

ERROR:	Unexpected slfsed(internal) error occurred.
	The installation procedure cannot proceed and is being aborted.

DONE
	exit 1
fi

unset slfsedMode

# set root file system's size to slice's size, ditto usr's

if [ \${RootSlice} = \${SwapSlice} ]
then
	modSliceInfo \${RootSlice} \${ddefsRootSize} root
else
	modSliceInfo \${RootSlice} \\
		\`getSlfsedEntry \${RootSlice} "sl size"\` root
fi

if \${usrOnRootDevice}
then
	modSliceInfo \${UsrSlice} \\
		\`getSlfsedEntry \${UsrSlice} "sl size"\` usr
fi


# Check for changes to the root file system's disk drive slicing information

while :
do
	slicingErrors=false

	RootSliceSize=\`getSlfsedEntry \${RootSlice} "sl size"\`
	RootSize=\`getSlfsedEntry \${RootSlice} "fs size"\`

	if [ \${RootSlice} = \${SwapSlice} ]
	then
		if [ \${RootSliceSize} -lt \`
			expr \${ddefsRootSize} + \${MinimumSwapSize}\` ]
		then
			while :
			do
				0<<DONE cat -

The slicing information on the root file system's disk drive indicates
there are \${RootSliceSize} 512-byte blocks \\
(the 'sl size' field for slice \${RootSlice},
below) in the root file system's and swap area's shared slice; this amount
is insufficient to create the root file system and the minimum sized
swap area.  In the step below, you must update the slicing information in
order to provide a minimum of \\
\`expr \${ddefsRootSize} + \${MinimumSwapSize}\` \\
512-byte blocks for the root file
system's and swap area's slice (slice number \${RootSlice}).

DONE
				if pressReturn
				then
					break
				fi
			done
		fi

		if [ \${RootSize} -lt \${MinimumRootSize} ]
		then
			while :
			do
				0<<DONE cat -

The slicing information on the root file system's disk drive indicates
there are \${RootSize} 512-byte blocks \\
(the 'fs size' field for slice \${RootSlice})
in the root file system; this amount is insufficient to create the minimum
sized root file system.  In the step below, you must update the slicing
information in order to provide a minimum of \${MinimumRootSize} 512-byte
blocks in the new root file system.

DONE
				if pressReturn
				then
					break
				fi
			done
		fi

		if [ \${RootSize} -gt \${ddefsRootSize} ]
		then
			while :
			do
				0<<DONE cat -

The slicing information on the root file system's disk drive indicates
there are \${RootSize} 512-byte blocks \\
(the 'fs size' field for slice \${RootSlice})
in the root file system; this size will cause the new root file system
to overlap the swap area as defined in the operating system.  In the step
below, you must decrease the size of the root file system to a maximum of
\${ddefsRootSize} 512-byte blocks.

DONE
				if pressReturn
				then
					break
				fi
			done
		fi

		SwapSize=\`expr \${RootSliceSize} - \${RootSize}\`

		if [ \${SwapSize} -lt \${MinimumSwapSize} ]
		then
			while :
			do
				0<<DONE cat -

The slicing information on the root file system's disk drive indicates there
is \${SwapSize} 512-byte blocks (the 'sl size' field minus the 'fs size' field
for slice \${RootSlice}, below) allocated for the new swap area; this amount
is less than the minimum size supported.  In the step below, you must update
the slicing information in order \\
to provide a minimum of \${MinimumSwapSize} 512-byte
blocks for the new swap area slice.

DONE
				if pressReturn
				then
					break
				fi
			done
		fi
	else
		# [ \${RootSlice} != \${SwapSlice} ]

		if [ \${RootSliceSize} -lt \${MinimumRootSize} ]
		then
			while :
			do
				0<<DONE cat -

The slicing information on the root file system's disk drive indicates
there are \${RootSliceSize} 512-byte blocks \\
(the 'sl size' field for slice \${SwapSlice}, below)
in the root file system's slice; this amount is insufficient to create
the minimum sized root file system.  In the step below, you must provide
a minimum of \${MinimumRootSize} 512-byte blocks \\
in the new root file system's slice.

DONE
				if pressReturn
				then
					break
				fi
			done

		elif [ \${RootSize} -lt \${MinimumRootSize} ]
		then
			while :
			do
				0<<DONE cat -

The slicing information on the root file system's disk drive indicates there
are \${RootSize} 512-byte blocks \\
(the 'fs size' field for slice \${RootSlice}, below)
in the root file system; this amount is less than the minimum size supported.
In the step below, you must update the slicing information in order to provide
a minimum of \${MinimumRootSize} 512-byte blocks in the new root file system.

DONE
				if pressReturn
				then
					break
				fi
			done
		fi

		SwapSize=\`getSlfsedEntry \${SwapSlice} "sl size"\`

		if [ \${SwapSize} -lt \${MinimumSwapSize} ]
		then
			while :
			do
				0<<DONE cat -

The slicing information on the root file system's disk drive indicates there
are \${SwapSize} 512-byte blocks \\
(the 'sl size' field for slice \${SwapSlice}, below) in the
swap area's slice; this amount is less than the minimum size supported.
In the step below, you must update the slicing information in order to provide
a minimum of \${MinimumSwapSize} 512-byte blocks in the new swap area slice.

DONE
				if pressReturn
				then
					break
				fi
			done
		fi
	fi

	if \${usrOnRootDevice}
	then
		UsrSliceSize=\`getSlfsedEntry \${UsrSlice} "sl size"\`
		UsrSize=\`getSlfsedEntry \${UsrSlice} "fs size"\`

		if [ \${UsrSliceSize} -lt \${MinimumUsrSize} ]
		then
			while :
			do
				0<<DONE cat -

The slicing information on the root file system's disk drive indicates there
are \${UsrSliceSize} 512-byte blocks \\
(the 'sl size' field for slice \${UsrSlice},
below) in the usr file system's slice; this amount is insufficient to create
the minimum sized usr file system.  In the step below, you must update the
slicing information in order to provide a minimum of \\
\${MinimumUsrSize} 512-byte
blocks in the new usr file system's slice.

DONE
				if pressReturn
				then
					break
				fi
			done
		elif [ \${UsrSize} -lt \${MinimumUsrSize} ]
		then
			while :
			do
				0<<DONE cat -

The slicing information on the root file system's disk drive indicates there
is \${UsrSize} 512-byte blocks \\
(the 'fs size' field for slice \${UsrSlice},
below) in the usr file system; this amount is below the minimum size supported
for the usr file system.  In the step below, you must update the
slicing information in order to provide a minimum of \\
\${MinimumUsrSize} 512-byte
blocks in the new usr file system.

DONE
				if pressReturn
				then
					break
				fi
			done
		fi
	fi

	while :
	do
		if \${slicingErrors}
		then
			0<<DONE cat - \${slfsedOutput}

Examine the root file system's disk drive slicing information below;
the error(s) described above must be corrected before the installation
procedure can proceed.  You may modify the slicing information by
entering a 'y' at the prompt below; the msledit(1M) utility will
be executed to modify this information; afterwards, the slicing information
will be evaluated for any unresolved errors.  If you do not wish to
modify the slicing information on this disk drive (/dev/dsk/\${RootDevice}s7),
you may enter a 'q' at the prompt below, and the installation
procedure will be aborted.

DONE
		else

			0<<DONE cat - \${slfsedOutput}

Check the following slicing information for the root file system's disk
drive; indicate below whether you wish to modify this information:

DONE
		fi

		echo "
---> Modify any of these parameters? (y, n, ?, q): [n] \\c"

		read userResponse

		case \${userResponse} in
		"" )
			0<<DONE cat -

Selected not to modify these sizes and offsets.

DONE
			if \${slicingErrors}
			then
				break 1
			fi
			break 2
			;;
		n )
			if \${slicingErrors}
			then
				break 1
			fi
			break 2
			;;
		y )
			0<<DONE cat -

When using the msledit utility [see the sledit(1M) man page],
type 'help' for assistance on the utility's commands, '?' for
information on the current field.

DONE
			if \${usrOnRootDevice}
			then
				${SLFSED} -o \${slfsedOutput} \\
						-p \${RootSlice} \\
						-p \${SwapSlice} \\
						-p \${UsrSlice} \\
						-e \${slfsedOutput}
			else
				${SLFSED} -o \${slfsedOutput} \\
						-p \${RootSlice} \\
						-p \${SwapSlice} \\
						-e \${slfsedOutput}
			fi
			break 1
			;;
		\\? )
			0<<DONE cat -

If you wish to modify the displayed parameters, then enter a 'y'; if not,
then enter a 'n'.

If you wish to terminate execution of the installation procedure, enter
a 'q'; execution will resume at the main menu.

DONE
			;;
		q\\? )
			0<<DONE cat -

If you wish to terminate execution of the installation procedure, enter
a 'q'; execution will resume at the main menu.

DONE
			;;
		q )
			exit 1
			;;
		* )
			0<<DONE cat -

	Invalid response; please try again.

DONE
			;;
		esac
	done
done

if \${usrOnRootDevice}
then
	: already done
else
	if \${UsrDiskFormatDrive}
	then
		slfsedMode="-n \${UsrDiskDdefsName} \${UsrDiskDdefsName}"

	elif \${UsrHasASliceTable}
	then
		slfsedMode="-d /dev/rdsk/\${UsrDevice}s7"
	else
		slfsedMode=UNDEFINED
	fi

	slfsedOutput=\${usrSlfsedOutput}

	if 1>\${slfsedOutput} ${SLFSED} \${slfsedMode}
	then
		: Success
	else
		0<<DONE 1>&2 cat -

ERROR:	Unexpected slfsed(internal) error occurred.
	The installation procedure cannot proceed and is being aborted.

DONE
		exit 1
	fi

	unset slfsedMode


	# set usr file system's size to slice's size;

	modSliceInfo \${UsrSlice} \\
			\`getSlfsedEntry \${UsrSlice} "sl size"\` usr


	# Check for changes to the usr file system's
	# disk drive slicing information

	while :
	do
		slicingErrors=false

		UsrSliceSize=\`getSlfsedEntry \${UsrSlice} "sl size"\`
		UsrSize=\`getSlfsedEntry \${UsrSlice} "fs size"\`

		if [ \${UsrSliceSize} -lt \${MinimumUsrSize} ]
		then
			while :
			do
				0<<DONE cat -

The slicing information on the usr file system's disk drive indicates there
is \${UsrSliceSize} 512-byte blocks \\
(the 'sl size' field for slice \${UsrSlice},
below) in the usr file system's slice; this amount is insufficient to create
the minimum sized usr file system.  In the step below, you must update the
slicing information in order to provide a minimum of \\
\${MinimumUsrSize} 512-byte
blocks in the new usr file system's slice.

DONE
				if pressReturn
				then
					break
				fi
			done
		elif [ \${UsrSize} -lt \${MinimumUsrSize} ]
		then
			while :
			do
				0<<DONE cat -

The slicing information on the usr file system's disk drive indicates there
is \${UsrSize} 512-byte blocks \\
(the 'fs size' field for slice \${UsrSlice},
below) in the usr file system; this amount is below the minimum size supported
for the usr file system.  In the step below, you must update the
slicing information in order to provide a minimum of \\
\${MinimumUsrSize} 512-byte
blocks in the new usr file system.

DONE
				if pressReturn
				then
					break
				fi
			done
		fi

		while :
		do
			if \${slicingErrors}
			then
				0<<DONE cat - \${slfsedOutput}

Examine the usr file system's disk drive slicing information below;
the error(s) described above must be corrected before the installation
procedure can proceed.  You may modify the slicing information by
entering a 'y' at the prompt below; the msledit(1M) utility will
be executed to modify this information; afterwards, the slicing information
will be evaluated for any unresolved errors.  If you do not wish to
modify the slicing information on this disk drive (/dev/dsk/\${UsrDevice}s7),
you may enter a 'q' at the prompt below, and the installation
procedure will be aborted.

DONE
			else

				0<<DONE cat - \${slfsedOutput}

Check the following slicing information for the root file system's disk
drive; indicate below whether you wish to modify this information:

DONE
			fi

			echo "
---> Modify any of these parameters? (y, n, ?, q): [n] \\c"

			read userResponse

			case \${userResponse} in
			"" )
				0<<DONE cat -

Selected not to modify these sizes and offsets.

DONE
				if \${slicingErrors}
				then
					break 1
				fi
				break 2
				;;
			n )
				if \${slicingErrors}
				then
					break 1
				fi
				break 2
				;;
			y )
				0<<DONE cat -

When using the msledit utility [see the sledit(1M) man page],
type 'help' for assistance on the utility's commands, '?' for
information on the current field.

DONE
				${SLFSED} -o \${slfsedOutput} \\
						-p \${UsrSlice} \\
						-e \${slfsedOutput}
				break 1
				;;
			\\? )
				0<<DONE cat -

If you wish to modify the displayed parameters, then enter a 'y'; if not,
then enter a 'n'.

If you wish to terminate execution of the installation procedure, enter
a 'q'; execution will resume at the main menu.

DONE
				;;
			q\\? )
				0<<DONE cat -

If you wish to terminate execution of the installation procedure, enter
a 'q'; execution will resume at the main menu.

DONE
				;;
			q )
				exit 1
				;;
			* )
				0<<DONE cat -

	Invalid response; please try again.

DONE
				;;
			esac
		done
	done
fi


# Determine that all the entered information is correct

while :
do
	0<<DONE cat -

Check the information below.  If any part of the information is incorrect,
the previous questions will have to be answered again.

DONE
	if \${RootDiskFormatDrive}
	then
		0<<DONE cat -
	* Format and install the new bootloader on the \${RootControllerType},
	  controller #\${RootControllerNumber}, disk drive #\${RootDriveNumber},
	  using the ddefs(1M) description '\${RootDiskDdefsName}'.
DONE
	else
		0<<DONE cat -
	* Install the new bootloader on the \${RootControllerType}, \\
controller #\${RootControllerNumber},
	  drive #\${RootDriveNumber}, using the ddefs(1M) \\
description '\${RootDiskDdefsName}'.
DONE
	fi

	0<<DONE cat -

	* Create a root file system on slice \${RootSlice} on the
	  \${RootControllerType}, controller #\${RootControllerNumber}, \\
disk drive #\${RootDriveNumber}.

	* Create a swap area in slice \${SwapSlice} on the
	  \${RootControllerType}, controller #\${RootControllerNumber}, \\
disk drive #\${RootDriveNumber}.

DONE

	if \${UsrDiskFormatDrive}
	then
		0<<DONE cat -

	* Format the \${UsrControllerType}, controller #\${UsrControllerNumber},
	  disk drive #\${UsrDriveNumber}, using the ddefs(1M) \\
description '\${UsrDiskDdefsName}'.

DONE
	fi

	0<<DONE cat -
	* Create a usr file system on slice \${UsrSlice} on the
	  \${UsrControllerType}, controller #\${UsrControllerNumber}, \\
drive #\${UsrDriveNumber}.

DONE

	echo "\\
---> Is all of this information correct (y, n, q, ?): \\c"

	read userResponse

	case \${userResponse} in
	y )
		break
		;;
	n )
		exit 1
		;;
	\? )
		0<<DONE cat -

Enter a 'y' if the information displayed is correct,
an 'n' if the information is incorrect, or 
a 'q' if installation processing is to be aborted
and execution resumed at the main menu.
The 'n' and 'q' responses are functionally equivalent.

DONE
		;;
	q\\? )
		0<<DONE cat -

Enter a 'q' if the installation processing is to be aborted.
Execution will resume at the main menu.

DONE
		;;
	q )
		exit 1
		;;
	* )
		0<<DONE 1>&2 cat -

	Invalid response; please try again.

DONE
		;;
	esac
done

unset userResponse


# Confirm that the product's tape is in the tape drive

checkTape ()
{
	0<<DONE cat -
***> Checking tape in drive
DONE
!!!

if [ X"${DEBUG}" = X"true" ]
then
	0<<!!! cat -
	if 0<<DONE cat - |
${TapePACK}
${TapeDESC}
${TapeVER}
DONE
!!!
else
	0<<!!! cat -
	if ${IXF} -pdVc /dev/r41an |
!!!
fi

0<<!!! cat -
	   for expectedLine in \\
		"\${TapePACK}" \\
		"\${TapeDESC}" \\
		"\${TapeVER}"
	   do
		if read optionLine && \\
		   [ X"\${optionLine}" = X"\${expectedLine}" ]
		then
			: Success
		else
			exit 1
		fi
	   done
	then
		return 0
	else
		return 1
	fi
}

if checkTape
then
	: Success
else
	while :
	do
		0<<DONE cat -

Place the \${TapePACK} (\${TapeVER}) tape in the cartridge tape drive.

DONE
		echo "\\
---> Press the RETURN key when ready to continue (?, q): \\c"

		read userResponse

		case \${userResponse} in
		\\? )
			0<<DONE cat -

In order to install the ${ProductName} software, it is necessary
to read the ${ProductName} tape.  Place the ${ProductName} tape
in the cartridge tape drive, and press the RETURN key when
ready to proceed.

DONE
			;;
		q\\? )
			0<<DONE cat -

Enter 'q' if the installation processing is to be aborted.
Execution will resume at the main menu.

DONE
			;;
		q )
			exit 1
			;;
		* )
			if checkTape
			then
				break
			else
				0<<DONE 1>&2 cat -

	The tape in the cartridge tape drive is not the
	correct tape or is not properly installed in the drive.

	Check the tape and the tape drive.  Please try again.

DONE
			fi
		esac
	done
fi

unset checkTape


trap "
	0<<DONE cat -

ERROR:	Installation processing interrupted!
	Installation disk left in unknown state!
	Resuming execution at the main menu.
	
DONE 
	rm -f \${ddefsOutput} \${rootSlfsedOutput} \${usrSlfsedOutput}
	exit 1
" 1 2 3 15


0<<DONE cat -


Phase 3.  Prepare Installation Disk Drive(s)

DONE

0<<DONE cat -
***> Retensioning tape (in background)
DONE

${TAPECTL} -t /dev/r41t &


if [ X"\`${MOUNT}\`" != X"" ]
then
	0<<DONE cat -
***> Unmounting all mounted file systems
DONE
	${UMOUNTALL}
fi


# Format root and/or usr file systems' disk drive(s).
# Create and label root and usr file systems.

{
	if [ \${RootSlice} != \${SwapSlice} ]
	then
		0<<DONE cat -
\${RootControllerType} \${RootDiskFormatDrive} \${RootHasASliceTable} \\
	\${rootSlfsedOutput} \${RootDevice} \${RootDiskDdefsName} \\
	\${RootSlice} root \${RootSize}
\${RootControllerType} false \${RootHasASliceTable} \\
	\${rootSlfsedOutput} \${RootDevice} \${RootDiskDdefsName} \\
	\${SwapSlice} swap \${SwapSize}
DONE
	else
		0<<DONE cat -
\${RootControllerType} \${RootDiskFormatDrive} \${RootHasASliceTable} \\
	\${rootSlfsedOutput} \${RootDevice} \${RootDiskDdefsName} \\
	\${RootSlice} root \${RootSize}
DONE
	fi

	0<<DONE cat -
\${UsrControllerType} \${UsrDiskFormatDrive} \${UsrHasASliceTable} \\
	\${usrSlfsedOutput} \${UsrDevice} \${UsrDiskDdefsName} \\
	\${UsrSlice} usr \${UsrSize}
DONE

} | while read diskControllerType formatDisk diskHasASliceTable \\
	slfsedOutput diskDevice diskDdefsName \\
	sliceNumber fsName fsSize
do
	if \${formatDisk}
	then
		0<<DONE cat -
***> Formatting \${fsName} file system's disk drive
DONE
		if ${DINIT} -f -t \${BadSpotsDirectory}/\${diskDevice} \\
			\${diskDdefsName} /dev/rdsk/\${diskDevice}s7
		then
			: Success
		else
			0<<DONE cat -

ERROR:	Unexpected dinit(1M) error occurred.
	Installation processing cannot proceed and is being aborted.

DONE
			exit 1
		fi

	elif [ \${fsName} = swap ] ||
	     ( [ \${fsName} = usr ] && \${usrOnRootDevice} )
	then
		: do nothing
	else
		case \${diskControllerType} in
!!!

echo "${ControllerTypeFiles}" |
while read controllerTypeFile
do
	upgradeCommand=`
		diskctlrs UpgradeScriptFor: ${controllerTypeFile} |
	sed -e 's:\(\\\\*\)${deviceNode}:/dev/rdsk/\1${diskDevice}s7:g'`

	if [ X"${upgradeCommand}" != X"" ]
	then
		0<<!!! cat -
		`diskctlrs TypeFor: ${controllerTypeFile}` )
!!!
		eval "${upgradeCommand}"
		0<<!!! cat -
			;;
!!!
	fi
done

0<<!!! cat -
		esac
	fi

	if [ \${fsName} = swap ] ||
	   ( [ \${fsName} = usr ] && \${usrOnRootDevice} )
	then
		: do nothing

	elif \${formatDisk} || \${diskHasASliceTable}
	then
		0<<DONE cat -
***> Writing slice table to /dev/rdsk/\${diskDevice}s7
DONE
		if 0<\${slfsedOutput} ${SLFSED} -w /dev/rdsk/\${diskDevice}s7
		then
			: Success
		else
			0<<DONE cat -

ERROR:	Unexpected msledit(1M) error occurred with
	the /dev/rdsk/\${diskDevice}s7 device node.
	Installation processing cannot proceed and is being aborted.

DONE
			exit 1
		fi
	fi

	if [ \${fsName} != swap ]
	then
		0<<DONE cat -
***> Creating the \${fsName} file system
DONE
		if ${MKFS} /dev/rdsk/\${diskDevice}s\${sliceNumber} \${fsSize}
		then
			: Success
		else
			0<<DONE 1>&2 cat -

ERROR:	Unexpected mkfs(1) error.
	Could not create the \${fsSize} block \${fsName} file system on 
	the /dev/rdsk/\${diskDevice}s\${sliceNumber} device node.
	Installation processing cannot proceed and is being aborted.

DONE
			exit 1
		fi

		0<<DONE cat -
***> Labeling the \${fsName} file system
DONE
		if ${LABELIT} /dev/rdsk/\${diskDevice}s\${sliceNumber} \\
				\${fsName} \${BosReleaseName}
		then
			: Success
		else
			0<<DONE 1>&2 cat -

ERROR:	Unexpected labelit(1M) error.
	Could not label the \${fsName} file system on the
	/dev/rdsk/\${diskDevice}s\${sliceNumber} device node.
	Installation processing cannot proceed and is being aborted.

DONE
			exit 1
		fi
	fi
done

if [ \${?} -ne 0 ]
then
	exit 1
fi


# Install boot-loader on root file system's disk drive

0<<DONE cat -
***> Installing boot-loader on root file system's disk drive
DONE

if ${DINIT} -b /stand/m68k/boots/vmeboot \\
	\${RootDiskDdefsName} /dev/rdsk/\${RootDevice}s7
then
	: Success
else
	0<<DONE 1>&2 cat -

ERROR:	Unexpected dinit(1M) error.
	Could not install new boot-loader.
	Installation processing cannot proceed.

DONE
	exit 1
fi


# Mount root and usr file systems

mountFs ()
{
	fsName=\${1}
	fsCharNode=\${2}
	fsBlockNode=\${3}
	fsMount=\${4}

	while :
	do
		${FSSTAT} \${fsBlockNode}

		case \${?} in
		0 )
			0<<DONE cat -
***> Mounting \${fsName} file system as \${fsMount}
DONE
			if ${MOUNT} \${fsBlockNode} \${fsMount}
			then
				: Success
			else
				0<<DONE 1>&2 cat -

ERROR:	Unexpected mount(1M) error.
	Could not mount the \${fsName} file system using
	the \${fsBlockNode} device node as \${fsMount}.
	Installation processing cannot proceed and
	is being aborted.

DONE
				exit 1
			fi
			break
			;;
		1 )
			0<<DONE cat -
***> Checking integrity of the \${fsName} file system
DONE
			if ${FSCK} -y \${fsCharNode}
			then
				: Success
			else
				0<<DONE 1>&2 cat -

ERROR:	Unexpected fsck(1M) error.
	Could not check the integrity of the \${fsName} file system
	using the \${fsCharNode} device node.
	Installation processing cannot proceed.

DONE
				exit 1
			fi
			;;
		* )
			0<<DONE 1>&2 cat -

ERROR:	Unexpected fsstat(1M) error.
	Could not determine the status of the \${fsName} file system on
	the \${fsBlockNode} device node.
	Installation processing cannot proceed.

DONE
			exit 1
			;;
		esac
	done

	unset fsName fsCharNode fsBlockNode fsMount
	return 0
}

mountFs root /dev/rdsk/\${RootDevice}s\${RootSlice} \\
	/dev/dsk/\${RootDevice}s\${RootSlice} \${RootDirectory}

for directoryPath in tmp usr
do
	if [ ! -d \${RootDirectory}/\${directoryPath} ]
	then
		0<<DONE cat -
***> Making the /\${directoryPath} directory
DONE
		if ${MKDIR} \${RootDirectory}/\${directoryPath}
		then
			: Success
		else
			0<<DONE 1>&2 cat -

ERROR:	Unexpected mkdir(1) error.
	Could not make the \${directoryPath} directory.
	Installation processing cannot proceed.

DONE
			exit 1
		fi
	fi
done

mountFs usr /dev/rdsk/\${UsrDevice}s\${UsrSlice} \\
	/dev/dsk/\${UsrDevice}s\${UsrSlice} \${RootDirectory}/usr

unset mountFs


# Install ${ProductName} software

0<<DONE cat -


Phase 4.  Install ${ProductName} Software

DONE

0<<DONE cat -
***> Waiting for tape to complete retensioning
DONE

wait

0<<DONE cat -
***> Copying files; this will take from \${TapeReadTime} minutes
             depending upon your system configuration...
DONE

if ${IXF} -l 2,3 /dev/r41an
then
	: Success
else
	0<<DONE 1>&2 cat -

ERROR:	Unexpected ixf(1M) error.
	Could not read the ${ProductName} tape.
	Installation processing cannot proceed.

DONE
	exit 1
fi

0<<DONE cat - |
root \${RootDirectory}     /dev/rdsk/\${RootDevice}s\${RootSlice}
usr  \${RootDirectory}/usr /dev/rdsk/\${UsrDevice}s\${UsrSlice}
DONE
while read fsName fsMount fsCharNode
do
	0<<DONE cat -
***> Making the \${fsName} file system lost+found directory
DONE
	if ${MKLOSTFOUND} \${fsMount} \${fsCharNode}
	then
		: Success
	else
		0<<DONE 1>&2 cat -

ERROR:	Unexpected mklost+found(1M) error occurred.
	Could not create the \${fsName} file system lost+found directory.
	Installation processing cannot proceed.

DONE
		exit 1
	fi
done

for pathList in \\
	\${BadSpotsDirectory}/\${RootDevice} \\
	\${BadSpotsDirectory}/\${UsrDevice} 
do
	if [ -f /\${pathList} ] && [ ! -f \${RootDirectory}/\${pathList} ]
	then
		0<<DONE cat -
***> Installing /\${pathList} bad spot list
DONE
		if ${CP} /\${pathList} \${RootDirectory}/\${pathList}
		then
			: Success
		else
			0<<DONE 1>&2 cat -

ERROR:	Unexpected cp(1) error occurred.
	Could not copy the installation disk's bad spots list file,
	/\${BadSpotsDirectory}/\${RootDevice}, to
	\${RootDirectory}/\${BadSpotsDirectory}/\${RootDevice}.
	Installation processing cannot proceed.

DONE
			exit 1
		fi
	fi
done

if [ ! -d \${RootDirectory}/\${OptionsDirectory} ]
then
	0<<DONE cat -
***> Creating \${OptionsDirectory} directory
DONE
	if ${MKDIR} \${RootDirectory}/\${OptionsDirectory}
	then
		: Success
	else
		0<<DONE 1>&2 cat -

ERROR:	Unexpected mkdir(1M) error occurred.
	Could not create the \${OptionsDirectory} directory.
	Installation processing is being aborted.

DONE
		exit 1
	fi
fi

0<<DONE cat -
***> Creating sysadm(1M) package information file
DONE

!!!

if [ X"${DEBUG}" = X"true" ]
then
	0<<!!! cat -
if :
!!!
else
	0<<!!! cat -
if 1>\${RootDirectory}/\${OptionsDirectory}/\${TapePACK} ${IXF} -pdVc /dev/r41an
!!!
fi

0<<!!! cat -
then
	: Success
else
	0<<DONE 1>&2 cat -

ERROR:	Unexpected ixf(1M) error occurred.
	Could not create sysadm(1M) package information file,
	\${OptionsDirectory}/\${TapePACK}.
	Installation processing has failed to properly install
	the ${ProductName} product and is being aborted.

DONE
	exit 1
fi

0<<DONE cat -
***> Setting up the new operating system
DONE

0<<DONE cat - |
\${RootDirectory}/sysV68.rel \${RootDirectory}/stand/sysV68
\${RootDirectory}/sysV68.rel \${RootDirectory}/sysV68
\${RootDirectory}/master.rel \${RootDirectory}/stand/master
\${RootDirectory}/master.rel \${RootDirectory}/etc/master
DONE
while read sourcePath targetPath
do
	if ${LN} \${sourcePath} \${targetPath}
	then
		: Success
	else
		0<<DONE 1>&2 cat -

ERROR:	Unexpected ln(1) error occurred.
	Could not link \${sourcePath} to \${targetPath}.
	Installation processing has failed to properly install
	the ${ProductName} product and is being aborted.

DONE
		exit 1
	fi
done

0<<DONE cat -
***> Creating root and usr file system associated device nodes
DONE

0<<DONE cat - |
\${RootDirectory}/dev/dsk/\${RootDevice}s\${RootSlice}	\\
	\${RootDirectory}/dev/root
\${RootDirectory}/dev/rdsk/\${RootDevice}s\${RootSlice}	\\
	\${RootDirectory}/dev/rroot
\${RootDirectory}/dev/dsk/\${UsrDevice}s\${UsrSlice}	\\
	\${RootDirectory}/dev/usr
\${RootDirectory}/dev/rdsk/\${UsrDevice}s\${UsrSlice}	\\
	\${RootDirectory}/dev/rusr
DONE
while read nodeName nodeAlias
do
	if ${LN} \${nodeName} \${nodeAlias}
	then
		: Success
	else
		0<<DONE 1>&2 cat -

ERROR:	Unexpected ln(1) error occurred.
	Could not link '\${nodeName}' to '\${nodeAlias}'.
	Installation processing has failed to properly install
	the ${ProductName} product and is being aborted.

DONE
		exit 1
	fi
done

0<<DONE cat -
***> Setting permissions on installation disk's root directory
DONE

if ${CHMOD} 755 \${RootDirectory}
then
	: Success
else
	0<<DONE 1>&2 cat -

ERROR:	Unexpected chmod(1) error occurred.
	Could not change the modes on the \${RootDirectory} directory to 755.
	Installation processing has failed to properly install
	the ${ProductName} product and is being aborted.

DONE
	exit 1
fi

trap '' 1 2 3 15

0<<DONE cat -
***> Unmounting all mounted file systems
DONE

${UMOUNTALL}

0<<DONE cat -
***> Synchronizing the installation disk
DONE

sync
${SLEEP} 30

0<<DONE cat -






                 ${ProductName} product installation is completed.

   You must RESET the system and allow it to autoboot from the hard disk.






                       **************************
                       **** RESET THE SYSTEM ****
                       **************************






DONE

${SLEEP} 65000
#NOTREACHED
!!!

exit 0
