# @(#)install:upgrades/BS81.05/ArLib.sh	35.3
# ArchiveLib Merge Script
# Copyright 1988, Motorola, Inc.

# Merge consists of:
#	o Addition of 120Mb streaming tape entry;
#	o Modification of floppy devices entries from
#	  dev/rSA/*diskette to dev/SA/*diskette
#	  (i.e., use block devices);

RootDirectory=${RootDirectory:-/root}
ArchiveLib=${RootDirectory}/backups/files/ArchiveLib
TMPDIR=${TMPDIR:-${RootDirectory}/usr/tmp}

source=${TMPDIR}/al1$$
target=${TMPDIR}/al2$$

trap 'rm -f ${source} ${target}' 0 1 2 15

if cp ${ArchiveLib} ${source}
then
	: continue
else
	1>&2 echo "\t${ArchiveLib} NOT updated."
	exit 1
fi

1>/dev/null grep '.*-s.*120M' ${source}
case ${?} in
0 )
	: Found it, no need for an update.
	;;
1 )
	if 0<<!!! 1>${target} cat ${source} - &&
Streaming-Tape(120Mb)	/dev/rmt/m350_0t	-b 128k   -s 120M   -p
!!!
	   mv ${target} ${source}
	then
		: success, continue
	else
		echo "\t${ArchiveLib} NOT updated."
		exit 1
	fi
	;;
* )
	1>&2 echo "\t${ArchiveLib} NOT updated."
	exit 1
	;;
esac

if 0<${source} 1>${target} \
	sed -e 's:\(/dev/\)r\(SA/.*diskette\):\1\2:' &&
   cp ${target} ${ArchiveLib}
then
	: success, continue
else
	1>&2 echo "\t${ArchiveLib} NOT updated."
	exit 1
fi

exit 0
