# @(#)install:upgrades/BS83.08/ArLib.sh	35.2
# ArchiveLib Upgrade Script
# Copyright 1988, Motorola, Inc.
#
# Convert Streaming-Tape entry to Streaming-Tape(60Mb)
# remove the sccs id string too

RootDirectory=${RootDirectory:-/root}
ArchiveLib=${ArchiveLib:-${RootDirectory}/backups/files/ArchiveLib}
TMPDIR=${TMPDIR:-${RootDirectory}/usr/tmp}

source=${TMPDIR}/al1$$
destination=${TMPDIR}/al2$$

trap 'rm -f ${source} ${destination}' 0 1 2 15

# Note that the two entries below have white space differences, one is what
# comes from r3v2 and one is from later versions.  They are both here to
# upgrade the different releases.

if cp ${ArchiveLib} ${source} &&
   0<<!!! cat |
Streaming-Tape		/dev/r40t		-b 128k   -s 60M    -p
Streaming-Tape(60Mb)	/dev/r40t       	-b 128k   -s 60M    -p
Streaming-Tape		/dev/r40t       	-b 128k   -s 60M    -p
Streaming-Tape(60Mb)	/dev/r40t       	-b 128k   -s 60M    -p
!!!
	while read old_line && 
	      read new_line &&
	      0<${source} 1>${destination} \
		sed -e "s~^${old_line}$~${new_line}~" &&
	      fgrep -v '@(#)' ${destination} > ${source} &&
	      rm ${destination}
	do
		continue
	done
then
	if cp ${source} ${ArchiveLib}
	then
		: success
	else
		0<<!!! 1>&2 cat -
	Un-expected error.  ${ArchiveLib} possibly corrupted.
!!!
		exit 1
	fi
else
	0<<!!! 1>&2 cat -
	Merge error occurred.  ${ArchiveLib} has not been updated.
!!!
	exit 1
fi

exit 0
