#ident "@(#)install:upgrades/BS83.08/inittab.c	35.5"
/* BS83.08 Inittab Merge Program
 * Copyright 1988, Motorola, Inc.
 */

#include <sys/types.h>
#include <ctype.h>
#include <stdio.h>
#include <inittab.h>
#include <memory.h>
#include <string.h>

#define I_ARRAY_INC 16

#define DEF_ROOT_DIR "/root"
#define USER_INITTAB "/etc/inittab"

#define USAGE "Usage: %s [-v] [-N newinittab] [inittab...]\n"
#define OPTSTRING "vN:"

static int verbose = 0;
static char * my_name;
static char * inittab [ 128 ];

static INITTAB_T
	entry_fs = {
		'f', 's', '\0', '\0',
		0,
		M_SYSINIT,
		"/etc/bcheckrc </dev/console >/dev/console 2>&1"
	},
	entry_sm = {
		's', 'm', '\0', '\0',
		0,
		M_SYSINIT,
		"/etc/sglusr </dev/console >/dev/console 2>&1"
	},
	entry_mt = {
		'm', 't', '\0', '\0',
		MASK2 | MASK3,
		M_BOOTWAIT,
		"/etc/brc </dev/console >/dev/console 2>&1"
	},
	entry_is = {
		'i', 's', '\0', '\0',
		MASK2,
		M_INITDEFAULT,
		""
	},
	entry_p3 = {
		'p', '3', '\0', '\0',
		MASKSU | MASK1 | MASK2 | MASK3 | MASK4,
		M_PF,
		"/etc/shutdown -y -i0 -g0 >/dev/console 2>&1"
	},
	entry_s0 = {
		's', '0', '\0', '\0',
		MASK0 | MASK5 | MASK6,
		M_WAIT,
		"/etc/rc0 >/dev/console 2>&1 </dev/console"
	},
	entry_s1 = {
		's', '1', '\0', '\0',
		MASK1,
		M_WAIT,
		"/etc/shutdown -y -iS -g0 >/dev/console 2>&1 </dev/console"
	},
	entry_s2 = {
		's', '2', '\0', '\0',
		MASK2 | MASK3,
		M_WAIT,
		"/etc/rc2 >/dev/console 2>&1 </dev/console"
	},
	entry_s3 = {
		's', '3', '\0', '\0',
		MASK3,
		M_WAIT,
		"/etc/rc3 >/dev/console 2>&1 </dev/console"
	},
	entry_of = {
		'o', 'f', '\0', '\0',
		MASK0,
		M_WAIT,
		"/etc/uadmin 2 0 >/dev/console 2>&1 </dev/console"
	},
	entry_fw = {
		'f', 'w', '\0', '\0',
		MASK5,
		M_WAIT,
		"/etc/uadmin 2 2 >/dev/console 2>&1 </dev/console"
	},
	entry_rb = {
		'r', 'b', '\0', '\0',
		MASK6,
		M_WAIT,
		"/etc/uadmin 2 1 >/dev/console 2>&1 </dev/console"
	},
	entry_co = {
		'c', 'o', '\0', '\0',
		MASK2 | MASK3 | MASK4,
		M_RESPAWN,
		"/etc/getty console console"
	},
	entry_02 = {
		'0', '2', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty01 1200UUCP  # 2nd port on mvme131 card"
	},
	entry_03 = {
		'0', '3', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty mpcc0 9600 # 1st port on mvme050 card"
	},
	entry_04 = {
		'0', '4', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty mpcc1 9600 # 2nd port on mvme050 card"
	},
	entry_05 = {
		'0', '5', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty scc2 9600 # used for 147"
	},
	entry_06 = {
		'0', '6', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty scc3 9600 # used for 147"
	},
	entry_07 = {
		'0', '7', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty scc4 9600 # used for 147"
	},
	entry_08 = {
		'0', '8', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty02 9600 # 3rd port on processor card"
	},
	entry_09 = {
		'0', '9', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty03 9600 # 4th port on processor card"
	},
	entry_11 = {
		'1', '1', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty11 9600 # 1st port on 1st mvme332 card"
	},
	entry_12 = {
		'1', '2', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty12 9600 # 2nd port on 1st mvme332 card"
	},
	entry_13 = {
		'1', '3', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty13 9600 # 3rd port on 1st mvme332 card"
	},
	entry_14 = {
		'1', '4', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty14 9600 # 4th port on 1st mvme332 card"
	},
	entry_15 = {
		'1', '5', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty15 9600 # 5th port on 1st mvme332 card"
	},
	entry_16 = {
		'1', '6', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty16 9600 # 6th port on 1st mvme332 card"
	},
	entry_17 = {
		'1', '7', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty17 9600 # 7th port on 1st mvme332 card"
	},
	entry_18 = {
		'1', '8', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty18 9600 # 8th port on 1st mvme332 card"
	},
	entry_21 = {
		'2', '1', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty21 9600 # 1st port on 2nd mvme332 card"
	},
	entry_22 = {
		'2', '2', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty22 9600 # 2nd port on 2nd mvme332 card"
	},
	entry_23 = {
		'2', '3', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty23 9600 # 3rd port on 2nd mvme332 card"
	},
	entry_24 = {
		'2', '4', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty24 9600 # 4th port on 2nd mvme332 card"
	},
	entry_25 = {
		'2', '5', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty25 9600 # 5th port on 2nd mvme332 card"
	},
	entry_26 = {
		'2', '6', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty26 9600 # 6th port on 2nd mvme332 card"
	},
	entry_27 = {
		'2', '7', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty27 9600 # 7th port on 2nd mvme332 card"
	},
	entry_28 = {
		'2', '8', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty28 9600 # 8th port on 2nd mvme332 card"
	},
	entry_31 = {
		'3', '1', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty31 9600 # 1st port on 3rd mvme332 card"
	},
	entry_32 = {
		'3', '2', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty32 9600 # 2nd port on 3rd mvme332 card"
	},
	entry_33 = {
		'3', '3', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty33 9600 # 3rd port on 3rd mvme332 card"
	},
	entry_34 = {
		'3', '4', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty34 9600 # 4th port on 3rd mvme332 card"
	},
	entry_35 = {
		'3', '5', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty35 9600 # 5th port on 3rd mvme332 card"
	},
	entry_36 = {
		'3', '6', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty36 9600 # 6th port on 3rd mvme332 card"
	},
	entry_37 = {
		'3', '7', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty37 9600 # 7th port on 3rd mvme332 card"
	},
	entry_38 = {
		'3', '8', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty38 9600 # 8th port on 3rd mvme332 card"
	},
	entry_41 = {
		'4', '1', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty41 9600 # 1st port on 4th mvme332 card"
	},
	entry_42 = {
		'4', '2', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty42 9600 # 2nd port on 4th mvme332 card"
	},
	entry_43 = {
		'4', '3', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty43 9600 # 3rd port on 4th mvme332 card"
	},
	entry_44 = {
		'4', '4', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty44 9600 # 4th port on 4th mvme332 card"
	},
	entry_45 = {
		'4', '5', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty45 9600 # 5th port on 4th mvme332 card"
	},
	entry_46 = {
		'4', '6', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty46 9600 # 6th port on 4th mvme332 card"
	},
	entry_47 = {
		'4', '7', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty47 9600 # 7th port on 4th mvme332 card"
	},
	entry_48 = {
		'4', '8', '\0', '\0',
		MASK2 | MASK3,
		M_OFF,
		"/etc/getty tty48 9600 # 8th port on 4th mvme332 card"
	};

static INITTAB_T * new_inittab_entries [] = {
	& entry_fs, & entry_sm, & entry_mt, & entry_is, & entry_p3,
	& entry_s0, & entry_s1, & entry_s2, & entry_s3, & entry_of,
	& entry_fw, & entry_rb, & entry_co, & entry_02, & entry_03,
	& entry_04, & entry_05, & entry_06, & entry_07, & entry_11,
	& entry_12, & entry_13, & entry_14, & entry_15, & entry_16,
	& entry_17, & entry_18, & entry_21, & entry_22, & entry_23,
	& entry_24, & entry_25, & entry_26, & entry_27, & entry_28,
	& entry_31, & entry_32, & entry_33, & entry_34, & entry_35,
	& entry_36, & entry_37, & entry_38, & entry_41, & entry_42,
	& entry_43, & entry_44, & entry_45, & entry_46, & entry_47,
	& entry_48, NULL
};

static INITTAB_T ** new_inittab_array = new_inittab_entries;

int
main( argc, argv, envp )
int argc;
char *argv[], *envp[];
{
	extern char * optarg, * getenv (), * strcpy (), * strcat ();
	extern int optind;

	INITTAB_T ** read_inittab_array ();
	int update();
	void free_inittab_array ();

	int count;
	char * root;

	verbose = count = 0;
	my_name = argv[0];

	if ( ( root = getenv ( "RootDirectory" ) ) == NULL )
		root = DEF_ROOT_DIR;

	strcpy ( inittab, root );
	strcat ( inittab, USER_INITTAB );

	for ( ; ; ) {
		switch ( getopt ( argc, argv, OPTSTRING ) ) {
		case -1:
			break;
		case 'N':
			new_inittab_array = read_inittab_array ( optarg );
			if ( new_inittab_array == NULL )
				return ( 1 );
			continue;
		case 'v':
			--verbose;
			continue;
		case '?':
			count ++;
			continue;
		}
		break;
	}

	if ( count ) {
		fprintf ( stderr, USAGE, my_name );
		return ( 2 );
	}

	if ( optind == argc )
		count = update ( inittab );
	else
		while ( optind < argc )
			count += update ( argv[ optind ++ ] );

	return ( count );
}

static int
update ( filename )
char * filename;
{
	INITTAB_F * in_inittab_f, * out_inittab_f;
	INITTAB_T ** new_inittab_a, ** inittab_a, ** inittab_array,
			** old_inittab_array;
	char * tempname, * buffer, * ptr;
	int count, any_changes;

	extern char * malloc ();
	extern void free ();
	INITTAB_T ** read_inittab_array (), ** expand_inittab_array (),
			* dup_inittab ();
	void free_inittab_array (), update_error (), sort_inittab_array ();
	int inittab_p_cmp ();

	if ( verbose )
		printf ( "%s:\n", filename );

	if ( ( inittab_array = read_inittab_array ( filename ) ) == NULL )
		return ( 1 );

	count = 0;
	for ( inittab_a = inittab_array; * inittab_a != NULL; inittab_a ++ )
		count ++;

	/*   Combine the two inittab collections together and
	 *   then output the new collection.
	 *   Remove new inittabs which are already defined on the user's system.
	 */
	any_changes = 0;
	for ( new_inittab_a = new_inittab_array;
	      * new_inittab_a != NULL;
	      new_inittab_a ++ ) {
		for ( inittab_a = inittab_array;
		      * inittab_a != NULL;
		      inittab_a ++ )
			if ( strncmp ( ( * new_inittab_a ) -> c_id,
					( * inittab_a ) -> c_id, 4 ) == 0 )
				break;
		if ( * inittab_a == NULL ) {
			inittab_array =
	expand_inittab_array ( old_inittab_array = inittab_array );
			if ( inittab_array == NULL ) {
				update_error ( NULL );
				free_inittab_array ( old_inittab_array );
				return ( 1 );
			}
			if ( verbose ) {
				fputs ( "\tadding '", stdout );
				ptr = ( * new_inittab_a ) -> c_id;
				while ( ( * ptr != '\0' ) &&
					( ptr < & ( * new_inittab_a ) ->
							c_id [ 4 ] ) )
					fputc ( * ptr ++, stdout );
				puts ( "' entry." );
			}
			if ( ( inittab_array [ count ++ ] =
					dup_inittab ( * new_inittab_a ) ) ==
						NULL ) {
				update_error ( NULL );
				free_inittab_array ( inittab_array );
				return ( 1 );
			}
			any_changes ++;
		}
	}

	if ( ! any_changes ) {
		if ( verbose )
			puts ( "\tNo changes required - no action taken." );
	} else {
		tempname = tempnam ( NULL, "bsei" );
		if ( tempname == NULL ) {
			update_error ( NULL );
			free_inittab_array ( inittab_array );
			return ( 1 );
		}
		out_inittab_f = openinittab ( tempname, "w" );
		if ( out_inittab_f == NULL ) {
			update_error ( tempname );
			free ( tempname );
			free_inittab_array ( inittab_array );
			return ( 1 );
		}

		sort_inittab_array ( inittab_array );

		for ( inittab_a = inittab_array;
		      * inittab_a != NULL;
		      inittab_a ++ )
			if ( writeinittab ( out_inittab_f, * inittab_a ) ) {
				update_error ( tempname );
				if ( unlink ( tempname ) )
					update_error ( tempname );
				free ( tempname );
				free_inittab_array ( inittab_array );
				return ( 1 );
			}

		free_inittab_array ( inittab_array );

		if ( closeinittab ( out_inittab_f ) ) {
			update_error ( tempname );
			if ( unlink ( tempname ) )
				update_error ( tempname );
			free ( tempname );
			return ( 1 );
		}
		buffer = malloc( BUFSIZ );
		if ( buffer == NULL ) {
			update_error ( NULL );
			if ( unlink ( tempname ) )
				update_error ( tempname );
			free ( tempname );
			return ( 1 );
		}
		sprintf ( buffer, "mv %s %s", tempname, filename );
		if ( system ( buffer ) ) {
			free ( buffer );
			if ( unlink ( tempname ) )
				update_error ( tempname );
			free ( tempname );
			return ( 1 );
		}
		free ( buffer );
	}
	free ( tempname );
	return ( 0 );
}

static INITTAB_T **
read_inittab_array ( filename )
{
	INITTAB_T * inittab_t, ** inittab_array, ** old_inittab_array;
	INITTAB_F * inittab_f;
	int count;

	INITTAB_T * dup_inittab (), ** create_inittab_array (),
			 ** expand_inittab_array ();
	void free_inittab_array (), update_error ();

	inittab_f = openinittab ( filename, "r" );
	if ( inittab_f == NULL ) {
		update_error ( filename );
		return ( NULL );
	}
	inittab_array = create_inittab_array ();
	if ( inittab_array == NULL ) {
		update_error ( NULL );
		if ( closeinittab ( inittab_f ) )
			update_error ( filename );
		return ( NULL );
	}
	count = 0;
	while ( ! ( feof ( inittab_f -> init_fp ) ||
			ferror ( inittab_f -> init_fp ) ) )
		if ( ( inittab_t = readinittab ( inittab_f ) ) != NULL ) {
			inittab_array =
	expand_inittab_array ( old_inittab_array = inittab_array );
			if ( inittab_array == NULL ) {
				update_error ( NULL );
				free_inittab_array ( old_inittab_array );
				if ( closeinittab ( inittab_f ) )
					update_error ( filename );
				return ( NULL );
			}
			if ( ( inittab_array [ count ++ ] =
					dup_inittab ( inittab_t ) ) == NULL ) {
				update_error ( NULL );
				if ( closeinittab ( inittab_f ) )
					update_error ( filename );
				free_inittab_array ( inittab_array );
				return ( NULL );
			}
		}

	if ( ! feof ( inittab_f -> init_fp ) ) {
		update_error ( filename );
		closeinittab ( inittab_f );
		free_inittab_array ( inittab_array );
		return ( NULL );
	}
	if ( closeinittab ( inittab_f ) ) {
		update_error ( filename );
		free_inittab_array ( inittab_array );
		return ( NULL );
	}
	return ( inittab_array );
}

typedef struct {
	int	ga_size;	/* total size in bytes */
	int	ga_avail;	/* entries available */
	INITTAB_T * ga_first;	/* first entry */
} _INITTAB_ARRAY;

static INITTAB_T **
create_inittab_array ()
{
	_INITTAB_ARRAY  * _inittab_array;
	extern char * malloc ();

	_inittab_array = ( _INITTAB_ARRAY * )
malloc ( sizeof ( _INITTAB_ARRAY ) + I_ARRAY_INC * sizeof ( INITTAB_T * ) );
	if ( _inittab_array == NULL )
		return ( NULL );
	
	_inittab_array -> ga_size =
sizeof ( _INITTAB_ARRAY ) + I_ARRAY_INC * sizeof ( INITTAB_T * );
	_inittab_array -> ga_avail = I_ARRAY_INC;

	memset ( & _inittab_array -> ga_first, '\0',
			 ( I_ARRAY_INC + 1 ) * sizeof ( INITTAB_T * ) );

	return ( & _inittab_array -> ga_first );
}

static INITTAB_T **
expand_inittab_array ( inittab_array )
INITTAB_T ** inittab_array;
{
	_INITTAB_ARRAY * _inittab_array;
	int old_size;
	extern char * realloc ();

	_inittab_array = ( _INITTAB_ARRAY * )
( ( ( char * ) inittab_array ) - ( sizeof ( int ) * 2 ) );
	if ( ! _inittab_array -> ga_avail ) {
		old_size = _inittab_array -> ga_size;
		_inittab_array -> ga_size +=
				( I_ARRAY_INC * sizeof ( INITTAB_T * ) );

		_inittab_array =
( _INITTAB_ARRAY * ) realloc ( _inittab_array, _inittab_array -> ga_size );
		if ( _inittab_array == NULL )
			return ( NULL );

		memset ( ( ( char * ) _inittab_array ) + old_size,
			'\0', I_ARRAY_INC * sizeof ( INITTAB_T * ) );
		_inittab_array -> ga_avail = I_ARRAY_INC;
	}
	( _inittab_array -> ga_avail ) -- ;
	return ( & _inittab_array -> ga_first );
}

static void
sort_inittab_array ( inittab_array )
INITTAB_T ** inittab_array;
{
	extern void qsort ();
	int cmp_inittab ();

	INITTAB_T ** inittab_a;
	int count;

	count = 0;
	for ( inittab_a = inittab_array; * inittab_a != NULL; inittab_a ++ )
		count ++;

	qsort ( (char *) inittab_array, count,
		sizeof ( INITTAB_T * ), cmp_inittab );
}

static void
free_inittab_array ( inittab_array )
INITTAB_T ** inittab_array;
{
	extern void free ();
	void free_inittab ();

	INITTAB_T ** inittab_a;

	for ( inittab_a = inittab_array; * inittab_a != NULL; inittab_a ++ )
		free_inittab ( * inittab_a );
	free ( inittab_array );
}

static INITTAB_T *
dup_inittab ( inittab_t )
INITTAB_T * inittab_t;
{
	INITTAB_T * n_inittab_t;
	char * buffer_p;
	int members_length;

	buffer_p = malloc ( sizeof ( INITTAB_T ) +
				strlen ( inittab_t -> c_command ) + 1 );
	if ( buffer_p == NULL ) {
		update_error ( NULL );
		return ( NULL );
	}
	n_inittab_t = ( INITTAB_T * ) buffer_p;
	buffer_p += sizeof ( INITTAB_T );

	memcpy ( n_inittab_t -> c_id, inittab_t -> c_id, 4 );
	n_inittab_t -> c_levels = inittab_t -> c_levels;
	n_inittab_t -> c_action = inittab_t -> c_action;
	n_inittab_t -> c_command  = strcpy ( buffer_p, inittab_t -> c_command );

	return ( n_inittab_t );
}

static int
cmp_inittab ( a_inittab_t, b_inittab_t )
INITTAB_T ** a_inittab_t, ** b_inittab_t;
{
	extern int strcmp (), strncmp ();

	if ( ! strcmp ( ( * a_inittab_t ) -> c_id, "fs" ) )
		return ( -1 );
	
	if ( ! strcmp ( ( * b_inittab_t ) -> c_id, "fs" ) )
		return ( 1 );
	
	if ( ! strcmp ( ( * a_inittab_t ) -> c_id, "sm" ) )
		return ( -1 );
	
	if ( ! strcmp ( ( * b_inittab_t ) -> c_id, "sm" ) )
		return ( 1 );

	if ( isalpha ( ( * a_inittab_t ) -> c_id [ 0 ] ) )
		return ( -1 );

	if ( isalpha ( ( * b_inittab_t ) -> c_id [ 0 ] ) )
		return ( 1 );

	return ( strncmp ( ( * a_inittab_t ) -> c_id,
				( * b_inittab_t ) -> c_id, 4 ) );
}

static void
free_inittab ( inittab_t )
INITTAB_T * inittab_t;
{
	extern void free () ;

	free ( ( char * ) inittab_t );
}

static void
update_error ( string )
char * string;
{
	fprintf ( stderr, ( string == NULL ) ? "%s: " : "%s: %s: ",
			my_name, string );
	perror ( NULL );
	return;
}
