# @(#)install:upgrades/FE83.15/ArLib.sh	35.3
# ArchiveLib Upgrade Script
# Copyright 1988, Motorola, Inc.
#
# Convert /dev/rmt/m350_0t references to equiv. generic tape node, /dev/r40t

RootDirectory=${RootDirectory:-/root}
ArchiveLib=${ArchiveLib:-${RootDirectory}/backups/files/ArchiveLib}
TMPDIR=${TMPDIR:-${RootDirectory}/usr/tmp}

source=${TMPDIR}/al1$$
destination=${TMPDIR}/al2$$

trap 'rm -f ${source} ${destination}' 0 1 2 15

if cp ${ArchiveLib} ${source} &&
   0<<!!! cat |
Streaming-Tape		/dev/rmt/m350_0t	-b 128k   -s 60M    -p
Streaming-Tape		/dev/r40t       	-b 128k   -s 60M    -p
Streaming-Tape(120Mb)	/dev/rmt/m350_0t	-b 128k   -s 120M   -p
Streaming-Tape(120Mb)	/dev/r40t       	-b 128k   -s 120M   -p
!!!
	while read old_line && 
	      read new_line &&
	      0<${source} 1>${destination} \
		sed -e "s~^${old_line}$~${new_line}~" &&
	      mv ${destination} ${source}
	do
		continue
	done
then
	if cp ${source} ${ArchiveLib}
	then
		: success
	else
		0<<!!! 1>&2 cat -
	Un-expected error.  ${ArchiveLib} possibly corrupted.
!!!
		exit 1
	fi
else
	0<<!!! 1>&2 cat -
	Merge error occurred.  ${ArchiveLib} has not been updated.
!!!
	exit 1
fi

exit 0
