# @(#)install:upgrades/upgrades.mk	35.1
# BOS/BSE Upgrade Procedures Makefile
# Copyright 1988, Motorola, Inc.

MBFS_MOUNT=/mbfs

all:
	@isSuccessful=true;						\
	for release in *;						\
	do								\
		if [ -d $${release} ] &&				\
		   [ -f $${release}/$${release}.mk ];			\
		then							\
			echo "\tmake -f $${release}.mk $@";		\
			cd $${release};					\
			if make -f $${release}.mk $@;			\
			then						\
				: Success;				\
			else						\
				isSuccessful=false;			\
			fi;						\
			cd ..;						\
		fi;							\
	done;								\
	$${isSuccessful}

install: all
	@isSuccessful=true;						\
	for release in *;						\
	do								\
		if [ -d $${release} ] &&				\
		   [ -f $${release}/$${release}.mk ];			\
		then							\
			echo "\tmake -f $${release}.mk $@";		\
			cd $${release};					\
			if make -f $${release}.mk			\
				MBFS_MOUNT=$(MBFS_MOUNT) $@;		\
			then						\
				: Success;				\
			else						\
				isSuccessful=false;			\
			fi;						\
			cd ..;						\
		fi;							\
	done;								\
	$${isSuccessful}

clean:
	@for release in *;						\
	do								\
		if [ -d $${release} ] &&				\
		   [ -f $${release}/$${release}.mk ];			\
		then							\
			echo "\tmake -f $${release}.mk $@";		\
			cd $${release};					\
			make -f $${release}.mk $@;			\
			cd ..;						\
		fi;							\
	done

clobber: clean
	@for release in *;						\
	do								\
		if [ -d $${release} ] &&				\
		   [ -f $${release}/$${release}.mk ];			\
		then							\
			echo "\tmake -f $${release}.mk $@";		\
			cd $${release};					\
			make -f $${release}.mk $@;			\
			cd ..;						\
		fi;							\
	done
