#ident	"@(#)sigs.c	35.1"
#include	<stdio.h>
#include	<signal.h>

static	sigprint();

/*
 * The following routines, sigblock(), sigsetmask(), are
 * provided to preserve the BSD signal interface. The sigmask macro
 * is at the top of this file. There are suttle differences in the way
 * they behave.
 */
static int	Holdsigs = 0;			/* assuming 32bit int */
int		Sig_bug = 0;			/* signal debug flag */

sigblock(mask)
int	mask;
{
	register	curbit, i;
	int		omask = Holdsigs;

/**/	sigprint("block", mask);

	for (curbit=1, i=1; i < NSIG; i++, curbit <<= 1) {
		if (curbit & mask && (curbit&Holdsigs) == 0) { /* want held and not held */
			if (sighold(i) == 0) {			/* hold */
				Holdsigs |= curbit;		/* note it */
			}
		}
	}
/**/	sigprint("blocked", Holdsigs);
	return(omask);
}

sigsetmask(mask)
int	mask;
{
	int		omask = Holdsigs;
	register	curbit, i;

	for (curbit=1, i=1; i < NSIG; i++, curbit <<= 1) {
		if ( curbit & mask ) {			/* want held */
			if ((curbit&Holdsigs) == 0) {		/* not held */
				if (sighold(i) == 0) {		/* hold */
					Holdsigs |= curbit;	/* note it */
				}
			}
		}
		else {					/* want released */
			if ( curbit & Holdsigs ) {		/* is held */
				if (sigrelse(i) == 0) {		/* release */
					Holdsigs &= ~curbit;	/* note it */
				}
			}
		}
	}
/**/	sigprint("setmask", mask);
	return(omask);
}

/*
 * DEBUG code for signal handling.
 */
char	*Signam[] = {
	"NONE",
	"HUP",
	"INT",
	"QUIT",
	"ILL",
	"TRAP",
	"IOT/ABRT",
	"EMT",
	"FPE",
	"KILL",
	"BUS",
	"SEGV",
	"SYS",
	"PIPE",
	"ALRM",
	"TERM",
	"USR1",
	"USR2",
	"CLD",
	"PWR",
	"URG",
	"UNDEF",
	"POLL",
};

static
sigprint(s, mask)
char	*s;
int	mask;
{
	register	curbit, i;

	if (! Sig_bug) {
		return;
	}

	fprintf(stderr, "%s (0x%x): ", s, mask);
	if ( ! mask ) {
		fprintf(stderr, "\n");
		return;
	}

	for (curbit=1, i=1; i < NSIG; i++, curbit <<= 1) {
		if (curbit & mask) {
			fprintf(stderr, "%s ", Signam[i]);
		}
	}
	fprintf(stderr, "\n");
	fflush(stderr);
	return;
}
