#ident	"@(#)libc-port:gen/ttyname.c	35.2	88/09/12	"
#ident  "Copyright (c) 1984 AT&T, INC."
#ident  "Copyright (c) 1985 MOTOROLA, INC."

/*LINTLIBRARY*/
/*
 * ttyname(f): return "/dev/ttyXX" which the the name of the
 * tty belonging to file f.
 *
 * This program works in two passes: the first pass tries to
 * find the device by matching device and inode numbers; if
 * that doesn't work, it tries a second time, this time doing a
 * stat on every file in /dev and trying to match device numbers
 * only. If that fails too, NULL is returned.
 */

#define	NULL	0
#include <sys/types.h>
/*
** include header file for directory definitions
*/
#include <dirent.h>
#include <sys/stat.h>

extern int stat(), fstat(), isatty();
extern char *strcpy(), *strcat();
extern long lseek();

static char rbuf[32], dev[]="/dev/";

char *
ttyname(f)
int	f;
{
	struct stat fsb;
	struct stat tsb;
	register struct dirent *db;
	register DIR *df;
	int pass1 = 0;

	if(isatty(f) == 0)
		return(NULL);
	if(fstat(f, &fsb) < 0)
		return(NULL);
	if((fsb.st_mode & S_IFMT) != S_IFCHR)
		return(NULL);

/*
** open the directory using directory functions
**	Changed by PEG 2/8/88
*/

	if ((df = opendir(dev)) == NULL)
		return(NULL);

	/*
	** read the directory using directory functions
	**	Changed by PEG 2/8/88
	*/

	pass1 = 1;
	do {
		while((db = readdir(df)) != NULL) {

			if(db->d_ino == 0)
				continue;
			if(pass1 && db->d_ino != fsb.st_ino)
				continue;
			(void) strcpy(rbuf, dev);
			(void) strcat(rbuf, db->d_name);
			if(stat(rbuf, &tsb) < 0)
				continue;
			if(tsb.st_rdev == fsb.st_rdev &&
				(tsb.st_mode&S_IFMT) == S_IFCHR &&
				(!pass1 || tsb.st_ino == fsb.st_ino))
			{
				/*
				** close the directory using directory operations
				**      Changed by PEG 2/8/88
				*/
				(void) closedir(df);
				return(rbuf);
			}
		}
		(void) lseek(df, 0L, 0);
	} while(pass1--);
	/*
	** close the directory using directory operations
	**      Changed by PEG 2/8/88
	*/
	(void) closedir(df);
	return(NULL);
}
