#
# @(#)libinet.mk	35.1
# Copyright (c) 1987 Motorola Computer Division	
#   All Rights Reserved 
#
# Makefile for libinet.a, the BSD Internet interface routines.
#
ROOT =
CC = cc
LIBDIR = .
INCDIR = $(ROOT)/usr/include
USRLIB = $(ROOT)/usr/lib
LIBNAME = libinet.a
LLIB = inet
LINTLIB = llib-l$(LLIB).ln
LOG=
PROFILE=
DEBUG=
CFLAGS=-O -I $(INCDIR) $(DEBUG) $(LOG) $(PROFILE)
SRC= 	bcmp.c byte.c gethostn.c \
	inet_addr.c  \
	inet_lnaof.c in_makeadd.c inet_netof.c in_network.c \
	inet_ntoa.c netdb.c rcmd.c ruserpass.c

FILES = $(LIBNAME)(bcmp.o) \
	$(LIBNAME)(byte.o) \
	$(LIBNAME)(gethostn.o) \
	$(LIBNAME)(inet_addr.o) \
	$(LIBNAME)(inet_lnaof.o) \
	$(LIBNAME)(in_makeadd.o) \
	$(LIBNAME)(inet_netof.o) \
	$(LIBNAME)(in_network.o) \
	$(LIBNAME)(inet_ntoa.o) \
	$(LIBNAME)(netdb.o) \
	$(LIBNAME)(rcmd.o) \
	$(LIBNAME)(ruserpass.o)

lib:	$(LIBNAME)

lint:
	lint -uax -DLOGGING -o $(LLIB) $(SRC)

install: lib
	cp $(LIBNAME) $(USRLIB)

uninstall:
	-rm $(USRLIB)/$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

.s.a:
	$(AS) -o $*.o $<
	$(AR) $(ARFLAGS) $@ $*.o
	rm -f $*.o

$(LIBNAME):	$(FILES)

clean:
	-rm -f *.o

clobber: clean
	-rm -f $(LIBNAME)

#### dependencies now follow
$(LIBNAME)(bcmp.o): bcmp.c \
	$(FRC)

$(LIBNAME)(byte.o): byte.c \
	$(FRC)

$(LIBNAME)(gethostn.o): gethostn.c \
	$(INCDIR)/sys/utsname.h \
	$(FRC)

$(LIBNAME)(inet_addr.o): inet_addr.c \
	$(INCDIR)/sys/types.h \
	$(INCDIR)/netinet/types.h \
	$(INCDIR)/ctype.h \
	$(INCDIR)/netinet/in.h \
	$(FRC)

$(LIBNAME)(inet_lnaof.o): inet_lnaof.c \
	$(INCDIR)/sys/types.h \
	$(INCDIR)/netinet/types.h \
	$(INCDIR)/netinet/in.h \
	$(FRC)

$(LIBNAME)(in_makeadd.o): in_makeadd.c \
	$(INCDIR)/sys/types.h \
	$(INCDIR)/netinet/types.h \
	$(INCDIR)/netinet/in.h \
	$(FRC)

$(LIBNAME)(inet_netof.o): inet_netof.c \
	$(INCDIR)/sys/types.h \
	$(INCDIR)/netinet/types.h \
	$(INCDIR)/netinet/in.h \
	$(FRC)

$(LIBNAME)(in_network.o): in_network.c \
	$(INCDIR)/sys/types.h \
	$(INCDIR)/netinet/types.h \
	$(INCDIR)/ctype.h \
	$(FRC)

$(LIBNAME)(inet_ntoa.o): inet_ntoa.c \
	$(INCDIR)/sys/types.h \
	$(INCDIR)/netinet/types.h \
	$(INCDIR)/netinet/in.h \
	$(FRC)

$(LIBNAME)(netdb.o): netdb.c \
	$(INCDIR)/sys/types.h \
	$(INCDIR)/netinet/types.h \
	$(INCDIR)/netinet/in.h \
	$(INCDIR)/sys/socket.h \
	$(INCDIR)/netdb.h \
	$(INCDIR)/stdio.h \
	$(FRC)

$(LIBNAME)(rcmd.o): rcmd.c \
	$(INCDIR)/stdio.h \
	$(INCDIR)/sys/types.h \
	$(INCDIR)/netinet/types.h \
	$(INCDIR)/sys/errno.h \
	$(INCDIR)/sys/socket.h \
	$(INCDIR)/netinet/in.h \
	$(INCDIR)/netdb.h \
	$(FRC)

$(LIBNAME)(ruserpass.o): ruserpass.c \
	$(INCDIR)/stdio.h \
	$(INCDIR)/stdio.h \
	$(INCDIR)/sys/types.h \
	$(INCDIR)/utmp.h \
	$(INCDIR)/ctype.h \
	$(INCDIR)/sys/stat.h \
	$(INCDIR)/sys/errno.h \
	$(FRC)
