/*		Copyright (c) 1985 AT&T		*/
/*		All Rights Reserved		*/
/* @(#)exp.c	6.1	 */
/*	Added to Ferranti System V by msw 21/3/89 */

/*	@(#)exp.c	6.1		*/
/*	@(#)exp.c	1.11	*/
/*LINTLIBRARY*/
/*
 *	exp returns the exponential function of its double-precision argument.
 *	Returns ERANGE error and value 0 if argument too small,
 *	   value HUGE if argument too large.
 */

#include <math.h>
#include <values.h>
#include <errno.h>
#include <sys/fpu.h>

double
exp(x)
register double x;
{
	double y;
	struct exception exc;
	register unsigned int status = etox881(x,&y);

	if (!(status & (EXC_OVFL|EXC_UNFL|FPCC_NAN|FPCC_I)))
		return(y); /* No important error conditions found */

	exc.arg1 = x;
	exc.name = "exp";

	if (status & EXC_UNFL) {	/* Underflow condition */
		exc.type = UNDERFLOW;
		exc.retval = 0.0;
		if (!matherr(&exc))
			errno = ERANGE;
		return (exc.retval);
	}

	if (status & (EXC_OVFL|FPCC_I)) {/* Overflow or input +inf. */
		exc.type = OVERFLOW;
		exc.retval = HUGE;
		if (!matherr(&exc)) 
			errno = ERANGE;
		return (exc.retval);
	}

	if (status & (FPCC_NAN)) {/* Input was a NaN! */
		exc.type = DOMAIN;
		exc.retval = 0.0;
		if (!matherr(&exc)) 
			{
			(void) write(2, exc.name, 4);
			(void) write(2, ": DOMAIN error\n", 15);
			errno = EDOM;
			}
		return (exc.retval);
	}
}
