/*		Copyright (c) 1985 AT&T		*/
/*		All Rights Reserved		*/
/* @(#)sin.c	6.2	 */
/*	Added to Ferranti System V by msw 21/3/89 */

/*	@(#)sin.c	6.1		*/
/*	@(#)sin.c	1.13	*/
/*LINTLIBRARY*/
/*
 *	sin and cos of double-precision argument.
 *	Returns ERANGE error and value 0 if argument too large.
 */

#include <math.h>
#include <values.h>
#include <errno.h>
#include <sys/fpu.h>

double
sin(x)
double x;
{
	extern double sin_cos();

	return (sin_cos(x, 0));
}

static double
sin_cos(x, cosflag)
register double x;
int cosflag;
{
	register double y;
	struct exception exc;
	
	exc.arg1 = x;
	y = x;
	if (x < 0) {
		y = -y;
	}
	if (cosflag) {
		y += M_PI_2;
		exc.name = "cos";
	} else
		exc.name = "sin";
	exc.type =NOEXC;
	if (y > X_TLOSS) {
		exc.type = TLOSS;
	} else  {
		/* Normal case. */
		double z;
		register unsigned int excep;
		excep = cosflag ? cos881(x,&z) : sin881(x,&z);
		if (excep & (FPCC_NAN|EXC_OPER))
			exc.type = TLOSS; /* NaN or infinity returned from
					  ** sin or cos */
		else
			exc.retval = z;
	}
	if (exc.type == TLOSS) {
		exc.retval = 0.0;
		if (!matherr(&exc)) {
			(void) write(2, exc.name, 3);
			(void) write(2, ": TLOSS error\n", 14);
			errno = ERANGE;
		}
		return (exc.retval);
	}
	if (exc.arg1 > X_PLOSS || exc.arg1 < -X_PLOSS) {
		exc.type = PLOSS;
		if (!matherr(&exc))
			errno = ERANGE;
	}
	return (exc.retval);
}

double
cos(x)
register double x;
{
	return (x ? sin_cos(x, 1) : 1.0);
}
