/*	
 *	@(#)getnum.c	35.1		created:8/24/88 
 *
 *	Copyright (c)  Motorola Inc,  1986,1987
 *	All rights Reserved
 */

#include	<mnt.h>
#include	<stdio.h>

/*	
 *	getnum(value):	Calculates the absolute integer value 
 *			of the string passed in and returns it.
 */



getnum( value )
register char	*value;
{
	register unsigned int	n;
	register unsigned int	y;
	char     *strpbrk();

	/*   Skip the leading white space.  */
	if  (  (value = strpbrk( value, ":0123456789" ) )  == NULL ) {
#ifdef EBUG
		fprintf( stderr, "Invalid numeric argument: %s\n", value );
#endif
		return( -1 );
	}

	/*   Calculate the numeric value. */
	n = 0;
	while ( *value >= '0' && *value <= '9')
		n = n*10 + *value++ - '0';
	/*  
	 *  Now add the value of the alphabetical characters.
	 *  Note if another numberic character appear this is an error.
	 */
	while ( *value < '0'  ||  *value > '9' ) {
		switch ( *value++ ) {
		case  ' ':
		case '\t':
			continue;   /*  skip  whitespace  */
		case  'k':
		case  'K':
			n *= 1024;
			continue;
		case  'b':
		case  'B':
			n *= 512;
			continue;
		case  'w':
		case  'W':
			n *= 2;
			continue;
		case  '*':
		case  'x':
		case  'X':
			return( n * getnum(value) );
		case  ':':
			return( n );  /* given fsize:inodes */
		case '\0':
			return( n );
		default  :
			fprintf( stderr, "Unknown numeric multipier.  %c\n", *--value );
			return( -1 );
		}
	fprintf( stderr,  " Mulitple numeric args given for a single flag.\n" );
	}
}
