
/*	@(#)getperms.c	35.1	created:8/24/88 
 *
 *	Copyright (c)  Motorola Inc.  1986,1987
 *	All rights Reserved
 */

#include	<stdio.h>
#include	<mnt.h>

/*	Open the permissions file and determine 
 *	if the average user may access this device.
 *
 *	This function starts with:
 *		a lookfor which may match the alias entry or the
 *		device entry in the permissions file.
 *
 *	This function returns:
 *		the slice to be mounted.
 *		the alias of the device.
 *		the size of a file-system that can be made.
 *      	permissible operations, small letters super user only.
 *		the default mount directory.
 *		the format program to use.
 */



getperms( dsk )
register struct  usrdev   *dsk;
{
	register FILE	*map;
	register char	*base;
	char	lookfor[PATH_SZ];
	char	*strrchr();
	static char line[BUFSIZ];

	if ( (map = fopen( PERMS_FILE, "r" ))  ==  NULL ) {
		fprintf( stderr, "Could not open the permissions file.\n" );
		return( 2 );
	}

	if (  (base = strrchr( dsk->alias, '/' ))  != NULL )
		strcpy( lookfor, ++base );
	else
		strcpy( lookfor, dsk->alias );
	
	while (  fgets( line, BUFSIZ, map) != NULL )
	if ( (sscanf( line, "%s%s%s%s%s%*[^']'%[^']'", dsk->slice, dsk->alias, dsk->fsize, dsk->modes, dsk->mnt_pt, dsk->pgm )  !=  EOF )  ) {
		if (  strncmp(dsk->slice, "#", 1) == 0 ) {
#ifdef  EBUG
			fprintf( stderr, "getperms read a comment line:\n" );
			fprintf( stderr, "%s\n", line );
#endif
			continue;
		}
#ifdef	EBUG	
		fprintf( stderr, "getperms looking for %s, read:\n", lookfor);
		fprintf( stderr, "	slice	= %s\n", dsk->slice );
		fprintf( stderr, "	alias	= %s\n", dsk->alias );
		fprintf( stderr, "	fsize	= %s\n", dsk->fsize );
		fprintf( stderr, "	mode	= %s\n", dsk->modes );
		fprintf( stderr, "	mnt_pt	= %s\n", dsk->mnt_pt );
		fprintf( stderr, "	pgm	= %s\n", dsk->pgm );
#endif
		if ( (strcmp( dsk->alias, lookfor )  ==  0 ) | (strcmp( dsk->slice, lookfor ) == 0 ) ) {
#ifdef EBUG
			fprintf( stderr, "getperms SUCCEEDED will return\n" );
			fprintf( stderr, "	slice	= %s\n", dsk->slice );
			fprintf( stderr, "	alias	= %s\n", dsk->alias );
			fprintf( stderr, "	fsize	= %s\n", dsk->fsize );
			fprintf( stderr, "	mode	= %s\n", dsk->modes );
			fprintf( stderr, "	mnt_pt	= %s\n", dsk->mnt_pt );
			fprintf( stderr, "	pgm	= %s\n", dsk->pgm );
#endif
			return( 0 );
		}
	}
#ifdef  EBUG
	fprintf( stderr, "\ngetperms FAILED to find a match\n" );
#endif
	return( 1 );
}
