#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"@(#)librpc.mk	35.1"
# RPC/XDR library (librpc.a) makefile

CC = cc
AR = ar
RM=/bin/rm
STRIP = strip
MAKE=make
CFLAGS = -O -DSYSTEM=V5 -DMY_IN_ADDR=0x7f000001 -DDEBUG=DEBUG4
INS = install
LIB=$(ROOT)/usr/lib
LIBP=$(ROOT)/usr/lib/libp
VARIANT = rpc
LIBNAME = lib$(VARIANT).a


OBJ =	$(LIBNAME)(au_none.o) \
	$(LIBNAME)(au_unix.o) \
	$(LIBNAME)(au_ux_prot.o) \
	$(LIBNAME)(clnt_perr.o) \
	$(LIBNAME)(clnt_raw.o) \
	$(LIBNAME)(clnt_simp.o) \
	$(LIBNAME)(clnt_tcp.o) \
	$(LIBNAME)(clnt_udp.o) \
	$(LIBNAME)(pmap_clnt.o) \
	$(LIBNAME)(pmap_gtmps.o) \
	$(LIBNAME)(pmap_gtprt.o) \
	$(LIBNAME)(pmap_prot.o) \
	$(LIBNAME)(pmap_rmt.o) \
	$(LIBNAME)(rpc_prot.o) \
	$(LIBNAME)(svc.o) \
	$(LIBNAME)(svc_au_ux.o) \
	$(LIBNAME)(svc_auth.o) \
	$(LIBNAME)(svc_raw.o) \
	$(LIBNAME)(svc_simp.o) \
	$(LIBNAME)(svc_tcp.o) \
	$(LIBNAME)(svc_udp.o) \
	$(LIBNAME)(xdr.o) \
	$(LIBNAME)(xdr_array.o) \
	$(LIBNAME)(xdr_float.o) \
	$(LIBNAME)(xdr_mem.o) \
	$(LIBNAME)(xdr_rec.o) \
	$(LIBNAME)(xdr_refnce.o) \
	$(LIBNAME)(xdr_stdio.o) \

	$(LIBNAME)(gethostent.o) \
	$(LIBNAME)(get_time.o) \
	$(LIBNAME)(inet_ntoa.o) \
	$(LIBNAME)(inet_addr.o) \
	$(LIBNAME)(innetgr.o) \
	$(LIBNAME)(getrpcent.o) \
	$(LIBNAME)(gethostnm.o) \
	$(LIBNAME)(getdom.o) \
	$(LIBNAME)(rename.o)

.c.o:;

all: $(LIBNAME) profiledlib

$(LIBNAME):	$(OBJ)
		$(CC) -c $(CFLAGS) $(?:.o=.c)
		$(AR) r $(LIBNAME) $?
		$(RM) $?

.c.a:;

profiledlib:
	$(MAKE) -f librpc.mk -e libp.$(LIBNAME) \
	LIBNAME=libp.$(LIBNAME) CFLAGS="-p $(CFLAGS)"

install: all
	cp $(LIBNAME) $(LIB)/$(LIBNAME)
	cp libp.$(LIBNAME) $(LIBP)/$(LIBNAME)
clean:
	-rm -f *.o

clobber:	clean
	-rm -f $(LIBNAME) libp.$(LIBNAME)
