/*@(#)bp_global.c	35.1*/
/*MH************************ MODULE HEADER ****************************
**
**  MODULE NAME:	bp_global.c
**
**  DESCRIPTION:	This module defines global data structures used by
**					BPP and BPPIR functions.
**
**  CONTENTS:		
**
**  SYSTEM GLOBALS:
**
**  MODULE GLOBALS:
**
**  NOTES:	
**
**  UPDATE LOG:
**  Date	Name		V/R	Comments
**  --------	-----------	---	-----------------------------
**
**********************************************************************/

#include <sys/bppv2/bpptypes.h>
#include <sys/bppv2/mvme147/bpp_local.h>
#include <sys/bppv2/bpp.h>
#include <sys/bppv2/bm.h>
#include <sys/bppv2/ccb.h>


/* Maximum disable level for all interrupting CPU's.  Stored in PSR
	for 680x0 processors */
LONG	bpp_disable_level;

CPU_ID	bpp_local_cpu;

/* Define pipe table pointer arrays */
PCT_T	*bp_local_pipe_tbl[BP_MAX_CHAN] = {0};
PCT_T	*bp_remote_pipe_tbl[BP_MAX_CHAN] = {0};
CCB_T	bp_ccb_tbl[BP_MAX_CHAN] = {0};

/* Define registration table */
REG_ENT_T	bp_reg_table[BP_MAX_REGISTERED] = {0};

/* Allocate window management structures */
BM_WINDOW	bm_windows[BP_MAX_WINDOWS];
USHORT		bp_default_wid;				/* default window id */

/* Allocate request pend structures */
BM_PEND_T	*bp_pend_head, *bp_pend_tail;
BM_PEND_T	bp_pend_array[BP_MAX_PEND];

/* Allocate PCB pointer table */
BM_PCB_T	*bp_pcb_array[BP_MAX_POOLS];

