/*@(#)bp_init.c	35.1*/
/*MH************************ MODULE HEADER ****************************
**
**  MODULE NAME:	bp_init.c
**
**  DESCRIPTION:	This module contains initialization routines for
**					BPP Rel. 2.
**
**  CONTENTS:		
**
**  SYSTEM GLOBALS:
**
**  MODULE GLOBALS:
**
**  NOTES:	
**
**  UPDATE LOG:
**  Date		Name		V/R	Comments
**  --------	-----------	---	-----------------------------
**	12/29/87	jeh			1.0	Initial coding.
**********************************************************************/

#include <sys/bppv2/bpptypes.h>
#include <sys/bppv2/mvme147/bpp_local.h>
#include <sys/bppv2/bpp.h>
#include <sys/bppv2/ccb.h>
#include <sys/bppv2/bm.h>


void	bp_init()

{
	extern	BM_PEND_T	*bp_pend_head, *bp_pend_tail;
	extern	BM_PEND_T	bp_pend_array[];
	extern	ULONG		bp_local_init();
/*************************** later *********************************
	extern	void		bppir_serve();
	extern	void		bp_bfm_serve();
	extern	void		bp_dld_serve();
*************************** later *********************************/
	extern	REG_ENT_T	bp_reg_table[];

	register int		i;
	register BM_PEND_T	*pptr;
	register REG_ENT_T	*rptr;

/**************** kdb startup trap *****************
asm("trap &14");
**************** kdb startup trap *****************/

/* Initialize request pend structure list */
	for (i = 0, pptr = bp_pend_array; i < BP_MAX_PEND; i++, pptr++)
	{
		pptr->next_pend = pptr + 1;
	}
	pptr->next_pend = NULL;
	bp_pend_head = bp_pend_array;
	bp_pend_tail = pptr;

/* Initialize registration table entries */
	for (i = 0, rptr = bp_reg_table; i < BP_MAX_REGISTERED; i++, rptr++)
	{
		rptr->ip = i;
		rptr->status = 0;
		rptr->route_in = (PTF) NULL;
		rptr->route_out = (PTF) NULL;
		rptr->que_head = (BP_MPB_T *) NULL;
		rptr->que_tail = (BP_MPB_T *) NULL;
		rptr->control = NULL;
	}

/* Register BPPIR interface points */
/*************************** later *********************************
	if (bp_open_ip((USHORT) BP_IR_IP, bppir_serve, (ULONG) 0, (PTF) 0, 0))
	{
		LOG("BPP:  Cannot open BPPIR base IP\n");
	}
	if (bp_open_ip((USHORT) BP_BFM_IP, bp_bfm_serve, (ULONG) 0, (PTF) 0, 0))
	{
		LOG("BPP:  Cannot open BPPIR bfm IP\n");
	}
	if (bp_open_ip((USHORT) BP_DLD_IP, bp_dld_serve, (ULONG) 0, (PTF) 0, 0))
	{
		LOG("BPP:  Cannot open BPPIR download IP\n");
	}
*************************** later *********************************/

	bp_local_init();

}
