/*@(#)bp_rel_mpb.c	35.1*/
/*MH************************ MODULE HEADER ****************************
**
**  MODULE NAME:	bp_ret_mpb.c
**
**  DESCRIPTION:	
**
**  CONTENTS:		
**
**  SYSTEM GLOBALS:
**
**  MODULE GLOBALS:
**
**  NOTES:	
**
**  UPDATE LOG:
**  Date		Name		V/R	Comments
**  --------	-----------	---	-----------------------------
**	12/21/87	jeh			1.0	Initial coding.
**
**********************************************************************/

#include <sys/bppv2/bpptypes.h>
#include <sys/bppv2/mvme147/bpp_local.h>
#include <sys/bppv2/bpp.h>
#include <sys/bppv2/ccb.h>
#include <sys/bppv2/bm.h>

ULONG	bp_ret_mpb(mpb)
	register BP_SYSHDR_T	*mpb;
{

	extern	void		bp_wakeup();
	extern	 CPU_ID		bpp_local_cpu;
	extern	 BM_PCB_T	*bp_pcb_array[];
	extern	 PCT_T		*bp_local_pipe_tbl[];
	extern	 PCT_T		*bp_remote_pipe_tbl[];
	extern	int			bpp_disable_level;

	register BM_PCB_T		*pcb;
	register BP_SYSHDR_T	*lm_mpb;  /* locally mapped MPB pointer */
	register POOL_ID	pool;
	register CPU_ID		cpu;
	register PCT_T	*pctp;
	int					pri;		/* save variable for disable */

	/*
	**	Check input parameters
	*/

	if (mpb == NULL_PTR)
		return (BM_INVALID_MPB);

	lm_mpb = (BP_SYSHDR_T *) LOCAL_ADDRESS(mpb);
	if ((cpu = lm_mpb->creator.cpu) >= BP_MAX_CHAN)
		return (BPP_BAD_CPU_ID);

	if ((pool = lm_mpb->manager.pool_id) >= BP_MAX_POOLS )
	{
		LOG("BPP: Release bad pool ID, 0x%x, already free\n", lm_mpb);
		return (BM_BAD_POOL_ID);
	}

	/*
	**	Make sure we aren't releasing a whole string of MPBs
	*/
	if ( lm_mpb->bmh_link != NULL )
	{
		return (BM_INVALID_MPB);
	}
	/*
	**	Make sure we aren't releasing an MPB that's already released
	*/
	if ( lm_mpb->buf_status && BUF_IN_POOL )
	{
		LOG("BPP: Released mpb, 0x%x, already free\n", lm_mpb);
		return (BM_INVALID_MPB);
	}

	/*
	**	Find Pool Control Block for this MPB
	*/

	pcb = bp_pcb_array[pool];

	/*
	**  Determine if we are managing a pool for this MPB
	*/
	if ( cpu == bpp_local_cpu )
	{ /* normal case -- we're managing this pool */
	    DISABLE(pri, bpp_disable_level);
		lm_mpb->bmh_link = NULL;  
		lm_mpb->buf_status |= BUF_IN_POOL;
		lm_mpb = (BP_SYSHDR_T *) LOCAL_ADDRESS(pcb->rel_ptr);
		pcb->rel_ptr = mpb;
		ENABLE(pri);

		/* Kick the other processor here to allow it
			to wake up processes blocked on resources.  It would
			probably be useful to have a status flag in the other
			processor's PCT that it could set when it has tasks
			pended for resources or needs a wakeup for another reason.
		*/
		pctp = bp_remote_pipe_tbl[lm_mpb->partnercpu];
		if (pctp)
		{
			if (pctp->pipe_status & PENDING_BUF)
			{
				bp_intr_remote(bp_local_pipe_tbl[lm_mpb->partnercpu]);
			}
		}

	}
	else if (lm_mpb->creator.cpu == bpp_local_cpu)
	{ /* created here, managed by remote; must release to head */
	    DISABLE(pri, bpp_disable_level);
		lm_mpb->bmh_link = pcb->get_ptr;
		lm_mpb->buf_status |= BUF_IN_POOL;
		pcb->get_ptr = mpb;
		ENABLE(pri);
		bp_wakeup(lm_mpb->creator.pool_id);
	}
	else if ( lm_mpb->manager.pool_id == MPB_STATIC_POOL_ID )
	{
		/*
		**	static buffer -- just mark status free
		*/
		lm_mpb->buf_status &= ~ (BUF_IN_POOL);		/* mark it free at least */
		lm_mpb->buf_status |= BUF_FREE;
	}
	else
	{  /* if we don't manage this pool, send to someone who does.
		  Try to send to manager, then creator, and then sender. If
		  we're unable to send to any of them, just mark it free and
		  log an error. */
		
		((BFM_REQ_T *)lm_mpb)->hdr.src_id.ip = BP_BFM_IP;
		((BFM_REQ_T *)lm_mpb)->hdr.dst_id.ip = BP_BFM_IP;
		((BFM_REQ_T *)lm_mpb)->hdr.dst_id.cpu = cpu;
		((BFM_REQ_T *)lm_mpb)->hdr.msg_status = BPP_SUCCESSFUL;
		((BFM_REQ_T *)lm_mpb)->hdr.data_size = sizeof(BFM_REQ_T) - sizeof(BP_MPB_T);
		((BFM_REQ_T *)lm_mpb)->hdr.data = (UBYTE *)&((BFM_REQ_T *)lm_mpb)->type;
		((BFM_REQ_T *)lm_mpb)->type = BM_RET_BUF_REQ;
		if (! bp_pwrite(bp_local_pipe_tbl[cpu], mpb))
		{ 
			return(BM_SUCCESS);
		}
		else
		{ /* try to send to creator */
			((BFM_REQ_T *)lm_mpb)->hdr.dst_id.cpu = lm_mpb->creator.cpu;
			((BFM_REQ_T *)lm_mpb)->hdr.msg_status = BPP_SUCCESSFUL;
			if (! bp_pwrite(bp_local_pipe_tbl[lm_mpb->creator.cpu], mpb))
			{
			}
			else
			{ /* try to send to original sender */
				((BFM_REQ_T *)lm_mpb)->hdr.dst_id.cpu = ((BP_MPB_T *)lm_mpb)->src_id.cpu;
				((BFM_REQ_T *)lm_mpb)->hdr.msg_status = BPP_SUCCESSFUL;
				if (! bp_pwrite(bp_local_pipe_tbl[((BP_MPB_T *)lm_mpb)->src_id.cpu], mpb))
				{
				}
				else
				{
					LOG("BPP: unable to return unowned buffer 0x%x\n", mpb);
					lm_mpb->buf_status |= BUF_FREE;	/* mark it free at least */
					return(BM_INVALID_MPB);
				}
			}
		}
	}

	return(BM_SUCCESS);

}
