/*@(#)bp_utils.c	35.1*/
/*MH*********************** MODULE HEADER *****************************
**
**  MODULE NAME:	bp_utils.c
**
**  DESCRIPTION:	This module contains the Common Interface
**			utility functions.
**
**  FUNCTIONS:		bp_swap_id, bp_add_retry
**
**  NOTES:
**
**  UPDATE LOG:
**  Date	Name		V/R	Comments
**  --------	-----------   	---	-----------------------------
**
***********************************************************************/

#include <sys/bppv2/bpptypes.h>
#include <sys/bppv2/mvme147/bpp_local.h>
#include <sys/bppv2/bpp.h>
#include <sys/bppv2/ccb.h>
#include <sys/bppv2/bm.h>

extern ULONG	bp_rel_mpb();	/* return MPB */

/*FH*********************** FUNCTION HEADER ***************************
**
**  FUNCTION NAME:	bp_swap_id()	
**
**  DESCRIPTION:	Swap MPB destination and source IDs.
**
**  CONTENTS:		This function will swap the passed MPB's
**			destination and source ID fields.
**
**  PARAMETERS:		
**
**	Input:		mpb		- MPB pointer.
**
**	Output:		NONE
**
**	Returns:	NONE
**
**  COMPLEX LOCALS:
**
**  METHOD:
**
**  NOTES:
**
**  UPDATE LOG:
**  Date	Name		V/R	Comments
**  --------	-----------	---	-----------------------------
**
**********************************************************************/

void bp_swap_id(mpb)
	register	BP_MPB_T	*mpb;		/* MPB address */
{
	BP_IP_T 	tmp_id;		/* Temporary holder */

	tmp_id      = mpb->src_id;
	mpb->src_id = mpb->dst_id;
	mpb->dst_id = tmp_id;
}


