#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"@(#)c37x.mk	35.1"

STRIP = strip
INCRT = ..
LIBNAME = ../$(LIBDIR)/lib.c37x
DASHG = 
DASHO = -O
CFLAGS= -I$(INCRT) -DINKERNEL $(DASHG) $(DASHO) $(BRDEFS) -D$(CPU)
FRC =

FILES = \
		$(LIBNAME)(ci_bufmgt.o)	\
		$(LIBNAME)(ci_debug.o)	\
		$(LIBNAME)(ci_driver.o)	\
		$(LIBNAME)(ci_global.o)	\
		$(LIBNAME)(ci_init.o)	\
		$(LIBNAME)(ci_malloc.o)	\
		$(LIBNAME)(ci_pipe.o)	\
		$(LIBNAME)(ci_regdreg.o) \
		$(LIBNAME)(ci_user.o)	\
		$(LIBNAME)(ci_utils.o)	

all:	pickup $(LIBNAME) 

.PRECIOUS:	$(LIBNAME)

pickup:
	-@if [ "`ls *.o 2>/dev/null`" ] ; \
	then \
		echo "\t$(AR) ruv $(LIBNAME) *.o" ; \
		$(AR) ruv $(LIBNAME) *.o ; \
		echo "\trm -f *.o" ; \
		rm -f *.o  ; \
	fi

$(LIBNAME):	$(FILES)
	$(AR) ruv $(LIBNAME) *.o
	rm -f *.o

.c.a:
	$(CC) $(CFLAGS) -c -UDEBUG $<

clean:
	-rm -f *.o

clobber:	clean
	-rm -f $(LIBNAME)

FRC:

#
# Header dependencies
#

$(LIBNAME)(ci_bufmgt.o):	ci_bufmgt.c	\
		$(INCRT)/sys/c37x/ci_driver.h \
		$(INCRT)/sys/c37x/ci_struct.h \
		$(INCRT)/sys/c37x/ci_const.h	\
		$(INCRT)/sys/c37x/ci_global.h \
		$(FRC)

$(LIBNAME)(ci_debug.o):	ci_debug.c	\
		$(INCRT)/sys/c37x/ci_driver.h \
		$(INCRT)/sys/c37x/ci_struct.h \
		$(INCRT)/sys/c37x/ci_const.h	\
		$(INCRT)/sys/c37x/ci_global.h \
		$(FRC)

$(LIBNAME)(ci_driver.o):	ci_driver.c \
		$(INCRT)/sys/errno.h	\
		$(INCRT)/sys/types.h	\
		$(INCRT)/sys/param.h	\
		$(INCRT)/sys/dir.h	\
		$(INCRT)/sys/signal.h	\
		$(INCRT)/sys/proc.h	\
		$(INCRT)/sys/user.h	\
		$(INCRT)/sys/c37x/ci_driver.h \
		$(INCRT)/sys/c37x/ci_struct.h \
		$(INCRT)/sys/c37x/ci_const.h	\
		$(FRC)

$(LIBNAME)(ci_global.o):	ci_global.c \
		$(INCRT)/sys/c37x/ci_driver.h \
		$(INCRT)/sys/c37x/ci_struct.h \
		$(INCRT)/sys/c37x/ci_const.h	\
		$(FRC)

$(LIBNAME)(ci_init.o):	ci_init.c \
		$(INCRT)/sys/types.h	\
		$(INCRT)/sys/param.h	\
		$(INCRT)/sys/proc.h	\
		$(INCRT)/sys/c37x/ci_driver.h \
		$(INCRT)/sys/c37x/ci_struct.h \
		$(INCRT)/sys/c37x/ci_const.h	\
		$(INCRT)/sys/c37x/ci_global.h	\
		$(FRC)

$(LIBNAME)(ci_malloc.o):	ci_malloc.c \
		$(INCRT)/sys/param.h	\
		$(INCRT)/sys/sysmacros.h	\
		$(INCRT)/sys/c37x/ci_driver.h \
		$(INCRT)/sys/c37x/ci_struct.h \
		$(INCRT)/sys/c37x/ci_const.h	\
		$(INCRT)/sys/c37x/ci_global.h	\
		$(FRC)

$(LIBNAME)(ci_pipe.o):	ci_pipe.c \
		$(INCRT)/sys/c37x/ci_driver.h \
		$(INCRT)/sys/c37x/ci_struct.h \
		$(INCRT)/sys/c37x/ci_const.h	\
		$(INCRT)/sys/c37x/ci_global.h	\
		$(FRC)

$(LIBNAME)(ci_regdreg.o):	ci_regdreg.c \
		$(INCRT)/sys/errno.h	\
		$(INCRT)/sys/types.h	\
		$(INCRT)/sys/param.h	\
		$(INCRT)/sys/dir.h	\
		$(INCRT)/sys/signal.h	\
		$(INCRT)/sys/proc.h	\
		$(INCRT)/sys/user.h	\
		$(INCRT)/sys/c37x/ci_driver.h \
		$(INCRT)/sys/c37x/ci_struct.h \
		$(INCRT)/sys/c37x/ci_const.h	\
		$(INCRT)/sys/c37x/ci_global.h	\
		$(FRC)

$(LIBNAME)(ci_user.o):	ci_user.c \
		$(INCRT)/sys/types.h	\
		$(INCRT)/sys/param.h	\
		$(INCRT)/sys/proc.h	\
		$(INCRT)/sys/c37x/ci_driver.h \
		$(INCRT)/sys/c37x/ci_struct.h \
		$(INCRT)/sys/c37x/ci_const.h	\
		$(INCRT)/sys/c37x/ci_global.h	\
		$(FRC)

$(LIBNAME)(ci_utils.o):	ci_utils.c \
		$(INCRT)/sys/c37x/ci_driver.h \
		$(INCRT)/sys/c37x/ci_struct.h \
		$(INCRT)/sys/c37x/ci_const.h	\
		$(INCRT)/sys/c37x/ci_global.h	\
		$(FRC)

