/*	@(#)ci_global.c	35.1	*/
/*MH************************ MODULE HEADER ****************************
**
**  MODULE NAME:	ci_global.c
**
**  DESCRIPTION:	This module holds all of the global Common
**			Interface variables.
**
**  CONTENTS:
**
**  SYSTEM GLOBALS:
**
**  MODULE GLOBALS:
**
**  NOTES:
**
**  UPDATE LOG:
**  Date	Name		V/R	Comments
**  --------	-----------	---	-----------------------------
**  04/20/87    R. Robinson     1.1     Original coding. 
**  09/10/87	dtk             2.1     Changed location of header files
**
**********************************************************************/


#include <sys/c37x/ci_driver.h>
#include <sys/c37x/ci_const.h>
#include <sys/c37x/ci_struct.h>


CPU_ENT	ci_cpu[NUM_CPU_ENTRIES] = {0};	/* CPU table */

CPU_TAB	ci_cputab[NUM_CPU_ENTRIES];	/* CPU description table */

BYTE	ci_dev[]  = "c37x";		/* Device name */

#ifdef DEBUG				/* Debug flag */
BOOLEAN	ci_debug  = TRUE;
#else
BOOLEAN	ci_debug  = FALSE;
#endif

/*
**	Registration EPB, only used for registration notification 
**	immediately following an "open".
*/

EPB	ci_reg_epb =
{
	(EPB *)NULL,			/* hdr.next	*/	
	3,				/* hdr.mem_id	*/	
	0,				/* hdr.dst_id	*/	
	0,				/* hdr.src_id	*/
	sizeof(EPB),			/* hdr.epb_size */
	CE_REGISTRATION_RESPONSE,	/* hdr.type	*/
	NO_ERROR,			/* hdr.status	*/	
	(BUF *)NULL,			/* hdr.buf	*/	
	0				/* hdr.user_def */	
};

/*	The following variables were added to make references indirect
**	so that vme147-specific libraries would not be linked into vme130
**	kernels.  The variables are statically initialized to zero here
**	and are set to useful values by the vme147 library initialization
**	when lib.lnc and lib.bppv2 are present.
*/

UBYTE	*bppv2_local_cpu = 0;
LONG	**bppv2_remote_pipe_tbl = 0;
ULONG	(*bppv2_pread)() = 0;
ULONG	(*bppv2_pwrite)() = 0;

/*
**	ci driver first open flag
*/

UBYTE	ci_first_open = TRUE;

