

/*****************************************************************************

	Rev = 1.1		Date of 'get'   = 15:59:30 1/5/89
				Date of 'delta' = 15:51:03 1/5/89

	File = blkcopy.c

*****************************************************************************/


/**********************************************************************
 *								      *
 *		Copyright (c) Ferranti plc 1988			      *
 *								      *
 *	This is unpublished proprietory source code of Ferranti plc.  *
 *		The copyright of which vests in Ferranti plc.	      *
 **********************************************************************/


/**********************************************************************
 *								      *
 * blkcopy							      *
 * fast block copy of <count> bytes from <from> to <to>.              *
 *								      *
 * Notes:							      *
 * System V/68 assembler (M68010) doesn't like cmpi and messes up cmp *
 *								      *
 **********************************************************************/

blkcopy(from, to, count)
	register char *from, *to;
	register int   count;
{
#ifdef m68k
	/*
	 * on m68k:
	 * from   is known to be %a2
	 * to     is known to be %a3
	 * count  is known to be %d2
	 */
	asm("	text");
	asm("	tst.l %d2");
	asm("	ble L%blk22");
	asm("	mov.l %d1,-(%a7)");
	asm("	mov.l %a3,%d0");
	asm("	mov.l %a2,%d1");
						/* if greater than 64K */
	asm("	long 0x0C820000");		/* cmpi.l &0x8000,%d2 */
	asm("	short 0x8000");
	asm("	bge L%blk1");
	asm("	and.w &0x1,%d0");
	asm("	and.w &0x1,%d1");
	asm("	short 0xb240");			/* cmp.w %d0,%d1 */
	asm("	beq L%blk2");
	asm("	mov.w %d2,%d1");
	asm("	bra L%blk3");
	asm("L%blk2:");
	asm("	mov.w %d2,%d1");
	asm("	tst.w %d0");
	asm("	beq L%blk4");
	asm("	mov.b (%a2)+,(%a3)+");
	asm("	sub.w &0x1,%d1");
	asm("	beq L%blk5");
	asm("L%blk4:");
	asm("	mov.w %d1,%d0");
	asm("	and.w &0x1ff,%d0");
	asm("	beq L%blk6");
	asm("	mov.w %d1,%d0");
	asm("	and.w &0xfffffffc,%d0");
	asm("	beq  L%blk3");
	asm("	sub.w %d0,%d1");
	asm("	asr.w &0x2,%d0");
	asm("	long 0x0c400061");		/* cmpi.w &0x61, %d0 */
	asm("	blt L%blk7");
	asm("	movm.l &0x7fce,-(%a7)");	/* d1-d7,a0,a1,a4-a6 */
	asm("	sub.w &0x31,%d0");
	asm("L%blk21:");
	asm("	movm.l (%a2)+,&0x73fe");	/* d1-d7,a0,a1,a4-a6 */
	asm("	movm.l &0x73fe,(%a3)");		/* d1-d7,a0,a1,a4-a6 */
	asm("	movm.l (%a2)+,&0x73fe");
	asm("	movm.l &0x73fe,0x30(%a3)");
	asm("	movm.l (%a2)+,&0x73fe");
	asm("	movm.l &0x73fe,0x60(%a3)");
	asm("	movm.l (%a2)+,&0x73fe");
	asm("	movm.l &0x73fe,0x90(%a3)");
	asm("	add.w &0xc0,%a3");
	asm("	sub.w &0x30,%d0");
	asm("	bge L%blk21");
	asm("	movm.l (%a7)+,&0x73fe");
	asm("	add.w &0x31,%d0");
	asm("	beq L%blk3");
	asm("L%blk7:");
	asm("	long 0x0c400008");		/* cmpi.w &0x8, %d0 */
	asm("	blt L%blk8");
	asm("	sub.w &0x8,%d0");
	asm("L%blk9:");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	sub.w &0x8,%d0");
	asm("	bge L%blk9");
	asm("	add.w &0x8,%d0");
	asm("	beq L%blk3");
	asm("L%blk8:");
	asm("	sub.w &0x1,%d0");
	asm("L%blk10:");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	dbra %d0,L%blk10");
	asm("L%blk3:");
	asm("	tst.w %d1");
	asm("	beq L%blk5");
	asm("	sub.w &0x1,%d1");
	asm("L%blk11:");
	asm("	mov.b (%a2)+,(%a3)+");
	asm("	dbra %d1,L%blk11");
	asm("	bra L%blk5");

	asm("L%blk1:");				/* 64K+ byte transfer */

	asm("	and.l &0x1,%d0");
	asm("	and.l &0x1,%d1");
	asm("	short 0xb240");			/* cmp.w %d0,%d1 */
	asm("	beq L%blk12");
	asm("	mov.l %d2,%d1");
	asm("	bra L%blk13");
	asm("L%blk12:");
	asm("	mov.l %d2,%d1");
	asm("	tst.w %d0");
	asm("	beq L%blk14");
	asm("	neg.l %d0");
	asm("	add.l &0x2,%d0");
	asm("	short 0xb081");			/* cmp.l %d1,%d0 */
	asm("	bge L%blk13");
	asm("	sub.l %d0,%d1");
	asm("	sub.l &0x1,%d0");
	asm("L%blk15:");
	asm("	mov.b (%a2)+,(%a3)+");
	asm("	sub.l &0x1,%d0");
	asm("	bge L%blk15");
	asm("L%blk14:");
	asm("	mov.l %d1,%d0");
	asm("	and.l &0xfffffffc,%d0");
	asm("	beq L%blk13");
	asm("	sub.l %d0,%d1");
	asm("	asr.l &0x2,%d0");
	asm("	short 0x0c80");			/* cmpi.l &0xd, %d0 */
	asm("	long  0x0000000d");
	asm("	blt L%blk16");
	asm("	movm.l &0x7fce,-(%a7)");	/* d1-d7,a0,a1,a4-a6 */
	asm("L%blk17:");
	asm("	movm.l (%a2)+,&0x73fe");	/* a6-a4,a1,a0,d7-d1 */
	asm("	movm.l &0x73fe,(%a3)");
	asm("	add.w &0x30,%a3");
	asm("	sub.l &0xc,%d0");
	asm("	short 0x0c80");			/* cmpi.l &0xd, %d0 */
	asm("	long  0x0000000d");
	asm("	bge L%blk17");
	asm("	movm.l (%a7)+,&0x73fe");	/* a6-a4,a1,a0,d7-d1 */
	asm("	tst.l %d0");
	asm("	beq L%blk13");
	asm("L%blk16:");
	asm("	sub.l &0x1,%d0");
	asm("L%blk18:");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	sub.l &0x1,%d0");
	asm("	bge L%blk18");
	asm("L%blk13:");
	asm("	tst.l %d1");
	asm("	beq L%blk5");
	asm("	sub.l &0x1,%d1");
	asm("L%blk19:");
	asm("	mov.b (%a2)+,(%a3)+");
	asm("	sub.l &0x1,%d1");
	asm("	bge L%blk19");
	asm("	bra L%blk5");
	asm("L%blk6:");
	asm("	mov.w %d1,%d0");
	asm("	beq L%blk5");
	asm("	mov.l &0x9,%d1");
	asm("	asr.w %d1,%d0");
	asm("	sub.l &0x1,%d0");
	asm("	movm.l &0x7fce,-(%a7)");	/* d1-d7,a0,a1,a4-a6 */
	asm("L%blk20:");
	asm("	movm.l (%a2)+,&0x73fe");	/* a6-a4,a1,a0,d7-d1 */
	asm("	movm.l &0x73fe,(%a3)");
	asm("	movm.l (%a2)+,&0x73fe");
	asm("	movm.l &0x73fe,0x30(%a3)");
	asm("	movm.l (%a2)+,&0x73fe");
	asm("	movm.l &0x73fe,0x60(%a3)");
	asm("	movm.l (%a2)+,&0x73fe");
	asm("	movm.l &0x73fe,0x90(%a3)");
	asm("	movm.l (%a2)+,&0x73fe");
	asm("	movm.l &0x73fe,0xc0(%a3)");
	asm("	movm.l (%a2)+,&0x73fe");
	asm("	movm.l &0x73fe,0xf0(%a3)");
	asm("	movm.l (%a2)+,&0x73fe");
	asm("	movm.l &0x73fe,0x120(%a3)");
	asm("	movm.l (%a2)+,&0x73fe");
	asm("	movm.l &0x73fe,0x150(%a3)");
	asm("	movm.l (%a2)+,&0x73fe");
	asm("	movm.l &0x73fe,0x180(%a3)");
	asm("	movm.l (%a2)+,&0x73fe");
	asm("	movm.l &0x73fe,0x1b0(%a3)");
	asm("	add.w &0x1e0,%a3");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	dbra %d0,L%blk20");
	asm("	movm.l (%a7)+,&0x73fe");	/* a6-a4,a1,a0,d7-d1 */
	asm("L%blk5:");
	asm("	clr.l %d0");
	asm("	mov.l (%a7)+,%d1");
	asm("	bra L%blk23");
	asm("L%blk22:");
	asm("	mov.l &0xffffffff,%d0");
	asm("L%blk23:");

	return;
#else	
	for ( ; count--; )
		*to++ = *from++;
	return (0);
#endif
}
