

/*****************************************************************************

	Rev = 1.1		Date of 'get'   = 15:59:45 1/5/89
				Date of 'delta' = 15:50:16 1/5/89

	File = blkcopy512.c

*****************************************************************************/


/**********************************************************************
 *								      *
 *		Copyright (c) Ferranti plc 1988			      *
 *								      *
 *	This is unpublished proprietory source code of Ferranti plc.  *
 *		The copyright of which vests in Ferranti plc.	      *
 **********************************************************************/


/**********************************************************************
 *								      *
 * blkcopy512							      *
 * fast copy of <count> bytes from <from> to <to>.                    *
 * where count is the number of 512 byte blocks                       *
 **********************************************************************/

blkcopy512(from, to, count)
	register char *from, *to;
	register int   count;
{
#ifdef m68k
	/*
	 * on m68k:
	 * from   is known to be %a2
	 * to     is known to be %a3
	 * count  is known to be %d2
	 */
	asm("	mov.l &0xffffffff,%d0");
	asm("	tst.l %d2");
	asm("	ble L%blkend");
	asm("	sub.w &0x1,%d2");
	asm("	movm.l &0x5fce,-(%a7)");	/* d1,d3-d7,a0,a1,a4-a6 */
	asm("L%blk512:");
	asm("	movm.l (%a2)+,&0x73fb");	/* a6-a4,a1,a0,d7-d3,d1,d0 */
	asm("	movm.l &0x73fb,(%a3)");
	asm("	movm.l (%a2)+,&0x73fb");
	asm("	movm.l &0x73fb,0x30(%a3)");
	asm("	movm.l (%a2)+,&0x73fb");
	asm("	movm.l &0x73fb,0x60(%a3)");
	asm("	movm.l (%a2)+,&0x73fb");
	asm("	movm.l &0x73fb,0x90(%a3)");
	asm("	movm.l (%a2)+,&0x73fb");
	asm("	movm.l &0x73fb,0xc0(%a3)");
	asm("	movm.l (%a2)+,&0x73fb");
	asm("	movm.l &0x73fb,0xf0(%a3)");
	asm("	movm.l (%a2)+,&0x73fb");
	asm("	movm.l &0x73fb,0x120(%a3)");
	asm("	movm.l (%a2)+,&0x73fb");
	asm("	movm.l &0x73fb,0x150(%a3)");
	asm("	movm.l (%a2)+,&0x73fb");
	asm("	movm.l &0x73fb,0x180(%a3)");
	asm("	movm.l (%a2)+,&0x73fb");
	asm("	movm.l &0x73fb,0x1b0(%a3)");
	asm("	add.w &0x1e0,%a3");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	mov.l (%a2)+,(%a3)+");
	asm("	dbra %d2,L%blk512");
	asm("	movm.l (%a7)+,&0x73fa");	/* a6-a4,a1,a0,d7-d3,d1 */
	asm("	clr.l %d0");
	asm("L%blkend:");

	return ;
#else	
	count <<= 9;
	for ( ; count--; )
		*to++ = *from++;
	return (0);
#endif
}
