
#
#	Rev = 1.1		Date of 'get'   = 16:08:07 1/5/89
#				Date of 'delta' = 16:06:36 1/5/89
#
#	File = fbprobe.s


#	A version of bprobe that uses word accesses (not bytes).
#	This is because the FVME250 does not allow byte accesses over VME.
#

	set NOINTS, 0x0700	# sr mask: ipl 7

# int me250bprobe( addr, byte )
# caddr_t addr;
# int byte;

# if "byte" < 0, read the byte at "addr" to see if a bus error occurs.
# else write (byte) "byte" into address "addr" and see if a bus error occurs.

# return true (1) if the error occurs, else false (0).

me250bprobe:	global	me250bprobe
	mov.w	%sr,%d1 	# save status register
	or.w	&NOINTS,%sr	# block interrupts

	mov.l	%vbr,%a0	# Save current bus error handler.
	mov.l	8(%a0),%a1
	mov.l	&L%bpr9,8(%a0)	# catch bus error exceptions


	mov.l	4(%sp),%a0	# "addr"
	mov.l	8(%sp),%d0	# get the int "byte"
	bge.b	L%bpr1		# skip for write
	tst.w	(%a0)		# read (byte) "byte" at "addr"
	bra.b	L%bpr2
L%bpr1:	mov.w	%d0,(%a0)	# write (byte) "byte" into "addr"
L%bpr2:	mov.l	&0,%d0		# false return value
L%bpr3:	
	mov.l	%vbr,%a0	# Restore bus error handler.
	mov.l	%a1,8(%a0)
	mov.w	%d1,%sr		# restore status register
	rts

# L%bpr9 can be reached only by a bus error exception trap

L%bpr9:	#rmstkfrm		# true return value
	mov.w	6(%sp),%d0	# get the stack format
	lsr.w	&12,%d0		# shift to low order byte
	mov.b	(stkfmtsz,%d0.w),%d0	# look up size of the saved stack
	add.w	&8,%d0		#  adjust to full saved stack size
	add.w	%d0,%sp		# adjust stack to remove
	# K2 mov.l	&0xfffb0032,%a0	# Address of STAT2 on 131 card
	# K2 mov.b	(%a0),%d0	# Read to clear BERR source status register
	mov.l	&1,%d0		# true return value
	bra.b	L%bpr3

