
#
#	Rev = 1.1		Date of 'get'   = 16:11:03 1/5/89
#				Date of 'delta' = 16:06:07 1/5/89
#
#	File = fvme250.mk
#


#	Copyright (c) 1988 Ferranti International 
#	All Rights Reserved
# 	@(#)kern-port:io/fvme250.mk
# 

ROOT =
INCRT = ..
LIBNAME = ../cf/libme250.a

DASHG =
DASHO = -O
PFLAGS = $(DASHG) -I$(INCRT) -DINKERNEL 
CFLAGS = $(DASHO) $(PFLAGS)
FRC =
OWN = bin
GRP = bin

DFILES = \
	$(LIBNAME)(blkcopy.o) \
	$(LIBNAME)(blkcopy512.o) \
	$(LIBNAME)(fmalloc.o) \
	$(LIBNAME)(fbprobe.o) \
	$(LIBNAME)(physdsk.o)

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)


$(LIBNAME):	$(DFILES)
	ar ruv $(LIBNAME) *.o
	rm -f *.o

.c.a:
	$(CC) $(CFLAGS) -c $<

clean:
	-@for i in * ; \
	do \
		if [ -d $$i -a -f $$i/$$i.mk ] ; then \
			cd $$i; \
			echo "	$(MAKE) -f $$i clean"; \
			$(MAKE) -f $$i.mk clean; \
			cd ..; \
		fi ; \
	done
	-rm -f *.o

clobber:
	-@for i in * ; \
	do \
		if [ -d $$i -a -f $$i/$$i.mk ] ; then \
			cd $$i; \
			echo "	$(MAKE) -f $$i clobber"; \
			$(MAKE) -f $$i.mk clobber; \
			cd ..; \
		fi ; \
	done
	-rm -f $(LIBNAME)

FRC:

#
# Header dependencies
#

$(LIBNAME)(blkcopy.o): blkcopy.c 

$(LIBNAME)(blkcopy512.o):blkcopy512.c

$(LIBNAME)(fmalloc.o): fmalloc.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/map.h \
	$(FRC)

$(LIBNAME)(fbprobe.o): fbprobe.s
	as -o fbprobe.o fbprobe.s

$(LIBNAME)(physdsk.o): physdsk.c\
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/psw.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/debug.h \
	$(FRC)
