

/*****************************************************************************

	Rev = 1.1		Date of 'get'   = 16:00:23 1/5/89
				Date of 'delta' = 15:51:27 1/5/89

	File = physdsk.c

*****************************************************************************/


/**********************************************************************
 *								      *
 *		Copyright (c) Ferranti plc 1988			      *
 *								      *
 *	This is unpublished proprietory source code of Ferranti plc.  *
 *		The copyright of which vests in Ferranti plc.	      *
 **********************************************************************/


/**********************************************************************
 *								      *
 * physdsk.c							      *	
 *								      *
 **********************************************************************/

#include "sys/types.h"
#include "sys/param.h"
#include "sys/immu.h"
#include "sys/fs/s5dir.h"
#include "sys/psw.h"
#include "sys/region.h"
#include "sys/sysmacros.h"
#include "sys/conf.h"
#include "sys/signal.h"
#include "sys/user.h"
#include "sys/proc.h"
#include "sys/errno.h"
#include "sys/buf.h"
#include "sys/elog.h"
#include "sys/iobuf.h"
#include "sys/systm.h"
#include "sys/debug.h"


me250_dma_breakup(strat, bp, sectsize)
int (*strat)(); 		/* address of device driver strategy routine */
register struct buf *bp;	/* buffer header from physical buffer list */
int sectsize; 			/* sector size */
{
	register caddr_t bufaddr;	/* kernel buffer address */
	register int count;		/* user requested byte count */
	register int rw;

	count = bp->b_bcount;
	rw = bp->b_flags & B_READ;

	/*if ((count & (sectsize - 1)) || ((bufaddr = getphysbuf(count)) == 0)) {*/
	if (((bufaddr = getphysbuf(count)) == 0)) {
		bp->b_flags |= B_ERROR | B_DONE;
  		bp->b_error = ENXIO;
		return;
	}
	bp->b_un.b_addr = bufaddr;

	if (rw == B_READ) {
		doio(strat, bp);
		iomove(bufaddr, bp->b_bcount, rw);
	}
	else {
		iomove(bufaddr, count, rw);
		doio(strat, bp); 
	}

	freephysbuf(bufaddr, count);
}

