/*		Copyright (c) 1988 Motorola, Inc.		*/
/*		All Rights Reserved				*/
/*  		@(#)clk147.c	35.1	*/
/*
	This file contains the routines required to 
	manipulate the PCC tick timer on the MVME147
*/

/* This declaration is used to force the object for this module to be extracted
   from the library before other clock handlers (which have same entry points*/

int	CLK147;

/*
 * The following definitions prevent multiple definitions when
 * loaded with other clock drivers.
 */
#define clkstart ckst147
#define clkreld  ckrl147

#include "sys/types.h"
#include "sys/pcc.h"

#define	PCC_ADDR 0xfffe1000	/* clock address */
#define	COUNT	63036		/* counter initial value (1/64 second) */

extern time_t time;			/* time of day in seconds */

static int slipctr = 0;			/*cnts interrupts; returns every 15th*/

/* initialize the clock */
clkstart ()
{
	register struct pcc *clk;

	clk = (struct pcc *) PCC_ADDR;
	clk->tpr1 = COUNT;
	clk->ticr1 = PCC_ICLR | PCC_IEN | PCC_IL6;	
	clk->tcr1 = PCC_CLROVF | PCC_CTRENA | PCC_ENAB;

}

/* comment out this function as the functionality is identical
   in clkZ8036.c

clkset (oldtime)
time_t	oldtime;
{
	time = oldtime;
}
*/

clkreld (on)
int on;
{
	register struct pcc *clk;

	clk = (struct pcc *) PCC_ADDR;

	if (on) {
		clk->ticr1 |= PCC_ICLR;
		if( slipctr++ == 15) {
			slipctr = 0;
			return(1);
		}
	}
	else
		clk->tcr1 &= ~PCC_ENAB;    /* stop clock */
	return(0);
}
