/*		Copyright (c) 1987 Motorola, Inc.		*/
/*		All Rights Reserved				*/
/*  		@(#)clk681.c	35.1	*/
/*
	This file contains the routines required to 
	manipulate the MC68681 hardware clock on the MVME140.
*/

/* This declaration is used to force the object for this module to be extracted
   from the library before other clock handlers (which have same entry points*/

int	CLK681;

#include "sys/types.h"
#include "sys/m68681.h"

extern time_t time;			/* time of day in seconds */

clkstary()
{
	register union m681_io *clk;       /* pointer to DUART regs */
	unsigned char dummy;

	clk = m681_addr[0];
	clk->write.wr_ctur = SLCTIM >> 8;
	clk->write.wr_ctlr = SLCTIM & 0xFF;
	clk->write.wr_acr  = BDSET2 | CCLK1 | IPDCDIB | IPDCDIA;  
	dummy = clk->read.rd_ctstart;
	clk->write.wr_opcr = OPSETTO;

}

clkreldy(flg)
{

	if (!flg)
		clkstop();
	return(0);
}

clkstop()
{
	int i;

	i= m681_addr[0]->read.rd_ctstop;
}

#ifdef NOT_DEFINED
clkset(newtime)
{
	time = newtime;
}
#endif
