/*		Copyright (c) 1987 Motorola, Inc.		*/
/*		All Rights Reserved				*/
/*  		@(#)clk68901.c	35.1	*/
/*
	This file contains the routines required to 
	manipulate the MC68901 hardware clock on the MVME134.
*/

/* This declaration is used to force the object for this module to be extracted
   from the library before other clock handlers (which have same entry points*/

int	CLK901;

/*
 * The following definitions prevent multiple definitions when
 * loaded with clkZ8036.
 */
#define clkstart clkstarx
#define clkreld  clkreldx

#include "sys/types.h"
#include "sys/mfp.h"

#define	CLK_ADDR 0xfff80001	/* clock address */
#define	COUNT	102		/* counter initial value (1/60 second) */

/* bit defines for Timer A Control Register */

#define RESTAO		0x10
#define TIMSTOP 	0x00
#define DMDIV100	0x06	
#define DMDIV200	0x07

extern time_t time;			/* time of day in seconds */
int slipctr = 0;			/* cnts interrupts */

/* initialize the clock */
clkstart ()
{
	register struct mfp_io *clk;

	clk = (struct mfp_io *) CLK_ADDR;
	clk->tacr = RESTAO | TIMSTOP;
	clk->tadr = COUNT;
	clk->tacr = DMDIV200;

	clk->iera |= ITIMERA;	
	clk->imra |= ITIMERA;

}

/* comment out this function as the functionality is identical
   in clkZ8036.c

clkset (oldtime)
time_t	oldtime;
{
	time = oldtime;
}
*/

clkreld (on)
int on;
{
	register struct mfp_io *clk;

	clk = (struct mfp_io *) CLK_ADDR;
	if (on) {
		clk->tacr = DMDIV200;
		if( slipctr++ == 180)
		{
			slipctr = 0;
			return(1);
		}
	}
	else
		clk->tacr = TIMSTOP;    /* stop clock */
	return(0);
}
