

/*****************************************************************************

	Rev = 1.1		Date of 'get'   = 13:53:40 1/6/89
				Date of 'delta' = 15:17:39 1/5/89

	File = fvme250psd.c

*****************************************************************************/


/**********************************************************************
 *								      *
 *		Copyright (c) Ferranti plc 1988			      *
 *								      *
 *	This is unpublished proprietory source code of Ferranti plc.  *
 *		The copyright of which vests in Ferranti plc.	      *
 **********************************************************************/


/**********************************************************************
 *								      *
 *                  FVME250 PSEUDO DEVICE DRIVER		      *
 *    							              *	
 * 		    Written  1988  by P.E.Callow   	              *	
 *    							              *	
 **********************************************************************
 *    							              *	
 *	This file contains pseudo FVME250 routines called by the      *
 *	kernel.							      *
 *								      *
 *	These pseudo drivers have their own read, write, open, close, *
 *	ioctl and print routines.				      *
 *	The only routine in the driver which calls a pseudo routine   *
 *	is me250check().					      *
 *								      *
 **********************************************************************/

#include <sys/types.h>
#include <sys/param.h>
#include <sys/buf.h>
#include <sys/sysmacros.h>


void
ps_0open(dev, flag)
	register dev_t dev;
	register int flag;
{
	m250open(0,minor(dev), flag );
}

void
ps_0close(dev, flag)
	register dev_t dev;
	register int flag;
{
	m250close(0,minor(dev), flag );
}

void
ps_0ioctl(dev, cmd, arg, flag)
	register dev_t dev;
	register int cmd, arg,flag;
{
	m250ioctl(0,minor(dev),cmd,arg,flag);
}


void
ps_0print(dev, msg)
	register dev_t dev;
	register char *msg;
{
	m250print(0,minor(dev),msg);
}

void
ps_0read(dev)
	register dev_t dev;
{
	m250read(0, minor(dev) );
}

void
ps_0write(dev)
	register dev_t dev;
{
	m250write(0, minor(dev) );
}

ps_0strategy(bp)
	struct buf *bp;
{
	m250strategy(0, bp);
}
