#
#	Copyright (c) 1987 Motorola Inc
#	All Rights Reserved
# 	@(#)kern-port:io/io.mk	35.8
# 
#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

ROOT =
INCRT = ..
LIBNAME = ../cf/lib.io

DASHG =
DASHO = -O
PFLAGS = $(DASHG) -D$(TAS) -I$(INCRT) -DINKERNEL 
CFLAGS = $(DASHO) $(PFLAGS)
FRC =
OWN = bin
GRP = bin

DFILES = \
	$(LIBNAME)(badtrk.o) \
	$(LIBNAME)(bppmgr.o) \
	$(LIBNAME)(chkparity.o) \
	$(LIBNAME)(clist.o) \
	$(LIBNAME)(clk147.o) \
	$(LIBNAME)(clk681.o) \
	$(LIBNAME)(clk68901.o) \
	$(LIBNAME)(clkZ8036.o) \
	$(LIBNAME)(clone.o) \
	$(LIBNAME)(cpvmeram.o) \
	$(LIBNAME)(dbuf.o) \
 	$(LIBNAME)(disjointio.o) \
	$(LIBNAME)(err.o) \
	$(LIBNAME)(errlog.o) \
	$(LIBNAME)(fpu881a.o) \
	$(LIBNAME)(fvme250.o) \
	$(LIBNAME)(fvme250psd.o) \
	$(LIBNAME)(gentape.o) \
	$(LIBNAME)(gentty.o) \
	$(LIBNAME)(ipc.o) \
	$(LIBNAME)(log.o) \
	$(LIBNAME)(lp050.o) \
	$(LIBNAME)(lp147.o) \
	$(LIBNAME)(lp.o) \
	$(LIBNAME)(m146818tdc.o) \
	$(LIBNAME)(mem.o) \
	$(LIBNAME)(mem143.o) \
	$(LIBNAME)(mem147.o) \
	$(LIBNAME)(mfp.o) \
	$(LIBNAME)(mk48t02nvr.o) \
	$(LIBNAME)(mk48t02tdc.o) \
	$(LIBNAME)(mk68564.o) \
	$(LIBNAME)(msg.o) \
	$(LIBNAME)(mvme050.o) \
	$(LIBNAME)(mvme204.o) \
	$(LIBNAME)(mvme320.o) \
	$(LIBNAME)(mvme321.o) \
	$(LIBNAME)(macs323.o) \
	$(LIBNAME)(mvme323.o) \
	$(LIBNAME)(mvme327dk.o) \
	$(LIBNAME)(mvme327tp.o) \
	$(LIBNAME)(mvme331.o) \
	$(LIBNAME)(mvme332xt.o) \
	$(LIBNAME)(mvme350.o) \
	$(LIBNAME)(mvme355.o) \
	$(LIBNAME)(mvme360.o) \
	$(LIBNAME)(mvmecpu.o) \
	$(LIBNAME)(nvram.o) \
	$(LIBNAME)(osm.o) \
	$(LIBNAME)(partab.o) \
	$(LIBNAME)(pcc.o) \
	$(LIBNAME)(physdsk.o) \
	$(LIBNAME)(prf.o) \
	$(LIBNAME)(prfclk.o) \
	$(LIBNAME)(pty.o) \
	$(LIBNAME)(port.o) \
	$(LIBNAME)(r68560.o) \
	$(LIBNAME)(rtc252.o) \
	$(LIBNAME)(ram.o) \
	$(LIBNAME)(sem.o) \
	$(LIBNAME)(shm.o) \
	$(LIBNAME)(sobppmgr.o) \
	$(LIBNAME)(sp.o) \
	$(LIBNAME)(stream.o) \
	$(LIBNAME)(sxt.o) \
	$(LIBNAME)(timod.o) \
	$(LIBNAME)(tirdwr.o) \
	$(LIBNAME)(tpoke00.o) \
	$(LIBNAME)(tt1.o) \
	$(LIBNAME)(tty.o) \
	$(LIBNAME)(isp.o) \
	$(LIBNAME)(ramdisk.o) \
	$(LIBNAME)(mvme336sio.o) \
	$(LIBNAME)(mvme336xpc.o) \
	$(LIBNAME)(m68681.o) \
	$(LIBNAME)(x68681.o) \
	$(LIBNAME)(m68230.o) \
	$(LIBNAME)(dsk.o) \
	$(LIBNAME)(mvme147tp.o) \
	$(LIBNAME)(mvme147dk.o) \
	$(LIBNAME)(scsi.o) \
	$(LIBNAME)(sxt332.o) \
	$(LIBNAME)(pty.o) \
	$(LIBNAME)(prfclk.o) \
	$(LIBNAME)(z8530.o) \
	$(LIBNAME)(scc.o) \
	$(LIBNAME)(scc_conf.o) \
	$(LIBNAME)(sccl.o) \
	$(LIBNAME)(tasmem.o) \
	$(LIBNAME)(sccfifo.o)
 

all:	subdirs pickup $(LIBNAME)

.PRECIOUS:	$(LIBNAME)

pickup:
	-@if [ "`ls *.o 2>/dev/null`" ] ; \
	then \
		echo "\tar ruv $(LIBNAME) *.o" ; \
		ar ruv $(LIBNAME) *.o ; \
		echo "\trm -f *.o" ; \
		rm -f *.o  ; \
		rm -f *.to  ; \
	fi

subdirs:
	-@for i in * ; \
	do \
		if [ -d $$i -a -f $$i/$$i.mk ] ; then \
			cd $$i; \
			echo "	$(MAKE) -f $$i.mk \"MAKE=$(MAKE)\" \"CC=$(CC)\" \"FRC=$(FRC)\" \"INCRT=$(INCRT)\" \"DASHO=$(DASHO)\" "; \
			$(MAKE) -f $$i.mk "MAKE=$(MAKE)" "CC=$(CC)" "FRC=$(FRC)" "INCRT=$(INCRT)" "DASHO=$(DASHO)" ; \
			cd ..; \
		fi ; \
	done

$(LIBNAME):	$(DFILES)
	ar ruv $(LIBNAME) *.o
	rm -f *.o
	rm -f *.to

.c.a:
	$(CC) $(CFLAGS) -c $<

clean:
	-@for i in * ; \
	do \
		if [ -d $$i -a -f $$i/$$i.mk ] ; then \
			cd $$i; \
			echo "	$(MAKE) -f $$i clean"; \
			$(MAKE) -f $$i.mk clean; \
			cd ..; \
		fi ; \
	done
	-rm -f *.o
	-rm -f *.to
	-rm -f *.s

clobber:
	-@for i in * ; \
	do \
		if [ -d $$i -a -f $$i/$$i.mk ] ; then \
			cd $$i; \
			echo "	$(MAKE) -f $$i clobber"; \
			$(MAKE) -f $$i.mk clobber; \
			cd ..; \
		fi ; \
	done
	-rm -f *.o z8530.c
	-rm -f *.to
	-rm -f $(LIBNAME)

FRC:

#
# Header dependencies
#

$(LIBNAME)(badtrk.o): badtrk.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/dk.h \
	$(FRC)

$(LIBNAME)(bppmgr.o):bppmgr.c\
	$(INCRT)/sys/bpp.h\
	$(INCRT)/sys/types.h\
	$(FRC)

$(LIBNAME)(chkparity.o): chkparity.c \
	$(INCRT)/sys/param.h \
	$(FRC)

$(LIBNAME)(clist.o): clist.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/var.h \
	$(INCRT)/sys/cmn_err.h \
	$(FRC)

$(LIBNAME)(clk147.o): clk147.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/pcc.h \
	$(FRC)

$(LIBNAME)(clk681.o):clk681.c\
	$(INCRT)/sys/types.h\
	$(INCRT)/sys/m68681.h \
	$(FRC)
	$(CC) $(CFLAGS) -c -DXREGS clk681.c

$(LIBNAME)(clk68901.o): clk68901.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/mfp.h \
	$(FRC)

$(LIBNAME)(clkZ8036.o): clkZ8036.c \
	$(INCRT)/sys/types.h \
	$(FRC)

$(LIBNAME)(clone.o): clone.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/fstyp.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/inode.h \
	$(INCRT)/sys/psw.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/stropts.h \
	$(INCRT)/sys/stream.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/var.h \
	$(INCRT)/sys/debug.h \
	$(FRC)

$(LIBNAME)(cpvmeram.o): cpvmeram.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/utsname.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/erec.h \
	$(INCRT)/sys/cmn_err.h \
	$(INCRT)/sys/cpvmeram.h \
	$(FRC)

$(LIBNAME)(dbuf.o): dbuf.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/fs/s5param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/dbuf.h \
	$(INCRT)/sys/cmn_err.h \
	$(FRC)

$(LIBNAME)(disjointio.o): disjointio.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/disjointio.h \
	$(INCRT)/sys/debug.h \
	$(FRC)

$(LIBNAME)(err.o): err.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/utsname.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/erec.h \
	$(INCRT)/sys/sysmacros.h \
	$(FRC)

$(LIBNAME)(errlog.o): errlog.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/utsname.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/erec.h \
	$(INCRT)/sys/err.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/var.h \
	$(FRC)

$(LIBNAME)(fpu881a.o): fpu881a.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/trap.h \
	$(FRC)

$(LIBNAME)(fvme250.o): fvme250.c\
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/dir.h \
	$(INCRT)/sys/reg.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/cmn_err.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/inode.h \
	$(INCRT)/sys/utsname.h \
	$(INCRT)/sys/erec.h \
	$(INCRT)/sys/mvmecpu.h \
	/usr/include/stdio.h\
	$(INCRT)/sys/fvme250/f250bits.h \
	$(INCRT)/sys/fvme250/f250buf.h \
	$(INCRT)/sys/fvme250/f250cmds.h \
	$(INCRT)/sys/fvme250/f250dev.h \
	$(INCRT)/sys/fvme250/f250fix.h \
	$(INCRT)/sys/fvme250/f250addr.h \
	$(INCRT)/sys/fvme250/f250error.h \
	$(INCRT)/sys/fvme250/f250legal.h \
	$(INCRT)/sys/fvme250/f250value.h \
	$(INCRT)/sys/fvme250/f250slice.h \
	$(FRC)

$(LIBNAME)(fvme250psd.o): fvme250psd.c\
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/buf.h\
	$(FRC)

$(LIBNAME)(gentape.o):gentape.c\
	$(INCRT)/sys/types.h\
	$(INCRT)/sys/param.h\
	$(INCRT)/sys/immu.h\
	$(INCRT)/sys/sysmacros.h\
	$(INCRT)/sys/buf.h\
	$(INCRT)/sys/fs/s5dir.h\
	$(INCRT)/sys/errno.h\
	$(INCRT)/sys/signal.h\
	$(INCRT)/sys/region.h\
	$(INCRT)/sys/proc.h\
	$(INCRT)/sys/psw.h\
	$(INCRT)/sys/user.h\
	$(INCRT)/sys/conf.h\
	$(INCRT)/sys/tty.h\
	$(INCRT)/sys/stream.h\
	$(INCRT)/sys/mvmecpu.h\
	$(INCRT)/sys/fvme250/f250value.h\
	$(INCRT)/sys/fvme250/f250fix.h\
	$(FRC)

$(LIBNAME)(gentty.o): gentty.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/psw.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/stream.h \
	$(INCRT)/sys/mvmecpu.h \
	$(INCRT)/sys/open.h \
	$(INCRT)/sys/gentty.h \
	$(INCRT)/sys/m68681.h \
	$(FRC)

$(LIBNAME)(ipc.o): ipc.c \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/psw.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/ipc.h \
	$(FRC)

$(LIBNAME)(log.o): log.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/stropts.h \
	$(INCRT)/sys/stream.h \
	$(INCRT)/sys/strstat.h \
	$(INCRT)/sys/log.h \
	$(INCRT)/sys/strlog.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/debug.h \
	$(FRC)

$(LIBNAME)(lp050.o): lp050.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/lp0.h \
	$(INCRT)/sys/lprio.h \
	$(FRC)

$(LIBNAME)(lp147.o): lp147.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/lp0.h \
	$(INCRT)/sys/pcc.h \
	$(INCRT)/sys/sysmacros.h \
	$(FRC)

$(LIBNAME)(m146818tdc.o): m146818tdc.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/todc.h \
	$(FRC)

$(LIBNAME)(mem.o): mem.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/immu.h \
	$(FRC)

$(LIBNAME)(mem143.o): mem143.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/utsname.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/erec.h \
	$(INCRT)/sys/cmn_err.h \
	$(INCRT)/sys/mvme143.h \
	$(INCRT)/sys/mvmecpu.h \
	$(FRC)

$(LIBNAME)(mem147.o): mem147.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/utsname.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/erec.h \
	$(INCRT)/sys/cmn_err.h \
	$(INCRT)/sys/pcc.h \
	$(INCRT)/sys/mvmecpu.h \
	$(FRC)

$(LIBNAME)(mk48t02nvr.o): mk48t02nvr.c\
	$(INCRT)/sys/types.h\
	$(INCRT)/sys/nvram.h\
	$(FRC)

$(LIBNAME)(mk48t02tdc.o): mk48t02tdc.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/todc.h \
	$(FRC)

$(LIBNAME)(mk68564.o): mk68564.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/gentty.h \
	$(FRC)

$(LIBNAME)(mfp.o):mfp.c\
	$(INCRT)/sys/param.h\
	$(INCRT)/sys/types.h\
	$(INCRT)/sys/dir.h\
	$(INCRT)/sys/file.h\
	$(INCRT)/sys/signal.h\
	$(INCRT)/sys/tty.h\
	$(INCRT)/sys/user.h\
	$(INCRT)/sys/errno.h\
	$(INCRT)/sys/termio.h\
	$(INCRT)/sys/conf.h\
	$(INCRT)/sys/sysinfo.h\
	$(INCRT)/sys/mfp.h\
	$(INCRT)/sys/gentty.h\
	$(FRC)

$(LIBNAME)(msg.o): msg.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/psw.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/ipc.h \
	$(INCRT)/sys/msg.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/cmn_err.h \
	$(INCRT)/sys/sysinfo.h \
	$(FRC)

$(LIBNAME)(mvme050.o): mvme050.c \
	$(INCRT)/sys/mc68153.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/dir.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/todc.h \
	$(FRC)

$(LIBNAME)(mvme204.o): mvme204.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/utsname.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/erec.h \
	$(INCRT)/sys/cmn_err.h \
	$(INCRT)/sys/mvme204.h \
	$(FRC)

$(LIBNAME)(mvme320.o): mvme320.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/dk.h \
	$(INCRT)/sys/mvme320.h \
	$(FRC)

$(LIBNAME)(mvme321.o):mvme321.c\
	$(INCRT)/sys/param.h\
	$(INCRT)/sys/types.h\
	$(INCRT)/sys/sysmacros.h\
	$(INCRT)/sys/dir.h\
	$(INCRT)/sys/signal.h\
	$(INCRT)/sys/user.h\
	$(INCRT)/sys/errno.h\
	$(INCRT)/sys/buf.h\
	$(INCRT)/sys/elog.h\
	$(INCRT)/sys/iobuf.h\
	$(INCRT)/sys/systm.h\
	$(INCRT)/sys/dk.h\
	$(INCRT)/sys/dsk.h\
	$(INCRT)/sys/bpp.h\
	$(INCRT)/sys/mvme321.h\
	$(FRC)

$(LIBNAME)(macs323.o): macs323.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/dk.h \
	$(INCRT)/sys/mvme323.h \
	$(INCRT)/sys/macs323.h \
	$(FRC)

$(LIBNAME)(mvme323.o): mvme323.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/dk.h \
	$(INCRT)/sys/mvme323.h \
	$(FRC)

$(LIBNAME)(mvme327dk.o): mvme327dk.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/dk.h \
	$(INCRT)/sys/dsk.h \
	$(INCRT)/sys/sobpp.h \
	$(INCRT)/sys/mvme327.h \
	$(INCRT)/sys/open.h \
	$(FRC)

$(LIBNAME)(mvme327tp.o): mvme327tp.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/cmn_err.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/sobpp.h \
	$(INCRT)/sys/mvme327.h \
	$(INCRT)/sys/dbuf.h \
	$(INCRT)/sys/open.h \
	$(FRC)

$(LIBNAME)(mvme331.o): mvme331.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/mvme331.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/proc.h \
	$(FRC)

$(LIBNAME)(mvme332xt.o): mvme332xt.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/inode.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/ttold.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/mvme332xt.h \
	$(INCRT)/sys/bpp.h \
	$(FRC)

$(LIBNAME)(mvme350.o): mvme350.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/fs/s5param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/mvme350.h \
	$(INCRT)/sys/dbuf.h \
	$(INCRT)/sys/cmn_err.h \
	$(INCRT)/sys/bpp.h \
	$(FRC)

$(LIBNAME)(mvme355.o): mvme355.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/dk.h \
	$(INCRT)/sys/mvme355.h \
	$(FRC)

$(LIBNAME)(mvme360.o): mvme360.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/dk.h \
	$(INCRT)/sys/mvme360.h \
	$(FRC)

$(LIBNAME)(mvmecpu.o): mvmecpu.c \
	$(INCRT)/sys/cmn_err.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/mvmecpu.h \
	$(INCRT)/sys/mvme131.h \
	$(INCRT)/sys/mvme134.h \
	$(INCRT)/sys/mvme136.h \
	$(INCRT)/sys/mvme140.h \
	$(INCRT)/sys/mvme141.h \
	$(INCRT)/sys/mvme143.h \
	$(INCRT)/sys/mvme147.h \
	$(INCRT)/sys/fvme252.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/pcc.h \
	$(INCRT)/sys/var.h \
	$(INCRT)/sys/vmechip.h \
	$(INCRT)/sys/todc.h \
	$(INCRT)/sys/nvram.h \
	$(INCRT)/sys/systm.h
	$(CC) $(CFLAGS) -c mvmecpu.c
	$(FRC)

$(LIBNAME)(nvram.o): nvram.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/nvram.h \
	$(FRC)

$(LIBNAME)(osm.o): osm.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/psw.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/debug.h \
	$(FRC)

$(LIBNAME)(partab.o): partab.c \
	$(FRC)

$(LIBNAME)(pcc.o): pcc.c \
	$(INCRT)/sys/pcc.h \
	$(FRC)

$(LIBNAME)(physdsk.o): physdsk.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/psw.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/debug.h \
	$(FRC)

$(LIBNAME)(prf.o): prf.c \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/psw.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/buf.h \
	$(FRC)

$(LIBNAME)(prfclk.o): prfclk.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/mc68153.h \
	$(FRC)

$(LIBNAME)(pty.o): pty.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/pty.h \
	$(INCRT)/sys/cmn_err.h \
	$(FRC)

$(LIBNAME)(port.o): port.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/gentty.h \
	$(INCRT)/sys/MC68681.h \
	$(FRC)

$(LIBNAME)(r68560.o): r68560.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/sysinfo.h \
	$(FRC)

$(LIBNAME)(rtc252.o): rtc252.c\
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/MC68681.h \
	$(FRC)

$(LIBNAME)(ram.o): ram.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(FRC)

$(LIBNAME)(sem.o): sem.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/ipc.h \
	$(INCRT)/sys/sem.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/psw.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/sysinfo.h \
	$(FRC)

$(LIBNAME)(shm.o): shm.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/ipc.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/shm.h \
	$(INCRT)/sys/debug.h \
	$(INCRT)/sys/tuneable.h \
	$(INCRT)/sys/cmn_err.h \
	$(FRC)

$(LIBNAME)(sitm.o): sitm.c \
	$(INCRT)/sys/CMC/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/stream.h \
	$(INCRT)/sys/stropts.h \
	$(INCRT)/sys/tihdr.h \
	$(INCRT)/sys/tiuser.h \
	$(INCRT)/sys/CMC/signal.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/CMC/errno.h \
	$(INCRT)/sys/CMC/longnames.h \
	$(INCRT)/sys/CMC/netbfr.h \
	$(INCRT)/sys/CMC/ring.h \
	$(INCRT)/sys/CMC/CMC_proto.h \
	$(INCRT)/sys/CMC/CMC_socket.h \
	$(INCRT)/sys/CMC/in.h \
	$(INCRT)/sys/CMC/enp.h \
	$(INCRT)/sys/sitm.h \
	$(INCRT)/sys/log.h \
	$(INCRT)/sys/track.h \
	$(FRC)

$(LIBNAME)(sobppmgr.o):sobppmgr.c\
	$(INCRT)/sys/sobpp.h\
	$(INCRT)/sys/types.h\
	$(FRC)

$(LIBNAME)(sp.o): sp.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/stropts.h \
	$(INCRT)/sys/stream.h \
	$(FRC)

$(LIBNAME)(stream.o): stream.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/stropts.h \
	$(INCRT)/sys/stream.h \
	$(INCRT)/sys/strstat.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/var.h \
	$(INCRT)/sys/debug.h \
	$(INCRT)/sys/cmn_err.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/tuneable.h \
	$(INCRT)/sys/map.h \
	$(FRC)

$(LIBNAME)(stubs.o): stubs.c \
	$(FRC)

$(LIBNAME)(sxt.o): sxt.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/psw.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/ttold.h \
	$(INCRT)/sys/sxt.h \
	$(INCRT)/sys/cmn_err.h \
	$(FRC)

$(LIBNAME)(timod.o): timod.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/stream.h \
	$(INCRT)/sys/stropts.h \
	$(INCRT)/sys/tihdr.h \
	$(INCRT)/sys/timod.h \
	$(INCRT)/sys/tiuser.h \
	$(INCRT)/sys/debug.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/psw.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(FRC)

$(LIBNAME)(tirdwr.o): tirdwr.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/stream.h \
	$(INCRT)/sys/stropts.h \
	$(INCRT)/sys/tihdr.h \
	$(INCRT)/sys/psw.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/debug.h \
	$(INCRT)/sys/errno.h \
	$(FRC)

$(LIBNAME)(tpoke00.o): tpoke00.c \
	$(FRC)

$(LIBNAME)(tracker.o): tracker.c \
	$(INCRT)/sys/track.h \
	$(FRC)

$(LIBNAME)(ramdisk.o): ramdisk.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/var.h \
	$(FRC)

$(LIBNAME)(isp.o): isp.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/ttold.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/cmn_err.h \
	$(INCRT)/sys/cstty.h \
	$(INCRT)/sys/csintern.h \
	$(FRC)

$(LIBNAME)(tt1.o): tt1.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/cmn_err.h \
	$(INCRT)/sys/cstty.h \
	$(FRC)

$(LIBNAME)(tty.o): tty.c \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/debug.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/psw.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/ttold.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/cstty.h \
	$(FRC)

$(LIBNAME)(mvme336sio.o): mvme336sio.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/mvme336s.h \
	$(INCRT)/sys/mvme336c.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/mvme336t.h \
	$(FRC)

$(LIBNAME)(mvme336xpc.o): mvme336xpc.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/mvme336x.h \
	$(INCRT)/sys/mvme336c.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/mvme336t.h \
	$(FRC)

$(LIBNAME)(m68230.o): m68230.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/lprio.h \
	$(INCRT)/sys/lp0.h \
	$(FRC)

$(LIBNAME)(m68681.o): m68681.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/dir.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/gentty.h \
	$(INCRT)/sys/mvmecpu.h \
	$(FRC)

$(LIBNAME)(lp.o): lp.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/lprio.h \
	$(INCRT)/sys/lp0.h \
	$(INCRT)/sys/mc68153.h \
	$(INCRT)/sys/sysmacros.h \
	$(FRC)

$(LIBNAME)(x68681.o):m68681.c\
	$(INCRT)/sys/param.h\
	$(INCRT)/sys/types.h\
	$(INCRT)/sys/dir.h\
	$(INCRT)/sys/file.h\
	$(INCRT)/sys/signal.h\
	$(INCRT)/sys/tty.h\
	$(INCRT)/sys/user.h\
	$(INCRT)/sys/errno.h\
	$(INCRT)/sys/termio.h\
	$(INCRT)/sys/conf.h\
	$(INCRT)/sys/sysinfo.h\
	$(INCRT)/sys/sysmacros.h\
	$(INCRT)/sys/gentty.h\
	$(INCRT)/sys/mvmecpu.h
	cp m68681.c x68681.c
	$(CC) $(CFLAGS) -c -DXREGS x68681.c
	rm -f x68681.c
	$(FRC)

$(LIBNAME)(z8530.o):z8530.m4\
	gtty.m4\
	$(INCRT)/sys/param.h\
	$(INCRT)/sys/types.h\
	$(INCRT)/sys/dir.h\
	$(INCRT)/sys/file.h\
	$(INCRT)/sys/signal.h\
	$(INCRT)/sys/tty.h\
	$(INCRT)/sys/user.h\
	$(INCRT)/sys/errno.h\
	$(INCRT)/sys/termio.h\
	$(INCRT)/sys/conf.h\
	$(INCRT)/sys/sysinfo.h\
	$(INCRT)/sys/sysmacros.h\
	$(INCRT)/sys/gentty.h\
	$(INCRT)/sys/mvmecpu.h
	m4 z8530.m4 > z8530.c
	$(CC) $(CFLAGS) -c z8530.c
	rm -f z8530.c
	$(FRC)

$(LIBNAME)(mvme147dk.o):mvme147dk.c\
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/dk.h \
	$(INCRT)/sys/dsk.h \
	$(INCRT)/sys/scsi.h \
	$(INCRT)/sys/mvme147s.h \
	$(INCRT)/sys/open.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/cmn_err.h \
	$(INCRT)/sys/mvme336t.h \
	$(FRC)

$(LIBNAME)(mvme147tp.o):mvme147tp.c\
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/fs/s5param.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/cmn_err.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/dbuf.h \
	$(INCRT)/sys/scsi.h \
	$(INCRT)/sys/mvme147s.h \
	$(INCRT)/sys/mvme336t.h \
	$(FRC)

$(LIBNAME)(scsi.o):scsi.m4
	m4 scsi.m4 > scsi.s
	$(AS) -o scsi.o scsi.s
	rm -f scsi.s
	$(FRC)

$(LIBNAME)(dsk.o):dsk.c\
	$(INCRT)/sys/param.h\
	$(INCRT)/sys/signal.h\
	$(INCRT)/sys/errno.h\
	$(INCRT)/sys/types.h\
	$(INCRT)/sys/dir.h\
	$(INCRT)/sys/user.h\
	$(INCRT)/sys/systm.h\
	$(INCRT)/sys/buf.h\
	$(INCRT)/sys/iobuf.h\
	$(INCRT)/sys/elog.h\
	$(INCRT)/sys/sysmacros.h\
	$(INCRT)/sys/dk.h\
	$(INCRT)/sys/dsk.h\
	$(FRC)

$(LIBNAME)(sxt332.o):sxt332.c\
	$(INCRT)/sys/types.h\
	$(INCRT)/sys/param.h\
	$(INCRT)/sys/sysmacros.h\
	$(INCRT)/sys/immu.h\
	$(INCRT)/sys/region.h\
	$(INCRT)/sys/proc.h\
	$(INCRT)/sys/dir.h\
	$(INCRT)/sys/signal.h\
	$(INCRT)/sys/user.h\
	$(INCRT)/sys/inode.h\
	$(INCRT)/sys/elog.h\
	$(INCRT)/sys/file.h\
	$(INCRT)/sys/errno.h\
	$(INCRT)/sys/termio.h\
	$(INCRT)/sys/ttold.h\
	$(INCRT)/sys/tty.h\
	$(INCRT)/sys/sxt.h\
	$(INCRT)/sys/mvme332xt.h\
	$(FRC)

$(LIBNAME)(prfclk.o): prfclk.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/mc68153.h \
	$(FRC)

$(LIBNAME)(pty.o): pty.c \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/pty.h \
	$(INCRT)/sys/cmn_err.h \
	$(FRC)


$(LIBNAME)(sccfifo.o):	sccfifo.as
	/lib/cpp -P -DTASFRIG sccfifo.as >> sccfifo.ts
	/lib/cpp -P sccfifo.as >> sccfifo.s
	as  -o sccfifo.to sccfifo.ts
	as  -o sccfifo.o sccfifo.s
	rm -f sccfifo.s
	rm -f sccfifo.ts


$(LIBNAME)(tasmem.o):	tasmem.as
	/lib/cpp -P -DTASFRIG tasmem.as >> tasmem.ts
	/lib/cpp -P tasmem.as >> tasmem.s
	as  -o tasmem.to tasmem.ts
	as  -o tasmem.o tasmem.s
	rm -f tasmem.s
	rm -f tasmem.ts


$(LIBNAME)(scc_conf.o):	scc_conf.c\
		$(INCRT)/sys/param.h\
		$(INCRT)/sys/types.h\
		$(INCRT)/local/scc/duartchan.h\
		$(INCRT)/local/scc/duartdefs.h\
		$(INCRT)/local/scc/sccdctrl.h \
		$(FRC)

$(LIBNAME)(sccl.o): sccl.c\
		$(INCRT)/sys/param.h\
		$(INCRT)/sys/types.h\
		$(INCRT)/sys/errno.h\
		$(INCRT)/sys/signal.h\
		$(INCRT)/sys/fs/s5dir.h\
		$(INCRT)/sys/user.h\
		$(INCRT)/sys/immu.h\
		$(INCRT)/sys/region.h\
		$(INCRT)/sys/proc.h\
		$(INCRT)/sys/sysinfo.h\
		$(INCRT)/sys/conf.h\
		$(INCRT)/sys/termio.h\
		$(INCRT)/sys/tty.h\
		$(INCRT)/sys/file.h\
		$(INCRT)/sys/cmn_err.h\
		$(INCRT)/local/scc/fifo.h\
		$(INCRT)/local/scc/lowmem.h\
		$(INCRT)/local/scc/status.h\
		$(INCRT)/local/scc/duartchan.h\
		$(INCRT)/local/scc/duartdefs.h\
		$(INCRT)/local/scc/termctrl.h\
		$(INCRT)/local/scc/scccmd.h\
		$(INCRT)/local/scc/scclioctl.h\
		$(INCRT)/local/scc/scclerr.h\
		$(INCRT)/local/scc/sccdctrl.h \
		$(FRC)

$(LIBNAME)(scc.o): scc.c\
		$(INCRT)/sys/param.h\
		$(INCRT)/sys/types.h\
		$(INCRT)/sys/errno.h\
		$(INCRT)/sys/signal.h\
		$(INCRT)/sys/fs/s5dir.h\
		$(INCRT)/sys/user.h\
		$(INCRT)/sys/immu.h\
		$(INCRT)/sys/region.h\
		$(INCRT)/sys/proc.h\
		$(INCRT)/sys/sysinfo.h\
		$(INCRT)/sys/conf.h\
		$(INCRT)/sys/termio.h\
		$(INCRT)/sys/tty.h\
		$(INCRT)/sys/file.h\
		$(INCRT)/sys/cmn_err.h\
		$(INCRT)/sys/ttold.h\
		$(INCRT)/local/scc/fifo.h\
		$(INCRT)/local/scc/lowmem.h\
		$(INCRT)/local/scc/duartchan.h\
		$(INCRT)/local/scc/duartdefs.h\
		$(INCRT)/local/scc/termctrl.h\
		$(INCRT)/local/scc/scctermio.h\
		$(INCRT)/local/scc/scccmd.h\
		$(INCRT)/local/scc/sccdctrl.h\
		$(INCRT)/local/scc/sccioctl.h \
		$(FRC)
